/*
 Navicat Premium Data Transfer

 Source Server         : MySQL
 Source Server Type    : MySQL
 Source Server Version : 50733
 Source Host           : localhost:3306
 Source Schema         : datasharing

 Target Server Type    : MySQL
 Target Server Version : 50733
 File Encoding         : 65001

 Date: 29/10/2023 21:35:19
*/

SET NAMES utf8mb4;
SET FOREIGN_KEY_CHECKS = 0;

-- ----------------------------
-- Table structure for rixiaoliang
-- ----------------------------
DROP TABLE IF EXISTS `rixiaoliang`;
CREATE TABLE `rixiaoliang`  (
  `date` varchar(10) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `count` int(10) NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of rixiaoliang
-- ----------------------------
INSERT INTO `rixiaoliang` VALUES ('2017-11-25', 46631);
INSERT INTO `rixiaoliang` VALUES ('2017-11-26', 48506);
INSERT INTO `rixiaoliang` VALUES ('2017-11-27', 53171);
INSERT INTO `rixiaoliang` VALUES ('2017-11-28', 49957);
INSERT INTO `rixiaoliang` VALUES ('2017-11-29', 52216);
INSERT INTO `rixiaoliang` VALUES ('2017-11-30', 52429);
INSERT INTO `rixiaoliang` VALUES ('2017-12-01', 50200);
INSERT INTO `rixiaoliang` VALUES ('2017-12-02', 61376);
INSERT INTO `rixiaoliang` VALUES ('2017-12-03', 61384);

-- ----------------------------
-- Table structure for sys_data
-- ----------------------------
DROP TABLE IF EXISTS `sys_data`;
CREATE TABLE `sys_data`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `code` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NOT NULL COMMENT '代码',
  `codeDesc` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '代码描述',
  `type` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '类型代码',
  `typeDesc` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '类型描述',
  `status` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '状态 0-未生效 1-已生效',
  `orderNo` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '排序',
  `createDate` datetime(0) NULL DEFAULT NULL,
  `lastUpdAcct` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lastUpdTime` datetime(0) NULL DEFAULT NULL,
  `note` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `type`(`type`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 7 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_data
-- ----------------------------
INSERT INTO `sys_data` VALUES (1, '0', '未启用', 'STATUS_COMMON', '通用状态', '1', '1', '2016-09-28 11:00:18', 'admin', '2018-01-17 19:07:18', '修改数据字典');
INSERT INTO `sys_data` VALUES (2, '1', '启用', 'STATUS_COMMON', '通用状态', '1', '2', '2016-09-28 11:00:56', 'sys', '2016-09-28 11:00:18', '初始数据');
INSERT INTO `sys_data` VALUES (3, '0', '正常', 'STATUS_USER4S', '系统用户状态', '1', '1', '2016-09-28 11:20:03', 'sys', '2016-09-28 11:20:03', '添加数据字典');
INSERT INTO `sys_data` VALUES (4, '2', '冻结', 'STATUS_USER4S', '系统用户状态', '1', '2', '2016-09-28 11:20:38', 'sys', '2017-10-17 10:35:59', '启用数据');
INSERT INTO `sys_data` VALUES (5, '1', '菜单', 'TYPE_SYSTEM_RES', '资源类型1-菜单 2-功能', '1', '1', '2016-10-18 14:37:15', 'sys', '2016-10-18 14:37:15', '添加数据字典');
INSERT INTO `sys_data` VALUES (6, '2', '功能', 'TYPE_SYSTEM_RES', '资源类型1-菜单 2-功能', '1', '2', '2016-10-18 14:38:15', 'sys', '2016-10-18 14:38:15', '添加数据字典');

-- ----------------------------
-- Table structure for sys_log
-- ----------------------------
DROP TABLE IF EXISTS `sys_log`;
CREATE TABLE `sys_log`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `uid` bigint(20) NULL DEFAULT NULL,
  `browser` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `operation` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT 'GET/POST',
  `from` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '来源 url',
  `ip` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `createDate` datetime(0) NULL DEFAULT NULL,
  `status` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '1' COMMENT '1-记录',
  `lastUpdAcct` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lastUpdTime` datetime(0) NULL DEFAULT NULL,
  `note` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `FK_sys_EVENT`(`uid`) USING BTREE,
  CONSTRAINT `sys_log_ibfk_1` FOREIGN KEY (`uid`) REFERENCES `sys_user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE = InnoDB AUTO_INCREMENT = 9158 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_log
-- ----------------------------
INSERT INTO `sys_log` VALUES (1, NULL, 'Chrome', 'GET', NULL, '127.0.0.1', '/login', '2018-01-15 17:53:30', '1', 'guest', '2018-01-15 17:53:30', '记录日志');
INSERT INTO `sys_log` VALUES (742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-11-18 11:17:57', '1', 'admin', '2021-11-18 11:17:57', '记录日志');
INSERT INTO `sys_log` VALUES (743, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-11-18 11:17:57', '1', 'admin', '2021-11-18 11:17:57', '记录日志');
INSERT INTO `sys_log` VALUES (744, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-11-18 11:17:59', '1', 'admin', '2021-11-18 11:17:59', '记录日志');
INSERT INTO `sys_log` VALUES (745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-11-18 11:17:59', '1', 'admin', '2021-11-18 11:17:59', '记录日志');
INSERT INTO `sys_log` VALUES (746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-11-18 11:17:59', '1', 'admin', '2021-11-18 11:17:59', '记录日志');
INSERT INTO `sys_log` VALUES (747, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-11-18 11:18:14', '1', 'admin', '2021-11-18 11:18:14', '记录日志');
INSERT INTO `sys_log` VALUES (748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-11-18 11:18:14', '1', 'admin', '2021-11-18 11:18:14', '记录日志');
INSERT INTO `sys_log` VALUES (749, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-11-18 11:18:17', '1', 'admin', '2021-11-18 11:18:17', '记录日志');
INSERT INTO `sys_log` VALUES (750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-11-18 11:18:17', '1', 'admin', '2021-11-18 11:18:17', '记录日志');
INSERT INTO `sys_log` VALUES (751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-11-18 11:18:19', '1', 'admin', '2021-11-18 11:18:19', '记录日志');
INSERT INTO `sys_log` VALUES (752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-11-18 11:18:20', '1', 'admin', '2021-11-18 11:18:20', '记录日志');
INSERT INTO `sys_log` VALUES (753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-11-18 11:18:21', '1', 'admin', '2021-11-18 11:18:21', '记录日志');
INSERT INTO `sys_log` VALUES (754, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-11-18 11:18:21', '1', 'admin', '2021-11-18 11:18:21', '记录日志');
INSERT INTO `sys_log` VALUES (755, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-11-25 10:20:18', '1', 'admin', '2021-11-25 10:20:18', '记录日志');
INSERT INTO `sys_log` VALUES (756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-11-25 10:20:18', '1', 'admin', '2021-11-25 10:20:18', '记录日志');
INSERT INTO `sys_log` VALUES (757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-11-25 10:20:21', '1', 'admin', '2021-11-25 10:20:21', '记录日志');
INSERT INTO `sys_log` VALUES (758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-11-25 10:20:21', '1', 'admin', '2021-11-25 10:20:21', '记录日志');
INSERT INTO `sys_log` VALUES (759, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-11-25 10:20:21', '1', 'admin', '2021-11-25 10:20:21', '记录日志');
INSERT INTO `sys_log` VALUES (760, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-11-25 10:20:22', '1', 'admin', '2021-11-25 10:20:22', '记录日志');
INSERT INTO `sys_log` VALUES (761, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-11-25 10:20:22', '1', 'admin', '2021-11-25 10:20:22', '记录日志');
INSERT INTO `sys_log` VALUES (762, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-11-25 10:20:24', '1', 'admin', '2021-11-25 10:20:24', '记录日志');
INSERT INTO `sys_log` VALUES (763, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-11-25 10:20:24', '1', 'admin', '2021-11-25 10:20:24', '记录日志');
INSERT INTO `sys_log` VALUES (764, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 11:24:48', '1', 'admin', '2021-12-03 11:24:48', '记录日志');
INSERT INTO `sys_log` VALUES (765, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 11:24:48', '1', 'admin', '2021-12-03 11:24:48', '记录日志');
INSERT INTO `sys_log` VALUES (766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 11:24:50', '1', 'admin', '2021-12-03 11:24:50', '记录日志');
INSERT INTO `sys_log` VALUES (767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:24:50', '1', 'admin', '2021-12-03 11:24:50', '记录日志');
INSERT INTO `sys_log` VALUES (768, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:24:50', '1', 'admin', '2021-12-03 11:24:50', '记录日志');
INSERT INTO `sys_log` VALUES (769, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:24:52', '1', 'admin', '2021-12-03 11:24:52', '记录日志');
INSERT INTO `sys_log` VALUES (770, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:24:53', '1', 'admin', '2021-12-03 11:24:53', '记录日志');
INSERT INTO `sys_log` VALUES (771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 11:24:54', '1', 'admin', '2021-12-03 11:24:54', '记录日志');
INSERT INTO `sys_log` VALUES (772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 11:24:55', '1', 'admin', '2021-12-03 11:24:55', '记录日志');
INSERT INTO `sys_log` VALUES (773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 11:24:56', '1', 'admin', '2021-12-03 11:24:56', '记录日志');
INSERT INTO `sys_log` VALUES (774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 11:24:56', '1', 'admin', '2021-12-03 11:24:56', '记录日志');
INSERT INTO `sys_log` VALUES (775, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-03 11:25:01', '1', 'admin', '2021-12-03 11:25:01', '记录日志');
INSERT INTO `sys_log` VALUES (776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 11:25:01', '1', 'admin', '2021-12-03 11:25:01', '记录日志');
INSERT INTO `sys_log` VALUES (777, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-03 11:25:02', '1', 'admin', '2021-12-03 11:25:02', '记录日志');
INSERT INTO `sys_log` VALUES (778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-03 11:25:02', '1', 'admin', '2021-12-03 11:25:02', '记录日志');
INSERT INTO `sys_log` VALUES (779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-03 11:25:04', '1', 'admin', '2021-12-03 11:25:04', '记录日志');
INSERT INTO `sys_log` VALUES (780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2021-12-03 11:25:06', '1', 'admin', '2021-12-03 11:25:06', '记录日志');
INSERT INTO `sys_log` VALUES (781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:25:20', '1', 'admin', '2021-12-03 11:25:20', '记录日志');
INSERT INTO `sys_log` VALUES (782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 11:25:23', '1', 'admin', '2021-12-03 11:25:23', '记录日志');
INSERT INTO `sys_log` VALUES (783, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:25:34', '1', 'admin', '2021-12-03 11:25:34', '记录日志');
INSERT INTO `sys_log` VALUES (784, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:25:34', '1', 'admin', '2021-12-03 11:25:34', '记录日志');
INSERT INTO `sys_log` VALUES (785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:25:35', '1', 'admin', '2021-12-03 11:25:35', '记录日志');
INSERT INTO `sys_log` VALUES (786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 11:25:48', '1', 'admin', '2021-12-03 11:25:48', '记录日志');
INSERT INTO `sys_log` VALUES (787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 11:27:56', '1', 'admin', '2021-12-03 11:27:56', '记录日志');
INSERT INTO `sys_log` VALUES (788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 11:27:56', '1', 'admin', '2021-12-03 11:27:56', '记录日志');
INSERT INTO `sys_log` VALUES (789, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 11:27:59', '1', 'admin', '2021-12-03 11:27:59', '记录日志');
INSERT INTO `sys_log` VALUES (790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 11:28:01', '1', 'admin', '2021-12-03 11:28:01', '记录日志');
INSERT INTO `sys_log` VALUES (791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 11:28:02', '1', 'admin', '2021-12-03 11:28:02', '记录日志');
INSERT INTO `sys_log` VALUES (792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 11:28:02', '1', 'admin', '2021-12-03 11:28:02', '记录日志');
INSERT INTO `sys_log` VALUES (793, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 11:28:03', '1', 'admin', '2021-12-03 11:28:03', '记录日志');
INSERT INTO `sys_log` VALUES (794, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:28:03', '1', 'admin', '2021-12-03 11:28:03', '记录日志');
INSERT INTO `sys_log` VALUES (795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:03', '1', 'admin', '2021-12-03 11:28:03', '记录日志');
INSERT INTO `sys_log` VALUES (796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:07', '1', 'admin', '2021-12-03 11:28:07', '记录日志');
INSERT INTO `sys_log` VALUES (797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:08', '1', 'admin', '2021-12-03 11:28:08', '记录日志');
INSERT INTO `sys_log` VALUES (798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:09', '1', 'admin', '2021-12-03 11:28:09', '记录日志');
INSERT INTO `sys_log` VALUES (799, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:09', '1', 'admin', '2021-12-03 11:28:09', '记录日志');
INSERT INTO `sys_log` VALUES (800, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:10', '1', 'admin', '2021-12-03 11:28:10', '记录日志');
INSERT INTO `sys_log` VALUES (801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:10', '1', 'admin', '2021-12-03 11:28:10', '记录日志');
INSERT INTO `sys_log` VALUES (802, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:11', '1', 'admin', '2021-12-03 11:28:11', '记录日志');
INSERT INTO `sys_log` VALUES (803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:11', '1', 'admin', '2021-12-03 11:28:11', '记录日志');
INSERT INTO `sys_log` VALUES (804, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:13', '1', 'admin', '2021-12-03 11:28:13', '记录日志');
INSERT INTO `sys_log` VALUES (805, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:16', '1', 'admin', '2021-12-03 11:28:16', '记录日志');
INSERT INTO `sys_log` VALUES (806, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:17', '1', 'admin', '2021-12-03 11:28:17', '记录日志');
INSERT INTO `sys_log` VALUES (807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:18', '1', 'admin', '2021-12-03 11:28:18', '记录日志');
INSERT INTO `sys_log` VALUES (808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:18', '1', 'admin', '2021-12-03 11:28:18', '记录日志');
INSERT INTO `sys_log` VALUES (809, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:19', '1', 'admin', '2021-12-03 11:28:19', '记录日志');
INSERT INTO `sys_log` VALUES (810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:24', '1', 'admin', '2021-12-03 11:28:24', '记录日志');
INSERT INTO `sys_log` VALUES (811, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:26', '1', 'admin', '2021-12-03 11:28:26', '记录日志');
INSERT INTO `sys_log` VALUES (812, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:27', '1', 'admin', '2021-12-03 11:28:27', '记录日志');
INSERT INTO `sys_log` VALUES (813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:29', '1', 'admin', '2021-12-03 11:28:29', '记录日志');
INSERT INTO `sys_log` VALUES (814, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:32', '1', 'admin', '2021-12-03 11:28:32', '记录日志');
INSERT INTO `sys_log` VALUES (815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:33', '1', 'admin', '2021-12-03 11:28:33', '记录日志');
INSERT INTO `sys_log` VALUES (816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 11:28:35', '1', 'admin', '2021-12-03 11:28:35', '记录日志');
INSERT INTO `sys_log` VALUES (817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:44', '1', 'admin', '2021-12-03 11:28:44', '记录日志');
INSERT INTO `sys_log` VALUES (818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:28:44', '1', 'admin', '2021-12-03 11:28:44', '记录日志');
INSERT INTO `sys_log` VALUES (819, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2021-12-03 11:28:48', '1', 'admin', '2021-12-03 11:28:48', '记录日志');
INSERT INTO `sys_log` VALUES (820, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:48', '1', 'admin', '2021-12-03 11:28:48', '记录日志');
INSERT INTO `sys_log` VALUES (821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:28:48', '1', 'admin', '2021-12-03 11:28:48', '记录日志');
INSERT INTO `sys_log` VALUES (822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 11:28:52', '1', 'admin', '2021-12-03 11:28:52', '记录日志');
INSERT INTO `sys_log` VALUES (823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 11:28:52', '1', 'admin', '2021-12-03 11:28:52', '记录日志');
INSERT INTO `sys_log` VALUES (824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 11:28:55', '1', 'admin', '2021-12-03 11:28:55', '记录日志');
INSERT INTO `sys_log` VALUES (825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:28:55', '1', 'admin', '2021-12-03 11:28:55', '记录日志');
INSERT INTO `sys_log` VALUES (826, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:28:55', '1', 'admin', '2021-12-03 11:28:55', '记录日志');
INSERT INTO `sys_log` VALUES (827, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:29:01', '1', 'admin', '2021-12-03 11:29:01', '记录日志');
INSERT INTO `sys_log` VALUES (828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 11:29:02', '1', 'admin', '2021-12-03 11:29:02', '记录日志');
INSERT INTO `sys_log` VALUES (829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 11:52:48', '1', 'admin', '2021-12-03 11:52:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 11:52:48', '1', 'admin', '2021-12-03 11:52:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (831, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 11:52:55', '1', 'admin', '2021-12-03 11:52:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:52:55', '1', 'admin', '2021-12-03 11:52:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (833, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:52:55', '1', 'admin', '2021-12-03 11:52:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 11:53:40', '1', 'admin', '2021-12-03 11:53:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (835, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 11:53:40', '1', 'admin', '2021-12-03 11:53:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (836, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 11:53:44', '1', 'admin', '2021-12-03 11:53:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (837, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 11:53:44', '1', 'admin', '2021-12-03 11:53:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 11:53:44', '1', 'admin', '2021-12-03 11:53:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 11:54:05', '1', 'admin', '2021-12-03 11:54:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (840, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 11:54:06', '1', 'admin', '2021-12-03 11:54:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (841, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 12:08:06', '1', 'admin', '2021-12-03 12:08:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (842, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 12:08:07', '1', 'admin', '2021-12-03 12:08:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 12:17:06', '1', 'admin', '2021-12-03 12:17:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 12:17:06', '1', 'admin', '2021-12-03 12:17:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 12:17:06', '1', 'admin', '2021-12-03 12:17:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (846, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 12:17:15', '1', 'admin', '2021-12-03 12:17:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (847, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 12:17:15', '1', 'admin', '2021-12-03 12:17:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 12:18:08', '1', 'admin', '2021-12-03 12:18:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 12:18:08', '1', 'admin', '2021-12-03 12:18:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (850, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 12:18:08', '1', 'admin', '2021-12-03 12:18:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 12:18:11', '1', 'admin', '2021-12-03 12:18:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 12:18:11', '1', 'admin', '2021-12-03 12:18:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 12:19:24', '1', 'admin', '2021-12-03 12:19:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (854, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 12:19:24', '1', 'admin', '2021-12-03 12:19:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 12:20:22', '1', 'admin', '2021-12-03 12:20:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (856, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 12:20:22', '1', 'admin', '2021-12-03 12:20:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (857, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 12:59:32', '1', 'admin', '2021-12-03 12:59:32', '记录日志');
INSERT INTO `sys_log` VALUES (858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 12:59:32', '1', 'admin', '2021-12-03 12:59:32', '记录日志');
INSERT INTO `sys_log` VALUES (859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 13:00:28', '1', 'admin', '2021-12-03 13:00:28', '记录日志');
INSERT INTO `sys_log` VALUES (860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 13:00:28', '1', 'admin', '2021-12-03 13:00:28', '记录日志');
INSERT INTO `sys_log` VALUES (861, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 13:01:15', '1', 'admin', '2021-12-03 13:01:15', '记录日志');
INSERT INTO `sys_log` VALUES (862, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 13:01:15', '1', 'admin', '2021-12-03 13:01:15', '记录日志');
INSERT INTO `sys_log` VALUES (863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 13:03:45', '1', 'admin', '2021-12-03 13:03:45', '记录日志');
INSERT INTO `sys_log` VALUES (864, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 13:03:45', '1', 'admin', '2021-12-03 13:03:45', '记录日志');
INSERT INTO `sys_log` VALUES (865, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 13:05:21', '1', 'admin', '2021-12-03 13:05:21', '记录日志');
INSERT INTO `sys_log` VALUES (866, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 13:05:21', '1', 'admin', '2021-12-03 13:05:21', '记录日志');
INSERT INTO `sys_log` VALUES (867, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 14:39:10', '1', 'admin', '2021-12-03 14:39:10', '记录日志');
INSERT INTO `sys_log` VALUES (868, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 14:39:10', '1', 'admin', '2021-12-03 14:39:10', '记录日志');
INSERT INTO `sys_log` VALUES (869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 14:39:56', '1', 'admin', '2021-12-03 14:39:56', '记录日志');
INSERT INTO `sys_log` VALUES (870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 14:39:56', '1', 'admin', '2021-12-03 14:39:56', '记录日志');
INSERT INTO `sys_log` VALUES (871, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 14:39:56', '1', 'admin', '2021-12-03 14:39:56', '记录日志');
INSERT INTO `sys_log` VALUES (872, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 14:40:08', '1', 'admin', '2021-12-03 14:40:08', '记录日志');
INSERT INTO `sys_log` VALUES (873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 14:41:55', '1', 'admin', '2021-12-03 14:41:55', '记录日志');
INSERT INTO `sys_log` VALUES (874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 14:41:55', '1', 'admin', '2021-12-03 14:41:55', '记录日志');
INSERT INTO `sys_log` VALUES (875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 14:42:35', '1', 'admin', '2021-12-03 14:42:35', '记录日志');
INSERT INTO `sys_log` VALUES (876, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 14:42:56', '1', 'admin', '2021-12-03 14:42:56', '记录日志');
INSERT INTO `sys_log` VALUES (877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 14:42:56', '1', 'admin', '2021-12-03 14:42:56', '记录日志');
INSERT INTO `sys_log` VALUES (878, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 14:42:57', '1', 'admin', '2021-12-03 14:42:57', '记录日志');
INSERT INTO `sys_log` VALUES (879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 14:42:59', '1', 'admin', '2021-12-03 14:42:59', '记录日志');
INSERT INTO `sys_log` VALUES (880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 14:42:59', '1', 'admin', '2021-12-03 14:42:59', '记录日志');
INSERT INTO `sys_log` VALUES (881, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 14:43:02', '1', 'admin', '2021-12-03 14:43:02', '记录日志');
INSERT INTO `sys_log` VALUES (882, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 14:43:03', '1', 'admin', '2021-12-03 14:43:03', '记录日志');
INSERT INTO `sys_log` VALUES (883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 14:43:03', '1', 'admin', '2021-12-03 14:43:03', '记录日志');
INSERT INTO `sys_log` VALUES (884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 14:43:17', '1', 'admin', '2021-12-03 14:43:17', '记录日志');
INSERT INTO `sys_log` VALUES (885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 14:43:17', '1', 'admin', '2021-12-03 14:43:17', '记录日志');
INSERT INTO `sys_log` VALUES (886, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 14:43:18', '1', 'admin', '2021-12-03 14:43:18', '记录日志');
INSERT INTO `sys_log` VALUES (887, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 14:43:22', '1', 'admin', '2021-12-03 14:43:22', '记录日志');
INSERT INTO `sys_log` VALUES (888, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 14:43:49', '1', 'admin', '2021-12-03 14:43:49', '记录日志');
INSERT INTO `sys_log` VALUES (889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 14:46:08', '1', 'admin', '2021-12-03 14:46:08', '记录日志');
INSERT INTO `sys_log` VALUES (890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 14:46:08', '1', 'admin', '2021-12-03 14:46:08', '记录日志');
INSERT INTO `sys_log` VALUES (891, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 14:46:10', '1', 'admin', '2021-12-03 14:46:10', '记录日志');
INSERT INTO `sys_log` VALUES (892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 14:46:10', '1', 'admin', '2021-12-03 14:46:10', '记录日志');
INSERT INTO `sys_log` VALUES (893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 14:46:10', '1', 'admin', '2021-12-03 14:46:10', '记录日志');
INSERT INTO `sys_log` VALUES (894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 14:46:11', '1', 'admin', '2021-12-03 14:46:11', '记录日志');
INSERT INTO `sys_log` VALUES (895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 14:46:17', '1', 'admin', '2021-12-03 14:46:17', '记录日志');
INSERT INTO `sys_log` VALUES (896, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 14:46:17', '1', 'admin', '2021-12-03 14:46:17', '记录日志');
INSERT INTO `sys_log` VALUES (897, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 14:46:53', '1', 'admin', '2021-12-03 14:46:53', '记录日志');
INSERT INTO `sys_log` VALUES (898, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 14:46:53', '1', 'admin', '2021-12-03 14:46:53', '记录日志');
INSERT INTO `sys_log` VALUES (899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 14:46:54', '1', 'admin', '2021-12-03 14:46:54', '记录日志');
INSERT INTO `sys_log` VALUES (900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 14:58:19', '1', 'admin', '2021-12-03 14:58:19', '记录日志');
INSERT INTO `sys_log` VALUES (901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 14:58:20', '1', 'admin', '2021-12-03 14:58:20', '记录日志');
INSERT INTO `sys_log` VALUES (902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 14:58:20', '1', 'admin', '2021-12-03 14:58:20', '记录日志');
INSERT INTO `sys_log` VALUES (903, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-03 14:58:22', '1', 'admin', '2021-12-03 14:58:22', '记录日志');
INSERT INTO `sys_log` VALUES (904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 14:58:28', '1', 'admin', '2021-12-03 14:58:28', '记录日志');
INSERT INTO `sys_log` VALUES (905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-03 14:58:31', '1', 'admin', '2021-12-03 14:58:31', '记录日志');
INSERT INTO `sys_log` VALUES (906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 14:58:31', '1', 'admin', '2021-12-03 14:58:31', '记录日志');
INSERT INTO `sys_log` VALUES (907, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2021-12-03 14:58:32', '1', 'admin', '2021-12-03 14:58:32', '记录日志');
INSERT INTO `sys_log` VALUES (908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 14:58:34', '1', 'admin', '2021-12-03 14:58:34', '记录日志');
INSERT INTO `sys_log` VALUES (909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2021-12-03 14:58:42', '1', 'admin', '2021-12-03 14:58:42', '记录日志');
INSERT INTO `sys_log` VALUES (910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:03:13', '1', 'admin', '2021-12-03 15:03:13', '记录日志');
INSERT INTO `sys_log` VALUES (911, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2021-12-03 15:03:16', '1', 'admin', '2021-12-03 15:03:16', '记录日志');
INSERT INTO `sys_log` VALUES (912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:03:21', '1', 'admin', '2021-12-03 15:03:21', '记录日志');
INSERT INTO `sys_log` VALUES (913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-03 15:03:21', '1', 'admin', '2021-12-03 15:03:21', '记录日志');
INSERT INTO `sys_log` VALUES (914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-03 15:03:21', '1', 'admin', '2021-12-03 15:03:21', '记录日志');
INSERT INTO `sys_log` VALUES (915, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-03 15:03:24', '1', 'admin', '2021-12-03 15:03:24', '记录日志');
INSERT INTO `sys_log` VALUES (916, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2021-12-03 15:03:26', '1', 'admin', '2021-12-03 15:03:26', '记录日志');
INSERT INTO `sys_log` VALUES (917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-03 15:03:29', '1', 'admin', '2021-12-03 15:03:29', '记录日志');
INSERT INTO `sys_log` VALUES (918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:03:30', '1', 'admin', '2021-12-03 15:03:30', '记录日志');
INSERT INTO `sys_log` VALUES (919, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2021-12-03 15:03:31', '1', 'admin', '2021-12-03 15:03:31', '记录日志');
INSERT INTO `sys_log` VALUES (920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:03:39', '1', 'admin', '2021-12-03 15:03:39', '记录日志');
INSERT INTO `sys_log` VALUES (921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-03 15:04:09', '1', 'admin', '2021-12-03 15:04:09', '记录日志');
INSERT INTO `sys_log` VALUES (922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:05:10', '1', 'admin', '2021-12-03 15:05:10', '记录日志');
INSERT INTO `sys_log` VALUES (923, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:05:10', '1', 'admin', '2021-12-03 15:05:10', '记录日志');
INSERT INTO `sys_log` VALUES (924, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 15:05:12', '1', 'admin', '2021-12-03 15:05:12', '记录日志');
INSERT INTO `sys_log` VALUES (925, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:05:12', '1', 'admin', '2021-12-03 15:05:12', '记录日志');
INSERT INTO `sys_log` VALUES (926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:05:13', '1', 'admin', '2021-12-03 15:05:13', '记录日志');
INSERT INTO `sys_log` VALUES (927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:05:13', '1', 'admin', '2021-12-03 15:05:13', '记录日志');
INSERT INTO `sys_log` VALUES (928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:05:14', '1', 'admin', '2021-12-03 15:05:14', '记录日志');
INSERT INTO `sys_log` VALUES (929, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:05:20', '1', 'admin', '2021-12-03 15:05:20', '记录日志');
INSERT INTO `sys_log` VALUES (930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:05:48', '1', 'admin', '2021-12-03 15:05:48', '记录日志');
INSERT INTO `sys_log` VALUES (931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:05:48', '1', 'admin', '2021-12-03 15:05:48', '记录日志');
INSERT INTO `sys_log` VALUES (932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:05:52', '1', 'admin', '2021-12-03 15:05:52', '记录日志');
INSERT INTO `sys_log` VALUES (933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:05:52', '1', 'admin', '2021-12-03 15:05:52', '记录日志');
INSERT INTO `sys_log` VALUES (934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:05:52', '1', 'admin', '2021-12-03 15:05:52', '记录日志');
INSERT INTO `sys_log` VALUES (935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:05:54', '1', 'admin', '2021-12-03 15:05:54', '记录日志');
INSERT INTO `sys_log` VALUES (936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:10:32', '1', 'admin', '2021-12-03 15:10:32', '记录日志');
INSERT INTO `sys_log` VALUES (937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:10:32', '1', 'admin', '2021-12-03 15:10:32', '记录日志');
INSERT INTO `sys_log` VALUES (938, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:10:37', '1', 'admin', '2021-12-03 15:10:37', '记录日志');
INSERT INTO `sys_log` VALUES (939, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:11:22', '1', 'admin', '2021-12-03 15:11:22', '记录日志');
INSERT INTO `sys_log` VALUES (940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:11:22', '1', 'admin', '2021-12-03 15:11:22', '记录日志');
INSERT INTO `sys_log` VALUES (941, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:11:26', '1', 'admin', '2021-12-03 15:11:26', '记录日志');
INSERT INTO `sys_log` VALUES (942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:11:26', '1', 'admin', '2021-12-03 15:11:26', '记录日志');
INSERT INTO `sys_log` VALUES (943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:11:26', '1', 'admin', '2021-12-03 15:11:26', '记录日志');
INSERT INTO `sys_log` VALUES (944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:11:28', '1', 'admin', '2021-12-03 15:11:28', '记录日志');
INSERT INTO `sys_log` VALUES (945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:11:29', '1', 'admin', '2021-12-03 15:11:29', '记录日志');
INSERT INTO `sys_log` VALUES (946, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:11:29', '1', 'admin', '2021-12-03 15:11:29', '记录日志');
INSERT INTO `sys_log` VALUES (947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:11:29', '1', 'admin', '2021-12-03 15:11:29', '记录日志');
INSERT INTO `sys_log` VALUES (948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:11:30', '1', 'admin', '2021-12-03 15:11:30', '记录日志');
INSERT INTO `sys_log` VALUES (949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:11:32', '1', 'admin', '2021-12-03 15:11:32', '记录日志');
INSERT INTO `sys_log` VALUES (950, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:11:32', '1', 'admin', '2021-12-03 15:11:32', '记录日志');
INSERT INTO `sys_log` VALUES (951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:12:02', '1', 'admin', '2021-12-03 15:12:02', '记录日志');
INSERT INTO `sys_log` VALUES (952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:12:02', '1', 'admin', '2021-12-03 15:12:02', '记录日志');
INSERT INTO `sys_log` VALUES (953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:12:03', '1', 'admin', '2021-12-03 15:12:03', '记录日志');
INSERT INTO `sys_log` VALUES (954, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:12:03', '1', 'admin', '2021-12-03 15:12:03', '记录日志');
INSERT INTO `sys_log` VALUES (955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:12:03', '1', 'admin', '2021-12-03 15:12:03', '记录日志');
INSERT INTO `sys_log` VALUES (956, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:12:04', '1', 'admin', '2021-12-03 15:12:04', '记录日志');
INSERT INTO `sys_log` VALUES (957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:12:07', '1', 'admin', '2021-12-03 15:12:07', '记录日志');
INSERT INTO `sys_log` VALUES (958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:12:07', '1', 'admin', '2021-12-03 15:12:07', '记录日志');
INSERT INTO `sys_log` VALUES (959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:12:08', '1', 'admin', '2021-12-03 15:12:08', '记录日志');
INSERT INTO `sys_log` VALUES (960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:12:08', '1', 'admin', '2021-12-03 15:12:08', '记录日志');
INSERT INTO `sys_log` VALUES (961, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:12:09', '1', 'admin', '2021-12-03 15:12:09', '记录日志');
INSERT INTO `sys_log` VALUES (962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:12:11', '1', 'admin', '2021-12-03 15:12:11', '记录日志');
INSERT INTO `sys_log` VALUES (963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 15:12:11', '1', 'admin', '2021-12-03 15:12:11', '记录日志');
INSERT INTO `sys_log` VALUES (964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:12:12', '1', 'admin', '2021-12-03 15:12:12', '记录日志');
INSERT INTO `sys_log` VALUES (965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-03 15:12:12', '1', 'admin', '2021-12-03 15:12:12', '记录日志');
INSERT INTO `sys_log` VALUES (966, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:12:14', '1', 'admin', '2021-12-03 15:12:14', '记录日志');
INSERT INTO `sys_log` VALUES (967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-03 15:12:15', '1', 'admin', '2021-12-03 15:12:15', '记录日志');
INSERT INTO `sys_log` VALUES (968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:12:15', '1', 'admin', '2021-12-03 15:12:15', '记录日志');
INSERT INTO `sys_log` VALUES (969, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2021-12-03 15:12:16', '1', 'admin', '2021-12-03 15:12:16', '记录日志');
INSERT INTO `sys_log` VALUES (970, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:12:18', '1', 'admin', '2021-12-03 15:12:18', '记录日志');
INSERT INTO `sys_log` VALUES (971, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-03 15:13:16', '1', 'admin', '2021-12-03 15:13:16', '记录日志');
INSERT INTO `sys_log` VALUES (972, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:13:18', '1', 'admin', '2021-12-03 15:13:18', '记录日志');
INSERT INTO `sys_log` VALUES (973, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-03 15:13:22', '1', 'admin', '2021-12-03 15:13:22', '记录日志');
INSERT INTO `sys_log` VALUES (974, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:13:26', '1', 'admin', '2021-12-03 15:13:26', '记录日志');
INSERT INTO `sys_log` VALUES (975, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:13:29', '1', 'admin', '2021-12-03 15:13:29', '记录日志');
INSERT INTO `sys_log` VALUES (976, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:15:08', '1', 'admin', '2021-12-03 15:15:08', '记录日志');
INSERT INTO `sys_log` VALUES (977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:15:08', '1', 'admin', '2021-12-03 15:15:08', '记录日志');
INSERT INTO `sys_log` VALUES (978, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:15:09', '1', 'admin', '2021-12-03 15:15:09', '记录日志');
INSERT INTO `sys_log` VALUES (979, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:15:09', '1', 'admin', '2021-12-03 15:15:09', '记录日志');
INSERT INTO `sys_log` VALUES (980, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:15:09', '1', 'admin', '2021-12-03 15:15:09', '记录日志');
INSERT INTO `sys_log` VALUES (981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:15:10', '1', 'admin', '2021-12-03 15:15:10', '记录日志');
INSERT INTO `sys_log` VALUES (982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:15:25', '1', 'admin', '2021-12-03 15:15:25', '记录日志');
INSERT INTO `sys_log` VALUES (983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:15:25', '1', 'admin', '2021-12-03 15:15:25', '记录日志');
INSERT INTO `sys_log` VALUES (984, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-03 15:15:32', '1', 'admin', '2021-12-03 15:15:32', '记录日志');
INSERT INTO `sys_log` VALUES (985, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:15:32', '1', 'admin', '2021-12-03 15:15:32', '记录日志');
INSERT INTO `sys_log` VALUES (986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2021-12-03 15:15:35', '1', 'admin', '2021-12-03 15:15:35', '记录日志');
INSERT INTO `sys_log` VALUES (987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:15:47', '1', 'admin', '2021-12-03 15:15:47', '记录日志');
INSERT INTO `sys_log` VALUES (988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:16:53', '1', 'admin', '2021-12-03 15:16:53', '记录日志');
INSERT INTO `sys_log` VALUES (989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:16:53', '1', 'admin', '2021-12-03 15:16:53', '记录日志');
INSERT INTO `sys_log` VALUES (990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:16:55', '1', 'admin', '2021-12-03 15:16:55', '记录日志');
INSERT INTO `sys_log` VALUES (991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:16:55', '1', 'admin', '2021-12-03 15:16:55', '记录日志');
INSERT INTO `sys_log` VALUES (992, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:16:55', '1', 'admin', '2021-12-03 15:16:55', '记录日志');
INSERT INTO `sys_log` VALUES (993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:16:56', '1', 'admin', '2021-12-03 15:16:56', '记录日志');
INSERT INTO `sys_log` VALUES (994, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:17:04', '1', 'admin', '2021-12-03 15:17:04', '记录日志');
INSERT INTO `sys_log` VALUES (995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:17:04', '1', 'admin', '2021-12-03 15:17:04', '记录日志');
INSERT INTO `sys_log` VALUES (996, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:17:26', '1', 'admin', '2021-12-03 15:17:26', '记录日志');
INSERT INTO `sys_log` VALUES (997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:17:26', '1', 'admin', '2021-12-03 15:17:26', '记录日志');
INSERT INTO `sys_log` VALUES (998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:17:27', '1', 'admin', '2021-12-03 15:17:27', '记录日志');
INSERT INTO `sys_log` VALUES (999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:17:29', '1', 'admin', '2021-12-03 15:17:29', '记录日志');
INSERT INTO `sys_log` VALUES (1000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:19:42', '1', 'admin', '2021-12-03 15:19:42', '记录日志');
INSERT INTO `sys_log` VALUES (1001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:19:42', '1', 'admin', '2021-12-03 15:19:42', '记录日志');
INSERT INTO `sys_log` VALUES (1002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:19:43', '1', 'admin', '2021-12-03 15:19:43', '记录日志');
INSERT INTO `sys_log` VALUES (1003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:19:43', '1', 'admin', '2021-12-03 15:19:43', '记录日志');
INSERT INTO `sys_log` VALUES (1004, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:19:43', '1', 'admin', '2021-12-03 15:19:43', '记录日志');
INSERT INTO `sys_log` VALUES (1005, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:19:44', '1', 'admin', '2021-12-03 15:19:44', '记录日志');
INSERT INTO `sys_log` VALUES (1006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:20:05', '1', 'admin', '2021-12-03 15:20:05', '记录日志');
INSERT INTO `sys_log` VALUES (1007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:20:05', '1', 'admin', '2021-12-03 15:20:05', '记录日志');
INSERT INTO `sys_log` VALUES (1008, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:22:27', '1', 'admin', '2021-12-03 15:22:27', '记录日志');
INSERT INTO `sys_log` VALUES (1009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:22:28', '1', 'admin', '2021-12-03 15:22:28', '记录日志');
INSERT INTO `sys_log` VALUES (1010, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/update', '2021-12-03 15:22:44', '1', 'admin', '2021-12-03 15:22:44', '记录日志');
INSERT INTO `sys_log` VALUES (1011, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:26:32', '1', 'admin', '2021-12-03 15:26:32', '记录日志');
INSERT INTO `sys_log` VALUES (1012, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:26:32', '1', 'admin', '2021-12-03 15:26:32', '记录日志');
INSERT INTO `sys_log` VALUES (1013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:26:34', '1', 'admin', '2021-12-03 15:26:34', '记录日志');
INSERT INTO `sys_log` VALUES (1014, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:26:34', '1', 'admin', '2021-12-03 15:26:34', '记录日志');
INSERT INTO `sys_log` VALUES (1015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:26:34', '1', 'admin', '2021-12-03 15:26:34', '记录日志');
INSERT INTO `sys_log` VALUES (1016, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:26:35', '1', 'admin', '2021-12-03 15:26:35', '记录日志');
INSERT INTO `sys_log` VALUES (1017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:28:19', '1', 'admin', '2021-12-03 15:28:19', '记录日志');
INSERT INTO `sys_log` VALUES (1018, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:28:19', '1', 'admin', '2021-12-03 15:28:19', '记录日志');
INSERT INTO `sys_log` VALUES (1019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:28:21', '1', 'admin', '2021-12-03 15:28:21', '记录日志');
INSERT INTO `sys_log` VALUES (1020, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:28:21', '1', 'admin', '2021-12-03 15:28:21', '记录日志');
INSERT INTO `sys_log` VALUES (1021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/update', '2021-12-03 15:28:22', '1', 'admin', '2021-12-03 15:28:22', '记录日志');
INSERT INTO `sys_log` VALUES (1022, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:28:40', '1', 'admin', '2021-12-03 15:28:40', '记录日志');
INSERT INTO `sys_log` VALUES (1023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:28:40', '1', 'admin', '2021-12-03 15:28:40', '记录日志');
INSERT INTO `sys_log` VALUES (1024, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:28:40', '1', 'admin', '2021-12-03 15:28:40', '记录日志');
INSERT INTO `sys_log` VALUES (1025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:28:44', '1', 'admin', '2021-12-03 15:28:44', '记录日志');
INSERT INTO `sys_log` VALUES (1026, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:29:21', '1', 'admin', '2021-12-03 15:29:21', '记录日志');
INSERT INTO `sys_log` VALUES (1027, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:29:21', '1', 'admin', '2021-12-03 15:29:21', '记录日志');
INSERT INTO `sys_log` VALUES (1028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:32:06', '1', 'admin', '2021-12-03 15:32:06', '记录日志');
INSERT INTO `sys_log` VALUES (1029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:32:06', '1', 'admin', '2021-12-03 15:32:06', '记录日志');
INSERT INTO `sys_log` VALUES (1030, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:32:07', '1', 'admin', '2021-12-03 15:32:07', '记录日志');
INSERT INTO `sys_log` VALUES (1031, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:32:07', '1', 'admin', '2021-12-03 15:32:07', '记录日志');
INSERT INTO `sys_log` VALUES (1032, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:32:07', '1', 'admin', '2021-12-03 15:32:07', '记录日志');
INSERT INTO `sys_log` VALUES (1033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:32:13', '1', 'admin', '2021-12-03 15:32:13', '记录日志');
INSERT INTO `sys_log` VALUES (1034, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:32:13', '1', 'admin', '2021-12-03 15:32:13', '记录日志');
INSERT INTO `sys_log` VALUES (1035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:33:05', '1', 'admin', '2021-12-03 15:33:05', '记录日志');
INSERT INTO `sys_log` VALUES (1036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:33:06', '1', 'admin', '2021-12-03 15:33:06', '记录日志');
INSERT INTO `sys_log` VALUES (1037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:33:09', '1', 'admin', '2021-12-03 15:33:09', '记录日志');
INSERT INTO `sys_log` VALUES (1038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:33:09', '1', 'admin', '2021-12-03 15:33:09', '记录日志');
INSERT INTO `sys_log` VALUES (1039, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:33:09', '1', 'admin', '2021-12-03 15:33:09', '记录日志');
INSERT INTO `sys_log` VALUES (1040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:33:12', '1', 'admin', '2021-12-03 15:33:12', '记录日志');
INSERT INTO `sys_log` VALUES (1041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:33:12', '1', 'admin', '2021-12-03 15:33:12', '记录日志');
INSERT INTO `sys_log` VALUES (1042, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-03 15:33:15', '1', 'admin', '2021-12-03 15:33:15', '记录日志');
INSERT INTO `sys_log` VALUES (1043, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:33:15', '1', 'admin', '2021-12-03 15:33:15', '记录日志');
INSERT INTO `sys_log` VALUES (1044, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2021-12-03 15:33:16', '1', 'admin', '2021-12-03 15:33:16', '记录日志');
INSERT INTO `sys_log` VALUES (1045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:34:06', '1', 'admin', '2021-12-03 15:34:06', '记录日志');
INSERT INTO `sys_log` VALUES (1046, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:34:07', '1', 'admin', '2021-12-03 15:34:07', '记录日志');
INSERT INTO `sys_log` VALUES (1047, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:34:07', '1', 'admin', '2021-12-03 15:34:07', '记录日志');
INSERT INTO `sys_log` VALUES (1048, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:34:09', '1', 'admin', '2021-12-03 15:34:09', '记录日志');
INSERT INTO `sys_log` VALUES (1049, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:34:09', '1', 'admin', '2021-12-03 15:34:09', '记录日志');
INSERT INTO `sys_log` VALUES (1050, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:34:09', '1', 'admin', '2021-12-03 15:34:09', '记录日志');
INSERT INTO `sys_log` VALUES (1051, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:34:26', '1', 'admin', '2021-12-03 15:34:26', '记录日志');
INSERT INTO `sys_log` VALUES (1052, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:34:26', '1', 'admin', '2021-12-03 15:34:26', '记录日志');
INSERT INTO `sys_log` VALUES (1053, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:35:09', '1', 'admin', '2021-12-03 15:35:09', '记录日志');
INSERT INTO `sys_log` VALUES (1054, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:35:09', '1', 'admin', '2021-12-03 15:35:09', '记录日志');
INSERT INTO `sys_log` VALUES (1055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:35:10', '1', 'admin', '2021-12-03 15:35:10', '记录日志');
INSERT INTO `sys_log` VALUES (1056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:35:10', '1', 'admin', '2021-12-03 15:35:10', '记录日志');
INSERT INTO `sys_log` VALUES (1057, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:35:10', '1', 'admin', '2021-12-03 15:35:10', '记录日志');
INSERT INTO `sys_log` VALUES (1058, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:35:12', '1', 'admin', '2021-12-03 15:35:12', '记录日志');
INSERT INTO `sys_log` VALUES (1059, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:35:19', '1', 'admin', '2021-12-03 15:35:19', '记录日志');
INSERT INTO `sys_log` VALUES (1060, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:35:19', '1', 'admin', '2021-12-03 15:35:19', '记录日志');
INSERT INTO `sys_log` VALUES (1061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:37:10', '1', 'admin', '2021-12-03 15:37:10', '记录日志');
INSERT INTO `sys_log` VALUES (1062, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:37:10', '1', 'admin', '2021-12-03 15:37:10', '记录日志');
INSERT INTO `sys_log` VALUES (1063, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:37:11', '1', 'admin', '2021-12-03 15:37:11', '记录日志');
INSERT INTO `sys_log` VALUES (1064, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:37:11', '1', 'admin', '2021-12-03 15:37:11', '记录日志');
INSERT INTO `sys_log` VALUES (1065, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:37:11', '1', 'admin', '2021-12-03 15:37:11', '记录日志');
INSERT INTO `sys_log` VALUES (1066, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:37:12', '1', 'admin', '2021-12-03 15:37:12', '记录日志');
INSERT INTO `sys_log` VALUES (1067, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:37:20', '1', 'admin', '2021-12-03 15:37:20', '记录日志');
INSERT INTO `sys_log` VALUES (1068, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:37:20', '1', 'admin', '2021-12-03 15:37:20', '记录日志');
INSERT INTO `sys_log` VALUES (1069, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:38:27', '1', 'admin', '2021-12-03 15:38:27', '记录日志');
INSERT INTO `sys_log` VALUES (1070, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:38:27', '1', 'admin', '2021-12-03 15:38:27', '记录日志');
INSERT INTO `sys_log` VALUES (1071, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:38:28', '1', 'admin', '2021-12-03 15:38:28', '记录日志');
INSERT INTO `sys_log` VALUES (1072, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:38:28', '1', 'admin', '2021-12-03 15:38:28', '记录日志');
INSERT INTO `sys_log` VALUES (1073, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:38:28', '1', 'admin', '2021-12-03 15:38:28', '记录日志');
INSERT INTO `sys_log` VALUES (1074, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/user/add', '2021-12-03 15:38:29', '1', 'admin', '2021-12-03 15:38:29', '记录日志');
INSERT INTO `sys_log` VALUES (1075, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:38:33', '1', 'admin', '2021-12-03 15:38:33', '记录日志');
INSERT INTO `sys_log` VALUES (1076, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:38:33', '1', 'admin', '2021-12-03 15:38:33', '记录日志');
INSERT INTO `sys_log` VALUES (1077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:39:01', '1', 'admin', '2021-12-03 15:39:01', '记录日志');
INSERT INTO `sys_log` VALUES (1078, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:39:01', '1', 'admin', '2021-12-03 15:39:01', '记录日志');
INSERT INTO `sys_log` VALUES (1079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:39:02', '1', 'admin', '2021-12-03 15:39:02', '记录日志');
INSERT INTO `sys_log` VALUES (1080, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:39:02', '1', 'admin', '2021-12-03 15:39:02', '记录日志');
INSERT INTO `sys_log` VALUES (1081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:39:02', '1', 'admin', '2021-12-03 15:39:02', '记录日志');
INSERT INTO `sys_log` VALUES (1082, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:39:03', '1', 'admin', '2021-12-03 15:39:03', '记录日志');
INSERT INTO `sys_log` VALUES (1083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:39:05', '1', 'admin', '2021-12-03 15:39:05', '记录日志');
INSERT INTO `sys_log` VALUES (1084, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:39:05', '1', 'admin', '2021-12-03 15:39:05', '记录日志');
INSERT INTO `sys_log` VALUES (1085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:44:16', '1', 'admin', '2021-12-03 15:44:16', '记录日志');
INSERT INTO `sys_log` VALUES (1086, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:44:16', '1', 'admin', '2021-12-03 15:44:16', '记录日志');
INSERT INTO `sys_log` VALUES (1087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:44:17', '1', 'admin', '2021-12-03 15:44:17', '记录日志');
INSERT INTO `sys_log` VALUES (1088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:44:17', '1', 'admin', '2021-12-03 15:44:17', '记录日志');
INSERT INTO `sys_log` VALUES (1089, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:44:17', '1', 'admin', '2021-12-03 15:44:17', '记录日志');
INSERT INTO `sys_log` VALUES (1090, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/adc', '2021-12-03 15:44:18', '1', 'admin', '2021-12-03 15:44:18', '记录日志');
INSERT INTO `sys_log` VALUES (1091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res/adc?pid=0', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:44:18', '1', 'admin', '2021-12-03 15:44:18', '记录日志');
INSERT INTO `sys_log` VALUES (1092, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res/adc?pid=0', '127.0.0.1', '/system/res/resData', '2021-12-03 15:44:18', '1', 'admin', '2021-12-03 15:44:18', '记录日志');
INSERT INTO `sys_log` VALUES (1093, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:44:25', '1', 'admin', '2021-12-03 15:44:25', '记录日志');
INSERT INTO `sys_log` VALUES (1094, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:44:25', '1', 'admin', '2021-12-03 15:44:25', '记录日志');
INSERT INTO `sys_log` VALUES (1095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/adc', '2021-12-03 15:44:26', '1', 'admin', '2021-12-03 15:44:26', '记录日志');
INSERT INTO `sys_log` VALUES (1096, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res/adc?pid=0', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:44:26', '1', 'admin', '2021-12-03 15:44:26', '记录日志');
INSERT INTO `sys_log` VALUES (1097, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res/adc?pid=0', '127.0.0.1', '/system/res/resData', '2021-12-03 15:44:26', '1', 'admin', '2021-12-03 15:44:26', '记录日志');
INSERT INTO `sys_log` VALUES (1098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res/adc?pid=0', '127.0.0.1', '/system/res/adc', '2021-12-03 15:44:28', '1', 'admin', '2021-12-03 15:44:28', '记录日志');
INSERT INTO `sys_log` VALUES (1099, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res/adc?pid=0', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:44:28', '1', 'admin', '2021-12-03 15:44:28', '记录日志');
INSERT INTO `sys_log` VALUES (1100, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res/adc?pid=0', '127.0.0.1', '/system/res/resData', '2021-12-03 15:44:28', '1', 'admin', '2021-12-03 15:44:28', '记录日志');
INSERT INTO `sys_log` VALUES (1101, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:44:30', '1', 'admin', '2021-12-03 15:44:30', '记录日志');
INSERT INTO `sys_log` VALUES (1102, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:44:30', '1', 'admin', '2021-12-03 15:44:30', '记录日志');
INSERT INTO `sys_log` VALUES (1103, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:45:45', '1', 'admin', '2021-12-03 15:45:45', '记录日志');
INSERT INTO `sys_log` VALUES (1104, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:45:45', '1', 'admin', '2021-12-03 15:45:45', '记录日志');
INSERT INTO `sys_log` VALUES (1105, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:45:46', '1', 'admin', '2021-12-03 15:45:46', '记录日志');
INSERT INTO `sys_log` VALUES (1106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:45:46', '1', 'admin', '2021-12-03 15:45:46', '记录日志');
INSERT INTO `sys_log` VALUES (1107, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:45:46', '1', 'admin', '2021-12-03 15:45:46', '记录日志');
INSERT INTO `sys_log` VALUES (1108, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:45:47', '1', 'admin', '2021-12-03 15:45:47', '记录日志');
INSERT INTO `sys_log` VALUES (1109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:45:49', '1', 'admin', '2021-12-03 15:45:49', '记录日志');
INSERT INTO `sys_log` VALUES (1110, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:45:49', '1', 'admin', '2021-12-03 15:45:49', '记录日志');
INSERT INTO `sys_log` VALUES (1111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:45:51', '1', 'admin', '2021-12-03 15:45:51', '记录日志');
INSERT INTO `sys_log` VALUES (1112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:45:51', '1', 'admin', '2021-12-03 15:45:51', '记录日志');
INSERT INTO `sys_log` VALUES (1113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:45:51', '1', 'admin', '2021-12-03 15:45:51', '记录日志');
INSERT INTO `sys_log` VALUES (1114, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:45:53', '1', 'admin', '2021-12-03 15:45:53', '记录日志');
INSERT INTO `sys_log` VALUES (1115, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 15:45:54', '1', 'admin', '2021-12-03 15:45:54', '记录日志');
INSERT INTO `sys_log` VALUES (1116, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:45:54', '1', 'admin', '2021-12-03 15:45:54', '记录日志');
INSERT INTO `sys_log` VALUES (1117, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/res/add', '2021-12-03 15:45:54', '1', 'admin', '2021-12-03 15:45:54', '记录日志');
INSERT INTO `sys_log` VALUES (1118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:45:58', '1', 'admin', '2021-12-03 15:45:58', '记录日志');
INSERT INTO `sys_log` VALUES (1119, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 15:47:51', '1', 'admin', '2021-12-03 15:47:51', '记录日志');
INSERT INTO `sys_log` VALUES (1120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 15:47:51', '1', 'admin', '2021-12-03 15:47:51', '记录日志');
INSERT INTO `sys_log` VALUES (1121, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 15:47:52', '1', 'admin', '2021-12-03 15:47:52', '记录日志');
INSERT INTO `sys_log` VALUES (1122, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:47:52', '1', 'admin', '2021-12-03 15:47:52', '记录日志');
INSERT INTO `sys_log` VALUES (1123, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:47:52', '1', 'admin', '2021-12-03 15:47:52', '记录日志');
INSERT INTO `sys_log` VALUES (1124, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:47:54', '1', 'admin', '2021-12-03 15:47:54', '记录日志');
INSERT INTO `sys_log` VALUES (1125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:47:56', '1', 'admin', '2021-12-03 15:47:56', '记录日志');
INSERT INTO `sys_log` VALUES (1126, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:47:56', '1', 'admin', '2021-12-03 15:47:56', '记录日志');
INSERT INTO `sys_log` VALUES (1127, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 15:49:08', '1', 'admin', '2021-12-03 15:49:08', '记录日志');
INSERT INTO `sys_log` VALUES (1128, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:49:08', '1', 'admin', '2021-12-03 15:49:08', '记录日志');
INSERT INTO `sys_log` VALUES (1129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 15:49:09', '1', 'admin', '2021-12-03 15:49:09', '记录日志');
INSERT INTO `sys_log` VALUES (1130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 15:49:11', '1', 'admin', '2021-12-03 15:49:11', '记录日志');
INSERT INTO `sys_log` VALUES (1131, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 15:49:12', '1', 'admin', '2021-12-03 15:49:12', '记录日志');
INSERT INTO `sys_log` VALUES (1132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:49:12', '1', 'admin', '2021-12-03 15:49:12', '记录日志');
INSERT INTO `sys_log` VALUES (1133, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-03 15:49:13', '1', 'admin', '2021-12-03 15:49:13', '记录日志');
INSERT INTO `sys_log` VALUES (1134, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:49:15', '1', 'admin', '2021-12-03 15:49:15', '记录日志');
INSERT INTO `sys_log` VALUES (1135, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2021-12-03 15:49:16', '1', 'admin', '2021-12-03 15:49:16', '记录日志');
INSERT INTO `sys_log` VALUES (1136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 15:49:17', '1', 'admin', '2021-12-03 15:49:17', '记录日志');
INSERT INTO `sys_log` VALUES (1137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-03 15:49:19', '1', 'admin', '2021-12-03 15:49:19', '记录日志');
INSERT INTO `sys_log` VALUES (1138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:49:19', '1', 'admin', '2021-12-03 15:49:19', '记录日志');
INSERT INTO `sys_log` VALUES (1139, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2021-12-03 15:49:20', '1', 'admin', '2021-12-03 15:49:20', '记录日志');
INSERT INTO `sys_log` VALUES (1140, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 15:51:53', '1', 'admin', '2021-12-03 15:51:53', '记录日志');
INSERT INTO `sys_log` VALUES (1141, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:52:49', '1', 'admin', '2021-12-03 15:52:49', '记录日志');
INSERT INTO `sys_log` VALUES (1142, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:54:55', '1', 'admin', '2021-12-03 15:54:55', '记录日志');
INSERT INTO `sys_log` VALUES (1143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:54:55', '1', 'admin', '2021-12-03 15:54:55', '记录日志');
INSERT INTO `sys_log` VALUES (1144, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 15:57:33', '1', 'admin', '2021-12-03 15:57:33', '记录日志');
INSERT INTO `sys_log` VALUES (1145, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 15:57:59', '1', 'admin', '2021-12-03 15:57:59', '记录日志');
INSERT INTO `sys_log` VALUES (1146, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 15:57:59', '1', 'admin', '2021-12-03 15:57:59', '记录日志');
INSERT INTO `sys_log` VALUES (1147, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:05:44', '1', 'admin', '2021-12-03 16:05:44', '记录日志');
INSERT INTO `sys_log` VALUES (1148, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:05:45', '1', 'admin', '2021-12-03 16:05:45', '记录日志');
INSERT INTO `sys_log` VALUES (1149, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:05:46', '1', 'admin', '2021-12-03 16:05:46', '记录日志');
INSERT INTO `sys_log` VALUES (1150, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:05:46', '1', 'admin', '2021-12-03 16:05:46', '记录日志');
INSERT INTO `sys_log` VALUES (1151, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:05:46', '1', 'admin', '2021-12-03 16:05:46', '记录日志');
INSERT INTO `sys_log` VALUES (1152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 16:05:47', '1', 'admin', '2021-12-03 16:05:47', '记录日志');
INSERT INTO `sys_log` VALUES (1153, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:05:51', '1', 'admin', '2021-12-03 16:05:51', '记录日志');
INSERT INTO `sys_log` VALUES (1154, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:05:51', '1', 'admin', '2021-12-03 16:05:51', '记录日志');
INSERT INTO `sys_log` VALUES (1155, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 16:06:29', '1', 'admin', '2021-12-03 16:06:29', '记录日志');
INSERT INTO `sys_log` VALUES (1156, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 16:06:29', '1', 'admin', '2021-12-03 16:06:29', '记录日志');
INSERT INTO `sys_log` VALUES (1157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-03 16:06:31', '1', 'admin', '2021-12-03 16:06:31', '记录日志');
INSERT INTO `sys_log` VALUES (1158, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 16:06:35', '1', 'admin', '2021-12-03 16:06:35', '记录日志');
INSERT INTO `sys_log` VALUES (1159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:10:01', '1', 'admin', '2021-12-03 16:10:01', '记录日志');
INSERT INTO `sys_log` VALUES (1160, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:10:01', '1', 'admin', '2021-12-03 16:10:01', '记录日志');
INSERT INTO `sys_log` VALUES (1161, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 16:10:03', '1', 'admin', '2021-12-03 16:10:03', '记录日志');
INSERT INTO `sys_log` VALUES (1162, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 16:10:03', '1', 'admin', '2021-12-03 16:10:03', '记录日志');
INSERT INTO `sys_log` VALUES (1163, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 16:10:04', '1', 'admin', '2021-12-03 16:10:04', '记录日志');
INSERT INTO `sys_log` VALUES (1164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 16:10:04', '1', 'admin', '2021-12-03 16:10:04', '记录日志');
INSERT INTO `sys_log` VALUES (1165, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:10:05', '1', 'admin', '2021-12-03 16:10:05', '记录日志');
INSERT INTO `sys_log` VALUES (1166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:10:05', '1', 'admin', '2021-12-03 16:10:05', '记录日志');
INSERT INTO `sys_log` VALUES (1167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:10:05', '1', 'admin', '2021-12-03 16:10:05', '记录日志');
INSERT INTO `sys_log` VALUES (1168, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 16:10:06', '1', 'admin', '2021-12-03 16:10:06', '记录日志');
INSERT INTO `sys_log` VALUES (1169, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=0', '127.0.0.1', '/system/res/postAdd', '2021-12-03 16:13:14', '1', 'admin', '2021-12-03 16:13:14', '记录日志');
INSERT INTO `sys_log` VALUES (1170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:13:14', '1', 'admin', '2021-12-03 16:13:14', '记录日志');
INSERT INTO `sys_log` VALUES (1171, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:13:14', '1', 'admin', '2021-12-03 16:13:14', '记录日志');
INSERT INTO `sys_log` VALUES (1172, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:13:19', '1', 'admin', '2021-12-03 16:13:19', '记录日志');
INSERT INTO `sys_log` VALUES (1173, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:13:19', '1', 'admin', '2021-12-03 16:13:19', '记录日志');
INSERT INTO `sys_log` VALUES (1174, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:13:21', '1', 'admin', '2021-12-03 16:13:21', '记录日志');
INSERT INTO `sys_log` VALUES (1175, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:13:21', '1', 'admin', '2021-12-03 16:13:21', '记录日志');
INSERT INTO `sys_log` VALUES (1176, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:13:21', '1', 'admin', '2021-12-03 16:13:21', '记录日志');
INSERT INTO `sys_log` VALUES (1177, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:15:34', '1', 'admin', '2021-12-03 16:15:34', '记录日志');
INSERT INTO `sys_log` VALUES (1178, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:15:34', '1', 'admin', '2021-12-03 16:15:34', '记录日志');
INSERT INTO `sys_log` VALUES (1179, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:15:37', '1', 'admin', '2021-12-03 16:15:37', '记录日志');
INSERT INTO `sys_log` VALUES (1180, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:15:37', '1', 'admin', '2021-12-03 16:15:37', '记录日志');
INSERT INTO `sys_log` VALUES (1181, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:15:38', '1', 'admin', '2021-12-03 16:15:38', '记录日志');
INSERT INTO `sys_log` VALUES (1182, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 16:15:46', '1', 'admin', '2021-12-03 16:15:46', '记录日志');
INSERT INTO `sys_log` VALUES (1183, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:15:51', '1', 'admin', '2021-12-03 16:15:51', '记录日志');
INSERT INTO `sys_log` VALUES (1184, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:15:51', '1', 'admin', '2021-12-03 16:15:51', '记录日志');
INSERT INTO `sys_log` VALUES (1185, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 16:16:02', '1', 'admin', '2021-12-03 16:16:02', '记录日志');
INSERT INTO `sys_log` VALUES (1186, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:21:11', '1', 'admin', '2021-12-03 16:21:11', '记录日志');
INSERT INTO `sys_log` VALUES (1187, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:21:12', '1', 'admin', '2021-12-03 16:21:12', '记录日志');
INSERT INTO `sys_log` VALUES (1188, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:26:04', '1', 'admin', '2021-12-03 16:26:04', '记录日志');
INSERT INTO `sys_log` VALUES (1189, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:26:04', '1', 'admin', '2021-12-03 16:26:04', '记录日志');
INSERT INTO `sys_log` VALUES (1190, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:26:06', '1', 'admin', '2021-12-03 16:26:06', '记录日志');
INSERT INTO `sys_log` VALUES (1191, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:26:06', '1', 'admin', '2021-12-03 16:26:06', '记录日志');
INSERT INTO `sys_log` VALUES (1192, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:26:06', '1', 'admin', '2021-12-03 16:26:06', '记录日志');
INSERT INTO `sys_log` VALUES (1193, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 16:26:07', '1', 'admin', '2021-12-03 16:26:07', '记录日志');
INSERT INTO `sys_log` VALUES (1194, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:26:11', '1', 'admin', '2021-12-03 16:26:11', '记录日志');
INSERT INTO `sys_log` VALUES (1195, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:26:12', '1', 'admin', '2021-12-03 16:26:12', '记录日志');
INSERT INTO `sys_log` VALUES (1196, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 16:26:12', '1', 'admin', '2021-12-03 16:26:12', '记录日志');
INSERT INTO `sys_log` VALUES (1197, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:26:27', '1', 'admin', '2021-12-03 16:26:27', '记录日志');
INSERT INTO `sys_log` VALUES (1198, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:26:27', '1', 'admin', '2021-12-03 16:26:27', '记录日志');
INSERT INTO `sys_log` VALUES (1199, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 16:26:44', '1', 'admin', '2021-12-03 16:26:44', '记录日志');
INSERT INTO `sys_log` VALUES (1200, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=0', '127.0.0.1', '/system/res/postAdd', '2021-12-03 16:27:09', '1', 'admin', '2021-12-03 16:27:09', '记录日志');
INSERT INTO `sys_log` VALUES (1201, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:27:09', '1', 'admin', '2021-12-03 16:27:09', '记录日志');
INSERT INTO `sys_log` VALUES (1202, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:27:09', '1', 'admin', '2021-12-03 16:27:09', '记录日志');
INSERT INTO `sys_log` VALUES (1203, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:27:16', '1', 'admin', '2021-12-03 16:27:16', '记录日志');
INSERT INTO `sys_log` VALUES (1204, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:27:16', '1', 'admin', '2021-12-03 16:27:16', '记录日志');
INSERT INTO `sys_log` VALUES (1205, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:27:19', '1', 'admin', '2021-12-03 16:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (1206, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:27:19', '1', 'admin', '2021-12-03 16:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (1207, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:27:19', '1', 'admin', '2021-12-03 16:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (1208, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:27:36', '1', 'admin', '2021-12-03 16:27:36', '记录日志');
INSERT INTO `sys_log` VALUES (1209, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:31:31', '1', 'admin', '2021-12-03 16:31:31', '记录日志');
INSERT INTO `sys_log` VALUES (1210, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:31:31', '1', 'admin', '2021-12-03 16:31:31', '记录日志');
INSERT INTO `sys_log` VALUES (1211, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:31:32', '1', 'admin', '2021-12-03 16:31:32', '记录日志');
INSERT INTO `sys_log` VALUES (1212, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:31:32', '1', 'admin', '2021-12-03 16:31:32', '记录日志');
INSERT INTO `sys_log` VALUES (1213, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:31:32', '1', 'admin', '2021-12-03 16:31:32', '记录日志');
INSERT INTO `sys_log` VALUES (1214, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 16:31:42', '1', 'admin', '2021-12-03 16:31:42', '记录日志');
INSERT INTO `sys_log` VALUES (1215, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:32:19', '1', 'admin', '2021-12-03 16:32:19', '记录日志');
INSERT INTO `sys_log` VALUES (1216, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:32:19', '1', 'admin', '2021-12-03 16:32:19', '记录日志');
INSERT INTO `sys_log` VALUES (1217, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 16:33:30', '1', 'admin', '2021-12-03 16:33:30', '记录日志');
INSERT INTO `sys_log` VALUES (1218, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=100', '127.0.0.1', '/system/res/postUpdate', '2021-12-03 16:33:34', '1', 'admin', '2021-12-03 16:33:34', '记录日志');
INSERT INTO `sys_log` VALUES (1219, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:33:34', '1', 'admin', '2021-12-03 16:33:34', '记录日志');
INSERT INTO `sys_log` VALUES (1220, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:33:34', '1', 'admin', '2021-12-03 16:33:34', '记录日志');
INSERT INTO `sys_log` VALUES (1221, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:33:58', '1', 'admin', '2021-12-03 16:33:58', '记录日志');
INSERT INTO `sys_log` VALUES (1222, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:34:01', '1', 'admin', '2021-12-03 16:34:01', '记录日志');
INSERT INTO `sys_log` VALUES (1223, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:34:02', '1', 'admin', '2021-12-03 16:34:02', '记录日志');
INSERT INTO `sys_log` VALUES (1224, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:34:31', '1', 'admin', '2021-12-03 16:34:31', '记录日志');
INSERT INTO `sys_log` VALUES (1225, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:34:31', '1', 'admin', '2021-12-03 16:34:31', '记录日志');
INSERT INTO `sys_log` VALUES (1226, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 16:34:32', '1', 'admin', '2021-12-03 16:34:32', '记录日志');
INSERT INTO `sys_log` VALUES (1227, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 16:34:32', '1', 'admin', '2021-12-03 16:34:32', '记录日志');
INSERT INTO `sys_log` VALUES (1228, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 16:34:32', '1', 'admin', '2021-12-03 16:34:32', '记录日志');
INSERT INTO `sys_log` VALUES (1229, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 16:58:41', '1', 'admin', '2021-12-03 16:58:41', '记录日志');
INSERT INTO `sys_log` VALUES (1230, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 16:58:41', '1', 'admin', '2021-12-03 16:58:41', '记录日志');
INSERT INTO `sys_log` VALUES (1231, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 16:58:42', '1', 'admin', '2021-12-03 16:58:42', '记录日志');
INSERT INTO `sys_log` VALUES (1232, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 16:58:42', '1', 'admin', '2021-12-03 16:58:42', '记录日志');
INSERT INTO `sys_log` VALUES (1233, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2021-12-03 16:58:49', '1', 'admin', '2021-12-03 16:58:49', '记录日志');
INSERT INTO `sys_log` VALUES (1234, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2021-12-03 16:58:49', '1', 'admin', '2021-12-03 16:58:49', '记录日志');
INSERT INTO `sys_log` VALUES (1235, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2021-12-03 16:58:52', '1', 'admin', '2021-12-03 16:58:52', '记录日志');
INSERT INTO `sys_log` VALUES (1236, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 16:58:52', '1', 'admin', '2021-12-03 16:58:52', '记录日志');
INSERT INTO `sys_log` VALUES (1237, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 16:58:58', '1', 'admin', '2021-12-03 16:58:58', '记录日志');
INSERT INTO `sys_log` VALUES (1238, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:58:58', '1', 'admin', '2021-12-03 16:58:58', '记录日志');
INSERT INTO `sys_log` VALUES (1239, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 16:59:04', '1', 'admin', '2021-12-03 16:59:04', '记录日志');
INSERT INTO `sys_log` VALUES (1240, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:09', '1', 'admin', '2021-12-03 17:01:09', '记录日志');
INSERT INTO `sys_log` VALUES (1241, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:12', '1', 'admin', '2021-12-03 17:01:12', '记录日志');
INSERT INTO `sys_log` VALUES (1242, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:12', '1', 'admin', '2021-12-03 17:01:12', '记录日志');
INSERT INTO `sys_log` VALUES (1243, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:13', '1', 'admin', '2021-12-03 17:01:13', '记录日志');
INSERT INTO `sys_log` VALUES (1244, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:14', '1', 'admin', '2021-12-03 17:01:14', '记录日志');
INSERT INTO `sys_log` VALUES (1245, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:18', '1', 'admin', '2021-12-03 17:01:18', '记录日志');
INSERT INTO `sys_log` VALUES (1246, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:01:21', '1', 'admin', '2021-12-03 17:01:21', '记录日志');
INSERT INTO `sys_log` VALUES (1247, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:01:21', '1', 'admin', '2021-12-03 17:01:21', '记录日志');
INSERT INTO `sys_log` VALUES (1248, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:01:21', '1', 'admin', '2021-12-03 17:01:21', '记录日志');
INSERT INTO `sys_log` VALUES (1249, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 17:01:23', '1', 'admin', '2021-12-03 17:01:23', '记录日志');
INSERT INTO `sys_log` VALUES (1250, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 17:01:23', '1', 'admin', '2021-12-03 17:01:23', '记录日志');
INSERT INTO `sys_log` VALUES (1251, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2021-12-03 17:01:26', '1', 'admin', '2021-12-03 17:01:26', '记录日志');
INSERT INTO `sys_log` VALUES (1252, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 17:01:28', '1', 'admin', '2021-12-03 17:01:28', '记录日志');
INSERT INTO `sys_log` VALUES (1253, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 17:01:29', '1', 'admin', '2021-12-03 17:01:29', '记录日志');
INSERT INTO `sys_log` VALUES (1254, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 17:01:29', '1', 'admin', '2021-12-03 17:01:29', '记录日志');
INSERT INTO `sys_log` VALUES (1255, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/update', '2021-12-03 17:01:31', '1', 'admin', '2021-12-03 17:01:31', '记录日志');
INSERT INTO `sys_log` VALUES (1256, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 17:01:37', '1', 'admin', '2021-12-03 17:01:37', '记录日志');
INSERT INTO `sys_log` VALUES (1257, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:40', '1', 'admin', '2021-12-03 17:01:40', '记录日志');
INSERT INTO `sys_log` VALUES (1258, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:01:42', '1', 'admin', '2021-12-03 17:01:42', '记录日志');
INSERT INTO `sys_log` VALUES (1259, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2021-12-03 17:07:37', '1', 'admin', '2021-12-03 17:07:37', '记录日志');
INSERT INTO `sys_log` VALUES (1260, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:07:37', '1', 'admin', '2021-12-03 17:07:37', '记录日志');
INSERT INTO `sys_log` VALUES (1261, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:07:37', '1', 'admin', '2021-12-03 17:07:37', '记录日志');
INSERT INTO `sys_log` VALUES (1262, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:07:38', '1', 'admin', '2021-12-03 17:07:38', '记录日志');
INSERT INTO `sys_log` VALUES (1263, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2021-12-03 17:07:42', '1', 'admin', '2021-12-03 17:07:42', '记录日志');
INSERT INTO `sys_log` VALUES (1264, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:07:44', '1', 'admin', '2021-12-03 17:07:44', '记录日志');
INSERT INTO `sys_log` VALUES (1265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 17:07:56', '1', 'admin', '2021-12-03 17:07:56', '记录日志');
INSERT INTO `sys_log` VALUES (1266, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=1', '127.0.0.1', '/system/res/postAdd', '2021-12-03 17:08:07', '1', 'admin', '2021-12-03 17:08:07', '记录日志');
INSERT INTO `sys_log` VALUES (1267, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:08:07', '1', 'admin', '2021-12-03 17:08:07', '记录日志');
INSERT INTO `sys_log` VALUES (1268, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:08:07', '1', 'admin', '2021-12-03 17:08:07', '记录日志');
INSERT INTO `sys_log` VALUES (1269, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2021-12-03 17:08:14', '1', 'admin', '2021-12-03 17:08:14', '记录日志');
INSERT INTO `sys_log` VALUES (1270, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2021-12-03 17:08:14', '1', 'admin', '2021-12-03 17:08:14', '记录日志');
INSERT INTO `sys_log` VALUES (1271, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2021-12-03 17:08:20', '1', 'admin', '2021-12-03 17:08:20', '记录日志');
INSERT INTO `sys_log` VALUES (1272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 17:08:20', '1', 'admin', '2021-12-03 17:08:20', '记录日志');
INSERT INTO `sys_log` VALUES (1273, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:08:23', '1', 'admin', '2021-12-03 17:08:23', '记录日志');
INSERT INTO `sys_log` VALUES (1274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:08:23', '1', 'admin', '2021-12-03 17:08:23', '记录日志');
INSERT INTO `sys_log` VALUES (1275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:08:25', '1', 'admin', '2021-12-03 17:08:25', '记录日志');
INSERT INTO `sys_log` VALUES (1276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:08:25', '1', 'admin', '2021-12-03 17:08:25', '记录日志');
INSERT INTO `sys_log` VALUES (1277, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:08:34', '1', 'admin', '2021-12-03 17:08:34', '记录日志');
INSERT INTO `sys_log` VALUES (1278, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:08:34', '1', 'admin', '2021-12-03 17:08:34', '记录日志');
INSERT INTO `sys_log` VALUES (1279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:08:34', '1', 'admin', '2021-12-03 17:08:34', '记录日志');
INSERT INTO `sys_log` VALUES (1280, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:08:37', '1', 'admin', '2021-12-03 17:08:37', '记录日志');
INSERT INTO `sys_log` VALUES (1281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:09:10', '1', 'admin', '2021-12-03 17:09:10', '记录日志');
INSERT INTO `sys_log` VALUES (1282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:09:10', '1', 'admin', '2021-12-03 17:09:10', '记录日志');
INSERT INTO `sys_log` VALUES (1283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:09:11', '1', 'admin', '2021-12-03 17:09:11', '记录日志');
INSERT INTO `sys_log` VALUES (1284, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:09:11', '1', 'admin', '2021-12-03 17:09:11', '记录日志');
INSERT INTO `sys_log` VALUES (1285, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:09:11', '1', 'admin', '2021-12-03 17:09:11', '记录日志');
INSERT INTO `sys_log` VALUES (1286, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:09:13', '1', 'admin', '2021-12-03 17:09:13', '记录日志');
INSERT INTO `sys_log` VALUES (1287, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:09:13', '1', 'admin', '2021-12-03 17:09:13', '记录日志');
INSERT INTO `sys_log` VALUES (1288, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:17:21', '1', 'admin', '2021-12-03 17:17:21', '记录日志');
INSERT INTO `sys_log` VALUES (1289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 17:17:25', '1', 'admin', '2021-12-03 17:17:25', '记录日志');
INSERT INTO `sys_log` VALUES (1290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:17:30', '1', 'admin', '2021-12-03 17:17:30', '记录日志');
INSERT INTO `sys_log` VALUES (1291, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:17:30', '1', 'admin', '2021-12-03 17:17:30', '记录日志');
INSERT INTO `sys_log` VALUES (1292, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:17:55', '1', 'admin', '2021-12-03 17:17:55', '记录日志');
INSERT INTO `sys_log` VALUES (1293, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:17:55', '1', 'admin', '2021-12-03 17:17:55', '记录日志');
INSERT INTO `sys_log` VALUES (1294, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:17:56', '1', 'admin', '2021-12-03 17:17:56', '记录日志');
INSERT INTO `sys_log` VALUES (1295, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:17:56', '1', 'admin', '2021-12-03 17:17:56', '记录日志');
INSERT INTO `sys_log` VALUES (1296, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:19:25', '1', 'admin', '2021-12-03 17:19:25', '记录日志');
INSERT INTO `sys_log` VALUES (1297, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/1', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:19:25', '1', 'admin', '2021-12-03 17:19:25', '记录日志');
INSERT INTO `sys_log` VALUES (1298, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:19:35', '1', 'admin', '2021-12-03 17:19:35', '记录日志');
INSERT INTO `sys_log` VALUES (1299, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:19:35', '1', 'admin', '2021-12-03 17:19:35', '记录日志');
INSERT INTO `sys_log` VALUES (1300, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:19:35', '1', 'admin', '2021-12-03 17:19:35', '记录日志');
INSERT INTO `sys_log` VALUES (1301, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:19:39', '1', 'admin', '2021-12-03 17:19:39', '记录日志');
INSERT INTO `sys_log` VALUES (1302, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 17:19:44', '1', 'admin', '2021-12-03 17:19:44', '记录日志');
INSERT INTO `sys_log` VALUES (1303, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2021-12-03 17:20:05', '1', 'admin', '2021-12-03 17:20:05', '记录日志');
INSERT INTO `sys_log` VALUES (1304, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:20:05', '1', 'admin', '2021-12-03 17:20:05', '记录日志');
INSERT INTO `sys_log` VALUES (1305, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:20:05', '1', 'admin', '2021-12-03 17:20:05', '记录日志');
INSERT INTO `sys_log` VALUES (1306, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:20:08', '1', 'admin', '2021-12-03 17:20:08', '记录日志');
INSERT INTO `sys_log` VALUES (1307, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:20:08', '1', 'admin', '2021-12-03 17:20:08', '记录日志');
INSERT INTO `sys_log` VALUES (1308, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:20:10', '1', 'admin', '2021-12-03 17:20:10', '记录日志');
INSERT INTO `sys_log` VALUES (1309, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:20:10', '1', 'admin', '2021-12-03 17:20:10', '记录日志');
INSERT INTO `sys_log` VALUES (1310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:20:11', '1', 'admin', '2021-12-03 17:20:11', '记录日志');
INSERT INTO `sys_log` VALUES (1311, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 17:20:11', '1', 'admin', '2021-12-03 17:20:11', '记录日志');
INSERT INTO `sys_log` VALUES (1312, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 17:20:11', '1', 'admin', '2021-12-03 17:20:11', '记录日志');
INSERT INTO `sys_log` VALUES (1313, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2021-12-03 17:20:12', '1', 'admin', '2021-12-03 17:20:12', '记录日志');
INSERT INTO `sys_log` VALUES (1314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2021-12-03 17:20:12', '1', 'admin', '2021-12-03 17:20:12', '记录日志');
INSERT INTO `sys_log` VALUES (1315, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2021-12-03 17:20:15', '1', 'admin', '2021-12-03 17:20:15', '记录日志');
INSERT INTO `sys_log` VALUES (1316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 17:20:16', '1', 'admin', '2021-12-03 17:20:16', '记录日志');
INSERT INTO `sys_log` VALUES (1317, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:20:18', '1', 'admin', '2021-12-03 17:20:18', '记录日志');
INSERT INTO `sys_log` VALUES (1318, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:20:18', '1', 'admin', '2021-12-03 17:20:18', '记录日志');
INSERT INTO `sys_log` VALUES (1319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/aaa', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:20:21', '1', 'admin', '2021-12-03 17:20:21', '记录日志');
INSERT INTO `sys_log` VALUES (1320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/aaa', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:20:21', '1', 'admin', '2021-12-03 17:20:21', '记录日志');
INSERT INTO `sys_log` VALUES (1321, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:21:16', '1', 'admin', '2021-12-03 17:21:16', '记录日志');
INSERT INTO `sys_log` VALUES (1322, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:21:16', '1', 'admin', '2021-12-03 17:21:16', '记录日志');
INSERT INTO `sys_log` VALUES (1323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:21:16', '1', 'admin', '2021-12-03 17:21:16', '记录日志');
INSERT INTO `sys_log` VALUES (1324, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:21:20', '1', 'admin', '2021-12-03 17:21:20', '记录日志');
INSERT INTO `sys_log` VALUES (1325, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 17:21:29', '1', 'admin', '2021-12-03 17:21:29', '记录日志');
INSERT INTO `sys_log` VALUES (1326, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:21:35', '1', 'admin', '2021-12-03 17:21:35', '记录日志');
INSERT INTO `sys_log` VALUES (1327, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:21:35', '1', 'admin', '2021-12-03 17:21:35', '记录日志');
INSERT INTO `sys_log` VALUES (1328, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:21:44', '1', 'admin', '2021-12-03 17:21:44', '记录日志');
INSERT INTO `sys_log` VALUES (1329, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:21:51', '1', 'admin', '2021-12-03 17:21:51', '记录日志');
INSERT INTO `sys_log` VALUES (1330, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:22:00', '1', 'admin', '2021-12-03 17:22:00', '记录日志');
INSERT INTO `sys_log` VALUES (1331, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:22:05', '1', 'admin', '2021-12-03 17:22:05', '记录日志');
INSERT INTO `sys_log` VALUES (1332, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:22:11', '1', 'admin', '2021-12-03 17:22:11', '记录日志');
INSERT INTO `sys_log` VALUES (1333, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 17:22:18', '1', 'admin', '2021-12-03 17:22:18', '记录日志');
INSERT INTO `sys_log` VALUES (1334, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=101', '127.0.0.1', '/system/res/postUpdate', '2021-12-03 17:22:25', '1', 'admin', '2021-12-03 17:22:25', '记录日志');
INSERT INTO `sys_log` VALUES (1335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:22:25', '1', 'admin', '2021-12-03 17:22:25', '记录日志');
INSERT INTO `sys_log` VALUES (1336, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:22:25', '1', 'admin', '2021-12-03 17:22:25', '记录日志');
INSERT INTO `sys_log` VALUES (1337, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 17:22:55', '1', 'admin', '2021-12-03 17:22:55', '记录日志');
INSERT INTO `sys_log` VALUES (1338, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:25:29', '1', 'admin', '2021-12-03 17:25:29', '记录日志');
INSERT INTO `sys_log` VALUES (1339, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:25:29', '1', 'admin', '2021-12-03 17:25:29', '记录日志');
INSERT INTO `sys_log` VALUES (1340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:25:30', '1', 'admin', '2021-12-03 17:25:30', '记录日志');
INSERT INTO `sys_log` VALUES (1341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:25:30', '1', 'admin', '2021-12-03 17:25:30', '记录日志');
INSERT INTO `sys_log` VALUES (1342, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/aaa', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:25:38', '1', 'admin', '2021-12-03 17:25:38', '记录日志');
INSERT INTO `sys_log` VALUES (1343, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/aaa', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:25:38', '1', 'admin', '2021-12-03 17:25:38', '记录日志');
INSERT INTO `sys_log` VALUES (1344, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:25:43', '1', 'admin', '2021-12-03 17:25:43', '记录日志');
INSERT INTO `sys_log` VALUES (1345, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:25:43', '1', 'admin', '2021-12-03 17:25:43', '记录日志');
INSERT INTO `sys_log` VALUES (1346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:25:43', '1', 'admin', '2021-12-03 17:25:43', '记录日志');
INSERT INTO `sys_log` VALUES (1347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:25:53', '1', 'admin', '2021-12-03 17:25:53', '记录日志');
INSERT INTO `sys_log` VALUES (1348, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 17:25:57', '1', 'admin', '2021-12-03 17:25:57', '记录日志');
INSERT INTO `sys_log` VALUES (1349, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:26:11', '1', 'admin', '2021-12-03 17:26:11', '记录日志');
INSERT INTO `sys_log` VALUES (1350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:26:11', '1', 'admin', '2021-12-03 17:26:11', '记录日志');
INSERT INTO `sys_log` VALUES (1351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/aaa', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:26:29', '1', 'admin', '2021-12-03 17:26:29', '记录日志');
INSERT INTO `sys_log` VALUES (1352, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/aaa', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:26:29', '1', 'admin', '2021-12-03 17:26:29', '记录日志');
INSERT INTO `sys_log` VALUES (1353, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:26:32', '1', 'admin', '2021-12-03 17:26:32', '记录日志');
INSERT INTO `sys_log` VALUES (1354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 17:26:35', '1', 'admin', '2021-12-03 17:26:35', '记录日志');
INSERT INTO `sys_log` VALUES (1355, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2021-12-03 17:26:47', '1', 'admin', '2021-12-03 17:26:47', '记录日志');
INSERT INTO `sys_log` VALUES (1356, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:26:47', '1', 'admin', '2021-12-03 17:26:47', '记录日志');
INSERT INTO `sys_log` VALUES (1357, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:26:47', '1', 'admin', '2021-12-03 17:26:47', '记录日志');
INSERT INTO `sys_log` VALUES (1358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:26:49', '1', 'admin', '2021-12-03 17:26:49', '记录日志');
INSERT INTO `sys_log` VALUES (1359, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:26:49', '1', 'admin', '2021-12-03 17:26:49', '记录日志');
INSERT INTO `sys_log` VALUES (1360, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:26:51', '1', 'admin', '2021-12-03 17:26:51', '记录日志');
INSERT INTO `sys_log` VALUES (1361, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:26:51', '1', 'admin', '2021-12-03 17:26:51', '记录日志');
INSERT INTO `sys_log` VALUES (1362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:26:52', '1', 'admin', '2021-12-03 17:26:52', '记录日志');
INSERT INTO `sys_log` VALUES (1363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 17:26:53', '1', 'admin', '2021-12-03 17:26:53', '记录日志');
INSERT INTO `sys_log` VALUES (1364, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 17:26:53', '1', 'admin', '2021-12-03 17:26:53', '记录日志');
INSERT INTO `sys_log` VALUES (1365, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2021-12-03 17:26:54', '1', 'admin', '2021-12-03 17:26:54', '记录日志');
INSERT INTO `sys_log` VALUES (1366, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2021-12-03 17:26:54', '1', 'admin', '2021-12-03 17:26:54', '记录日志');
INSERT INTO `sys_log` VALUES (1367, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2021-12-03 17:26:58', '1', 'admin', '2021-12-03 17:26:58', '记录日志');
INSERT INTO `sys_log` VALUES (1368, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 17:26:58', '1', 'admin', '2021-12-03 17:26:58', '记录日志');
INSERT INTO `sys_log` VALUES (1369, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 17:27:00', '1', 'admin', '2021-12-03 17:27:00', '记录日志');
INSERT INTO `sys_log` VALUES (1370, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 17:27:00', '1', 'admin', '2021-12-03 17:27:00', '记录日志');
INSERT INTO `sys_log` VALUES (1371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 17:27:19', '1', 'admin', '2021-12-03 17:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (1372, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 17:27:19', '1', 'admin', '2021-12-03 17:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (1373, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 17:27:19', '1', 'admin', '2021-12-03 17:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (1374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 20:30:49', '1', 'admin', '2021-12-03 20:30:49', '记录日志');
INSERT INTO `sys_log` VALUES (1375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 20:30:49', '1', 'admin', '2021-12-03 20:30:49', '记录日志');
INSERT INTO `sys_log` VALUES (1376, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 20:30:52', '1', 'admin', '2021-12-03 20:30:52', '记录日志');
INSERT INTO `sys_log` VALUES (1377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 20:30:52', '1', 'admin', '2021-12-03 20:30:52', '记录日志');
INSERT INTO `sys_log` VALUES (1378, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 20:30:52', '1', 'admin', '2021-12-03 20:30:52', '记录日志');
INSERT INTO `sys_log` VALUES (1379, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 20:30:53', '1', 'admin', '2021-12-03 20:30:53', '记录日志');
INSERT INTO `sys_log` VALUES (1380, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 20:31:02', '1', 'admin', '2021-12-03 20:31:02', '记录日志');
INSERT INTO `sys_log` VALUES (1381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 20:31:02', '1', 'admin', '2021-12-03 20:31:02', '记录日志');
INSERT INTO `sys_log` VALUES (1382, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 20:31:42', '1', 'admin', '2021-12-03 20:31:42', '记录日志');
INSERT INTO `sys_log` VALUES (1383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 20:31:42', '1', 'admin', '2021-12-03 20:31:42', '记录日志');
INSERT INTO `sys_log` VALUES (1384, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 20:31:43', '1', 'admin', '2021-12-03 20:31:43', '记录日志');
INSERT INTO `sys_log` VALUES (1385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 20:31:43', '1', 'admin', '2021-12-03 20:31:43', '记录日志');
INSERT INTO `sys_log` VALUES (1386, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 20:31:43', '1', 'admin', '2021-12-03 20:31:43', '记录日志');
INSERT INTO `sys_log` VALUES (1387, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-03 20:31:44', '1', 'admin', '2021-12-03 20:31:44', '记录日志');
INSERT INTO `sys_log` VALUES (1388, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 20:31:49', '1', 'admin', '2021-12-03 20:31:49', '记录日志');
INSERT INTO `sys_log` VALUES (1389, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 20:31:49', '1', 'admin', '2021-12-03 20:31:49', '记录日志');
INSERT INTO `sys_log` VALUES (1390, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 21:11:07', '1', 'admin', '2021-12-03 21:11:07', '记录日志');
INSERT INTO `sys_log` VALUES (1391, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 21:11:07', '1', 'admin', '2021-12-03 21:11:07', '记录日志');
INSERT INTO `sys_log` VALUES (1392, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 21:11:08', '1', 'admin', '2021-12-03 21:11:08', '记录日志');
INSERT INTO `sys_log` VALUES (1393, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 21:11:08', '1', 'admin', '2021-12-03 21:11:08', '记录日志');
INSERT INTO `sys_log` VALUES (1394, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 21:11:08', '1', 'admin', '2021-12-03 21:11:08', '记录日志');
INSERT INTO `sys_log` VALUES (1395, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 21:11:13', '1', 'admin', '2021-12-03 21:11:13', '记录日志');
INSERT INTO `sys_log` VALUES (1396, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 21:11:14', '1', 'admin', '2021-12-03 21:11:14', '记录日志');
INSERT INTO `sys_log` VALUES (1397, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 21:11:14', '1', 'admin', '2021-12-03 21:11:14', '记录日志');
INSERT INTO `sys_log` VALUES (1398, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-03 21:11:16', '1', 'admin', '2021-12-03 21:11:16', '记录日志');
INSERT INTO `sys_log` VALUES (1399, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 21:11:22', '1', 'admin', '2021-12-03 21:11:22', '记录日志');
INSERT INTO `sys_log` VALUES (1400, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 21:11:22', '1', 'admin', '2021-12-03 21:11:22', '记录日志');
INSERT INTO `sys_log` VALUES (1401, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-03 21:12:00', '1', 'admin', '2021-12-03 21:12:00', '记录日志');
INSERT INTO `sys_log` VALUES (1402, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 21:12:00', '1', 'admin', '2021-12-03 21:12:00', '记录日志');
INSERT INTO `sys_log` VALUES (1403, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-03 21:15:02', '1', 'admin', '2021-12-03 21:15:02', '记录日志');
INSERT INTO `sys_log` VALUES (1404, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 21:16:00', '1', 'admin', '2021-12-03 21:16:00', '记录日志');
INSERT INTO `sys_log` VALUES (1405, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-03 21:16:01', '1', 'admin', '2021-12-03 21:16:01', '记录日志');
INSERT INTO `sys_log` VALUES (1406, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-03 21:53:23', '1', 'admin', '2021-12-03 21:53:23', '记录日志');
INSERT INTO `sys_log` VALUES (1407, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-03 21:53:23', '1', 'admin', '2021-12-03 21:53:23', '记录日志');
INSERT INTO `sys_log` VALUES (1408, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-03 21:53:23', '1', 'admin', '2021-12-03 21:53:23', '记录日志');
INSERT INTO `sys_log` VALUES (1409, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-03 21:53:24', '1', 'admin', '2021-12-03 21:53:24', '记录日志');
INSERT INTO `sys_log` VALUES (1410, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-03 21:53:24', '1', 'admin', '2021-12-03 21:53:24', '记录日志');
INSERT INTO `sys_log` VALUES (1411, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-03 21:53:26', '1', 'admin', '2021-12-03 21:53:26', '记录日志');
INSERT INTO `sys_log` VALUES (1412, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-03 21:53:26', '1', 'admin', '2021-12-03 21:53:26', '记录日志');
INSERT INTO `sys_log` VALUES (1413, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-03 21:53:27', '1', 'admin', '2021-12-03 21:53:27', '记录日志');
INSERT INTO `sys_log` VALUES (1414, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-03 21:53:27', '1', 'admin', '2021-12-03 21:53:27', '记录日志');
INSERT INTO `sys_log` VALUES (1415, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 12:45:39', '1', 'admin', '2021-12-04 12:45:39', '记录日志');
INSERT INTO `sys_log` VALUES (1416, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 12:45:39', '1', 'admin', '2021-12-04 12:45:39', '记录日志');
INSERT INTO `sys_log` VALUES (1417, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 12:45:42', '1', 'admin', '2021-12-04 12:45:42', '记录日志');
INSERT INTO `sys_log` VALUES (1418, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 12:45:42', '1', 'admin', '2021-12-04 12:45:42', '记录日志');
INSERT INTO `sys_log` VALUES (1419, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 12:45:42', '1', 'admin', '2021-12-04 12:45:42', '记录日志');
INSERT INTO `sys_log` VALUES (1420, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 12:45:44', '1', 'admin', '2021-12-04 12:45:44', '记录日志');
INSERT INTO `sys_log` VALUES (1421, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/%E5%95%8A%E5%95%8A%E5%95%8A', '127.0.0.1', '/system/res/menuTop', '2021-12-04 12:49:41', '1', 'admin', '2021-12-04 12:49:41', '记录日志');
INSERT INTO `sys_log` VALUES (1422, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/%E5%95%8A%E5%95%8A%E5%95%8A', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 12:49:41', '1', 'admin', '2021-12-04 12:49:41', '记录日志');
INSERT INTO `sys_log` VALUES (1423, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 12:57:14', '1', 'admin', '2021-12-04 12:57:14', '记录日志');
INSERT INTO `sys_log` VALUES (1424, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 12:57:14', '1', 'admin', '2021-12-04 12:57:14', '记录日志');
INSERT INTO `sys_log` VALUES (1425, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 12:57:16', '1', 'admin', '2021-12-04 12:57:16', '记录日志');
INSERT INTO `sys_log` VALUES (1426, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 12:57:17', '1', 'admin', '2021-12-04 12:57:17', '记录日志');
INSERT INTO `sys_log` VALUES (1427, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 12:57:17', '1', 'admin', '2021-12-04 12:57:17', '记录日志');
INSERT INTO `sys_log` VALUES (1428, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 12:57:18', '1', 'admin', '2021-12-04 12:57:18', '记录日志');
INSERT INTO `sys_log` VALUES (1429, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 12:59:23', '1', 'admin', '2021-12-04 12:59:23', '记录日志');
INSERT INTO `sys_log` VALUES (1430, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 12:59:23', '1', 'admin', '2021-12-04 12:59:23', '记录日志');
INSERT INTO `sys_log` VALUES (1431, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 12:59:24', '1', 'admin', '2021-12-04 12:59:24', '记录日志');
INSERT INTO `sys_log` VALUES (1432, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 12:59:25', '1', 'admin', '2021-12-04 12:59:25', '记录日志');
INSERT INTO `sys_log` VALUES (1433, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 12:59:25', '1', 'admin', '2021-12-04 12:59:25', '记录日志');
INSERT INTO `sys_log` VALUES (1434, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 12:59:26', '1', 'admin', '2021-12-04 12:59:26', '记录日志');
INSERT INTO `sys_log` VALUES (1435, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 12:59:26', '1', 'admin', '2021-12-04 12:59:26', '记录日志');
INSERT INTO `sys_log` VALUES (1436, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-04 12:59:28', '1', 'admin', '2021-12-04 12:59:28', '记录日志');
INSERT INTO `sys_log` VALUES (1437, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-04 12:59:28', '1', 'admin', '2021-12-04 12:59:28', '记录日志');
INSERT INTO `sys_log` VALUES (1438, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/page', '2021-12-04 12:59:29', '1', 'admin', '2021-12-04 12:59:29', '记录日志');
INSERT INTO `sys_log` VALUES (1439, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-04 12:59:30', '1', 'admin', '2021-12-04 12:59:30', '记录日志');
INSERT INTO `sys_log` VALUES (1440, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-04 12:59:30', '1', 'admin', '2021-12-04 12:59:30', '记录日志');
INSERT INTO `sys_log` VALUES (1441, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 12:59:35', '1', 'admin', '2021-12-04 12:59:35', '记录日志');
INSERT INTO `sys_log` VALUES (1442, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 12:59:35', '1', 'admin', '2021-12-04 12:59:35', '记录日志');
INSERT INTO `sys_log` VALUES (1443, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-04 12:59:36', '1', 'admin', '2021-12-04 12:59:36', '记录日志');
INSERT INTO `sys_log` VALUES (1444, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2021-12-04 12:59:36', '1', 'admin', '2021-12-04 12:59:36', '记录日志');
INSERT INTO `sys_log` VALUES (1445, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 12:59:39', '1', 'admin', '2021-12-04 12:59:39', '记录日志');
INSERT INTO `sys_log` VALUES (1446, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-04 13:00:52', '1', 'admin', '2021-12-04 13:00:52', '记录日志');
INSERT INTO `sys_log` VALUES (1447, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/add', '127.0.0.1', '/system/role/tableData', '2021-12-04 13:00:52', '1', 'admin', '2021-12-04 13:00:52', '记录日志');
INSERT INTO `sys_log` VALUES (1448, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 13:00:54', '1', 'admin', '2021-12-04 13:00:54', '记录日志');
INSERT INTO `sys_log` VALUES (1449, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:05:00', '1', 'admin', '2021-12-04 13:05:00', '记录日志');
INSERT INTO `sys_log` VALUES (1450, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:05:00', '1', 'admin', '2021-12-04 13:05:00', '记录日志');
INSERT INTO `sys_log` VALUES (1451, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 13:05:02', '1', 'admin', '2021-12-04 13:05:02', '记录日志');
INSERT INTO `sys_log` VALUES (1452, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:05:02', '1', 'admin', '2021-12-04 13:05:02', '记录日志');
INSERT INTO `sys_log` VALUES (1453, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:05:02', '1', 'admin', '2021-12-04 13:05:02', '记录日志');
INSERT INTO `sys_log` VALUES (1454, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 13:05:02', '1', 'admin', '2021-12-04 13:05:02', '记录日志');
INSERT INTO `sys_log` VALUES (1455, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 13:05:02', '1', 'admin', '2021-12-04 13:05:02', '记录日志');
INSERT INTO `sys_log` VALUES (1456, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:05:03', '1', 'admin', '2021-12-04 13:05:03', '记录日志');
INSERT INTO `sys_log` VALUES (1457, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:23:10', '1', 'admin', '2021-12-04 13:23:10', '记录日志');
INSERT INTO `sys_log` VALUES (1458, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:23:10', '1', 'admin', '2021-12-04 13:23:10', '记录日志');
INSERT INTO `sys_log` VALUES (1459, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 13:23:16', '1', 'admin', '2021-12-04 13:23:16', '记录日志');
INSERT INTO `sys_log` VALUES (1460, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:23:16', '1', 'admin', '2021-12-04 13:23:16', '记录日志');
INSERT INTO `sys_log` VALUES (1461, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:23:16', '1', 'admin', '2021-12-04 13:23:16', '记录日志');
INSERT INTO `sys_log` VALUES (1462, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 13:23:18', '1', 'admin', '2021-12-04 13:23:18', '记录日志');
INSERT INTO `sys_log` VALUES (1463, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 13:23:18', '1', 'admin', '2021-12-04 13:23:18', '记录日志');
INSERT INTO `sys_log` VALUES (1464, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-04 13:23:19', '1', 'admin', '2021-12-04 13:23:19', '记录日志');
INSERT INTO `sys_log` VALUES (1465, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-04 13:23:19', '1', 'admin', '2021-12-04 13:23:19', '记录日志');
INSERT INTO `sys_log` VALUES (1466, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-04 13:23:22', '1', 'admin', '2021-12-04 13:23:22', '记录日志');
INSERT INTO `sys_log` VALUES (1467, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-04 13:23:23', '1', 'admin', '2021-12-04 13:23:23', '记录日志');
INSERT INTO `sys_log` VALUES (1468, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 13:23:24', '1', 'admin', '2021-12-04 13:23:24', '记录日志');
INSERT INTO `sys_log` VALUES (1469, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 13:23:24', '1', 'admin', '2021-12-04 13:23:24', '记录日志');
INSERT INTO `sys_log` VALUES (1470, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-04 13:23:25', '1', 'admin', '2021-12-04 13:23:25', '记录日志');
INSERT INTO `sys_log` VALUES (1471, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:23:34', '1', 'admin', '2021-12-04 13:23:34', '记录日志');
INSERT INTO `sys_log` VALUES (1472, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:26:49', '1', 'admin', '2021-12-04 13:26:49', '记录日志');
INSERT INTO `sys_log` VALUES (1473, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:26:52', '1', 'admin', '2021-12-04 13:26:52', '记录日志');
INSERT INTO `sys_log` VALUES (1474, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:26:59', '1', 'admin', '2021-12-04 13:26:59', '记录日志');
INSERT INTO `sys_log` VALUES (1475, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:26:59', '1', 'admin', '2021-12-04 13:26:59', '记录日志');
INSERT INTO `sys_log` VALUES (1476, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:03', '1', 'admin', '2021-12-04 13:27:03', '记录日志');
INSERT INTO `sys_log` VALUES (1477, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:12', '1', 'admin', '2021-12-04 13:27:12', '记录日志');
INSERT INTO `sys_log` VALUES (1478, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:27:15', '1', 'admin', '2021-12-04 13:27:15', '记录日志');
INSERT INTO `sys_log` VALUES (1479, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:18', '1', 'admin', '2021-12-04 13:27:18', '记录日志');
INSERT INTO `sys_log` VALUES (1480, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:27:18', '1', 'admin', '2021-12-04 13:27:18', '记录日志');
INSERT INTO `sys_log` VALUES (1481, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:27:19', '1', 'admin', '2021-12-04 13:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (1482, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:27:23', '1', 'admin', '2021-12-04 13:27:23', '记录日志');
INSERT INTO `sys_log` VALUES (1483, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:23', '1', 'admin', '2021-12-04 13:27:23', '记录日志');
INSERT INTO `sys_log` VALUES (1484, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:24', '1', 'admin', '2021-12-04 13:27:24', '记录日志');
INSERT INTO `sys_log` VALUES (1485, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:26', '1', 'admin', '2021-12-04 13:27:26', '记录日志');
INSERT INTO `sys_log` VALUES (1486, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:27:28', '1', 'admin', '2021-12-04 13:27:28', '记录日志');
INSERT INTO `sys_log` VALUES (1487, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 13:27:34', '1', 'admin', '2021-12-04 13:27:34', '记录日志');
INSERT INTO `sys_log` VALUES (1488, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:34', '1', 'admin', '2021-12-04 13:27:34', '记录日志');
INSERT INTO `sys_log` VALUES (1489, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:27:34', '1', 'admin', '2021-12-04 13:27:34', '记录日志');
INSERT INTO `sys_log` VALUES (1490, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:27:37', '1', 'admin', '2021-12-04 13:27:37', '记录日志');
INSERT INTO `sys_log` VALUES (1491, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:27:37', '1', 'admin', '2021-12-04 13:27:37', '记录日志');
INSERT INTO `sys_log` VALUES (1492, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 13:27:38', '1', 'admin', '2021-12-04 13:27:38', '记录日志');
INSERT INTO `sys_log` VALUES (1493, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 13:27:38', '1', 'admin', '2021-12-04 13:27:38', '记录日志');
INSERT INTO `sys_log` VALUES (1494, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 13:27:55', '1', 'admin', '2021-12-04 13:27:55', '记录日志');
INSERT INTO `sys_log` VALUES (1495, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:27:55', '1', 'admin', '2021-12-04 13:27:55', '记录日志');
INSERT INTO `sys_log` VALUES (1496, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:27:55', '1', 'admin', '2021-12-04 13:27:55', '记录日志');
INSERT INTO `sys_log` VALUES (1497, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:00', '1', 'admin', '2021-12-04 13:28:00', '记录日志');
INSERT INTO `sys_log` VALUES (1498, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:01', '1', 'admin', '2021-12-04 13:28:01', '记录日志');
INSERT INTO `sys_log` VALUES (1499, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:28:02', '1', 'admin', '2021-12-04 13:28:02', '记录日志');
INSERT INTO `sys_log` VALUES (1500, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:06', '1', 'admin', '2021-12-04 13:28:06', '记录日志');
INSERT INTO `sys_log` VALUES (1501, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:28:06', '1', 'admin', '2021-12-04 13:28:06', '记录日志');
INSERT INTO `sys_log` VALUES (1502, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:07', '1', 'admin', '2021-12-04 13:28:07', '记录日志');
INSERT INTO `sys_log` VALUES (1503, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:28:09', '1', 'admin', '2021-12-04 13:28:09', '记录日志');
INSERT INTO `sys_log` VALUES (1504, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:12', '1', 'admin', '2021-12-04 13:28:12', '记录日志');
INSERT INTO `sys_log` VALUES (1505, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:28:12', '1', 'admin', '2021-12-04 13:28:12', '记录日志');
INSERT INTO `sys_log` VALUES (1506, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:13', '1', 'admin', '2021-12-04 13:28:13', '记录日志');
INSERT INTO `sys_log` VALUES (1507, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:15', '1', 'admin', '2021-12-04 13:28:15', '记录日志');
INSERT INTO `sys_log` VALUES (1508, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:28:17', '1', 'admin', '2021-12-04 13:28:17', '记录日志');
INSERT INTO `sys_log` VALUES (1509, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:21', '1', 'admin', '2021-12-04 13:28:21', '记录日志');
INSERT INTO `sys_log` VALUES (1510, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:28:21', '1', 'admin', '2021-12-04 13:28:21', '记录日志');
INSERT INTO `sys_log` VALUES (1511, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:28:30', '1', 'admin', '2021-12-04 13:28:30', '记录日志');
INSERT INTO `sys_log` VALUES (1512, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 13:28:37', '1', 'admin', '2021-12-04 13:28:37', '记录日志');
INSERT INTO `sys_log` VALUES (1513, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:28:37', '1', 'admin', '2021-12-04 13:28:37', '记录日志');
INSERT INTO `sys_log` VALUES (1514, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:28:37', '1', 'admin', '2021-12-04 13:28:37', '记录日志');
INSERT INTO `sys_log` VALUES (1515, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:28:41', '1', 'admin', '2021-12-04 13:28:41', '记录日志');
INSERT INTO `sys_log` VALUES (1516, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:28:41', '1', 'admin', '2021-12-04 13:28:41', '记录日志');
INSERT INTO `sys_log` VALUES (1517, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:28:42', '1', 'admin', '2021-12-04 13:28:42', '记录日志');
INSERT INTO `sys_log` VALUES (1518, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:29:46', '1', 'admin', '2021-12-04 13:29:46', '记录日志');
INSERT INTO `sys_log` VALUES (1519, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:29:46', '1', 'admin', '2021-12-04 13:29:46', '记录日志');
INSERT INTO `sys_log` VALUES (1520, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 13:29:50', '1', 'admin', '2021-12-04 13:29:50', '记录日志');
INSERT INTO `sys_log` VALUES (1521, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 13:29:50', '1', 'admin', '2021-12-04 13:29:50', '记录日志');
INSERT INTO `sys_log` VALUES (1522, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:31:15', '1', 'admin', '2021-12-04 13:31:15', '记录日志');
INSERT INTO `sys_log` VALUES (1523, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:31:15', '1', 'admin', '2021-12-04 13:31:15', '记录日志');
INSERT INTO `sys_log` VALUES (1524, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 13:31:16', '1', 'admin', '2021-12-04 13:31:16', '记录日志');
INSERT INTO `sys_log` VALUES (1525, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:31:16', '1', 'admin', '2021-12-04 13:31:16', '记录日志');
INSERT INTO `sys_log` VALUES (1526, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:31:16', '1', 'admin', '2021-12-04 13:31:16', '记录日志');
INSERT INTO `sys_log` VALUES (1527, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:31:18', '1', 'admin', '2021-12-04 13:31:18', '记录日志');
INSERT INTO `sys_log` VALUES (1528, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:34:34', '1', 'admin', '2021-12-04 13:34:34', '记录日志');
INSERT INTO `sys_log` VALUES (1529, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:34:34', '1', 'admin', '2021-12-04 13:34:34', '记录日志');
INSERT INTO `sys_log` VALUES (1530, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 13:34:35', '1', 'admin', '2021-12-04 13:34:35', '记录日志');
INSERT INTO `sys_log` VALUES (1531, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:34:35', '1', 'admin', '2021-12-04 13:34:35', '记录日志');
INSERT INTO `sys_log` VALUES (1532, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:34:35', '1', 'admin', '2021-12-04 13:34:35', '记录日志');
INSERT INTO `sys_log` VALUES (1533, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:34:36', '1', 'admin', '2021-12-04 13:34:36', '记录日志');
INSERT INTO `sys_log` VALUES (1534, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 13:37:12', '1', 'admin', '2021-12-04 13:37:12', '记录日志');
INSERT INTO `sys_log` VALUES (1535, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 13:37:12', '1', 'admin', '2021-12-04 13:37:12', '记录日志');
INSERT INTO `sys_log` VALUES (1536, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:41:22', '1', 'admin', '2021-12-04 13:41:22', '记录日志');
INSERT INTO `sys_log` VALUES (1537, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:41:22', '1', 'admin', '2021-12-04 13:41:22', '记录日志');
INSERT INTO `sys_log` VALUES (1538, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:41:24', '1', 'admin', '2021-12-04 13:41:24', '记录日志');
INSERT INTO `sys_log` VALUES (1539, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 13:43:49', '1', 'admin', '2021-12-04 13:43:49', '记录日志');
INSERT INTO `sys_log` VALUES (1540, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:43:49', '1', 'admin', '2021-12-04 13:43:49', '记录日志');
INSERT INTO `sys_log` VALUES (1541, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:43:49', '1', 'admin', '2021-12-04 13:43:49', '记录日志');
INSERT INTO `sys_log` VALUES (1542, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:43:51', '1', 'admin', '2021-12-04 13:43:51', '记录日志');
INSERT INTO `sys_log` VALUES (1543, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 13:43:55', '1', 'admin', '2021-12-04 13:43:55', '记录日志');
INSERT INTO `sys_log` VALUES (1544, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:44:25', '1', 'admin', '2021-12-04 13:44:25', '记录日志');
INSERT INTO `sys_log` VALUES (1545, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:44:26', '1', 'admin', '2021-12-04 13:44:26', '记录日志');
INSERT INTO `sys_log` VALUES (1546, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:50:54', '1', 'admin', '2021-12-04 13:50:54', '记录日志');
INSERT INTO `sys_log` VALUES (1547, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:50:54', '1', 'admin', '2021-12-04 13:50:54', '记录日志');
INSERT INTO `sys_log` VALUES (1548, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:50:56', '1', 'admin', '2021-12-04 13:50:56', '记录日志');
INSERT INTO `sys_log` VALUES (1549, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 13:56:31', '1', 'admin', '2021-12-04 13:56:31', '记录日志');
INSERT INTO `sys_log` VALUES (1550, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 13:56:32', '1', 'admin', '2021-12-04 13:56:32', '记录日志');
INSERT INTO `sys_log` VALUES (1551, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 13:56:32', '1', 'admin', '2021-12-04 13:56:32', '记录日志');
INSERT INTO `sys_log` VALUES (1552, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 13:56:32', '1', 'admin', '2021-12-04 13:56:32', '记录日志');
INSERT INTO `sys_log` VALUES (1553, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 13:56:32', '1', 'admin', '2021-12-04 13:56:32', '记录日志');
INSERT INTO `sys_log` VALUES (1554, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 13:56:33', '1', 'admin', '2021-12-04 13:56:33', '记录日志');
INSERT INTO `sys_log` VALUES (1555, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:04:43', '1', 'admin', '2021-12-04 14:04:43', '记录日志');
INSERT INTO `sys_log` VALUES (1556, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:04:43', '1', 'admin', '2021-12-04 14:04:43', '记录日志');
INSERT INTO `sys_log` VALUES (1557, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 14:04:44', '1', 'admin', '2021-12-04 14:04:44', '记录日志');
INSERT INTO `sys_log` VALUES (1558, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 14:11:26', '1', 'admin', '2021-12-04 14:11:26', '记录日志');
INSERT INTO `sys_log` VALUES (1559, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 14:11:27', '1', 'admin', '2021-12-04 14:11:27', '记录日志');
INSERT INTO `sys_log` VALUES (1560, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2021-12-04 14:11:34', '1', 'admin', '2021-12-04 14:11:34', '记录日志');
INSERT INTO `sys_log` VALUES (1561, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:14:21', '1', 'admin', '2021-12-04 14:14:21', '记录日志');
INSERT INTO `sys_log` VALUES (1562, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:14:21', '1', 'admin', '2021-12-04 14:14:21', '记录日志');
INSERT INTO `sys_log` VALUES (1563, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 14:14:23', '1', 'admin', '2021-12-04 14:14:23', '记录日志');
INSERT INTO `sys_log` VALUES (1564, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:14:23', '1', 'admin', '2021-12-04 14:14:23', '记录日志');
INSERT INTO `sys_log` VALUES (1565, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:14:23', '1', 'admin', '2021-12-04 14:14:23', '记录日志');
INSERT INTO `sys_log` VALUES (1566, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-04 14:14:26', '1', 'admin', '2021-12-04 14:14:26', '记录日志');
INSERT INTO `sys_log` VALUES (1567, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-04 14:14:26', '1', 'admin', '2021-12-04 14:14:26', '记录日志');
INSERT INTO `sys_log` VALUES (1568, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:14:26', '1', 'admin', '2021-12-04 14:14:26', '记录日志');
INSERT INTO `sys_log` VALUES (1569, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 14:14:41', '1', 'admin', '2021-12-04 14:14:41', '记录日志');
INSERT INTO `sys_log` VALUES (1570, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:19:39', '1', 'admin', '2021-12-04 14:19:39', '记录日志');
INSERT INTO `sys_log` VALUES (1571, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:19:39', '1', 'admin', '2021-12-04 14:19:39', '记录日志');
INSERT INTO `sys_log` VALUES (1572, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 14:19:40', '1', 'admin', '2021-12-04 14:19:40', '记录日志');
INSERT INTO `sys_log` VALUES (1573, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:19:40', '1', 'admin', '2021-12-04 14:19:40', '记录日志');
INSERT INTO `sys_log` VALUES (1574, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:19:40', '1', 'admin', '2021-12-04 14:19:40', '记录日志');
INSERT INTO `sys_log` VALUES (1575, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 14:19:42', '1', 'admin', '2021-12-04 14:19:42', '记录日志');
INSERT INTO `sys_log` VALUES (1576, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:20:33', '1', 'admin', '2021-12-04 14:20:33', '记录日志');
INSERT INTO `sys_log` VALUES (1577, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 14:20:33', '1', 'admin', '2021-12-04 14:20:33', '记录日志');
INSERT INTO `sys_log` VALUES (1578, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:22:45', '1', 'admin', '2021-12-04 14:22:45', '记录日志');
INSERT INTO `sys_log` VALUES (1579, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:22:45', '1', 'admin', '2021-12-04 14:22:45', '记录日志');
INSERT INTO `sys_log` VALUES (1580, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:22:48', '1', 'admin', '2021-12-04 14:22:48', '记录日志');
INSERT INTO `sys_log` VALUES (1581, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:23:58', '1', 'admin', '2021-12-04 14:23:58', '记录日志');
INSERT INTO `sys_log` VALUES (1582, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:23:58', '1', 'admin', '2021-12-04 14:23:58', '记录日志');
INSERT INTO `sys_log` VALUES (1583, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:24:00', '1', 'admin', '2021-12-04 14:24:00', '记录日志');
INSERT INTO `sys_log` VALUES (1584, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:25:58', '1', 'admin', '2021-12-04 14:25:58', '记录日志');
INSERT INTO `sys_log` VALUES (1585, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:25:58', '1', 'admin', '2021-12-04 14:25:58', '记录日志');
INSERT INTO `sys_log` VALUES (1586, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 14:26:02', '1', 'admin', '2021-12-04 14:26:02', '记录日志');
INSERT INTO `sys_log` VALUES (1587, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-04 14:26:08', '1', 'admin', '2021-12-04 14:26:08', '记录日志');
INSERT INTO `sys_log` VALUES (1588, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-04 14:26:08', '1', 'admin', '2021-12-04 14:26:08', '记录日志');
INSERT INTO `sys_log` VALUES (1589, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:26:09', '1', 'admin', '2021-12-04 14:26:09', '记录日志');
INSERT INTO `sys_log` VALUES (1590, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 14:26:09', '1', 'admin', '2021-12-04 14:26:09', '记录日志');
INSERT INTO `sys_log` VALUES (1591, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-04 14:26:22', '1', 'admin', '2021-12-04 14:26:22', '记录日志');
INSERT INTO `sys_log` VALUES (1592, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2021-12-04 14:26:22', '1', 'admin', '2021-12-04 14:26:22', '记录日志');
INSERT INTO `sys_log` VALUES (1593, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:27:56', '1', 'admin', '2021-12-04 14:27:56', '记录日志');
INSERT INTO `sys_log` VALUES (1594, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:27:56', '1', 'admin', '2021-12-04 14:27:56', '记录日志');
INSERT INTO `sys_log` VALUES (1595, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-04 14:27:58', '1', 'admin', '2021-12-04 14:27:58', '记录日志');
INSERT INTO `sys_log` VALUES (1596, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-04 14:27:58', '1', 'admin', '2021-12-04 14:27:58', '记录日志');
INSERT INTO `sys_log` VALUES (1597, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:28:00', '1', 'admin', '2021-12-04 14:28:00', '记录日志');
INSERT INTO `sys_log` VALUES (1598, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 14:28:00', '1', 'admin', '2021-12-04 14:28:00', '记录日志');
INSERT INTO `sys_log` VALUES (1599, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:30:08', '1', 'admin', '2021-12-04 14:30:08', '记录日志');
INSERT INTO `sys_log` VALUES (1600, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:30:08', '1', 'admin', '2021-12-04 14:30:08', '记录日志');
INSERT INTO `sys_log` VALUES (1601, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-04 14:30:10', '1', 'admin', '2021-12-04 14:30:10', '记录日志');
INSERT INTO `sys_log` VALUES (1602, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-04 14:30:10', '1', 'admin', '2021-12-04 14:30:10', '记录日志');
INSERT INTO `sys_log` VALUES (1603, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-04 14:30:12', '1', 'admin', '2021-12-04 14:30:12', '记录日志');
INSERT INTO `sys_log` VALUES (1604, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-04 14:30:12', '1', 'admin', '2021-12-04 14:30:12', '记录日志');
INSERT INTO `sys_log` VALUES (1605, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:30:13', '1', 'admin', '2021-12-04 14:30:13', '记录日志');
INSERT INTO `sys_log` VALUES (1606, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:32:17', '1', 'admin', '2021-12-04 14:32:17', '记录日志');
INSERT INTO `sys_log` VALUES (1607, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:32:17', '1', 'admin', '2021-12-04 14:32:17', '记录日志');
INSERT INTO `sys_log` VALUES (1608, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 14:32:59', '1', 'admin', '2021-12-04 14:32:59', '记录日志');
INSERT INTO `sys_log` VALUES (1609, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:32:59', '1', 'admin', '2021-12-04 14:32:59', '记录日志');
INSERT INTO `sys_log` VALUES (1610, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:32:59', '1', 'admin', '2021-12-04 14:32:59', '记录日志');
INSERT INTO `sys_log` VALUES (1611, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:33:02', '1', 'admin', '2021-12-04 14:33:02', '记录日志');
INSERT INTO `sys_log` VALUES (1612, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 14:33:04', '1', 'admin', '2021-12-04 14:33:04', '记录日志');
INSERT INTO `sys_log` VALUES (1613, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 14:33:11', '1', 'admin', '2021-12-04 14:33:11', '记录日志');
INSERT INTO `sys_log` VALUES (1614, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:33:11', '1', 'admin', '2021-12-04 14:33:11', '记录日志');
INSERT INTO `sys_log` VALUES (1615, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:33:11', '1', 'admin', '2021-12-04 14:33:11', '记录日志');
INSERT INTO `sys_log` VALUES (1616, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:33:13', '1', 'admin', '2021-12-04 14:33:13', '记录日志');
INSERT INTO `sys_log` VALUES (1617, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:33:13', '1', 'admin', '2021-12-04 14:33:13', '记录日志');
INSERT INTO `sys_log` VALUES (1618, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log1', '2021-12-04 14:33:16', '1', 'admin', '2021-12-04 14:33:16', '记录日志');
INSERT INTO `sys_log` VALUES (1619, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:40:04', '1', 'admin', '2021-12-04 14:40:04', '记录日志');
INSERT INTO `sys_log` VALUES (1620, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:40:04', '1', 'admin', '2021-12-04 14:40:04', '记录日志');
INSERT INTO `sys_log` VALUES (1621, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-04 14:40:06', '1', 'admin', '2021-12-04 14:40:06', '记录日志');
INSERT INTO `sys_log` VALUES (1622, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-04 14:40:06', '1', 'admin', '2021-12-04 14:40:06', '记录日志');
INSERT INTO `sys_log` VALUES (1623, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-04 14:40:07', '1', 'admin', '2021-12-04 14:40:07', '记录日志');
INSERT INTO `sys_log` VALUES (1624, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-04 14:40:07', '1', 'admin', '2021-12-04 14:40:07', '记录日志');
INSERT INTO `sys_log` VALUES (1625, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:40:08', '1', 'admin', '2021-12-04 14:40:08', '记录日志');
INSERT INTO `sys_log` VALUES (1626, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log1', '2021-12-04 14:40:10', '1', 'admin', '2021-12-04 14:40:10', '记录日志');
INSERT INTO `sys_log` VALUES (1627, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:41:51', '1', 'admin', '2021-12-04 14:41:51', '记录日志');
INSERT INTO `sys_log` VALUES (1628, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:41:51', '1', 'admin', '2021-12-04 14:41:51', '记录日志');
INSERT INTO `sys_log` VALUES (1629, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-04 14:41:53', '1', 'admin', '2021-12-04 14:41:53', '记录日志');
INSERT INTO `sys_log` VALUES (1630, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-04 14:41:53', '1', 'admin', '2021-12-04 14:41:53', '记录日志');
INSERT INTO `sys_log` VALUES (1631, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 14:41:54', '1', 'admin', '2021-12-04 14:41:54', '记录日志');
INSERT INTO `sys_log` VALUES (1632, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log1', '2021-12-04 14:42:05', '1', 'admin', '2021-12-04 14:42:05', '记录日志');
INSERT INTO `sys_log` VALUES (1633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 14:45:23', '1', 'admin', '2021-12-04 14:45:23', '记录日志');
INSERT INTO `sys_log` VALUES (1634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:45:23', '1', 'admin', '2021-12-04 14:45:23', '记录日志');
INSERT INTO `sys_log` VALUES (1635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:45:23', '1', 'admin', '2021-12-04 14:45:23', '记录日志');
INSERT INTO `sys_log` VALUES (1636, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:45:26', '1', 'admin', '2021-12-04 14:45:26', '记录日志');
INSERT INTO `sys_log` VALUES (1637, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:45:27', '1', 'admin', '2021-12-04 14:45:27', '记录日志');
INSERT INTO `sys_log` VALUES (1638, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 14:45:29', '1', 'admin', '2021-12-04 14:45:29', '记录日志');
INSERT INTO `sys_log` VALUES (1639, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 14:45:38', '1', 'admin', '2021-12-04 14:45:38', '记录日志');
INSERT INTO `sys_log` VALUES (1640, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:45:39', '1', 'admin', '2021-12-04 14:45:39', '记录日志');
INSERT INTO `sys_log` VALUES (1641, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:45:39', '1', 'admin', '2021-12-04 14:45:39', '记录日志');
INSERT INTO `sys_log` VALUES (1642, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:46:50', '1', 'admin', '2021-12-04 14:46:50', '记录日志');
INSERT INTO `sys_log` VALUES (1643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:46:50', '1', 'admin', '2021-12-04 14:46:50', '记录日志');
INSERT INTO `sys_log` VALUES (1644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 14:46:52', '1', 'admin', '2021-12-04 14:46:52', '记录日志');
INSERT INTO `sys_log` VALUES (1645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/%E5%95%8A%E5%95%8A%E5%95%8A', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:47:00', '1', 'admin', '2021-12-04 14:47:00', '记录日志');
INSERT INTO `sys_log` VALUES (1646, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/%E5%95%8A%E5%95%8A%E5%95%8A', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:47:00', '1', 'admin', '2021-12-04 14:47:00', '记录日志');
INSERT INTO `sys_log` VALUES (1647, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-04 14:50:30', '1', 'admin', '2021-12-04 14:50:30', '记录日志');
INSERT INTO `sys_log` VALUES (1648, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:53:21', '1', 'admin', '2021-12-04 14:53:21', '记录日志');
INSERT INTO `sys_log` VALUES (1649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:53:21', '1', 'admin', '2021-12-04 14:53:21', '记录日志');
INSERT INTO `sys_log` VALUES (1650, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-04 14:53:24', '1', 'admin', '2021-12-04 14:53:24', '记录日志');
INSERT INTO `sys_log` VALUES (1651, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 14:53:26', '1', 'admin', '2021-12-04 14:53:26', '记录日志');
INSERT INTO `sys_log` VALUES (1652, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 14:53:36', '1', 'admin', '2021-12-04 14:53:36', '记录日志');
INSERT INTO `sys_log` VALUES (1653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:53:36', '1', 'admin', '2021-12-04 14:53:36', '记录日志');
INSERT INTO `sys_log` VALUES (1654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:37', '1', 'admin', '2021-12-04 14:53:37', '记录日志');
INSERT INTO `sys_log` VALUES (1655, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:39', '1', 'admin', '2021-12-04 14:53:39', '记录日志');
INSERT INTO `sys_log` VALUES (1656, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 14:53:41', '1', 'admin', '2021-12-04 14:53:41', '记录日志');
INSERT INTO `sys_log` VALUES (1657, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:45', '1', 'admin', '2021-12-04 14:53:45', '记录日志');
INSERT INTO `sys_log` VALUES (1658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:53:45', '1', 'admin', '2021-12-04 14:53:45', '记录日志');
INSERT INTO `sys_log` VALUES (1659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:46', '1', 'admin', '2021-12-04 14:53:46', '记录日志');
INSERT INTO `sys_log` VALUES (1660, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:48', '1', 'admin', '2021-12-04 14:53:48', '记录日志');
INSERT INTO `sys_log` VALUES (1661, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 14:53:51', '1', 'admin', '2021-12-04 14:53:51', '记录日志');
INSERT INTO `sys_log` VALUES (1662, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:55', '1', 'admin', '2021-12-04 14:53:55', '记录日志');
INSERT INTO `sys_log` VALUES (1663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:53:55', '1', 'admin', '2021-12-04 14:53:55', '记录日志');
INSERT INTO `sys_log` VALUES (1664, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:55', '1', 'admin', '2021-12-04 14:53:55', '记录日志');
INSERT INTO `sys_log` VALUES (1665, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:53:57', '1', 'admin', '2021-12-04 14:53:57', '记录日志');
INSERT INTO `sys_log` VALUES (1666, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 14:53:58', '1', 'admin', '2021-12-04 14:53:58', '记录日志');
INSERT INTO `sys_log` VALUES (1667, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 14:54:10', '1', 'admin', '2021-12-04 14:54:10', '记录日志');
INSERT INTO `sys_log` VALUES (1668, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 14:54:11', '1', 'admin', '2021-12-04 14:54:11', '记录日志');
INSERT INTO `sys_log` VALUES (1669, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 14:54:11', '1', 'admin', '2021-12-04 14:54:11', '记录日志');
INSERT INTO `sys_log` VALUES (1670, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 14:54:12', '1', 'admin', '2021-12-04 14:54:12', '记录日志');
INSERT INTO `sys_log` VALUES (1671, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 14:54:12', '1', 'admin', '2021-12-04 14:54:12', '记录日志');
INSERT INTO `sys_log` VALUES (1672, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 14:54:13', '1', 'admin', '2021-12-04 14:54:13', '记录日志');
INSERT INTO `sys_log` VALUES (1673, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 15:00:24', '1', 'admin', '2021-12-04 15:00:24', '记录日志');
INSERT INTO `sys_log` VALUES (1674, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 15:00:24', '1', 'admin', '2021-12-04 15:00:24', '记录日志');
INSERT INTO `sys_log` VALUES (1675, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 15:00:31', '1', 'admin', '2021-12-04 15:00:31', '记录日志');
INSERT INTO `sys_log` VALUES (1676, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 15:00:34', '1', 'admin', '2021-12-04 15:00:34', '记录日志');
INSERT INTO `sys_log` VALUES (1677, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-04 15:01:24', '1', 'admin', '2021-12-04 15:01:24', '记录日志');
INSERT INTO `sys_log` VALUES (1678, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 15:03:36', '1', 'admin', '2021-12-04 15:03:36', '记录日志');
INSERT INTO `sys_log` VALUES (1679, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:03:36', '1', 'admin', '2021-12-04 15:03:36', '记录日志');
INSERT INTO `sys_log` VALUES (1680, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:36', '1', 'admin', '2021-12-04 15:03:36', '记录日志');
INSERT INTO `sys_log` VALUES (1681, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:37', '1', 'admin', '2021-12-04 15:03:37', '记录日志');
INSERT INTO `sys_log` VALUES (1682, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:41', '1', 'admin', '2021-12-04 15:03:41', '记录日志');
INSERT INTO `sys_log` VALUES (1683, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:45', '1', 'admin', '2021-12-04 15:03:45', '记录日志');
INSERT INTO `sys_log` VALUES (1684, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:48', '1', 'admin', '2021-12-04 15:03:48', '记录日志');
INSERT INTO `sys_log` VALUES (1685, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:49', '1', 'admin', '2021-12-04 15:03:49', '记录日志');
INSERT INTO `sys_log` VALUES (1686, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:50', '1', 'admin', '2021-12-04 15:03:50', '记录日志');
INSERT INTO `sys_log` VALUES (1687, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:03:51', '1', 'admin', '2021-12-04 15:03:51', '记录日志');
INSERT INTO `sys_log` VALUES (1688, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:03:57', '1', 'admin', '2021-12-04 15:03:57', '记录日志');
INSERT INTO `sys_log` VALUES (1689, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:04:07', '1', 'admin', '2021-12-04 15:04:07', '记录日志');
INSERT INTO `sys_log` VALUES (1690, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:04:07', '1', 'admin', '2021-12-04 15:04:07', '记录日志');
INSERT INTO `sys_log` VALUES (1691, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:04:07', '1', 'admin', '2021-12-04 15:04:07', '记录日志');
INSERT INTO `sys_log` VALUES (1692, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:04:09', '1', 'admin', '2021-12-04 15:04:09', '记录日志');
INSERT INTO `sys_log` VALUES (1693, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:04:09', '1', 'admin', '2021-12-04 15:04:09', '记录日志');
INSERT INTO `sys_log` VALUES (1694, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 15:04:10', '1', 'admin', '2021-12-04 15:04:10', '记录日志');
INSERT INTO `sys_log` VALUES (1695, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 15:04:33', '1', 'admin', '2021-12-04 15:04:33', '记录日志');
INSERT INTO `sys_log` VALUES (1696, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 15:04:33', '1', 'admin', '2021-12-04 15:04:33', '记录日志');
INSERT INTO `sys_log` VALUES (1697, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:05:54', '1', 'admin', '2021-12-04 15:05:54', '记录日志');
INSERT INTO `sys_log` VALUES (1698, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:05:54', '1', 'admin', '2021-12-04 15:05:54', '记录日志');
INSERT INTO `sys_log` VALUES (1699, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 15:05:55', '1', 'admin', '2021-12-04 15:05:55', '记录日志');
INSERT INTO `sys_log` VALUES (1700, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:20:32', '1', 'admin', '2021-12-04 15:20:32', '记录日志');
INSERT INTO `sys_log` VALUES (1701, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:20:33', '1', 'admin', '2021-12-04 15:20:33', '记录日志');
INSERT INTO `sys_log` VALUES (1702, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 15:20:36', '1', 'admin', '2021-12-04 15:20:36', '记录日志');
INSERT INTO `sys_log` VALUES (1703, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:20:36', '1', 'admin', '2021-12-04 15:20:36', '记录日志');
INSERT INTO `sys_log` VALUES (1704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:20:36', '1', 'admin', '2021-12-04 15:20:36', '记录日志');
INSERT INTO `sys_log` VALUES (1705, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 15:20:37', '1', 'admin', '2021-12-04 15:20:37', '记录日志');
INSERT INTO `sys_log` VALUES (1706, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:20:56', '1', 'admin', '2021-12-04 15:20:56', '记录日志');
INSERT INTO `sys_log` VALUES (1707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:21:04', '1', 'admin', '2021-12-04 15:21:04', '记录日志');
INSERT INTO `sys_log` VALUES (1708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:21:06', '1', 'admin', '2021-12-04 15:21:06', '记录日志');
INSERT INTO `sys_log` VALUES (1709, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:21:22', '1', 'admin', '2021-12-04 15:21:22', '记录日志');
INSERT INTO `sys_log` VALUES (1710, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:21:22', '1', 'admin', '2021-12-04 15:21:22', '记录日志');
INSERT INTO `sys_log` VALUES (1711, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:21:22', '1', 'admin', '2021-12-04 15:21:22', '记录日志');
INSERT INTO `sys_log` VALUES (1712, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:22:02', '1', 'admin', '2021-12-04 15:22:02', '记录日志');
INSERT INTO `sys_log` VALUES (1713, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:22:02', '1', 'admin', '2021-12-04 15:22:02', '记录日志');
INSERT INTO `sys_log` VALUES (1714, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/check', '2021-12-04 15:22:03', '1', 'admin', '2021-12-04 15:22:03', '记录日志');
INSERT INTO `sys_log` VALUES (1715, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/%E5%95%8A%E5%95%8A%E5%95%8A', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:25:01', '1', 'admin', '2021-12-04 15:25:01', '记录日志');
INSERT INTO `sys_log` VALUES (1716, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/%E5%95%8A%E5%95%8A%E5%95%8A', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:25:01', '1', 'admin', '2021-12-04 15:25:01', '记录日志');
INSERT INTO `sys_log` VALUES (1717, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 15:25:23', '1', 'admin', '2021-12-04 15:25:23', '记录日志');
INSERT INTO `sys_log` VALUES (1718, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:25:23', '1', 'admin', '2021-12-04 15:25:23', '记录日志');
INSERT INTO `sys_log` VALUES (1719, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:25:23', '1', 'admin', '2021-12-04 15:25:23', '记录日志');
INSERT INTO `sys_log` VALUES (1720, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:25:28', '1', 'admin', '2021-12-04 15:25:28', '记录日志');
INSERT INTO `sys_log` VALUES (1721, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:25:30', '1', 'admin', '2021-12-04 15:25:30', '记录日志');
INSERT INTO `sys_log` VALUES (1722, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:25:41', '1', 'admin', '2021-12-04 15:25:41', '记录日志');
INSERT INTO `sys_log` VALUES (1723, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:25:41', '1', 'admin', '2021-12-04 15:25:41', '记录日志');
INSERT INTO `sys_log` VALUES (1724, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:25:43', '1', 'admin', '2021-12-04 15:25:43', '记录日志');
INSERT INTO `sys_log` VALUES (1725, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=103', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:26:11', '1', 'admin', '2021-12-04 15:26:11', '记录日志');
INSERT INTO `sys_log` VALUES (1726, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:26:12', '1', 'admin', '2021-12-04 15:26:12', '记录日志');
INSERT INTO `sys_log` VALUES (1727, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:26:12', '1', 'admin', '2021-12-04 15:26:12', '记录日志');
INSERT INTO `sys_log` VALUES (1728, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:26:22', '1', 'admin', '2021-12-04 15:26:22', '记录日志');
INSERT INTO `sys_log` VALUES (1729, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:26:24', '1', 'admin', '2021-12-04 15:26:24', '记录日志');
INSERT INTO `sys_log` VALUES (1730, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:26:24', '1', 'admin', '2021-12-04 15:26:24', '记录日志');
INSERT INTO `sys_log` VALUES (1731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:27:08', '1', 'admin', '2021-12-04 15:27:08', '记录日志');
INSERT INTO `sys_log` VALUES (1732, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:27:28', '1', 'admin', '2021-12-04 15:27:28', '记录日志');
INSERT INTO `sys_log` VALUES (1733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:27:28', '1', 'admin', '2021-12-04 15:27:28', '记录日志');
INSERT INTO `sys_log` VALUES (1734, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:27:28', '1', 'admin', '2021-12-04 15:27:28', '记录日志');
INSERT INTO `sys_log` VALUES (1735, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:27:31', '1', 'admin', '2021-12-04 15:27:31', '记录日志');
INSERT INTO `sys_log` VALUES (1736, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:27:42', '1', 'admin', '2021-12-04 15:27:42', '记录日志');
INSERT INTO `sys_log` VALUES (1737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:27:42', '1', 'admin', '2021-12-04 15:27:42', '记录日志');
INSERT INTO `sys_log` VALUES (1738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:27:42', '1', 'admin', '2021-12-04 15:27:42', '记录日志');
INSERT INTO `sys_log` VALUES (1739, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:27:51', '1', 'admin', '2021-12-04 15:27:51', '记录日志');
INSERT INTO `sys_log` VALUES (1740, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:27:51', '1', 'admin', '2021-12-04 15:27:51', '记录日志');
INSERT INTO `sys_log` VALUES (1741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:27:51', '1', 'admin', '2021-12-04 15:27:51', '记录日志');
INSERT INTO `sys_log` VALUES (1742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:27:53', '1', 'admin', '2021-12-04 15:27:53', '记录日志');
INSERT INTO `sys_log` VALUES (1743, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=103', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:28:07', '1', 'admin', '2021-12-04 15:28:07', '记录日志');
INSERT INTO `sys_log` VALUES (1744, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:28:07', '1', 'admin', '2021-12-04 15:28:07', '记录日志');
INSERT INTO `sys_log` VALUES (1745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:28:07', '1', 'admin', '2021-12-04 15:28:07', '记录日志');
INSERT INTO `sys_log` VALUES (1746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:28:09', '1', 'admin', '2021-12-04 15:28:09', '记录日志');
INSERT INTO `sys_log` VALUES (1747, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:28:23', '1', 'admin', '2021-12-04 15:28:23', '记录日志');
INSERT INTO `sys_log` VALUES (1748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:28:23', '1', 'admin', '2021-12-04 15:28:23', '记录日志');
INSERT INTO `sys_log` VALUES (1749, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:28:23', '1', 'admin', '2021-12-04 15:28:23', '记录日志');
INSERT INTO `sys_log` VALUES (1750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 15:28:24', '1', 'admin', '2021-12-04 15:28:24', '记录日志');
INSERT INTO `sys_log` VALUES (1751, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=103', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 15:28:29', '1', 'admin', '2021-12-04 15:28:29', '记录日志');
INSERT INTO `sys_log` VALUES (1752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:28:29', '1', 'admin', '2021-12-04 15:28:29', '记录日志');
INSERT INTO `sys_log` VALUES (1753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:28:29', '1', 'admin', '2021-12-04 15:28:29', '记录日志');
INSERT INTO `sys_log` VALUES (1754, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:28:32', '1', 'admin', '2021-12-04 15:28:32', '记录日志');
INSERT INTO `sys_log` VALUES (1755, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:28:32', '1', 'admin', '2021-12-04 15:28:32', '记录日志');
INSERT INTO `sys_log` VALUES (1756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 15:28:34', '1', 'admin', '2021-12-04 15:28:34', '记录日志');
INSERT INTO `sys_log` VALUES (1757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:28:34', '1', 'admin', '2021-12-04 15:28:34', '记录日志');
INSERT INTO `sys_log` VALUES (1758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:28:34', '1', 'admin', '2021-12-04 15:28:34', '记录日志');
INSERT INTO `sys_log` VALUES (1759, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-04 15:28:35', '1', 'admin', '2021-12-04 15:28:35', '记录日志');
INSERT INTO `sys_log` VALUES (1760, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:28:39', '1', 'admin', '2021-12-04 15:28:39', '记录日志');
INSERT INTO `sys_log` VALUES (1761, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:28:39', '1', 'admin', '2021-12-04 15:28:39', '记录日志');
INSERT INTO `sys_log` VALUES (1762, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:28:41', '1', 'admin', '2021-12-04 15:28:41', '记录日志');
INSERT INTO `sys_log` VALUES (1763, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-04 15:28:42', '1', 'admin', '2021-12-04 15:28:42', '记录日志');
INSERT INTO `sys_log` VALUES (1764, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2021-12-04 15:29:19', '1', 'admin', '2021-12-04 15:29:19', '记录日志');
INSERT INTO `sys_log` VALUES (1765, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:29:19', '1', 'admin', '2021-12-04 15:29:19', '记录日志');
INSERT INTO `sys_log` VALUES (1766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:29:19', '1', 'admin', '2021-12-04 15:29:19', '记录日志');
INSERT INTO `sys_log` VALUES (1767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:29:28', '1', 'admin', '2021-12-04 15:29:28', '记录日志');
INSERT INTO `sys_log` VALUES (1768, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:29:28', '1', 'admin', '2021-12-04 15:29:28', '记录日志');
INSERT INTO `sys_log` VALUES (1769, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:29:30', '1', 'admin', '2021-12-04 15:29:30', '记录日志');
INSERT INTO `sys_log` VALUES (1770, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:29:30', '1', 'admin', '2021-12-04 15:29:30', '记录日志');
INSERT INTO `sys_log` VALUES (1771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 15:29:36', '1', 'admin', '2021-12-04 15:29:36', '记录日志');
INSERT INTO `sys_log` VALUES (1772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 15:29:36', '1', 'admin', '2021-12-04 15:29:36', '记录日志');
INSERT INTO `sys_log` VALUES (1773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2021-12-04 15:29:39', '1', 'admin', '2021-12-04 15:29:39', '记录日志');
INSERT INTO `sys_log` VALUES (1774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2021-12-04 15:29:39', '1', 'admin', '2021-12-04 15:29:39', '记录日志');
INSERT INTO `sys_log` VALUES (1775, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2021-12-04 15:29:43', '1', 'admin', '2021-12-04 15:29:43', '记录日志');
INSERT INTO `sys_log` VALUES (1776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 15:29:43', '1', 'admin', '2021-12-04 15:29:43', '记录日志');
INSERT INTO `sys_log` VALUES (1777, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:29:45', '1', 'admin', '2021-12-04 15:29:45', '记录日志');
INSERT INTO `sys_log` VALUES (1778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:29:45', '1', 'admin', '2021-12-04 15:29:45', '记录日志');
INSERT INTO `sys_log` VALUES (1779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:29:50', '1', 'admin', '2021-12-04 15:29:50', '记录日志');
INSERT INTO `sys_log` VALUES (1780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 15:29:51', '1', 'admin', '2021-12-04 15:29:51', '记录日志');
INSERT INTO `sys_log` VALUES (1781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/tableData', '2021-12-04 15:29:51', '1', 'admin', '2021-12-04 15:29:51', '记录日志');
INSERT INTO `sys_log` VALUES (1782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 15:29:52', '1', 'admin', '2021-12-04 15:29:52', '记录日志');
INSERT INTO `sys_log` VALUES (1783, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tableData', '2021-12-04 15:29:52', '1', 'admin', '2021-12-04 15:29:52', '记录日志');
INSERT INTO `sys_log` VALUES (1784, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:32:20', '1', 'admin', '2021-12-04 15:32:20', '记录日志');
INSERT INTO `sys_log` VALUES (1785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:32:20', '1', 'admin', '2021-12-04 15:32:20', '记录日志');
INSERT INTO `sys_log` VALUES (1786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:32:21', '1', 'admin', '2021-12-04 15:32:21', '记录日志');
INSERT INTO `sys_log` VALUES (1787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 15:32:22', '1', 'admin', '2021-12-04 15:32:22', '记录日志');
INSERT INTO `sys_log` VALUES (1788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 15:32:23', '1', 'admin', '2021-12-04 15:32:23', '记录日志');
INSERT INTO `sys_log` VALUES (1789, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 15:33:01', '1', 'admin', '2021-12-04 15:33:01', '记录日志');
INSERT INTO `sys_log` VALUES (1790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:33:01', '1', 'admin', '2021-12-04 15:33:01', '记录日志');
INSERT INTO `sys_log` VALUES (1791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:33:01', '1', 'admin', '2021-12-04 15:33:01', '记录日志');
INSERT INTO `sys_log` VALUES (1792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-04 15:33:05', '1', 'admin', '2021-12-04 15:33:05', '记录日志');
INSERT INTO `sys_log` VALUES (1793, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 15:33:08', '1', 'admin', '2021-12-04 15:33:08', '记录日志');
INSERT INTO `sys_log` VALUES (1794, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 15:33:08', '1', 'admin', '2021-12-04 15:33:08', '记录日志');
INSERT INTO `sys_log` VALUES (1795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:35:07', '1', 'admin', '2021-12-04 15:35:07', '记录日志');
INSERT INTO `sys_log` VALUES (1796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:35:07', '1', 'admin', '2021-12-04 15:35:07', '记录日志');
INSERT INTO `sys_log` VALUES (1797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:35:08', '1', 'admin', '2021-12-04 15:35:08', '记录日志');
INSERT INTO `sys_log` VALUES (1798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 15:35:09', '1', 'admin', '2021-12-04 15:35:09', '记录日志');
INSERT INTO `sys_log` VALUES (1799, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 15:35:16', '1', 'admin', '2021-12-04 15:35:16', '记录日志');
INSERT INTO `sys_log` VALUES (1800, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:36:18', '1', 'admin', '2021-12-04 15:36:18', '记录日志');
INSERT INTO `sys_log` VALUES (1801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:36:19', '1', 'admin', '2021-12-04 15:36:19', '记录日志');
INSERT INTO `sys_log` VALUES (1802, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:36:20', '1', 'admin', '2021-12-04 15:36:20', '记录日志');
INSERT INTO `sys_log` VALUES (1803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 15:36:20', '1', 'admin', '2021-12-04 15:36:20', '记录日志');
INSERT INTO `sys_log` VALUES (1804, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 15:36:22', '1', 'admin', '2021-12-04 15:36:22', '记录日志');
INSERT INTO `sys_log` VALUES (1805, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:38:55', '1', 'admin', '2021-12-04 15:38:55', '记录日志');
INSERT INTO `sys_log` VALUES (1806, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:38:55', '1', 'admin', '2021-12-04 15:38:55', '记录日志');
INSERT INTO `sys_log` VALUES (1807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:38:58', '1', 'admin', '2021-12-04 15:38:58', '记录日志');
INSERT INTO `sys_log` VALUES (1808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 15:38:59', '1', 'admin', '2021-12-04 15:38:59', '记录日志');
INSERT INTO `sys_log` VALUES (1809, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 15:39:04', '1', 'admin', '2021-12-04 15:39:04', '记录日志');
INSERT INTO `sys_log` VALUES (1810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:39:48', '1', 'admin', '2021-12-04 15:39:48', '记录日志');
INSERT INTO `sys_log` VALUES (1811, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:39:48', '1', 'admin', '2021-12-04 15:39:48', '记录日志');
INSERT INTO `sys_log` VALUES (1812, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:39:50', '1', 'admin', '2021-12-04 15:39:50', '记录日志');
INSERT INTO `sys_log` VALUES (1813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 15:39:50', '1', 'admin', '2021-12-04 15:39:50', '记录日志');
INSERT INTO `sys_log` VALUES (1814, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:41:00', '1', 'admin', '2021-12-04 15:41:00', '记录日志');
INSERT INTO `sys_log` VALUES (1815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:41:00', '1', 'admin', '2021-12-04 15:41:00', '记录日志');
INSERT INTO `sys_log` VALUES (1816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:41:01', '1', 'admin', '2021-12-04 15:41:01', '记录日志');
INSERT INTO `sys_log` VALUES (1817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 15:41:01', '1', 'admin', '2021-12-04 15:41:01', '记录日志');
INSERT INTO `sys_log` VALUES (1818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 15:41:02', '1', 'admin', '2021-12-04 15:41:02', '记录日志');
INSERT INTO `sys_log` VALUES (1819, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 15:42:29', '1', 'admin', '2021-12-04 15:42:29', '记录日志');
INSERT INTO `sys_log` VALUES (1820, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 15:42:29', '1', 'admin', '2021-12-04 15:42:29', '记录日志');
INSERT INTO `sys_log` VALUES (1821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:46:49', '1', 'admin', '2021-12-04 15:46:49', '记录日志');
INSERT INTO `sys_log` VALUES (1822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:46:50', '1', 'admin', '2021-12-04 15:46:50', '记录日志');
INSERT INTO `sys_log` VALUES (1823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:46:50', '1', 'admin', '2021-12-04 15:46:50', '记录日志');
INSERT INTO `sys_log` VALUES (1824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-04 15:47:01', '1', 'admin', '2021-12-04 15:47:01', '记录日志');
INSERT INTO `sys_log` VALUES (1825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-04 15:47:01', '1', 'admin', '2021-12-04 15:47:01', '记录日志');
INSERT INTO `sys_log` VALUES (1826, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 15:49:37', '1', 'admin', '2021-12-04 15:49:37', '记录日志');
INSERT INTO `sys_log` VALUES (1827, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 15:49:37', '1', 'admin', '2021-12-04 15:49:37', '记录日志');
INSERT INTO `sys_log` VALUES (1828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 15:49:38', '1', 'admin', '2021-12-04 15:49:38', '记录日志');
INSERT INTO `sys_log` VALUES (1829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:10:18', '1', 'admin', '2021-12-04 16:10:18', '记录日志');
INSERT INTO `sys_log` VALUES (1830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:10:18', '1', 'admin', '2021-12-04 16:10:18', '记录日志');
INSERT INTO `sys_log` VALUES (1831, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:10:23', '1', 'admin', '2021-12-04 16:10:23', '记录日志');
INSERT INTO `sys_log` VALUES (1832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:11:49', '1', 'admin', '2021-12-04 16:11:49', '记录日志');
INSERT INTO `sys_log` VALUES (1833, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:11:49', '1', 'admin', '2021-12-04 16:11:49', '记录日志');
INSERT INTO `sys_log` VALUES (1834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:11:50', '1', 'admin', '2021-12-04 16:11:50', '记录日志');
INSERT INTO `sys_log` VALUES (1835, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:12:48', '1', 'admin', '2021-12-04 16:12:48', '记录日志');
INSERT INTO `sys_log` VALUES (1836, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:12:48', '1', 'admin', '2021-12-04 16:12:48', '记录日志');
INSERT INTO `sys_log` VALUES (1837, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:12:49', '1', 'admin', '2021-12-04 16:12:49', '记录日志');
INSERT INTO `sys_log` VALUES (1838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:13:54', '1', 'admin', '2021-12-04 16:13:54', '记录日志');
INSERT INTO `sys_log` VALUES (1839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:13:54', '1', 'admin', '2021-12-04 16:13:54', '记录日志');
INSERT INTO `sys_log` VALUES (1840, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:13:55', '1', 'admin', '2021-12-04 16:13:55', '记录日志');
INSERT INTO `sys_log` VALUES (1841, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:15:24', '1', 'admin', '2021-12-04 16:15:24', '记录日志');
INSERT INTO `sys_log` VALUES (1842, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:15:24', '1', 'admin', '2021-12-04 16:15:24', '记录日志');
INSERT INTO `sys_log` VALUES (1843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:15:26', '1', 'admin', '2021-12-04 16:15:26', '记录日志');
INSERT INTO `sys_log` VALUES (1844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:17:51', '1', 'admin', '2021-12-04 16:17:51', '记录日志');
INSERT INTO `sys_log` VALUES (1845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:17:51', '1', 'admin', '2021-12-04 16:17:51', '记录日志');
INSERT INTO `sys_log` VALUES (1846, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:17:53', '1', 'admin', '2021-12-04 16:17:53', '记录日志');
INSERT INTO `sys_log` VALUES (1847, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 16:17:56', '1', 'admin', '2021-12-04 16:17:56', '记录日志');
INSERT INTO `sys_log` VALUES (1848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 16:17:57', '1', 'admin', '2021-12-04 16:17:57', '记录日志');
INSERT INTO `sys_log` VALUES (1849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:19:23', '1', 'admin', '2021-12-04 16:19:23', '记录日志');
INSERT INTO `sys_log` VALUES (1850, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:19:23', '1', 'admin', '2021-12-04 16:19:23', '记录日志');
INSERT INTO `sys_log` VALUES (1851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:19:24', '1', 'admin', '2021-12-04 16:19:24', '记录日志');
INSERT INTO `sys_log` VALUES (1852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:23:21', '1', 'admin', '2021-12-04 16:23:21', '记录日志');
INSERT INTO `sys_log` VALUES (1853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:23:21', '1', 'admin', '2021-12-04 16:23:21', '记录日志');
INSERT INTO `sys_log` VALUES (1854, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:23:22', '1', 'admin', '2021-12-04 16:23:22', '记录日志');
INSERT INTO `sys_log` VALUES (1855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 16:23:35', '1', 'admin', '2021-12-04 16:23:35', '记录日志');
INSERT INTO `sys_log` VALUES (1856, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:28:05', '1', 'admin', '2021-12-04 16:28:05', '记录日志');
INSERT INTO `sys_log` VALUES (1857, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:28:05', '1', 'admin', '2021-12-04 16:28:05', '记录日志');
INSERT INTO `sys_log` VALUES (1858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:28:06', '1', 'admin', '2021-12-04 16:28:06', '记录日志');
INSERT INTO `sys_log` VALUES (1859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 16:28:09', '1', 'admin', '2021-12-04 16:28:09', '记录日志');
INSERT INTO `sys_log` VALUES (1860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 16:28:20', '1', 'admin', '2021-12-04 16:28:20', '记录日志');
INSERT INTO `sys_log` VALUES (1861, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:31:38', '1', 'admin', '2021-12-04 16:31:38', '记录日志');
INSERT INTO `sys_log` VALUES (1862, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:31:38', '1', 'admin', '2021-12-04 16:31:38', '记录日志');
INSERT INTO `sys_log` VALUES (1863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:31:39', '1', 'admin', '2021-12-04 16:31:39', '记录日志');
INSERT INTO `sys_log` VALUES (1864, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 16:31:42', '1', 'admin', '2021-12-04 16:31:42', '记录日志');
INSERT INTO `sys_log` VALUES (1865, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 16:31:44', '1', 'admin', '2021-12-04 16:31:44', '记录日志');
INSERT INTO `sys_log` VALUES (1866, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 16:46:56', '1', 'admin', '2021-12-04 16:46:56', '记录日志');
INSERT INTO `sys_log` VALUES (1867, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 16:46:56', '1', 'admin', '2021-12-04 16:46:56', '记录日志');
INSERT INTO `sys_log` VALUES (1868, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:46:56', '1', 'admin', '2021-12-04 16:46:56', '记录日志');
INSERT INTO `sys_log` VALUES (1869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:46:59', '1', 'admin', '2021-12-04 16:46:59', '记录日志');
INSERT INTO `sys_log` VALUES (1870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:47:02', '1', 'admin', '2021-12-04 16:47:02', '记录日志');
INSERT INTO `sys_log` VALUES (1871, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:47:04', '1', 'admin', '2021-12-04 16:47:04', '记录日志');
INSERT INTO `sys_log` VALUES (1872, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:47:08', '1', 'admin', '2021-12-04 16:47:08', '记录日志');
INSERT INTO `sys_log` VALUES (1873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 16:47:11', '1', 'admin', '2021-12-04 16:47:11', '记录日志');
INSERT INTO `sys_log` VALUES (1874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 16:47:11', '1', 'admin', '2021-12-04 16:47:11', '记录日志');
INSERT INTO `sys_log` VALUES (1875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 16:47:17', '1', 'admin', '2021-12-04 16:47:17', '记录日志');
INSERT INTO `sys_log` VALUES (1876, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 16:47:17', '1', 'admin', '2021-12-04 16:47:17', '记录日志');
INSERT INTO `sys_log` VALUES (1877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:47:17', '1', 'admin', '2021-12-04 16:47:17', '记录日志');
INSERT INTO `sys_log` VALUES (1878, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2021-12-04 16:47:22', '1', 'admin', '2021-12-04 16:47:22', '记录日志');
INSERT INTO `sys_log` VALUES (1879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:47:28', '1', 'admin', '2021-12-04 16:47:28', '记录日志');
INSERT INTO `sys_log` VALUES (1880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:47:28', '1', 'admin', '2021-12-04 16:47:28', '记录日志');
INSERT INTO `sys_log` VALUES (1881, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 16:47:29', '1', 'admin', '2021-12-04 16:47:29', '记录日志');
INSERT INTO `sys_log` VALUES (1882, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 16:47:29', '1', 'admin', '2021-12-04 16:47:29', '记录日志');
INSERT INTO `sys_log` VALUES (1883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:47:29', '1', 'admin', '2021-12-04 16:47:29', '记录日志');
INSERT INTO `sys_log` VALUES (1884, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2021-12-04 16:47:32', '1', 'admin', '2021-12-04 16:47:32', '记录日志');
INSERT INTO `sys_log` VALUES (1885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:47:35', '1', 'admin', '2021-12-04 16:47:35', '记录日志');
INSERT INTO `sys_log` VALUES (1886, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:47:37', '1', 'admin', '2021-12-04 16:47:37', '记录日志');
INSERT INTO `sys_log` VALUES (1887, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-04 16:47:44', '1', 'admin', '2021-12-04 16:47:44', '记录日志');
INSERT INTO `sys_log` VALUES (1888, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 16:47:44', '1', 'admin', '2021-12-04 16:47:44', '记录日志');
INSERT INTO `sys_log` VALUES (1889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2021-12-04 16:47:45', '1', 'admin', '2021-12-04 16:47:45', '记录日志');
INSERT INTO `sys_log` VALUES (1890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2021-12-04 16:47:45', '1', 'admin', '2021-12-04 16:47:45', '记录日志');
INSERT INTO `sys_log` VALUES (1891, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2021-12-04 16:47:48', '1', 'admin', '2021-12-04 16:47:48', '记录日志');
INSERT INTO `sys_log` VALUES (1892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-04 16:47:48', '1', 'admin', '2021-12-04 16:47:48', '记录日志');
INSERT INTO `sys_log` VALUES (1893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:47:51', '1', 'admin', '2021-12-04 16:47:51', '记录日志');
INSERT INTO `sys_log` VALUES (1894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:47:51', '1', 'admin', '2021-12-04 16:47:51', '记录日志');
INSERT INTO `sys_log` VALUES (1895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:48:07', '1', 'admin', '2021-12-04 16:48:07', '记录日志');
INSERT INTO `sys_log` VALUES (1896, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-04 16:49:00', '1', 'admin', '2021-12-04 16:49:00', '记录日志');
INSERT INTO `sys_log` VALUES (1897, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 16:49:00', '1', 'admin', '2021-12-04 16:49:00', '记录日志');
INSERT INTO `sys_log` VALUES (1898, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:49:00', '1', 'admin', '2021-12-04 16:49:00', '记录日志');
INSERT INTO `sys_log` VALUES (1899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:49:03', '1', 'admin', '2021-12-04 16:49:03', '记录日志');
INSERT INTO `sys_log` VALUES (1900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:49:04', '1', 'admin', '2021-12-04 16:49:04', '记录日志');
INSERT INTO `sys_log` VALUES (1901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:49:09', '1', 'admin', '2021-12-04 16:49:09', '记录日志');
INSERT INTO `sys_log` VALUES (1902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-04 16:49:10', '1', 'admin', '2021-12-04 16:49:10', '记录日志');
INSERT INTO `sys_log` VALUES (1903, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=101', '127.0.0.1', '/system/res/postUpdate', '2021-12-04 16:49:34', '1', 'admin', '2021-12-04 16:49:34', '记录日志');
INSERT INTO `sys_log` VALUES (1904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-04 16:49:34', '1', 'admin', '2021-12-04 16:49:34', '记录日志');
INSERT INTO `sys_log` VALUES (1905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-04 16:49:34', '1', 'admin', '2021-12-04 16:49:34', '记录日志');
INSERT INTO `sys_log` VALUES (1906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-04 16:49:36', '1', 'admin', '2021-12-04 16:49:36', '记录日志');
INSERT INTO `sys_log` VALUES (1907, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-04 16:49:36', '1', 'admin', '2021-12-04 16:49:36', '记录日志');
INSERT INTO `sys_log` VALUES (1908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-04 16:50:26', '1', 'admin', '2021-12-04 16:50:26', '记录日志');
INSERT INTO `sys_log` VALUES (1909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-04 16:50:41', '1', 'admin', '2021-12-04 16:50:41', '记录日志');
INSERT INTO `sys_log` VALUES (1910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-04 16:50:50', '1', 'admin', '2021-12-04 16:50:50', '记录日志');
INSERT INTO `sys_log` VALUES (1911, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-05 20:03:06', '1', 'admin', '2021-12-05 20:03:06', '记录日志');
INSERT INTO `sys_log` VALUES (1912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-05 20:03:07', '1', 'admin', '2021-12-05 20:03:07', '记录日志');
INSERT INTO `sys_log` VALUES (1913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-05 20:03:14', '1', 'admin', '2021-12-05 20:03:14', '记录日志');
INSERT INTO `sys_log` VALUES (1914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 20:03:14', '1', 'admin', '2021-12-05 20:03:14', '记录日志');
INSERT INTO `sys_log` VALUES (1915, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 20:15:43', '1', 'admin', '2021-12-05 20:15:43', '记录日志');
INSERT INTO `sys_log` VALUES (1916, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 20:16:10', '1', 'admin', '2021-12-05 20:16:10', '记录日志');
INSERT INTO `sys_log` VALUES (1917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 20:16:13', '1', 'admin', '2021-12-05 20:16:13', '记录日志');
INSERT INTO `sys_log` VALUES (1918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 20:16:28', '1', 'admin', '2021-12-05 20:16:28', '记录日志');
INSERT INTO `sys_log` VALUES (1919, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 20:16:42', '1', 'admin', '2021-12-05 20:16:42', '记录日志');
INSERT INTO `sys_log` VALUES (1920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 20:16:49', '1', 'admin', '2021-12-05 20:16:49', '记录日志');
INSERT INTO `sys_log` VALUES (1921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-05 20:18:07', '1', 'admin', '2021-12-05 20:18:07', '记录日志');
INSERT INTO `sys_log` VALUES (1922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-05 20:19:48', '1', 'admin', '2021-12-05 20:19:48', '记录日志');
INSERT INTO `sys_log` VALUES (1923, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:19:48', '1', 'admin', '2021-12-05 20:19:48', '记录日志');
INSERT INTO `sys_log` VALUES (1924, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 20:19:52', '1', 'admin', '2021-12-05 20:19:52', '记录日志');
INSERT INTO `sys_log` VALUES (1925, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-05 20:20:28', '1', 'admin', '2021-12-05 20:20:28', '记录日志');
INSERT INTO `sys_log` VALUES (1926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:20:28', '1', 'admin', '2021-12-05 20:20:28', '记录日志');
INSERT INTO `sys_log` VALUES (1927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 20:50:47', '1', 'admin', '2021-12-05 20:50:47', '记录日志');
INSERT INTO `sys_log` VALUES (1928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-05 20:51:46', '1', 'admin', '2021-12-05 20:51:46', '记录日志');
INSERT INTO `sys_log` VALUES (1929, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-05 20:51:46', '1', 'admin', '2021-12-05 20:51:46', '记录日志');
INSERT INTO `sys_log` VALUES (1930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-05 20:51:47', '1', 'admin', '2021-12-05 20:51:47', '记录日志');
INSERT INTO `sys_log` VALUES (1931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:51:47', '1', 'admin', '2021-12-05 20:51:47', '记录日志');
INSERT INTO `sys_log` VALUES (1932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 20:51:48', '1', 'admin', '2021-12-05 20:51:48', '记录日志');
INSERT INTO `sys_log` VALUES (1933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:51:55', '1', 'admin', '2021-12-05 20:51:55', '记录日志');
INSERT INTO `sys_log` VALUES (1934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 20:51:56', '1', 'admin', '2021-12-05 20:51:56', '记录日志');
INSERT INTO `sys_log` VALUES (1935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:51:58', '1', 'admin', '2021-12-05 20:51:58', '记录日志');
INSERT INTO `sys_log` VALUES (1936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-05 20:52:49', '1', 'admin', '2021-12-05 20:52:49', '记录日志');
INSERT INTO `sys_log` VALUES (1937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-05 20:52:49', '1', 'admin', '2021-12-05 20:52:49', '记录日志');
INSERT INTO `sys_log` VALUES (1938, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-05 20:52:50', '1', 'admin', '2021-12-05 20:52:50', '记录日志');
INSERT INTO `sys_log` VALUES (1939, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:52:50', '1', 'admin', '2021-12-05 20:52:50', '记录日志');
INSERT INTO `sys_log` VALUES (1940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 20:52:52', '1', 'admin', '2021-12-05 20:52:52', '记录日志');
INSERT INTO `sys_log` VALUES (1941, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-05 20:53:13', '1', 'admin', '2021-12-05 20:53:13', '记录日志');
INSERT INTO `sys_log` VALUES (1942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:53:13', '1', 'admin', '2021-12-05 20:53:13', '记录日志');
INSERT INTO `sys_log` VALUES (1943, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-05 20:53:17', '1', 'admin', '2021-12-05 20:53:17', '记录日志');
INSERT INTO `sys_log` VALUES (1944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 20:53:17', '1', 'admin', '2021-12-05 20:53:17', '记录日志');
INSERT INTO `sys_log` VALUES (1945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 20:55:12', '1', 'admin', '2021-12-05 20:55:12', '记录日志');
INSERT INTO `sys_log` VALUES (1946, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-05 21:00:56', '1', 'admin', '2021-12-05 21:00:56', '记录日志');
INSERT INTO `sys_log` VALUES (1947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:00:57', '1', 'admin', '2021-12-05 21:00:57', '记录日志');
INSERT INTO `sys_log` VALUES (1948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-05 21:10:17', '1', 'admin', '2021-12-05 21:10:17', '记录日志');
INSERT INTO `sys_log` VALUES (1949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-05 21:10:17', '1', 'admin', '2021-12-05 21:10:17', '记录日志');
INSERT INTO `sys_log` VALUES (1950, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-05 21:10:24', '1', 'admin', '2021-12-05 21:10:24', '记录日志');
INSERT INTO `sys_log` VALUES (1951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:10:24', '1', 'admin', '2021-12-05 21:10:24', '记录日志');
INSERT INTO `sys_log` VALUES (1952, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-05 21:10:27', '1', 'admin', '2021-12-05 21:10:27', '记录日志');
INSERT INTO `sys_log` VALUES (1953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:10:27', '1', 'admin', '2021-12-05 21:10:27', '记录日志');
INSERT INTO `sys_log` VALUES (1954, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 21:10:29', '1', 'admin', '2021-12-05 21:10:29', '记录日志');
INSERT INTO `sys_log` VALUES (1955, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-05 21:10:39', '1', 'admin', '2021-12-05 21:10:39', '记录日志');
INSERT INTO `sys_log` VALUES (1956, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:10:39', '1', 'admin', '2021-12-05 21:10:39', '记录日志');
INSERT INTO `sys_log` VALUES (1957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-05 21:11:59', '1', 'admin', '2021-12-05 21:11:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-05 21:11:59', '1', 'admin', '2021-12-05 21:11:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-05 21:12:01', '1', 'admin', '2021-12-05 21:12:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-05 21:12:01', '1', 'admin', '2021-12-05 21:12:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1961, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-05 21:12:02', '1', 'admin', '2021-12-05 21:12:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-05 21:12:05', '1', 'admin', '2021-12-05 21:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-05 21:12:05', '1', 'admin', '2021-12-05 21:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-05 21:12:07', '1', 'admin', '2021-12-05 21:12:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:12:07', '1', 'admin', '2021-12-05 21:12:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1966, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-05 21:12:10', '1', 'admin', '2021-12-05 21:12:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:12:10', '1', 'admin', '2021-12-05 21:12:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 21:12:10', '1', 'admin', '2021-12-05 21:12:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1969, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-05 21:12:25', '1', 'admin', '2021-12-05 21:12:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1970, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-05 21:15:16', '1', 'admin', '2021-12-05 21:15:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1971, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-05 21:15:16', '1', 'admin', '2021-12-05 21:15:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1972, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-05 21:15:18', '1', 'admin', '2021-12-05 21:15:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1973, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:15:18', '1', 'admin', '2021-12-05 21:15:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1974, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 21:15:18', '1', 'admin', '2021-12-05 21:15:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1975, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-05 21:15:34', '1', 'admin', '2021-12-05 21:15:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1976, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:15:34', '1', 'admin', '2021-12-05 21:15:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-05 21:15:50', '1', 'admin', '2021-12-05 21:15:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1978, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-05 21:16:02', '1', 'admin', '2021-12-05 21:16:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1979, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:16:02', '1', 'admin', '2021-12-05 21:16:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1980, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-05 21:16:20', '1', 'admin', '2021-12-05 21:16:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:16:20', '1', 'admin', '2021-12-05 21:16:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1982, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-05 21:16:23', '1', 'admin', '2021-12-05 21:16:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:16:23', '1', 'admin', '2021-12-05 21:16:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1984, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-05 21:16:28', '1', 'admin', '2021-12-05 21:16:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1985, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-05 21:16:28', '1', 'admin', '2021-12-05 21:16:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-05 21:16:30', '1', 'admin', '2021-12-05 21:16:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-05 21:16:31', '1', 'admin', '2021-12-05 21:16:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-05 21:16:32', '1', 'admin', '2021-12-05 21:16:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 09:42:07', '1', 'admin', '2021-12-06 09:42:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 09:42:07', '1', 'admin', '2021-12-06 09:42:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-06 09:42:23', '1', 'admin', '2021-12-06 09:42:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1992, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 09:42:23', '1', 'admin', '2021-12-06 09:42:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-06 09:42:24', '1', 'admin', '2021-12-06 09:42:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1994, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-06 09:42:39', '1', 'admin', '2021-12-06 09:42:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 09:42:39', '1', 'admin', '2021-12-06 09:42:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1996, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2021-12-06 09:42:45', '1', 'admin', '2021-12-06 09:42:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 09:42:50', '1', 'admin', '2021-12-06 09:42:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-06 09:45:36', '1', 'admin', '2021-12-06 09:45:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (1999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 09:45:44', '1', 'admin', '2021-12-06 09:45:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 09:51:18', '1', 'admin', '2021-12-06 09:51:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 09:51:18', '1', 'admin', '2021-12-06 09:51:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-06 09:51:19', '1', 'admin', '2021-12-06 09:51:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 09:51:19', '1', 'admin', '2021-12-06 09:51:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2004, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-06 09:51:21', '1', 'admin', '2021-12-06 09:51:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2005, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-06 09:51:33', '1', 'admin', '2021-12-06 09:51:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 10:17:59', '1', 'admin', '2021-12-06 10:17:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 10:17:59', '1', 'admin', '2021-12-06 10:17:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2008, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-06 10:18:01', '1', 'admin', '2021-12-06 10:18:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 10:18:01', '1', 'admin', '2021-12-06 10:18:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2010, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-06 10:18:02', '1', 'admin', '2021-12-06 10:18:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2011, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-06 10:18:14', '1', 'admin', '2021-12-06 10:18:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2012, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 10:18:15', '1', 'admin', '2021-12-06 10:18:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 10:33:17', '1', 'admin', '2021-12-06 10:33:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2014, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 10:33:17', '1', 'admin', '2021-12-06 10:33:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-06 10:33:19', '1', 'admin', '2021-12-06 10:33:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2016, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 10:33:19', '1', 'admin', '2021-12-06 10:33:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2021-12-06 10:33:20', '1', 'admin', '2021-12-06 10:33:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2018, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2021-12-06 10:33:35', '1', 'admin', '2021-12-06 10:33:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 10:33:35', '1', 'admin', '2021-12-06 10:33:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2020, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-06 10:34:17', '1', 'admin', '2021-12-06 10:34:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 10:34:17', '1', 'admin', '2021-12-06 10:34:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2022, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/delete', '2021-12-06 10:34:20', '1', 'admin', '2021-12-06 10:34:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 10:34:20', '1', 'admin', '2021-12-06 10:34:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2024, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:11:02', '1', 'admin', '2021-12-06 11:11:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:11:02', '1', 'admin', '2021-12-06 11:11:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2026, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 11:11:17', '1', 'admin', '2021-12-06 11:11:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2027, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 11:11:24', '1', 'admin', '2021-12-06 11:11:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:15:22', '1', 'admin', '2021-12-06 11:15:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:15:22', '1', 'admin', '2021-12-06 11:15:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2030, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 11:15:24', '1', 'admin', '2021-12-06 11:15:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2031, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 11:15:27', '1', 'admin', '2021-12-06 11:15:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2032, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:30:09', '1', 'admin', '2021-12-06 11:30:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:30:09', '1', 'admin', '2021-12-06 11:30:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2034, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 11:30:11', '1', 'admin', '2021-12-06 11:30:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2035, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 11:30:14', '1', 'admin', '2021-12-06 11:30:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:33:34', '1', 'admin', '2021-12-06 11:33:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:46:36', '1', 'admin', '2021-12-06 11:46:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:46:36', '1', 'admin', '2021-12-06 11:46:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2039, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:46:38', '1', 'admin', '2021-12-06 11:46:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:46:38', '1', 'admin', '2021-12-06 11:46:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:48:11', '1', 'admin', '2021-12-06 11:48:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2042, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:48:11', '1', 'admin', '2021-12-06 11:48:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2043, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:48:12', '1', 'admin', '2021-12-06 11:48:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2044, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:48:12', '1', 'admin', '2021-12-06 11:48:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:49:37', '1', 'admin', '2021-12-06 11:49:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2046, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:49:37', '1', 'admin', '2021-12-06 11:49:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2047, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:49:38', '1', 'admin', '2021-12-06 11:49:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2048, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:49:38', '1', 'admin', '2021-12-06 11:49:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2049, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:50:34', '1', 'admin', '2021-12-06 11:50:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2050, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:50:34', '1', 'admin', '2021-12-06 11:50:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2051, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:50:36', '1', 'admin', '2021-12-06 11:50:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2052, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:50:36', '1', 'admin', '2021-12-06 11:50:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2053, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:51:39', '1', 'admin', '2021-12-06 11:51:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2054, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:51:40', '1', 'admin', '2021-12-06 11:51:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:51:41', '1', 'admin', '2021-12-06 11:51:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:51:41', '1', 'admin', '2021-12-06 11:51:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2057, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 11:52:14', '1', 'admin', '2021-12-06 11:52:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2058, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaaa&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:52:14', '1', 'admin', '2021-12-06 11:52:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2059, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaaa&ip=', '127.0.0.1', '/system/user/check', '2021-12-06 11:52:22', '1', 'admin', '2021-12-06 11:52:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2060, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:52:22', '1', 'admin', '2021-12-06 11:52:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/check', '2021-12-06 11:52:27', '1', 'admin', '2021-12-06 11:52:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2062, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=&ip=aaaaa', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:52:27', '1', 'admin', '2021-12-06 11:52:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2063, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 11:54:07', '1', 'admin', '2021-12-06 11:54:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2064, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:54:21', '1', 'admin', '2021-12-06 11:54:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2065, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:54:21', '1', 'admin', '2021-12-06 11:54:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2066, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:54:22', '1', 'admin', '2021-12-06 11:54:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2067, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:54:22', '1', 'admin', '2021-12-06 11:54:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2068, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 11:59:37', '1', 'admin', '2021-12-06 11:59:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2069, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 11:59:37', '1', 'admin', '2021-12-06 11:59:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2070, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 11:59:37', '1', 'admin', '2021-12-06 11:59:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2071, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:59:37', '1', 'admin', '2021-12-06 11:59:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2072, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 11:59:48', '1', 'admin', '2021-12-06 11:59:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2073, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:59:48', '1', 'admin', '2021-12-06 11:59:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2074, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/check', '2021-12-06 11:59:56', '1', 'admin', '2021-12-06 11:59:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2075, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=admin&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 11:59:56', '1', 'admin', '2021-12-06 11:59:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2076, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-06 11:59:59', '1', 'admin', '2021-12-06 11:59:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-06 11:59:59', '1', 'admin', '2021-12-06 11:59:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2078, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-06 12:00:06', '1', 'admin', '2021-12-06 12:00:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-06 12:00:14', '1', 'admin', '2021-12-06 12:00:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2080, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-06 12:00:17', '1', 'admin', '2021-12-06 12:00:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-06 12:01:52', '1', 'admin', '2021-12-06 12:01:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2082, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 12:01:52', '1', 'admin', '2021-12-06 12:01:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-06 12:01:54', '1', 'admin', '2021-12-06 12:01:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2084, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-06 12:01:54', '1', 'admin', '2021-12-06 12:01:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-06 12:01:59', '1', 'admin', '2021-12-06 12:01:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2086, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=admin&ip=', '127.0.0.1', '/system/user/check', '2021-12-06 12:03:22', '1', 'admin', '2021-12-06 12:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:03:22', '1', 'admin', '2021-12-06 12:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:06:26', '1', 'admin', '2021-12-06 12:06:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2089, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:06:26', '1', 'admin', '2021-12-06 12:06:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2090, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:06:27', '1', 'admin', '2021-12-06 12:06:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:06:27', '1', 'admin', '2021-12-06 12:06:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2092, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 12:06:30', '1', 'admin', '2021-12-06 12:06:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2093, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:06:30', '1', 'admin', '2021-12-06 12:06:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2094, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/check', '2021-12-06 12:06:33', '1', 'admin', '2021-12-06 12:06:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=admin&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:06:33', '1', 'admin', '2021-12-06 12:06:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2096, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:07:39', '1', 'admin', '2021-12-06 12:07:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2097, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:07:40', '1', 'admin', '2021-12-06 12:07:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:07:41', '1', 'admin', '2021-12-06 12:07:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2099, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:07:41', '1', 'admin', '2021-12-06 12:07:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2100, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 12:07:42', '1', 'admin', '2021-12-06 12:07:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2101, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:07:42', '1', 'admin', '2021-12-06 12:07:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2102, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/check', '2021-12-06 12:07:44', '1', 'admin', '2021-12-06 12:07:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2103, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:07:44', '1', 'admin', '2021-12-06 12:07:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2104, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:09:40', '1', 'admin', '2021-12-06 12:09:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2105, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:09:40', '1', 'admin', '2021-12-06 12:09:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:09:41', '1', 'admin', '2021-12-06 12:09:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2107, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:09:41', '1', 'admin', '2021-12-06 12:09:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2108, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/log/tableData', '2021-12-06 12:09:44', '1', 'admin', '2021-12-06 12:09:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:10:43', '1', 'admin', '2021-12-06 12:10:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2110, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:10:44', '1', 'admin', '2021-12-06 12:10:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:10:44', '1', 'admin', '2021-12-06 12:10:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:10:44', '1', 'admin', '2021-12-06 12:10:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/log/tablesData', '2021-12-06 12:10:48', '1', 'admin', '2021-12-06 12:10:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2114, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:12:57', '1', 'admin', '2021-12-06 12:12:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2115, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:12:57', '1', 'admin', '2021-12-06 12:12:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2116, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:12:58', '1', 'admin', '2021-12-06 12:12:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2117, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:12:58', '1', 'admin', '2021-12-06 12:12:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/log/tablesData', '2021-12-06 12:13:01', '1', 'admin', '2021-12-06 12:13:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2119, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:14:17', '1', 'admin', '2021-12-06 12:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:14:17', '1', 'admin', '2021-12-06 12:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2121, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:14:18', '1', 'admin', '2021-12-06 12:14:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2122, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:14:18', '1', 'admin', '2021-12-06 12:14:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2123, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/log/tablesData', '2021-12-06 12:15:39', '1', 'admin', '2021-12-06 12:15:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2124, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:15:47', '1', 'admin', '2021-12-06 12:15:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:15:47', '1', 'admin', '2021-12-06 12:15:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2126, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:15:48', '1', 'admin', '2021-12-06 12:15:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2127, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:15:48', '1', 'admin', '2021-12-06 12:15:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2128, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/log/tablesData', '2021-12-06 12:15:52', '1', 'admin', '2021-12-06 12:15:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:17:16', '1', 'admin', '2021-12-06 12:17:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:17:16', '1', 'admin', '2021-12-06 12:17:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2131, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:17:17', '1', 'admin', '2021-12-06 12:17:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:17:17', '1', 'admin', '2021-12-06 12:17:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2133, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:17:20', '1', 'admin', '2021-12-06 12:17:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2134, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:18:05', '1', 'admin', '2021-12-06 12:18:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2135, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:18:05', '1', 'admin', '2021-12-06 12:18:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:18:06', '1', 'admin', '2021-12-06 12:18:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:18:06', '1', 'admin', '2021-12-06 12:18:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:18:09', '1', 'admin', '2021-12-06 12:18:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2139, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:21:53', '1', 'admin', '2021-12-06 12:21:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2140, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:21:53', '1', 'admin', '2021-12-06 12:21:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2141, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:21:54', '1', 'admin', '2021-12-06 12:21:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2142, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:21:55', '1', 'admin', '2021-12-06 12:21:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:22:03', '1', 'admin', '2021-12-06 12:22:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2144, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:22:26', '1', 'admin', '2021-12-06 12:22:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2145, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:23:19', '1', 'admin', '2021-12-06 12:23:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2146, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:23:19', '1', 'admin', '2021-12-06 12:23:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2147, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:23:25', '1', 'admin', '2021-12-06 12:23:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2148, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:23:25', '1', 'admin', '2021-12-06 12:23:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2149, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:24:58', '1', 'admin', '2021-12-06 12:24:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2150, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:24:58', '1', 'admin', '2021-12-06 12:24:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2151, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:24:59', '1', 'admin', '2021-12-06 12:24:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:24:59', '1', 'admin', '2021-12-06 12:24:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2153, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:25:08', '1', 'admin', '2021-12-06 12:25:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2154, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:27:08', '1', 'admin', '2021-12-06 12:27:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2155, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:27:08', '1', 'admin', '2021-12-06 12:27:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2156, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:27:09', '1', 'admin', '2021-12-06 12:27:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:27:09', '1', 'admin', '2021-12-06 12:27:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2158, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-06 12:28:09', '1', 'admin', '2021-12-06 12:28:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 12:28:09', '1', 'admin', '2021-12-06 12:28:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2160, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-06 12:28:10', '1', 'admin', '2021-12-06 12:28:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2161, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-06 12:28:10', '1', 'admin', '2021-12-06 12:28:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2162, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-06 12:28:34', '1', 'admin', '2021-12-06 12:28:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2163, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-06 12:28:34', '1', 'admin', '2021-12-06 12:28:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-06 12:28:36', '1', 'admin', '2021-12-06 12:28:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2165, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-06 12:28:36', '1', 'admin', '2021-12-06 12:28:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:33:07', '1', 'admin', '2021-12-06 12:33:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:33:07', '1', 'admin', '2021-12-06 12:33:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2168, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:33:08', '1', 'admin', '2021-12-06 12:33:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2169, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:33:08', '1', 'admin', '2021-12-06 12:33:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 12:33:12', '1', 'admin', '2021-12-06 12:33:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2171, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?userName=aaaaa&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:33:12', '1', 'admin', '2021-12-06 12:33:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2172, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-06 12:34:22', '1', 'admin', '2021-12-06 12:34:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2173, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-06 12:34:22', '1', 'admin', '2021-12-06 12:34:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2174, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 12:36:57', '1', 'admin', '2021-12-06 12:36:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2175, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 12:36:57', '1', 'admin', '2021-12-06 12:36:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2176, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 12:36:58', '1', 'admin', '2021-12-06 12:36:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2177, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:36:58', '1', 'admin', '2021-12-06 12:36:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2178, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:37:10', '1', 'admin', '2021-12-06 12:37:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2179, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 12:37:21', '1', 'admin', '2021-12-06 12:37:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2180, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 13:39:13', '1', 'admin', '2021-12-06 13:39:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2181, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 13:39:13', '1', 'admin', '2021-12-06 13:39:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2182, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 13:39:14', '1', 'admin', '2021-12-06 13:39:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2183, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 13:39:14', '1', 'admin', '2021-12-06 13:39:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2184, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 13:39:25', '1', 'admin', '2021-12-06 13:39:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2185, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 13:39:36', '1', 'admin', '2021-12-06 13:39:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2186, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 13:39:48', '1', 'admin', '2021-12-06 13:39:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2187, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 13:43:53', '1', 'admin', '2021-12-06 13:43:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2188, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 13:43:53', '1', 'admin', '2021-12-06 13:43:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2189, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 13:43:56', '1', 'admin', '2021-12-06 13:43:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2190, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 13:43:59', '1', 'admin', '2021-12-06 13:43:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2191, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 13:45:19', '1', 'admin', '2021-12-06 13:45:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2192, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 13:56:02', '1', 'admin', '2021-12-06 13:56:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2193, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:01:51', '1', 'admin', '2021-12-06 14:01:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2194, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:04:07', '1', 'admin', '2021-12-06 14:04:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2195, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:04:07', '1', 'admin', '2021-12-06 14:04:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2196, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:04:08', '1', 'admin', '2021-12-06 14:04:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2197, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:04:12', '1', 'admin', '2021-12-06 14:04:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2198, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:04:51', '1', 'admin', '2021-12-06 14:04:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2199, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:04:51', '1', 'admin', '2021-12-06 14:04:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2200, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:04:52', '1', 'admin', '2021-12-06 14:04:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2201, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:04:55', '1', 'admin', '2021-12-06 14:04:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2202, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:10:38', '1', 'admin', '2021-12-06 14:10:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2203, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:10:38', '1', 'admin', '2021-12-06 14:10:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2204, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:10:39', '1', 'admin', '2021-12-06 14:10:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2205, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:10:47', '1', 'admin', '2021-12-06 14:10:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2206, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:20:38', '1', 'admin', '2021-12-06 14:20:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2207, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:20:38', '1', 'admin', '2021-12-06 14:20:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2208, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:20:39', '1', 'admin', '2021-12-06 14:20:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2209, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:20:49', '1', 'admin', '2021-12-06 14:20:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2210, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:21:27', '1', 'admin', '2021-12-06 14:21:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2211, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:21:27', '1', 'admin', '2021-12-06 14:21:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2212, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:21:28', '1', 'admin', '2021-12-06 14:21:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2213, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:21:33', '1', 'admin', '2021-12-06 14:21:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2214, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:22:51', '1', 'admin', '2021-12-06 14:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2215, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:22:51', '1', 'admin', '2021-12-06 14:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2216, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:22:54', '1', 'admin', '2021-12-06 14:22:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2217, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:23:04', '1', 'admin', '2021-12-06 14:23:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2218, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:24:56', '1', 'admin', '2021-12-06 14:24:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2219, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:24:56', '1', 'admin', '2021-12-06 14:24:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2220, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:24:58', '1', 'admin', '2021-12-06 14:24:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2221, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:25:53', '1', 'admin', '2021-12-06 14:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2222, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:25:53', '1', 'admin', '2021-12-06 14:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2223, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:26:20', '1', 'admin', '2021-12-06 14:26:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2224, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:26:20', '1', 'admin', '2021-12-06 14:26:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2225, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:26:22', '1', 'admin', '2021-12-06 14:26:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2226, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:26:22', '1', 'admin', '2021-12-06 14:26:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2227, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:26:22', '1', 'admin', '2021-12-06 14:26:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2228, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:26:35', '1', 'admin', '2021-12-06 14:26:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2229, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:27:04', '1', 'admin', '2021-12-06 14:27:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2230, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:27:04', '1', 'admin', '2021-12-06 14:27:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2231, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:27:04', '1', 'admin', '2021-12-06 14:27:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2232, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:27:09', '1', 'admin', '2021-12-06 14:27:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2233, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:28:56', '1', 'admin', '2021-12-06 14:28:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2234, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:28:56', '1', 'admin', '2021-12-06 14:28:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2235, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:28:56', '1', 'admin', '2021-12-06 14:28:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2236, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:29:02', '1', 'admin', '2021-12-06 14:29:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2237, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:32:28', '1', 'admin', '2021-12-06 14:32:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2238, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:32:28', '1', 'admin', '2021-12-06 14:32:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2239, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:32:29', '1', 'admin', '2021-12-06 14:32:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2240, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:32:40', '1', 'admin', '2021-12-06 14:32:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2241, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:34:26', '1', 'admin', '2021-12-06 14:34:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2242, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:34:26', '1', 'admin', '2021-12-06 14:34:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2243, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:34:26', '1', 'admin', '2021-12-06 14:34:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2244, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:34:35', '1', 'admin', '2021-12-06 14:34:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2245, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:35:49', '1', 'admin', '2021-12-06 14:35:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2246, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:35:49', '1', 'admin', '2021-12-06 14:35:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2247, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:35:50', '1', 'admin', '2021-12-06 14:35:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2248, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:36:13', '1', 'admin', '2021-12-06 14:36:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2249, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:37:43', '1', 'admin', '2021-12-06 14:37:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2250, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:37:46', '1', 'admin', '2021-12-06 14:37:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2251, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:38:03', '1', 'admin', '2021-12-06 14:38:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2252, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:41:49', '1', 'admin', '2021-12-06 14:41:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2253, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:41:54', '1', 'admin', '2021-12-06 14:41:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2254, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:41:59', '1', 'admin', '2021-12-06 14:41:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2255, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:44:09', '1', 'admin', '2021-12-06 14:44:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2256, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:44:09', '1', 'admin', '2021-12-06 14:44:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2257, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:44:10', '1', 'admin', '2021-12-06 14:44:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2258, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:44:10', '1', 'admin', '2021-12-06 14:44:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2259, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:46:40', '1', 'admin', '2021-12-06 14:46:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2260, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:46:40', '1', 'admin', '2021-12-06 14:46:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2261, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:46:42', '1', 'admin', '2021-12-06 14:46:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2262, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:46:42', '1', 'admin', '2021-12-06 14:46:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2263, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:47:16', '1', 'admin', '2021-12-06 14:47:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2264, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:47:16', '1', 'admin', '2021-12-06 14:47:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:47:17', '1', 'admin', '2021-12-06 14:47:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2266, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:47:17', '1', 'admin', '2021-12-06 14:47:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2267, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:49:59', '1', 'admin', '2021-12-06 14:49:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2268, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:49:59', '1', 'admin', '2021-12-06 14:49:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2269, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:50:00', '1', 'admin', '2021-12-06 14:50:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2270, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:50:00', '1', 'admin', '2021-12-06 14:50:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2271, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:50:17', '1', 'admin', '2021-12-06 14:50:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:50:17', '1', 'admin', '2021-12-06 14:50:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2273, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:50:18', '1', 'admin', '2021-12-06 14:50:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:50:18', '1', 'admin', '2021-12-06 14:50:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:52:46', '1', 'admin', '2021-12-06 14:52:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:52:46', '1', 'admin', '2021-12-06 14:52:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2277, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:52:47', '1', 'admin', '2021-12-06 14:52:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2278, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:52:47', '1', 'admin', '2021-12-06 14:52:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 14:56:36', '1', 'admin', '2021-12-06 14:56:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2280, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 14:56:36', '1', 'admin', '2021-12-06 14:56:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 14:56:37', '1', 'admin', '2021-12-06 14:56:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 14:56:37', '1', 'admin', '2021-12-06 14:56:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 14:56:43', '1', 'admin', '2021-12-06 14:56:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2284, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 14:56:44', '1', 'admin', '2021-12-06 14:56:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2285, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 14:56:56', '1', 'admin', '2021-12-06 14:56:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2286, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:23:02', '1', 'admin', '2021-12-06 15:23:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2287, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:23:02', '1', 'admin', '2021-12-06 15:23:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2288, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:23:04', '1', 'admin', '2021-12-06 15:23:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:23:04', '1', 'admin', '2021-12-06 15:23:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 15:23:06', '1', 'admin', '2021-12-06 15:23:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2291, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 15:23:11', '1', 'admin', '2021-12-06 15:23:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2292, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:24:05', '1', 'admin', '2021-12-06 15:24:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2293, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:24:05', '1', 'admin', '2021-12-06 15:24:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2294, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:24:06', '1', 'admin', '2021-12-06 15:24:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2295, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:24:06', '1', 'admin', '2021-12-06 15:24:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2296, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 15:24:07', '1', 'admin', '2021-12-06 15:24:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2297, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 15:24:14', '1', 'admin', '2021-12-06 15:24:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2298, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:25:02', '1', 'admin', '2021-12-06 15:25:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2299, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:25:03', '1', 'admin', '2021-12-06 15:25:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2300, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:25:03', '1', 'admin', '2021-12-06 15:25:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2301, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:25:03', '1', 'admin', '2021-12-06 15:25:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2302, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:27:52', '1', 'admin', '2021-12-06 15:27:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2303, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:27:52', '1', 'admin', '2021-12-06 15:27:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2304, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:27:54', '1', 'admin', '2021-12-06 15:27:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2305, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 15:29:12', '1', 'admin', '2021-12-06 15:29:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2306, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:29:19', '1', 'admin', '2021-12-06 15:29:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2307, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:29:19', '1', 'admin', '2021-12-06 15:29:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2308, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:29:21', '1', 'admin', '2021-12-06 15:29:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2309, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:29:21', '1', 'admin', '2021-12-06 15:29:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:33:36', '1', 'admin', '2021-12-06 15:33:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2311, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:33:36', '1', 'admin', '2021-12-06 15:33:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2312, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:33:37', '1', 'admin', '2021-12-06 15:33:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2313, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:33:37', '1', 'admin', '2021-12-06 15:33:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:34:53', '1', 'admin', '2021-12-06 15:34:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2315, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:34:53', '1', 'admin', '2021-12-06 15:34:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:34:55', '1', 'admin', '2021-12-06 15:34:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2317, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:34:55', '1', 'admin', '2021-12-06 15:34:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2318, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:38:09', '1', 'admin', '2021-12-06 15:38:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:38:09', '1', 'admin', '2021-12-06 15:38:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:38:10', '1', 'admin', '2021-12-06 15:38:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2321, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:38:10', '1', 'admin', '2021-12-06 15:38:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2322, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 15:38:11', '1', 'admin', '2021-12-06 15:38:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:38:12', '1', 'admin', '2021-12-06 15:38:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2324, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:39:07', '1', 'admin', '2021-12-06 15:39:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2325, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:39:07', '1', 'admin', '2021-12-06 15:39:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2326, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:39:08', '1', 'admin', '2021-12-06 15:39:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2327, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:39:08', '1', 'admin', '2021-12-06 15:39:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2328, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 15:39:09', '1', 'admin', '2021-12-06 15:39:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2329, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:39:43', '1', 'admin', '2021-12-06 15:39:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2330, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:39:43', '1', 'admin', '2021-12-06 15:39:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2331, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:39:44', '1', 'admin', '2021-12-06 15:39:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2332, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:39:44', '1', 'admin', '2021-12-06 15:39:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2333, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 15:39:46', '1', 'admin', '2021-12-06 15:39:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2334, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:39:46', '1', 'admin', '2021-12-06 15:39:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 15:39:55', '1', 'admin', '2021-12-06 15:39:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2336, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-06 15:40:38', '1', 'admin', '2021-12-06 15:40:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2337, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-06 15:40:38', '1', 'admin', '2021-12-06 15:40:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2338, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:43:41', '1', 'admin', '2021-12-06 15:43:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2339, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:43:41', '1', 'admin', '2021-12-06 15:43:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:43:42', '1', 'admin', '2021-12-06 15:43:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:43:42', '1', 'admin', '2021-12-06 15:43:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2342, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:57:08', '1', 'admin', '2021-12-06 15:57:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2343, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:57:08', '1', 'admin', '2021-12-06 15:57:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2344, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:57:09', '1', 'admin', '2021-12-06 15:57:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2345, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:57:09', '1', 'admin', '2021-12-06 15:57:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 15:57:10', '1', 'admin', '2021-12-06 15:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?name=&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:57:10', '1', 'admin', '2021-12-06 15:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2348, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 15:58:06', '1', 'admin', '2021-12-06 15:58:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2349, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 15:58:06', '1', 'admin', '2021-12-06 15:58:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 15:58:07', '1', 'admin', '2021-12-06 15:58:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:58:07', '1', 'admin', '2021-12-06 15:58:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2352, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 15:58:08', '1', 'admin', '2021-12-06 15:58:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2353, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?name=&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 15:58:08', '1', 'admin', '2021-12-06 15:58:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:00:33', '1', 'admin', '2021-12-06 16:00:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2355, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:00:34', '1', 'admin', '2021-12-06 16:00:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2356, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:00:34', '1', 'admin', '2021-12-06 16:00:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2357, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:00:35', '1', 'admin', '2021-12-06 16:00:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2021-12-06 16:00:37', '1', 'admin', '2021-12-06 16:00:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2359, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?name=&ip=', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:00:37', '1', 'admin', '2021-12-06 16:00:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2360, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:04:22', '1', 'admin', '2021-12-06 16:04:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2361, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:04:22', '1', 'admin', '2021-12-06 16:04:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:04:24', '1', 'admin', '2021-12-06 16:04:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:04:24', '1', 'admin', '2021-12-06 16:04:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2364, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 16:05:04', '1', 'admin', '2021-12-06 16:05:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2365, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:05:04', '1', 'admin', '2021-12-06 16:05:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2366, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:12:36', '1', 'admin', '2021-12-06 16:12:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2367, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:14:17', '1', 'admin', '2021-12-06 16:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2368, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:14:17', '1', 'admin', '2021-12-06 16:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2369, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:14:19', '1', 'admin', '2021-12-06 16:14:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2370, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:14:19', '1', 'admin', '2021-12-06 16:14:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:17:27', '1', 'admin', '2021-12-06 16:17:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2372, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:17:27', '1', 'admin', '2021-12-06 16:17:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2373, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:17:29', '1', 'admin', '2021-12-06 16:17:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:17:29', '1', 'admin', '2021-12-06 16:17:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:19:16', '1', 'admin', '2021-12-06 16:19:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2376, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:19:16', '1', 'admin', '2021-12-06 16:19:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:19:19', '1', 'admin', '2021-12-06 16:19:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2378, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:19:19', '1', 'admin', '2021-12-06 16:19:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2379, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:19:23', '1', 'admin', '2021-12-06 16:19:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2380, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:25:37', '1', 'admin', '2021-12-06 16:25:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:25:37', '1', 'admin', '2021-12-06 16:25:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2382, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:25:42', '1', 'admin', '2021-12-06 16:25:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:25:42', '1', 'admin', '2021-12-06 16:25:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2384, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 16:26:56', '1', 'admin', '2021-12-06 16:26:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 16:27:34', '1', 'admin', '2021-12-06 16:27:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2386, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:31:03', '1', 'admin', '2021-12-06 16:31:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2387, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:31:03', '1', 'admin', '2021-12-06 16:31:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2388, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:31:08', '1', 'admin', '2021-12-06 16:31:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2389, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:31:08', '1', 'admin', '2021-12-06 16:31:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2390, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:31:12', '1', 'admin', '2021-12-06 16:31:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2391, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:33:44', '1', 'admin', '2021-12-06 16:33:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2392, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:33:44', '1', 'admin', '2021-12-06 16:33:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2393, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:33:45', '1', 'admin', '2021-12-06 16:33:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2394, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:33:45', '1', 'admin', '2021-12-06 16:33:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2395, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 16:33:46', '1', 'admin', '2021-12-06 16:33:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2396, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:33:46', '1', 'admin', '2021-12-06 16:33:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2397, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 16:34:16', '1', 'admin', '2021-12-06 16:34:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2398, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:42:09', '1', 'admin', '2021-12-06 16:42:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2399, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:42:09', '1', 'admin', '2021-12-06 16:42:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2400, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:42:09', '1', 'admin', '2021-12-06 16:42:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2401, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:42:09', '1', 'admin', '2021-12-06 16:42:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2402, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:42:22', '1', 'admin', '2021-12-06 16:42:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2403, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:42:38', '1', 'admin', '2021-12-06 16:42:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2404, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:42:44', '1', 'admin', '2021-12-06 16:42:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2405, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:42:48', '1', 'admin', '2021-12-06 16:42:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2406, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:43:23', '1', 'admin', '2021-12-06 16:43:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2407, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:43:27', '1', 'admin', '2021-12-06 16:43:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2408, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:43:27', '1', 'admin', '2021-12-06 16:43:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2409, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:43:29', '1', 'admin', '2021-12-06 16:43:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2410, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:43:29', '1', 'admin', '2021-12-06 16:43:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2411, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:43:34', '1', 'admin', '2021-12-06 16:43:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2412, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:43:39', '1', 'admin', '2021-12-06 16:43:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2413, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:44:55', '1', 'admin', '2021-12-06 16:44:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2414, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:44:55', '1', 'admin', '2021-12-06 16:44:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2415, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:44:57', '1', 'admin', '2021-12-06 16:44:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2416, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:44:57', '1', 'admin', '2021-12-06 16:44:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2417, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:45:07', '1', 'admin', '2021-12-06 16:45:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2418, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:47:52', '1', 'admin', '2021-12-06 16:47:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2419, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:47:52', '1', 'admin', '2021-12-06 16:47:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2420, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:47:53', '1', 'admin', '2021-12-06 16:47:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2421, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:47:53', '1', 'admin', '2021-12-06 16:47:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2422, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:48:05', '1', 'admin', '2021-12-06 16:48:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2423, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:49:02', '1', 'admin', '2021-12-06 16:49:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2424, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:49:02', '1', 'admin', '2021-12-06 16:49:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2425, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:49:02', '1', 'admin', '2021-12-06 16:49:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2426, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:49:02', '1', 'admin', '2021-12-06 16:49:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2427, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:49:12', '1', 'admin', '2021-12-06 16:49:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2428, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:51:11', '1', 'admin', '2021-12-06 16:51:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2429, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:51:11', '1', 'admin', '2021-12-06 16:51:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2430, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:51:12', '1', 'admin', '2021-12-06 16:51:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2431, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:51:12', '1', 'admin', '2021-12-06 16:51:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2432, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:51:16', '1', 'admin', '2021-12-06 16:51:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2433, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:53:54', '1', 'admin', '2021-12-06 16:53:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2434, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:53:54', '1', 'admin', '2021-12-06 16:53:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2435, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:53:55', '1', 'admin', '2021-12-06 16:53:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2436, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:53:55', '1', 'admin', '2021-12-06 16:53:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2437, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:54:38', '1', 'admin', '2021-12-06 16:54:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2438, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:54:38', '1', 'admin', '2021-12-06 16:54:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2439, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:54:40', '1', 'admin', '2021-12-06 16:54:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2440, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:54:40', '1', 'admin', '2021-12-06 16:54:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2441, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:54:42', '1', 'admin', '2021-12-06 16:54:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2442, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 16:56:00', '1', 'admin', '2021-12-06 16:56:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2443, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 16:56:00', '1', 'admin', '2021-12-06 16:56:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2444, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 16:56:02', '1', 'admin', '2021-12-06 16:56:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2445, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:56:02', '1', 'admin', '2021-12-06 16:56:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2446, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 16:56:04', '1', 'admin', '2021-12-06 16:56:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2447, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2021-12-06 16:56:41', '1', 'admin', '2021-12-06 16:56:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2448, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2021-12-06 16:56:41', '1', 'admin', '2021-12-06 16:56:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2449, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2021-12-06 16:57:29', '1', 'admin', '2021-12-06 16:57:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2450, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2021-12-06 16:57:29', '1', 'admin', '2021-12-06 16:57:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2451, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-06 16:57:31', '1', 'admin', '2021-12-06 16:57:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2452, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-06 16:57:31', '1', 'admin', '2021-12-06 16:57:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2453, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-06 16:57:32', '1', 'admin', '2021-12-06 16:57:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2454, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-06 16:57:32', '1', 'admin', '2021-12-06 16:57:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2455, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-06 16:58:33', '1', 'admin', '2021-12-06 16:58:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2456, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:05:31', '1', 'admin', '2021-12-06 17:05:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2457, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:05:31', '1', 'admin', '2021-12-06 17:05:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2458, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:05:32', '1', 'admin', '2021-12-06 17:05:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2459, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:05:32', '1', 'admin', '2021-12-06 17:05:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2460, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:05:35', '1', 'admin', '2021-12-06 17:05:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2461, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:05:50', '1', 'admin', '2021-12-06 17:05:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2462, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:10:01', '1', 'admin', '2021-12-06 17:10:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2463, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:10:01', '1', 'admin', '2021-12-06 17:10:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2464, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:10:02', '1', 'admin', '2021-12-06 17:10:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2465, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:10:02', '1', 'admin', '2021-12-06 17:10:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2466, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:11:11', '1', 'admin', '2021-12-06 17:11:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2467, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:11:11', '1', 'admin', '2021-12-06 17:11:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2468, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:11:12', '1', 'admin', '2021-12-06 17:11:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2469, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:11:12', '1', 'admin', '2021-12-06 17:11:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2470, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:11:28', '1', 'admin', '2021-12-06 17:11:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2471, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:11:28', '1', 'admin', '2021-12-06 17:11:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2472, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:11:29', '1', 'admin', '2021-12-06 17:11:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2473, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:11:29', '1', 'admin', '2021-12-06 17:11:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2474, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:12:04', '1', 'admin', '2021-12-06 17:12:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2475, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:12:04', '1', 'admin', '2021-12-06 17:12:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2476, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:12:05', '1', 'admin', '2021-12-06 17:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2477, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:12:05', '1', 'admin', '2021-12-06 17:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2478, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:13:10', '1', 'admin', '2021-12-06 17:13:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2479, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:13:10', '1', 'admin', '2021-12-06 17:13:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2480, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:13:11', '1', 'admin', '2021-12-06 17:13:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2481, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:13:11', '1', 'admin', '2021-12-06 17:13:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2482, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 17:13:49', '1', 'admin', '2021-12-06 17:13:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2483, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 17:14:17', '1', 'admin', '2021-12-06 17:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2484, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:14:21', '1', 'admin', '2021-12-06 17:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2485, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:14:21', '1', 'admin', '2021-12-06 17:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2486, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:14:22', '1', 'admin', '2021-12-06 17:14:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2487, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:14:22', '1', 'admin', '2021-12-06 17:14:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2488, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:15:05', '1', 'admin', '2021-12-06 17:15:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2489, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:15:05', '1', 'admin', '2021-12-06 17:15:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2490, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:15:07', '1', 'admin', '2021-12-06 17:15:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2491, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:15:07', '1', 'admin', '2021-12-06 17:15:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2492, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:15:12', '1', 'admin', '2021-12-06 17:15:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2493, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:15:17', '1', 'admin', '2021-12-06 17:15:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2494, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:15:20', '1', 'admin', '2021-12-06 17:15:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2495, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 17:15:24', '1', 'admin', '2021-12-06 17:15:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2496, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 17:15:52', '1', 'admin', '2021-12-06 17:15:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2497, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-06 17:15:55', '1', 'admin', '2021-12-06 17:15:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2498, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:15:55', '1', 'admin', '2021-12-06 17:15:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2499, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:17:29', '1', 'admin', '2021-12-06 17:17:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2500, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:17:29', '1', 'admin', '2021-12-06 17:17:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2501, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:17:30', '1', 'admin', '2021-12-06 17:17:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2502, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:17:30', '1', 'admin', '2021-12-06 17:17:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2503, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 17:17:34', '1', 'admin', '2021-12-06 17:17:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2504, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:22:55', '1', 'admin', '2021-12-06 17:22:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2505, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:22:59', '1', 'admin', '2021-12-06 17:22:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2506, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:26:46', '1', 'admin', '2021-12-06 17:26:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2507, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:26:46', '1', 'admin', '2021-12-06 17:26:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2508, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:26:47', '1', 'admin', '2021-12-06 17:26:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2509, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:26:47', '1', 'admin', '2021-12-06 17:26:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2510, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-06 17:26:52', '1', 'admin', '2021-12-06 17:26:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2511, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-06 17:27:32', '1', 'admin', '2021-12-06 17:27:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2512, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-06 17:27:37', '1', 'admin', '2021-12-06 17:27:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2513, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-06 17:27:37', '1', 'admin', '2021-12-06 17:27:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2514, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-06 17:27:38', '1', 'admin', '2021-12-06 17:27:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2515, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-06 17:27:38', '1', 'admin', '2021-12-06 17:27:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2516, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 10:10:13', '1', 'admin', '2021-12-08 10:10:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2517, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 10:10:13', '1', 'admin', '2021-12-08 10:10:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2518, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 10:24:12', '1', 'admin', '2021-12-08 10:24:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2519, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 10:24:12', '1', 'admin', '2021-12-08 10:24:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2520, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 11:05:18', '1', 'admin', '2021-12-08 11:05:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2521, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 11:05:19', '1', 'admin', '2021-12-08 11:05:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2522, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 11:05:21', '1', 'admin', '2021-12-08 11:05:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2523, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-08 11:05:26', '1', 'admin', '2021-12-08 11:05:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2524, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 11:07:51', '1', 'admin', '2021-12-08 11:07:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2525, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 11:07:51', '1', 'admin', '2021-12-08 11:07:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2526, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 11:07:53', '1', 'admin', '2021-12-08 11:07:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2527, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-08 11:08:20', '1', 'admin', '2021-12-08 11:08:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2528, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 11:08:24', '1', 'admin', '2021-12-08 11:08:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2529, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:08:24', '1', 'admin', '2021-12-08 11:08:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2530, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 11:09:37', '1', 'admin', '2021-12-08 11:09:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2531, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 11:09:37', '1', 'admin', '2021-12-08 11:09:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2532, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 11:09:38', '1', 'admin', '2021-12-08 11:09:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2533, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-08 11:09:49', '1', 'admin', '2021-12-08 11:09:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2534, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 11:09:50', '1', 'admin', '2021-12-08 11:09:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2535, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:09:50', '1', 'admin', '2021-12-08 11:09:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2536, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:10:23', '1', 'admin', '2021-12-08 11:10:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2537, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 11:10:29', '1', 'admin', '2021-12-08 11:10:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2538, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:10:29', '1', 'admin', '2021-12-08 11:10:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2539, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-08 11:12:58', '1', 'admin', '2021-12-08 11:12:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2540, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-08 11:12:58', '1', 'admin', '2021-12-08 11:12:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2541, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/check', '2021-12-08 11:13:01', '1', 'admin', '2021-12-08 11:13:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2542, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:13:01', '1', 'admin', '2021-12-08 11:13:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2543, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/upload', '2021-12-08 11:13:03', '1', 'admin', '2021-12-08 11:13:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2544, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/upload', '192.168.1.100', '/system/user/ChainAdd', '2021-12-08 11:13:10', '1', 'admin', '2021-12-08 11:13:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2545, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-08 11:13:14', '1', 'admin', '2021-12-08 11:13:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2546, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-08 11:13:14', '1', 'admin', '2021-12-08 11:13:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2547, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/check', '2021-12-08 11:13:15', '1', 'admin', '2021-12-08 11:13:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2548, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:13:15', '1', 'admin', '2021-12-08 11:13:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2549, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-08 11:14:35', '1', 'admin', '2021-12-08 11:14:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2550, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-08 11:14:35', '1', 'admin', '2021-12-08 11:14:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2551, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 11:18:49', '1', 'admin', '2021-12-08 11:18:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2552, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 11:18:49', '1', 'admin', '2021-12-08 11:18:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2553, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 11:18:50', '1', 'admin', '2021-12-08 11:18:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2554, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-08 11:18:57', '1', 'admin', '2021-12-08 11:18:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2555, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 11:18:59', '1', 'admin', '2021-12-08 11:18:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2556, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:18:59', '1', 'admin', '2021-12-08 11:18:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2557, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/upload', '2021-12-08 11:19:18', '1', 'admin', '2021-12-08 11:19:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2558, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/upload', '192.168.1.100', '/system/user/ChainAdd', '2021-12-08 11:19:23', '1', 'admin', '2021-12-08 11:19:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2559, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-08 11:19:27', '1', 'admin', '2021-12-08 11:19:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2560, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-08 11:19:27', '1', 'admin', '2021-12-08 11:19:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2561, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/check', '2021-12-08 11:19:28', '1', 'admin', '2021-12-08 11:19:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2562, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:19:28', '1', 'admin', '2021-12-08 11:19:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2563, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:19:39', '1', 'admin', '2021-12-08 11:19:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2564, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:19:43', '1', 'admin', '2021-12-08 11:19:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2565, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:19:44', '1', 'admin', '2021-12-08 11:19:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2566, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:19:45', '1', 'admin', '2021-12-08 11:19:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2567, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:19:46', '1', 'admin', '2021-12-08 11:19:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2568, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-08 11:19:47', '1', 'admin', '2021-12-08 11:19:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2569, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 11:24:18', '1', 'admin', '2021-12-08 11:24:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2570, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 11:24:18', '1', 'admin', '2021-12-08 11:24:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2571, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/check', '2021-12-08 11:24:25', '1', 'admin', '2021-12-08 11:24:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2572, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:24:25', '1', 'admin', '2021-12-08 11:24:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2573, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/upload', '2021-12-08 11:24:27', '1', 'admin', '2021-12-08 11:24:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2574, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/upload', '192.168.1.101', '/system/user/ChainAdd', '2021-12-08 11:24:36', '1', 'admin', '2021-12-08 11:24:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2575, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 11:24:41', '1', 'admin', '2021-12-08 11:24:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2576, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 11:24:41', '1', 'admin', '2021-12-08 11:24:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2577, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/check', '2021-12-08 11:24:42', '1', 'admin', '2021-12-08 11:24:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2578, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:24:42', '1', 'admin', '2021-12-08 11:24:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2579, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 11:26:28', '1', 'admin', '2021-12-08 11:26:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2580, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 11:26:28', '1', 'admin', '2021-12-08 11:26:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2581, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/check', '2021-12-08 11:26:29', '1', 'admin', '2021-12-08 11:26:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2582, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:26:29', '1', 'admin', '2021-12-08 11:26:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2583, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:27:12', '1', 'admin', '2021-12-08 11:27:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2584, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:27:22', '1', 'admin', '2021-12-08 11:27:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2585, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/download', '2021-12-08 11:27:23', '1', 'admin', '2021-12-08 11:27:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2586, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:27:24', '1', 'admin', '2021-12-08 11:27:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2587, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/download', '2021-12-08 11:27:31', '1', 'admin', '2021-12-08 11:27:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2588, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download?name=%09+192.168.1.101', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:27:31', '1', 'admin', '2021-12-08 11:27:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2589, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download?name=%09+192.168.1.101', '192.168.1.101', '/system/user/download', '2021-12-08 11:27:36', '1', 'admin', '2021-12-08 11:27:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2590, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download?name=192.168.1.101', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:27:36', '1', 'admin', '2021-12-08 11:27:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2591, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:27:44', '1', 'admin', '2021-12-08 11:27:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2592, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 11:27:57', '1', 'admin', '2021-12-08 11:27:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2593, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 11:31:43', '1', 'admin', '2021-12-08 11:31:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2594, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:31:43', '1', 'admin', '2021-12-08 11:31:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2595, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/download', '2021-12-08 11:31:47', '1', 'admin', '2021-12-08 11:31:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2596, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=192.168.1.101', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:31:47', '1', 'admin', '2021-12-08 11:31:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2597, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=192.168.1.101', '127.0.0.1', '/system/user/download', '2021-12-08 11:31:49', '1', 'admin', '2021-12-08 11:31:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2598, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=192.168.1.101', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:31:49', '1', 'admin', '2021-12-08 11:31:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2599, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:32:22', '1', 'admin', '2021-12-08 11:32:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2600, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 11:37:02', '1', 'admin', '2021-12-08 11:37:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2601, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 11:37:02', '1', 'admin', '2021-12-08 11:37:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2602, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 11:37:03', '1', 'admin', '2021-12-08 11:37:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2603, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:03', '1', 'admin', '2021-12-08 11:37:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2604, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/download', '2021-12-08 11:37:04', '1', 'admin', '2021-12-08 11:37:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2605, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:04', '1', 'admin', '2021-12-08 11:37:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2606, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=', '127.0.0.1', '/system/user/download', '2021-12-08 11:37:06', '1', 'admin', '2021-12-08 11:37:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2607, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:06', '1', 'admin', '2021-12-08 11:37:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2608, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 11:37:51', '1', 'admin', '2021-12-08 11:37:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2609, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 11:37:51', '1', 'admin', '2021-12-08 11:37:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2610, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 11:37:53', '1', 'admin', '2021-12-08 11:37:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2611, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:53', '1', 'admin', '2021-12-08 11:37:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2612, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 11:37:55', '1', 'admin', '2021-12-08 11:37:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2613, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:55', '1', 'admin', '2021-12-08 11:37:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2614, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/download', '2021-12-08 11:37:56', '1', 'admin', '2021-12-08 11:37:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2615, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:56', '1', 'admin', '2021-12-08 11:37:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2616, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=', '127.0.0.1', '/system/user/download', '2021-12-08 11:37:57', '1', 'admin', '2021-12-08 11:37:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2617, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:57', '1', 'admin', '2021-12-08 11:37:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2618, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=', '127.0.0.1', '/system/user/download', '2021-12-08 11:37:59', '1', 'admin', '2021-12-08 11:37:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2619, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download?name=%E5%88%98%E6%9C%97', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:37:59', '1', 'admin', '2021-12-08 11:37:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2620, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 11:39:04', '1', 'admin', '2021-12-08 11:39:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2621, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 11:39:05', '1', 'admin', '2021-12-08 11:39:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2622, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 11:39:07', '1', 'admin', '2021-12-08 11:39:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2623, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:39:07', '1', 'admin', '2021-12-08 11:39:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2624, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 11:39:11', '1', 'admin', '2021-12-08 11:39:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2625, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-08 11:55:46', '1', 'admin', '2021-12-08 11:55:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2626, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-08 11:55:47', '1', 'admin', '2021-12-08 11:55:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2627, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 11:55:47', '1', 'admin', '2021-12-08 11:55:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2628, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2021-12-08 11:55:48', '1', 'admin', '2021-12-08 11:55:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2629, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 11:55:50', '1', 'admin', '2021-12-08 11:55:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2630, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-08 11:55:50', '1', 'admin', '2021-12-08 11:55:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2631, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 11:55:54', '1', 'admin', '2021-12-08 11:55:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2632, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 11:55:56', '1', 'admin', '2021-12-08 11:55:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 11:56:02', '1', 'admin', '2021-12-08 11:56:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 11:56:04', '1', 'admin', '2021-12-08 11:56:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2021-12-08 11:56:06', '1', 'admin', '2021-12-08 11:56:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2636, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 11:56:34', '1', 'admin', '2021-12-08 11:56:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2637, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-08 11:56:34', '1', 'admin', '2021-12-08 11:56:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2638, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:07:04', '1', 'admin', '2021-12-08 12:07:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2639, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:07:04', '1', 'admin', '2021-12-08 12:07:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2640, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:07:05', '1', 'admin', '2021-12-08 12:07:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2641, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:07:05', '1', 'admin', '2021-12-08 12:07:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2642, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:09:35', '1', 'admin', '2021-12-08 12:09:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:09:35', '1', 'admin', '2021-12-08 12:09:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:09:37', '1', 'admin', '2021-12-08 12:09:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:09:37', '1', 'admin', '2021-12-08 12:09:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2646, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:14:02', '1', 'admin', '2021-12-08 12:14:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2647, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:14:02', '1', 'admin', '2021-12-08 12:14:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2648, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:14:03', '1', 'admin', '2021-12-08 12:14:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:14:03', '1', 'admin', '2021-12-08 12:14:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2650, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upload', '2021-12-08 12:14:06', '1', 'admin', '2021-12-08 12:14:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2651, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:15:13', '1', 'admin', '2021-12-08 12:15:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2652, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:15:13', '1', 'admin', '2021-12-08 12:15:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:15:14', '1', 'admin', '2021-12-08 12:15:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:15:14', '1', 'admin', '2021-12-08 12:15:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2655, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upload', '2021-12-08 12:15:18', '1', 'admin', '2021-12-08 12:15:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2656, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:23:02', '1', 'admin', '2021-12-08 12:23:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2657, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:23:02', '1', 'admin', '2021-12-08 12:23:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:23:03', '1', 'admin', '2021-12-08 12:23:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:23:03', '1', 'admin', '2021-12-08 12:23:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2660, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upload', '2021-12-08 12:23:07', '1', 'admin', '2021-12-08 12:23:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2661, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:25:04', '1', 'admin', '2021-12-08 12:25:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2662, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:25:04', '1', 'admin', '2021-12-08 12:25:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:25:06', '1', 'admin', '2021-12-08 12:25:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2664, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:25:06', '1', 'admin', '2021-12-08 12:25:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2665, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upload', '2021-12-08 12:25:18', '1', 'admin', '2021-12-08 12:25:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2666, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:28:31', '1', 'admin', '2021-12-08 12:28:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2667, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:28:31', '1', 'admin', '2021-12-08 12:28:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2668, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:28:32', '1', 'admin', '2021-12-08 12:28:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2669, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:28:32', '1', 'admin', '2021-12-08 12:28:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2670, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upload', '2021-12-08 12:28:45', '1', 'admin', '2021-12-08 12:28:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2671, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:29:37', '1', 'admin', '2021-12-08 12:29:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2672, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:29:37', '1', 'admin', '2021-12-08 12:29:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2673, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:29:38', '1', 'admin', '2021-12-08 12:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2674, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:29:38', '1', 'admin', '2021-12-08 12:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2675, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:29:41', '1', 'admin', '2021-12-08 12:29:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2676, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:31:44', '1', 'admin', '2021-12-08 12:31:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2677, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:31:44', '1', 'admin', '2021-12-08 12:31:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2678, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:31:44', '1', 'admin', '2021-12-08 12:31:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2679, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:31:45', '1', 'admin', '2021-12-08 12:31:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2680, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:31:48', '1', 'admin', '2021-12-08 12:31:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2681, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:36:21', '1', 'admin', '2021-12-08 12:36:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2682, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:36:21', '1', 'admin', '2021-12-08 12:36:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2683, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:36:22', '1', 'admin', '2021-12-08 12:36:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2684, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:36:22', '1', 'admin', '2021-12-08 12:36:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2685, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:36:56', '1', 'admin', '2021-12-08 12:36:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2686, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:37:22', '1', 'admin', '2021-12-08 12:37:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2687, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:37:22', '1', 'admin', '2021-12-08 12:37:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2688, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:38:03', '1', 'admin', '2021-12-08 12:38:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2689, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:38:03', '1', 'admin', '2021-12-08 12:38:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2690, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:38:08', '1', 'admin', '2021-12-08 12:38:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2691, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:45:17', '1', 'admin', '2021-12-08 12:45:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2692, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:45:54', '1', 'admin', '2021-12-08 12:45:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2693, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:47:47', '1', 'admin', '2021-12-08 12:47:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2694, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:49:42', '1', 'admin', '2021-12-08 12:49:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2695, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:49:42', '1', 'admin', '2021-12-08 12:49:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2696, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:49:43', '1', 'admin', '2021-12-08 12:49:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2697, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:49:44', '1', 'admin', '2021-12-08 12:49:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2698, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:49:47', '1', 'admin', '2021-12-08 12:49:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2699, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:51:43', '1', 'admin', '2021-12-08 12:51:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2700, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:51:44', '1', 'admin', '2021-12-08 12:51:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2701, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:51:44', '1', 'admin', '2021-12-08 12:51:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2702, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:51:44', '1', 'admin', '2021-12-08 12:51:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2703, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:51:47', '1', 'admin', '2021-12-08 12:51:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:52:18', '1', 'admin', '2021-12-08 12:52:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2705, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:52:18', '1', 'admin', '2021-12-08 12:52:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2706, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:52:20', '1', 'admin', '2021-12-08 12:52:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:52:20', '1', 'admin', '2021-12-08 12:52:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 12:52:40', '1', 'admin', '2021-12-08 12:52:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2709, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 12:52:40', '1', 'admin', '2021-12-08 12:52:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2710, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 12:52:41', '1', 'admin', '2021-12-08 12:52:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2711, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 12:52:41', '1', 'admin', '2021-12-08 12:52:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2712, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 12:52:50', '1', 'admin', '2021-12-08 12:52:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2713, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 13:32:35', '1', 'admin', '2021-12-08 13:32:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2714, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 13:33:41', '1', 'admin', '2021-12-08 13:33:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2715, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/upload', '2021-12-08 13:37:44', '1', 'admin', '2021-12-08 13:37:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2716, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 13:37:48', '1', 'admin', '2021-12-08 13:37:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2717, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 13:37:48', '1', 'admin', '2021-12-08 13:37:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2718, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/check', '2021-12-08 13:37:49', '1', 'admin', '2021-12-08 13:37:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2719, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 13:37:49', '1', 'admin', '2021-12-08 13:37:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2720, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 13:59:09', '1', 'admin', '2021-12-08 13:59:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2721, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 13:59:09', '1', 'admin', '2021-12-08 13:59:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2722, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 13:59:10', '1', 'admin', '2021-12-08 13:59:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2723, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 13:59:10', '1', 'admin', '2021-12-08 13:59:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2724, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 13:59:15', '1', 'admin', '2021-12-08 13:59:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2725, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 14:01:35', '1', 'admin', '2021-12-08 14:01:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2726, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 14:01:35', '1', 'admin', '2021-12-08 14:01:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2727, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/check', '2021-12-08 14:01:37', '1', 'admin', '2021-12-08 14:01:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2728, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 14:01:37', '1', 'admin', '2021-12-08 14:01:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2729, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/upfile', '2021-12-08 14:01:43', '1', 'admin', '2021-12-08 14:01:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2730, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:08:44', '1', 'admin', '2021-12-08 14:08:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:08:44', '1', 'admin', '2021-12-08 14:08:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2732, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:08:45', '1', 'admin', '2021-12-08 14:08:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:08:45', '1', 'admin', '2021-12-08 14:08:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2734, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:08:52', '1', 'admin', '2021-12-08 14:08:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2735, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:10:04', '1', 'admin', '2021-12-08 14:10:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2736, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:10:04', '1', 'admin', '2021-12-08 14:10:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:10:05', '1', 'admin', '2021-12-08 14:10:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:10:05', '1', 'admin', '2021-12-08 14:10:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2739, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:10:09', '1', 'admin', '2021-12-08 14:10:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2740, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:10:41', '1', 'admin', '2021-12-08 14:10:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:10:42', '1', 'admin', '2021-12-08 14:10:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:10:43', '1', 'admin', '2021-12-08 14:10:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2743, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:10:43', '1', 'admin', '2021-12-08 14:10:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2744, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:10:46', '1', 'admin', '2021-12-08 14:10:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:13:04', '1', 'admin', '2021-12-08 14:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:13:04', '1', 'admin', '2021-12-08 14:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2747, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:13:04', '1', 'admin', '2021-12-08 14:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:13:04', '1', 'admin', '2021-12-08 14:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2749, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:13:08', '1', 'admin', '2021-12-08 14:13:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:13:57', '1', 'admin', '2021-12-08 14:13:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:13:57', '1', 'admin', '2021-12-08 14:13:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:14:00', '1', 'admin', '2021-12-08 14:14:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:14:00', '1', 'admin', '2021-12-08 14:14:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2754, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:14:05', '1', 'admin', '2021-12-08 14:14:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2755, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/upfile', '2021-12-08 14:14:08', '1', 'admin', '2021-12-08 14:14:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:17:50', '1', 'admin', '2021-12-08 14:17:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:17:50', '1', 'admin', '2021-12-08 14:17:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:17:52', '1', 'admin', '2021-12-08 14:17:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2759, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:17:52', '1', 'admin', '2021-12-08 14:17:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2760, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:17:55', '1', 'admin', '2021-12-08 14:17:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2761, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:19:35', '1', 'admin', '2021-12-08 14:19:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2762, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:19:35', '1', 'admin', '2021-12-08 14:19:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2763, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:19:37', '1', 'admin', '2021-12-08 14:19:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2764, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:19:37', '1', 'admin', '2021-12-08 14:19:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2765, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:19:40', '1', 'admin', '2021-12-08 14:19:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:19:46', '1', 'admin', '2021-12-08 14:19:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:25:34', '1', 'admin', '2021-12-08 14:25:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2768, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:25:34', '1', 'admin', '2021-12-08 14:25:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2769, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:25:35', '1', 'admin', '2021-12-08 14:25:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2770, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:25:35', '1', 'admin', '2021-12-08 14:25:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:25:37', '1', 'admin', '2021-12-08 14:25:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:28:20', '1', 'admin', '2021-12-08 14:28:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:28:20', '1', 'admin', '2021-12-08 14:28:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:28:21', '1', 'admin', '2021-12-08 14:28:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2775, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:28:21', '1', 'admin', '2021-12-08 14:28:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:28:22', '1', 'admin', '2021-12-08 14:28:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2777, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:28:27', '1', 'admin', '2021-12-08 14:28:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:42:44', '1', 'admin', '2021-12-08 14:42:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:42:44', '1', 'admin', '2021-12-08 14:42:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:42:45', '1', 'admin', '2021-12-08 14:42:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:42:45', '1', 'admin', '2021-12-08 14:42:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:42:46', '1', 'admin', '2021-12-08 14:42:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2783, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:42:50', '1', 'admin', '2021-12-08 14:42:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2784, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:44:05', '1', 'admin', '2021-12-08 14:44:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:44:05', '1', 'admin', '2021-12-08 14:44:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 14:44:06', '1', 'admin', '2021-12-08 14:44:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 14:44:06', '1', 'admin', '2021-12-08 14:44:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:44:08', '1', 'admin', '2021-12-08 14:44:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2789, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:44:11', '1', 'admin', '2021-12-08 14:44:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:46:51', '1', 'admin', '2021-12-08 14:46:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:46:51', '1', 'admin', '2021-12-08 14:46:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:46:53', '1', 'admin', '2021-12-08 14:46:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2793, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:46:55', '1', 'admin', '2021-12-08 14:46:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2794, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:55:18', '1', 'admin', '2021-12-08 14:55:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:55:18', '1', 'admin', '2021-12-08 14:55:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:55:19', '1', 'admin', '2021-12-08 14:55:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:56:19', '1', 'admin', '2021-12-08 14:56:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:56:19', '1', 'admin', '2021-12-08 14:56:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2799, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:56:20', '1', 'admin', '2021-12-08 14:56:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2800, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:56:24', '1', 'admin', '2021-12-08 14:56:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 14:57:52', '1', 'admin', '2021-12-08 14:57:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2802, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 14:57:52', '1', 'admin', '2021-12-08 14:57:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 14:57:53', '1', 'admin', '2021-12-08 14:57:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2804, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 14:57:58', '1', 'admin', '2021-12-08 14:57:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2805, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 15:01:27', '1', 'admin', '2021-12-08 15:01:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2806, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-08 15:01:50', '1', 'admin', '2021-12-08 15:01:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2807, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-08 15:03:13', '1', 'admin', '2021-12-08 15:03:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 15:03:16', '1', 'admin', '2021-12-08 15:03:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2809, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:03:16', '1', 'admin', '2021-12-08 15:03:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:04:11', '1', 'admin', '2021-12-08 15:04:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2811, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:04:12', '1', 'admin', '2021-12-08 15:04:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2812, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:19:44', '1', 'admin', '2021-12-08 15:19:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:19:44', '1', 'admin', '2021-12-08 15:19:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2814, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 15:19:45', '1', 'admin', '2021-12-08 15:19:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:19:45', '1', 'admin', '2021-12-08 15:19:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:19:47', '1', 'admin', '2021-12-08 15:19:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:19:47', '1', 'admin', '2021-12-08 15:19:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:20:55', '1', 'admin', '2021-12-08 15:20:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2819, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:20:55', '1', 'admin', '2021-12-08 15:20:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2820, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:20:55', '1', 'admin', '2021-12-08 15:20:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:20:56', '1', 'admin', '2021-12-08 15:20:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:22:59', '1', 'admin', '2021-12-08 15:22:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:22:59', '1', 'admin', '2021-12-08 15:22:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:23:01', '1', 'admin', '2021-12-08 15:23:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:23:01', '1', 'admin', '2021-12-08 15:23:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2826, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2021-12-08 15:25:11', '1', 'admin', '2021-12-08 15:25:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2827, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2021-12-08 15:25:11', '1', 'admin', '2021-12-08 15:25:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2021-12-08 15:25:11', '1', 'admin', '2021-12-08 15:25:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:30:11', '1', 'admin', '2021-12-08 15:30:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:30:11', '1', 'admin', '2021-12-08 15:30:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2831, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:30:12', '1', 'admin', '2021-12-08 15:30:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:30:12', '1', 'admin', '2021-12-08 15:30:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2833, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:30:15', '1', 'admin', '2021-12-08 15:30:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:30:49', '1', 'admin', '2021-12-08 15:30:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2835, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:30:49', '1', 'admin', '2021-12-08 15:30:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2836, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:31:08', '1', 'admin', '2021-12-08 15:31:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2837, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:31:08', '1', 'admin', '2021-12-08 15:31:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:31:09', '1', 'admin', '2021-12-08 15:31:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:31:09', '1', 'admin', '2021-12-08 15:31:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2840, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:31:12', '1', 'admin', '2021-12-08 15:31:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2841, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:31:21', '1', 'admin', '2021-12-08 15:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2842, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:31:21', '1', 'admin', '2021-12-08 15:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:32:21', '1', 'admin', '2021-12-08 15:32:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:32:21', '1', 'admin', '2021-12-08 15:32:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:32:22', '1', 'admin', '2021-12-08 15:32:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2846, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:32:22', '1', 'admin', '2021-12-08 15:32:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2847, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:32:26', '1', 'admin', '2021-12-08 15:32:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:34:35', '1', 'admin', '2021-12-08 15:34:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:34:35', '1', 'admin', '2021-12-08 15:34:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2850, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:35:02', '1', 'admin', '2021-12-08 15:35:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:35:02', '1', 'admin', '2021-12-08 15:35:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:35:03', '1', 'admin', '2021-12-08 15:35:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:35:04', '1', 'admin', '2021-12-08 15:35:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2854, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:35:12', '1', 'admin', '2021-12-08 15:35:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 15:35:28', '1', 'admin', '2021-12-08 15:35:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2856, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:35:28', '1', 'admin', '2021-12-08 15:35:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2857, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:37:49', '1', 'admin', '2021-12-08 15:37:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:37:49', '1', 'admin', '2021-12-08 15:37:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:37:50', '1', 'admin', '2021-12-08 15:37:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:37:50', '1', 'admin', '2021-12-08 15:37:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2861, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:37:55', '1', 'admin', '2021-12-08 15:37:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2862, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:41:42', '1', 'admin', '2021-12-08 15:41:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:41:43', '1', 'admin', '2021-12-08 15:41:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2864, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:41:43', '1', 'admin', '2021-12-08 15:41:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2865, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:41:43', '1', 'admin', '2021-12-08 15:41:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2866, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:41:47', '1', 'admin', '2021-12-08 15:41:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2867, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:42:32', '1', 'admin', '2021-12-08 15:42:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2868, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:42:32', '1', 'admin', '2021-12-08 15:42:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 15:42:34', '1', 'admin', '2021-12-08 15:42:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:42:34', '1', 'admin', '2021-12-08 15:42:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2871, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:42:36', '1', 'admin', '2021-12-08 15:42:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2872, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:42:36', '1', 'admin', '2021-12-08 15:42:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2873, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:42:41', '1', 'admin', '2021-12-08 15:42:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:43:43', '1', 'admin', '2021-12-08 15:43:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:43:44', '1', 'admin', '2021-12-08 15:43:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2876, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:43:45', '1', 'admin', '2021-12-08 15:43:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:43:45', '1', 'admin', '2021-12-08 15:43:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2878, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:43:48', '1', 'admin', '2021-12-08 15:43:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:45:15', '1', 'admin', '2021-12-08 15:45:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:45:15', '1', 'admin', '2021-12-08 15:45:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2881, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:45:16', '1', 'admin', '2021-12-08 15:45:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2882, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:45:16', '1', 'admin', '2021-12-08 15:45:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2883, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:45:20', '1', 'admin', '2021-12-08 15:45:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:45:52', '1', 'admin', '2021-12-08 15:45:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:45:52', '1', 'admin', '2021-12-08 15:45:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2886, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:45:53', '1', 'admin', '2021-12-08 15:45:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2887, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:45:53', '1', 'admin', '2021-12-08 15:45:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2888, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:45:56', '1', 'admin', '2021-12-08 15:45:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:48:36', '1', 'admin', '2021-12-08 15:48:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:48:36', '1', 'admin', '2021-12-08 15:48:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2891, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:48:37', '1', 'admin', '2021-12-08 15:48:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:48:37', '1', 'admin', '2021-12-08 15:48:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2893, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:48:41', '1', 'admin', '2021-12-08 15:48:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:49:53', '1', 'admin', '2021-12-08 15:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:49:53', '1', 'admin', '2021-12-08 15:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2896, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:49:54', '1', 'admin', '2021-12-08 15:49:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2897, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:49:54', '1', 'admin', '2021-12-08 15:49:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2898, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:49:57', '1', 'admin', '2021-12-08 15:49:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2899, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:51:45', '1', 'admin', '2021-12-08 15:51:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2900, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:52:37', '1', 'admin', '2021-12-08 15:52:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2901, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:54:27', '1', 'admin', '2021-12-08 15:54:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2902, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 15:54:33', '1', 'admin', '2021-12-08 15:54:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2903, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:56:43', '1', 'admin', '2021-12-08 15:56:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:56:44', '1', 'admin', '2021-12-08 15:56:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:56:45', '1', 'admin', '2021-12-08 15:56:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:56:45', '1', 'admin', '2021-12-08 15:56:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2907, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:56:48', '1', 'admin', '2021-12-08 15:56:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:57:44', '1', 'admin', '2021-12-08 15:57:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:57:44', '1', 'admin', '2021-12-08 15:57:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:57:45', '1', 'admin', '2021-12-08 15:57:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2911, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:57:45', '1', 'admin', '2021-12-08 15:57:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2912, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:57:50', '1', 'admin', '2021-12-08 15:57:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2913, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 15:57:56', '1', 'admin', '2021-12-08 15:57:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 15:59:39', '1', 'admin', '2021-12-08 15:59:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2915, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 15:59:39', '1', 'admin', '2021-12-08 15:59:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2916, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 15:59:40', '1', 'admin', '2021-12-08 15:59:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 15:59:40', '1', 'admin', '2021-12-08 15:59:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2918, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 15:59:44', '1', 'admin', '2021-12-08 15:59:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2919, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 15:59:53', '1', 'admin', '2021-12-08 15:59:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:01:42', '1', 'admin', '2021-12-08 16:01:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:01:42', '1', 'admin', '2021-12-08 16:01:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:01:43', '1', 'admin', '2021-12-08 16:01:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2923, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:01:44', '1', 'admin', '2021-12-08 16:01:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2924, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:01:47', '1', 'admin', '2021-12-08 16:01:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2925, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 16:01:52', '1', 'admin', '2021-12-08 16:01:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:04:38', '1', 'admin', '2021-12-08 16:04:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:04:38', '1', 'admin', '2021-12-08 16:04:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:04:42', '1', 'admin', '2021-12-08 16:04:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2929, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:04:42', '1', 'admin', '2021-12-08 16:04:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2930, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:04:45', '1', 'admin', '2021-12-08 16:04:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:05:04', '1', 'admin', '2021-12-08 16:05:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:05:04', '1', 'admin', '2021-12-08 16:05:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:05:07', '1', 'admin', '2021-12-08 16:05:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:05:07', '1', 'admin', '2021-12-08 16:05:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2935, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:05:12', '1', 'admin', '2021-12-08 16:05:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2936, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 16:05:31', '1', 'admin', '2021-12-08 16:05:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:06:48', '1', 'admin', '2021-12-08 16:06:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2938, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:06:48', '1', 'admin', '2021-12-08 16:06:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2939, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:06:49', '1', 'admin', '2021-12-08 16:06:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:06:50', '1', 'admin', '2021-12-08 16:06:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2941, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:06:52', '1', 'admin', '2021-12-08 16:06:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:08:07', '1', 'admin', '2021-12-08 16:08:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:08:07', '1', 'admin', '2021-12-08 16:08:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:08:08', '1', 'admin', '2021-12-08 16:08:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:08:08', '1', 'admin', '2021-12-08 16:08:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2946, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:08:11', '1', 'admin', '2021-12-08 16:08:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:09:15', '1', 'admin', '2021-12-08 16:09:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:09:15', '1', 'admin', '2021-12-08 16:09:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:09:16', '1', 'admin', '2021-12-08 16:09:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2950, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:09:16', '1', 'admin', '2021-12-08 16:09:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2951, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:09:18', '1', 'admin', '2021-12-08 16:09:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:12:17', '1', 'admin', '2021-12-08 16:12:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:12:17', '1', 'admin', '2021-12-08 16:12:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2954, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:12:18', '1', 'admin', '2021-12-08 16:12:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:12:18', '1', 'admin', '2021-12-08 16:12:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2956, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:12:22', '1', 'admin', '2021-12-08 16:12:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:12:55', '1', 'admin', '2021-12-08 16:12:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:12:55', '1', 'admin', '2021-12-08 16:12:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:12:56', '1', 'admin', '2021-12-08 16:12:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:12:56', '1', 'admin', '2021-12-08 16:12:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2961, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:12:58', '1', 'admin', '2021-12-08 16:12:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:16:53', '1', 'admin', '2021-12-08 16:16:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:16:53', '1', 'admin', '2021-12-08 16:16:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:16:55', '1', 'admin', '2021-12-08 16:16:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:16:55', '1', 'admin', '2021-12-08 16:16:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2966, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:17:10', '1', 'admin', '2021-12-08 16:17:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:17:38', '1', 'admin', '2021-12-08 16:17:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:17:38', '1', 'admin', '2021-12-08 16:17:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2969, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:17:39', '1', 'admin', '2021-12-08 16:17:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2970, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:17:40', '1', 'admin', '2021-12-08 16:17:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2971, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:17:46', '1', 'admin', '2021-12-08 16:17:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2972, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 16:22:52', '1', 'admin', '2021-12-08 16:22:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2973, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 16:22:52', '1', 'admin', '2021-12-08 16:22:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2974, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/download', '2021-12-08 16:22:53', '1', 'admin', '2021-12-08 16:22:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2975, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/tablesData', '2021-12-08 16:22:53', '1', 'admin', '2021-12-08 16:22:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2976, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/downfile', '2021-12-08 16:22:59', '1', 'admin', '2021-12-08 16:22:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2977, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:25:39', '1', 'admin', '2021-12-08 16:25:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2978, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:27:05', '1', 'admin', '2021-12-08 16:27:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2979, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:27:59', '1', 'admin', '2021-12-08 16:27:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2980, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 16:28:28', '1', 'admin', '2021-12-08 16:28:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:29:37', '1', 'admin', '2021-12-08 16:29:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:29:37', '1', 'admin', '2021-12-08 16:29:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:29:38', '1', 'admin', '2021-12-08 16:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2984, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:29:38', '1', 'admin', '2021-12-08 16:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2985, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:29:46', '1', 'admin', '2021-12-08 16:29:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:30:02', '1', 'admin', '2021-12-08 16:30:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:30:02', '1', 'admin', '2021-12-08 16:30:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:30:03', '1', 'admin', '2021-12-08 16:30:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:30:03', '1', 'admin', '2021-12-08 16:30:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2990, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:30:07', '1', 'admin', '2021-12-08 16:30:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2991, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:33:04', '1', 'admin', '2021-12-08 16:33:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2992, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:36:21', '1', 'admin', '2021-12-08 16:36:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:36:21', '1', 'admin', '2021-12-08 16:36:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2994, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:36:22', '1', 'admin', '2021-12-08 16:36:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:36:22', '1', 'admin', '2021-12-08 16:36:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2996, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:36:24', '1', 'admin', '2021-12-08 16:36:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2997, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 16:36:55', '1', 'admin', '2021-12-08 16:36:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:44:28', '1', 'admin', '2021-12-08 16:44:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (2999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:44:29', '1', 'admin', '2021-12-08 16:44:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:44:30', '1', 'admin', '2021-12-08 16:44:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:44:31', '1', 'admin', '2021-12-08 16:44:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3002, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:44:37', '1', 'admin', '2021-12-08 16:44:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:47:48', '1', 'admin', '2021-12-08 16:47:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3004, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:47:48', '1', 'admin', '2021-12-08 16:47:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3005, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:47:49', '1', 'admin', '2021-12-08 16:47:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:47:49', '1', 'admin', '2021-12-08 16:47:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3007, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:48:00', '1', 'admin', '2021-12-08 16:48:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3008, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 16:48:05', '1', 'admin', '2021-12-08 16:48:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3009, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 16:49:33', '1', 'admin', '2021-12-08 16:49:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3010, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 16:49:33', '1', 'admin', '2021-12-08 16:49:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3011, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/check', '2021-12-08 16:49:35', '1', 'admin', '2021-12-08 16:49:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3012, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.101', '/system/user/tablesData', '2021-12-08 16:49:35', '1', 'admin', '2021-12-08 16:49:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3013, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/download', '2021-12-08 16:49:35', '1', 'admin', '2021-12-08 16:49:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3014, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/tablesData', '2021-12-08 16:49:35', '1', 'admin', '2021-12-08 16:49:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3015, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/downfile', '2021-12-08 16:49:38', '1', 'admin', '2021-12-08 16:49:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3016, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/downfile', '2021-12-08 16:49:59', '1', 'admin', '2021-12-08 16:49:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3017, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 16:50:50', '1', 'admin', '2021-12-08 16:50:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3018, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:52:02', '1', 'admin', '2021-12-08 16:52:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:52:02', '1', 'admin', '2021-12-08 16:52:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3020, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:52:03', '1', 'admin', '2021-12-08 16:52:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:52:03', '1', 'admin', '2021-12-08 16:52:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3022, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:52:11', '1', 'admin', '2021-12-08 16:52:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3023, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 16:52:28', '1', 'admin', '2021-12-08 16:52:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3024, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:52:39', '1', 'admin', '2021-12-08 16:52:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 16:52:46', '1', 'admin', '2021-12-08 16:52:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3026, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 16:52:49', '1', 'admin', '2021-12-08 16:52:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3027, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-08 16:52:55', '1', 'admin', '2021-12-08 16:52:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 16:53:09', '1', 'admin', '2021-12-08 16:53:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:53:09', '1', 'admin', '2021-12-08 16:53:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3030, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:53:16', '1', 'admin', '2021-12-08 16:53:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3031, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:53:16', '1', 'admin', '2021-12-08 16:53:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3032, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:53:16', '1', 'admin', '2021-12-08 16:53:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:53:16', '1', 'admin', '2021-12-08 16:53:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3034, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:53:20', '1', 'admin', '2021-12-08 16:53:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 16:59:35', '1', 'admin', '2021-12-08 16:59:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 16:59:35', '1', 'admin', '2021-12-08 16:59:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 16:59:35', '1', 'admin', '2021-12-08 16:59:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 16:59:36', '1', 'admin', '2021-12-08 16:59:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3039, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 16:59:40', '1', 'admin', '2021-12-08 16:59:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 17:00:37', '1', 'admin', '2021-12-08 17:00:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:00:37', '1', 'admin', '2021-12-08 17:00:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3042, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:01:27', '1', 'admin', '2021-12-08 17:01:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3043, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:01:28', '1', 'admin', '2021-12-08 17:01:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3044, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:01:29', '1', 'admin', '2021-12-08 17:01:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:01:29', '1', 'admin', '2021-12-08 17:01:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3046, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:01:31', '1', 'admin', '2021-12-08 17:01:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3047, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 17:01:34', '1', 'admin', '2021-12-08 17:01:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3048, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:03:17', '1', 'admin', '2021-12-08 17:03:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3049, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:03:17', '1', 'admin', '2021-12-08 17:03:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3050, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:03:18', '1', 'admin', '2021-12-08 17:03:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3051, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:03:18', '1', 'admin', '2021-12-08 17:03:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3052, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:03:19', '1', 'admin', '2021-12-08 17:03:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3053, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:03:55', '1', 'admin', '2021-12-08 17:03:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3054, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:03:56', '1', 'admin', '2021-12-08 17:03:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:03:57', '1', 'admin', '2021-12-08 17:03:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:03:57', '1', 'admin', '2021-12-08 17:03:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3057, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:03:59', '1', 'admin', '2021-12-08 17:03:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3058, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 17:04:04', '1', 'admin', '2021-12-08 17:04:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3059, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:13:04', '1', 'admin', '2021-12-08 17:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3060, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:13:04', '1', 'admin', '2021-12-08 17:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:13:05', '1', 'admin', '2021-12-08 17:13:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3062, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:13:45', '1', 'admin', '2021-12-08 17:13:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3063, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:13:45', '1', 'admin', '2021-12-08 17:13:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3064, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:13:46', '1', 'admin', '2021-12-08 17:13:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3065, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:16:37', '1', 'admin', '2021-12-08 17:16:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3066, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:16:37', '1', 'admin', '2021-12-08 17:16:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3067, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:16:38', '1', 'admin', '2021-12-08 17:16:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3068, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 17:16:42', '1', 'admin', '2021-12-08 17:16:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3069, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/download', '2021-12-08 17:16:46', '1', 'admin', '2021-12-08 17:16:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3070, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 17:17:35', '1', 'admin', '2021-12-08 17:17:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3071, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 17:17:35', '1', 'admin', '2021-12-08 17:17:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3072, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/upload', '2021-12-08 17:17:36', '1', 'admin', '2021-12-08 17:17:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3073, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/download', '2021-12-08 17:17:41', '1', 'admin', '2021-12-08 17:17:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3074, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.101', '/system/user/tablesData', '2021-12-08 17:17:41', '1', 'admin', '2021-12-08 17:17:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3075, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/upload', '192.168.1.101', '/hello/handleUpload', '2021-12-08 17:18:37', '1', 'admin', '2021-12-08 17:18:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3076, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:18:49', '1', 'admin', '2021-12-08 17:18:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:18:49', '1', 'admin', '2021-12-08 17:18:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3078, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:18:51', '1', 'admin', '2021-12-08 17:18:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:22:51', '1', 'admin', '2021-12-08 17:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3080, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:22:51', '1', 'admin', '2021-12-08 17:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:22:51', '1', 'admin', '2021-12-08 17:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3082, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 17:22:58', '1', 'admin', '2021-12-08 17:22:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:26:47', '1', 'admin', '2021-12-08 17:26:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3084, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:26:47', '1', 'admin', '2021-12-08 17:26:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:26:48', '1', 'admin', '2021-12-08 17:26:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3086, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 17:26:51', '1', 'admin', '2021-12-08 17:26:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/download', '2021-12-08 17:26:55', '1', 'admin', '2021-12-08 17:26:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:31:15', '1', 'admin', '2021-12-08 17:31:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3089, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:31:15', '1', 'admin', '2021-12-08 17:31:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3090, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:31:16', '1', 'admin', '2021-12-08 17:31:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:31:16', '1', 'admin', '2021-12-08 17:31:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3092, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:31:17', '1', 'admin', '2021-12-08 17:31:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3093, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:34:46', '1', 'admin', '2021-12-08 17:34:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3094, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:34:47', '1', 'admin', '2021-12-08 17:34:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:34:47', '1', 'admin', '2021-12-08 17:34:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3096, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:34:48', '1', 'admin', '2021-12-08 17:34:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3097, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 17:34:51', '1', 'admin', '2021-12-08 17:34:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:34:53', '1', 'admin', '2021-12-08 17:34:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3099, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:39:25', '1', 'admin', '2021-12-08 17:39:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3100, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:39:25', '1', 'admin', '2021-12-08 17:39:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3101, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:39:26', '1', 'admin', '2021-12-08 17:39:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3102, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 17:39:29', '1', 'admin', '2021-12-08 17:39:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3103, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:39:30', '1', 'admin', '2021-12-08 17:39:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3104, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:40:32', '1', 'admin', '2021-12-08 17:40:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3105, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:40:32', '1', 'admin', '2021-12-08 17:40:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 17:40:33', '1', 'admin', '2021-12-08 17:40:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3107, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 17:40:37', '1', 'admin', '2021-12-08 17:40:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3108, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:40:38', '1', 'admin', '2021-12-08 17:40:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:40:43', '1', 'admin', '2021-12-08 17:40:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3110, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:40:43', '1', 'admin', '2021-12-08 17:40:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:41:47', '1', 'admin', '2021-12-08 17:41:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:41:47', '1', 'admin', '2021-12-08 17:41:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:41:48', '1', 'admin', '2021-12-08 17:41:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3114, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:41:48', '1', 'admin', '2021-12-08 17:41:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3115, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:41:50', '1', 'admin', '2021-12-08 17:41:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3116, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:41:54', '1', 'admin', '2021-12-08 17:41:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3117, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:47:03', '1', 'admin', '2021-12-08 17:47:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:47:03', '1', 'admin', '2021-12-08 17:47:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3119, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:47:04', '1', 'admin', '2021-12-08 17:47:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:47:04', '1', 'admin', '2021-12-08 17:47:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3121, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:47:06', '1', 'admin', '2021-12-08 17:47:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3122, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 17:47:19', '1', 'admin', '2021-12-08 17:47:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3123, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:51:10', '1', 'admin', '2021-12-08 17:51:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3124, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:51:56', '1', 'admin', '2021-12-08 17:51:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:51:56', '1', 'admin', '2021-12-08 17:51:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3126, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:51:57', '1', 'admin', '2021-12-08 17:51:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3127, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:51:57', '1', 'admin', '2021-12-08 17:51:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3128, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:51:59', '1', 'admin', '2021-12-08 17:51:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:52:32', '1', 'admin', '2021-12-08 17:52:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:52:32', '1', 'admin', '2021-12-08 17:52:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3131, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:52:32', '1', 'admin', '2021-12-08 17:52:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:52:32', '1', 'admin', '2021-12-08 17:52:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3133, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:52:34', '1', 'admin', '2021-12-08 17:52:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3134, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 17:52:37', '1', 'admin', '2021-12-08 17:52:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3135, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:54:41', '1', 'admin', '2021-12-08 17:54:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:54:41', '1', 'admin', '2021-12-08 17:54:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:54:42', '1', 'admin', '2021-12-08 17:54:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:54:42', '1', 'admin', '2021-12-08 17:54:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3139, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:54:43', '1', 'admin', '2021-12-08 17:54:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3140, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 17:57:55', '1', 'admin', '2021-12-08 17:57:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3141, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 17:57:55', '1', 'admin', '2021-12-08 17:57:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3142, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 17:57:56', '1', 'admin', '2021-12-08 17:57:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 17:57:56', '1', 'admin', '2021-12-08 17:57:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3144, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 17:57:57', '1', 'admin', '2021-12-08 17:57:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3145, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 17:58:02', '1', 'admin', '2021-12-08 17:58:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3146, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 18:00:01', '1', 'admin', '2021-12-08 18:00:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3147, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 18:00:01', '1', 'admin', '2021-12-08 18:00:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3148, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 18:00:01', '1', 'admin', '2021-12-08 18:00:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3149, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 18:00:07', '1', 'admin', '2021-12-08 18:00:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3150, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:00:08', '1', 'admin', '2021-12-08 18:00:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3151, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 18:03:30', '1', 'admin', '2021-12-08 18:03:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 18:03:30', '1', 'admin', '2021-12-08 18:03:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3153, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 18:03:31', '1', 'admin', '2021-12-08 18:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3154, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 18:03:31', '1', 'admin', '2021-12-08 18:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3155, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:03:34', '1', 'admin', '2021-12-08 18:03:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3156, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 18:04:44', '1', 'admin', '2021-12-08 18:04:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 18:04:44', '1', 'admin', '2021-12-08 18:04:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3158, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 18:04:45', '1', 'admin', '2021-12-08 18:04:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 18:04:45', '1', 'admin', '2021-12-08 18:04:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3160, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:04:50', '1', 'admin', '2021-12-08 18:04:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3161, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 18:04:52', '1', 'admin', '2021-12-08 18:04:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3162, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 18:04:54', '1', 'admin', '2021-12-08 18:04:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3163, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:04:56', '1', 'admin', '2021-12-08 18:04:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:05:26', '1', 'admin', '2021-12-08 18:05:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3165, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 18:05:32', '1', 'admin', '2021-12-08 18:05:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 18:06:43', '1', 'admin', '2021-12-08 18:06:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 18:06:44', '1', 'admin', '2021-12-08 18:06:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3168, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 18:06:45', '1', 'admin', '2021-12-08 18:06:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3169, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 18:06:45', '1', 'admin', '2021-12-08 18:06:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 18:06:46', '1', 'admin', '2021-12-08 18:06:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3171, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/hello/handleUpload', '2021-12-08 18:06:50', '1', 'admin', '2021-12-08 18:06:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3172, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:06:51', '1', 'admin', '2021-12-08 18:06:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3173, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-08 18:07:13', '1', 'admin', '2021-12-08 18:07:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3174, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-08 18:07:13', '1', 'admin', '2021-12-08 18:07:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3175, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/upload', '2021-12-08 18:07:14', '1', 'admin', '2021-12-08 18:07:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3176, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuTop', '2021-12-08 18:07:32', '1', 'admin', '2021-12-08 18:07:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3177, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/res/menuLeft', '2021-12-08 18:07:32', '1', 'admin', '2021-12-08 18:07:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3178, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.101', '/system/user/upload', '2021-12-08 18:07:33', '1', 'admin', '2021-12-08 18:07:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3179, 3, 'Firefox 7', 'POST', 'http://192.168.1.10:8080/system/user/upload', '192.168.1.101', '/hello/handleUpload', '2021-12-08 18:07:35', '1', 'admin', '2021-12-08 18:07:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3180, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/upload', '192.168.1.101', '/system/user/downfile', '2021-12-08 18:07:37', '1', 'admin', '2021-12-08 18:07:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3181, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 18:09:42', '1', 'admin', '2021-12-08 18:09:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3182, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 18:09:43', '1', 'admin', '2021-12-08 18:09:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3183, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 18:09:43', '1', 'admin', '2021-12-08 18:09:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3184, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 18:09:43', '1', 'admin', '2021-12-08 18:09:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3185, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:09:45', '1', 'admin', '2021-12-08 18:09:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3186, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 18:09:50', '1', 'admin', '2021-12-08 18:09:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3187, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 18:12:36', '1', 'admin', '2021-12-08 18:12:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3188, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 18:12:37', '1', 'admin', '2021-12-08 18:12:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3189, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 18:12:37', '1', 'admin', '2021-12-08 18:12:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3190, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 18:12:37', '1', 'admin', '2021-12-08 18:12:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3191, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:12:39', '1', 'admin', '2021-12-08 18:12:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3192, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:12:46', '1', 'admin', '2021-12-08 18:12:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3193, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 18:12:59', '1', 'admin', '2021-12-08 18:12:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3194, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 18:15:32', '1', 'admin', '2021-12-08 18:15:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3195, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 18:15:32', '1', 'admin', '2021-12-08 18:15:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3196, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 18:15:33', '1', 'admin', '2021-12-08 18:15:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3197, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 18:15:33', '1', 'admin', '2021-12-08 18:15:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3198, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 18:15:35', '1', 'admin', '2021-12-08 18:15:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3199, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 18:15:39', '1', 'admin', '2021-12-08 18:15:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3200, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-08 18:18:58', '1', 'admin', '2021-12-08 18:18:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3201, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-08 18:18:58', '1', 'admin', '2021-12-08 18:18:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3202, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 18:19:00', '1', 'admin', '2021-12-08 18:19:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3203, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-08 18:19:06', '1', 'admin', '2021-12-08 18:19:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3204, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 19:41:34', '1', 'admin', '2021-12-08 19:41:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3205, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 19:41:34', '1', 'admin', '2021-12-08 19:41:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3206, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 19:41:36', '1', 'admin', '2021-12-08 19:41:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3207, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 19:41:36', '1', 'admin', '2021-12-08 19:41:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3208, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 19:43:55', '1', 'admin', '2021-12-08 19:43:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3209, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 19:43:55', '1', 'admin', '2021-12-08 19:43:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3210, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 19:43:56', '1', 'admin', '2021-12-08 19:43:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3211, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 19:43:56', '1', 'admin', '2021-12-08 19:43:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3212, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 19:45:34', '1', 'admin', '2021-12-08 19:45:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3213, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:07:16', '1', 'admin', '2021-12-08 20:07:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3214, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:07:16', '1', 'admin', '2021-12-08 20:07:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3215, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:07:17', '1', 'admin', '2021-12-08 20:07:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3216, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:07:17', '1', 'admin', '2021-12-08 20:07:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3217, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:08:19', '1', 'admin', '2021-12-08 20:08:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3218, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:08:19', '1', 'admin', '2021-12-08 20:08:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3219, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:08:20', '1', 'admin', '2021-12-08 20:08:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3220, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:08:20', '1', 'admin', '2021-12-08 20:08:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3221, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:13:03', '1', 'admin', '2021-12-08 20:13:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3222, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:13:03', '1', 'admin', '2021-12-08 20:13:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3223, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:13:04', '1', 'admin', '2021-12-08 20:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3224, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:13:04', '1', 'admin', '2021-12-08 20:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3225, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 20:13:05', '1', 'admin', '2021-12-08 20:13:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3226, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:14:08', '1', 'admin', '2021-12-08 20:14:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3227, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:14:08', '1', 'admin', '2021-12-08 20:14:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3228, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:14:08', '1', 'admin', '2021-12-08 20:14:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3229, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:14:09', '1', 'admin', '2021-12-08 20:14:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3230, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 20:14:09', '1', 'admin', '2021-12-08 20:14:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3231, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:16:08', '1', 'admin', '2021-12-08 20:16:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3232, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:16:08', '1', 'admin', '2021-12-08 20:16:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3233, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:16:09', '1', 'admin', '2021-12-08 20:16:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3234, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:16:09', '1', 'admin', '2021-12-08 20:16:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3235, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:16:11', '1', 'admin', '2021-12-08 20:16:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3236, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 20:16:34', '1', 'admin', '2021-12-08 20:16:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3237, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:16:36', '1', 'admin', '2021-12-08 20:16:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3238, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:19:20', '1', 'admin', '2021-12-08 20:19:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3239, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:19:20', '1', 'admin', '2021-12-08 20:19:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3240, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:19:21', '1', 'admin', '2021-12-08 20:19:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3241, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:19:21', '1', 'admin', '2021-12-08 20:19:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3242, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 20:31:41', '1', 'admin', '2021-12-08 20:31:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3243, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-08 20:31:47', '1', 'admin', '2021-12-08 20:31:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3244, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:31:50', '1', 'admin', '2021-12-08 20:31:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3245, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:31:52', '1', 'admin', '2021-12-08 20:31:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3246, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:31:52', '1', 'admin', '2021-12-08 20:31:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3247, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:31:53', '1', 'admin', '2021-12-08 20:31:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3248, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:31:53', '1', 'admin', '2021-12-08 20:31:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3249, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:33:32', '1', 'admin', '2021-12-08 20:33:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3250, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:33:32', '1', 'admin', '2021-12-08 20:33:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3251, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:33:33', '1', 'admin', '2021-12-08 20:33:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3252, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:33:33', '1', 'admin', '2021-12-08 20:33:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3253, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:35:05', '1', 'admin', '2021-12-08 20:35:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3254, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:35:05', '1', 'admin', '2021-12-08 20:35:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3255, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:35:06', '1', 'admin', '2021-12-08 20:35:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3256, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:35:06', '1', 'admin', '2021-12-08 20:35:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3257, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:39:22', '1', 'admin', '2021-12-08 20:39:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3258, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:39:22', '1', 'admin', '2021-12-08 20:39:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3259, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:39:23', '1', 'admin', '2021-12-08 20:39:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3260, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:40:19', '1', 'admin', '2021-12-08 20:40:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3261, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:40:19', '1', 'admin', '2021-12-08 20:40:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3262, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:40:20', '1', 'admin', '2021-12-08 20:40:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3263, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:40:20', '1', 'admin', '2021-12-08 20:40:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3264, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:47:58', '1', 'admin', '2021-12-08 20:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:47:58', '1', 'admin', '2021-12-08 20:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3266, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:47:58', '1', 'admin', '2021-12-08 20:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3267, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:47:59', '1', 'admin', '2021-12-08 20:47:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3268, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:50:42', '1', 'admin', '2021-12-08 20:50:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3269, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:50:42', '1', 'admin', '2021-12-08 20:50:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3270, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:50:43', '1', 'admin', '2021-12-08 20:50:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3271, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:50:43', '1', 'admin', '2021-12-08 20:50:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 20:50:44', '1', 'admin', '2021-12-08 20:50:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3273, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 20:50:51', '1', 'admin', '2021-12-08 20:50:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:56:47', '1', 'admin', '2021-12-08 20:56:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:56:47', '1', 'admin', '2021-12-08 20:56:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:56:48', '1', 'admin', '2021-12-08 20:56:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3277, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:56:48', '1', 'admin', '2021-12-08 20:56:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3278, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 20:56:49', '1', 'admin', '2021-12-08 20:56:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-08 20:58:34', '1', 'admin', '2021-12-08 20:58:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3280, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-08 20:58:35', '1', 'admin', '2021-12-08 20:58:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-08 20:58:35', '1', 'admin', '2021-12-08 20:58:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-08 20:58:35', '1', 'admin', '2021-12-08 20:58:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-08 20:58:36', '1', 'admin', '2021-12-08 20:58:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3284, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-08 20:58:43', '1', 'admin', '2021-12-08 20:58:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3285, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 12:47:05', '1', 'admin', '2021-12-09 12:47:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3286, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 12:47:05', '1', 'admin', '2021-12-09 12:47:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3287, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 12:47:09', '1', 'admin', '2021-12-09 12:47:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3288, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 12:47:09', '1', 'admin', '2021-12-09 12:47:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-09 12:48:22', '1', 'admin', '2021-12-09 12:48:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 12:49:21', '1', 'admin', '2021-12-09 12:49:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3291, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 12:49:21', '1', 'admin', '2021-12-09 12:49:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3292, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 12:49:22', '1', 'admin', '2021-12-09 12:49:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3293, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 12:49:22', '1', 'admin', '2021-12-09 12:49:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3294, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 12:49:24', '1', 'admin', '2021-12-09 12:49:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3295, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-09 12:49:29', '1', 'admin', '2021-12-09 12:49:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3296, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 12:56:05', '1', 'admin', '2021-12-09 12:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3297, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 12:56:05', '1', 'admin', '2021-12-09 12:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3298, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 12:56:05', '1', 'admin', '2021-12-09 12:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3299, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 12:56:05', '1', 'admin', '2021-12-09 12:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3300, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 12:56:06', '1', 'admin', '2021-12-09 12:56:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3301, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 12:56:14', '1', 'admin', '2021-12-09 12:56:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3302, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/downfile', '2021-12-09 12:56:18', '1', 'admin', '2021-12-09 12:56:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3303, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 12:56:36', '1', 'admin', '2021-12-09 12:56:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3304, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:00:53', '1', 'admin', '2021-12-09 13:00:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3305, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:01:04', '1', 'admin', '2021-12-09 13:01:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3306, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:07:25', '1', 'admin', '2021-12-09 13:07:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3307, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:07:25', '1', 'admin', '2021-12-09 13:07:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3308, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:07:26', '1', 'admin', '2021-12-09 13:07:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3309, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:07:26', '1', 'admin', '2021-12-09 13:07:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:07:28', '1', 'admin', '2021-12-09 13:07:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3311, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:07:28', '1', 'admin', '2021-12-09 13:07:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3312, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:07:34', '1', 'admin', '2021-12-09 13:07:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3313, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:07:34', '1', 'admin', '2021-12-09 13:07:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:08:03', '1', 'admin', '2021-12-09 13:08:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3315, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:08:03', '1', 'admin', '2021-12-09 13:08:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:08:05', '1', 'admin', '2021-12-09 13:08:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3317, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:08:05', '1', 'admin', '2021-12-09 13:08:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3318, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:08:08', '1', 'admin', '2021-12-09 13:08:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:08:15', '1', 'admin', '2021-12-09 13:08:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:08:15', '1', 'admin', '2021-12-09 13:08:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3321, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:08:17', '1', 'admin', '2021-12-09 13:08:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3322, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:08:17', '1', 'admin', '2021-12-09 13:08:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:08:26', '1', 'admin', '2021-12-09 13:08:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3324, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:10:01', '1', 'admin', '2021-12-09 13:10:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3325, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:10:01', '1', 'admin', '2021-12-09 13:10:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3326, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:10:02', '1', 'admin', '2021-12-09 13:10:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3327, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:10:02', '1', 'admin', '2021-12-09 13:10:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3328, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:11:57', '1', 'admin', '2021-12-09 13:11:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3329, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:11:57', '1', 'admin', '2021-12-09 13:11:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3330, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:11:59', '1', 'admin', '2021-12-09 13:11:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3331, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:11:59', '1', 'admin', '2021-12-09 13:11:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3332, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:13:13', '1', 'admin', '2021-12-09 13:13:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3333, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:13:13', '1', 'admin', '2021-12-09 13:13:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3334, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:13:14', '1', 'admin', '2021-12-09 13:13:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:13:14', '1', 'admin', '2021-12-09 13:13:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3336, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:13:17', '1', 'admin', '2021-12-09 13:13:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3337, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:13:17', '1', 'admin', '2021-12-09 13:13:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3338, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:14:02', '1', 'admin', '2021-12-09 13:14:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3339, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:14:02', '1', 'admin', '2021-12-09 13:14:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:14:11', '1', 'admin', '2021-12-09 13:14:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:14:11', '1', 'admin', '2021-12-09 13:14:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3342, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:14:21', '1', 'admin', '2021-12-09 13:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3343, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 13:43:19', '1', 'admin', '2021-12-09 13:43:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3344, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 13:43:19', '1', 'admin', '2021-12-09 13:43:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3345, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 13:43:21', '1', 'admin', '2021-12-09 13:43:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 13:43:21', '1', 'admin', '2021-12-09 13:43:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/downfile', '2021-12-09 13:43:27', '1', 'admin', '2021-12-09 13:43:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3348, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2021-12-09 13:43:44', '1', 'admin', '2021-12-09 13:43:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3349, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-09 13:43:44', '1', 'admin', '2021-12-09 13:43:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2021-12-09 13:43:45', '1', 'admin', '2021-12-09 13:43:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-09 13:43:48', '1', 'admin', '2021-12-09 13:43:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3352, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/update', '2021-12-09 13:43:49', '1', 'admin', '2021-12-09 13:43:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3353, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2021-12-09 13:43:54', '1', 'admin', '2021-12-09 13:43:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:08:03', '1', 'admin', '2021-12-09 14:08:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3355, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:08:03', '1', 'admin', '2021-12-09 14:08:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3356, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:08:05', '1', 'admin', '2021-12-09 14:08:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3357, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:08:05', '1', 'admin', '2021-12-09 14:08:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:08:06', '1', 'admin', '2021-12-09 14:08:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3359, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:08:12', '1', 'admin', '2021-12-09 14:08:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3360, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:09:25', '1', 'admin', '2021-12-09 14:09:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3361, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:09:25', '1', 'admin', '2021-12-09 14:09:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:09:26', '1', 'admin', '2021-12-09 14:09:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:09:26', '1', 'admin', '2021-12-09 14:09:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3364, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:09:27', '1', 'admin', '2021-12-09 14:09:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3365, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:23:24', '1', 'admin', '2021-12-09 14:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3366, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:23:24', '1', 'admin', '2021-12-09 14:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3367, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:23:28', '1', 'admin', '2021-12-09 14:23:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3368, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:23:28', '1', 'admin', '2021-12-09 14:23:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3369, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:23:30', '1', 'admin', '2021-12-09 14:23:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3370, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:24:16', '1', 'admin', '2021-12-09 14:24:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:24:16', '1', 'admin', '2021-12-09 14:24:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3372, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:24:16', '1', 'admin', '2021-12-09 14:24:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3373, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:24:16', '1', 'admin', '2021-12-09 14:24:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:24:19', '1', 'admin', '2021-12-09 14:24:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:24:35', '1', 'admin', '2021-12-09 14:24:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3376, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:26:59', '1', 'admin', '2021-12-09 14:26:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:26:59', '1', 'admin', '2021-12-09 14:26:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3378, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:27:00', '1', 'admin', '2021-12-09 14:27:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3379, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:27:00', '1', 'admin', '2021-12-09 14:27:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3380, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:27:01', '1', 'admin', '2021-12-09 14:27:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:28:06', '1', 'admin', '2021-12-09 14:28:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3382, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:28:07', '1', 'admin', '2021-12-09 14:28:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:28:07', '1', 'admin', '2021-12-09 14:28:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3384, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:28:07', '1', 'admin', '2021-12-09 14:28:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:28:09', '1', 'admin', '2021-12-09 14:28:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3386, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:30:16', '1', 'admin', '2021-12-09 14:30:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3387, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:30:16', '1', 'admin', '2021-12-09 14:30:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3388, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:30:17', '1', 'admin', '2021-12-09 14:30:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3389, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:30:17', '1', 'admin', '2021-12-09 14:30:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3390, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:30:18', '1', 'admin', '2021-12-09 14:30:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3391, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:30:23', '1', 'admin', '2021-12-09 14:30:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3392, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:31:18', '1', 'admin', '2021-12-09 14:31:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3393, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:31:18', '1', 'admin', '2021-12-09 14:31:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3394, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:31:19', '1', 'admin', '2021-12-09 14:31:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3395, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:31:19', '1', 'admin', '2021-12-09 14:31:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3396, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:31:20', '1', 'admin', '2021-12-09 14:31:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3397, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:31:21', '1', 'admin', '2021-12-09 14:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3398, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:35:54', '1', 'admin', '2021-12-09 14:35:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3399, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:35:54', '1', 'admin', '2021-12-09 14:35:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3400, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:35:55', '1', 'admin', '2021-12-09 14:35:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3401, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:35:55', '1', 'admin', '2021-12-09 14:35:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3402, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:35:56', '1', 'admin', '2021-12-09 14:35:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3403, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:36:07', '1', 'admin', '2021-12-09 14:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3404, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:36:07', '1', 'admin', '2021-12-09 14:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3405, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:36:47', '1', 'admin', '2021-12-09 14:36:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3406, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:36:47', '1', 'admin', '2021-12-09 14:36:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3407, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:36:47', '1', 'admin', '2021-12-09 14:36:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3408, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:36:47', '1', 'admin', '2021-12-09 14:36:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3409, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:36:52', '1', 'admin', '2021-12-09 14:36:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3410, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:40:34', '1', 'admin', '2021-12-09 14:40:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3411, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:40:34', '1', 'admin', '2021-12-09 14:40:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3412, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:40:34', '1', 'admin', '2021-12-09 14:40:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3413, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:40:35', '1', 'admin', '2021-12-09 14:40:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3414, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:40:36', '1', 'admin', '2021-12-09 14:40:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3415, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-09 14:40:37', '1', 'admin', '2021-12-09 14:40:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3416, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:47:27', '1', 'admin', '2021-12-09 14:47:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3417, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:47:27', '1', 'admin', '2021-12-09 14:47:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3418, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:47:28', '1', 'admin', '2021-12-09 14:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3419, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:47:28', '1', 'admin', '2021-12-09 14:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3420, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:47:29', '1', 'admin', '2021-12-09 14:47:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3421, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:47:49', '1', 'admin', '2021-12-09 14:47:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3422, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:47:49', '1', 'admin', '2021-12-09 14:47:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3423, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:47:50', '1', 'admin', '2021-12-09 14:47:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3424, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-09 14:47:52', '1', 'admin', '2021-12-09 14:47:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3425, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:49:30', '1', 'admin', '2021-12-09 14:49:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3426, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:49:30', '1', 'admin', '2021-12-09 14:49:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3427, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:49:31', '1', 'admin', '2021-12-09 14:49:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3428, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:49:31', '1', 'admin', '2021-12-09 14:49:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3429, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:49:32', '1', 'admin', '2021-12-09 14:49:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3430, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:50:33', '1', 'admin', '2021-12-09 14:50:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3431, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/user/showdown', '2021-12-09 14:50:36', '1', 'admin', '2021-12-09 14:50:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3432, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:50:41', '1', 'admin', '2021-12-09 14:50:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3433, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:55:41', '1', 'admin', '2021-12-09 14:55:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3434, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:55:41', '1', 'admin', '2021-12-09 14:55:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3435, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:55:42', '1', 'admin', '2021-12-09 14:55:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3436, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:55:42', '1', 'admin', '2021-12-09 14:55:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3437, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:55:42', '1', 'admin', '2021-12-09 14:55:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3438, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:56:05', '1', 'admin', '2021-12-09 14:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3439, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:56:05', '1', 'admin', '2021-12-09 14:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3440, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:56:05', '1', 'admin', '2021-12-09 14:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3441, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:56:06', '1', 'admin', '2021-12-09 14:56:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3442, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:56:06', '1', 'admin', '2021-12-09 14:56:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3443, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 14:57:43', '1', 'admin', '2021-12-09 14:57:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3444, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 14:57:43', '1', 'admin', '2021-12-09 14:57:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3445, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 14:57:45', '1', 'admin', '2021-12-09 14:57:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3446, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 14:57:45', '1', 'admin', '2021-12-09 14:57:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3447, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:57:47', '1', 'admin', '2021-12-09 14:57:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3448, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:58:03', '1', 'admin', '2021-12-09 14:58:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3449, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:58:06', '1', 'admin', '2021-12-09 14:58:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3450, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 14:58:08', '1', 'admin', '2021-12-09 14:58:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3451, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:00:12', '1', 'admin', '2021-12-09 15:00:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3452, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:00:12', '1', 'admin', '2021-12-09 15:00:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3453, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:00:17', '1', 'admin', '2021-12-09 15:00:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3454, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:00:17', '1', 'admin', '2021-12-09 15:00:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3455, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:00:18', '1', 'admin', '2021-12-09 15:00:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3456, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:01:13', '1', 'admin', '2021-12-09 15:01:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3457, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:01:13', '1', 'admin', '2021-12-09 15:01:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3458, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:01:14', '1', 'admin', '2021-12-09 15:01:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3459, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:01:14', '1', 'admin', '2021-12-09 15:01:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3460, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:01:15', '1', 'admin', '2021-12-09 15:01:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3461, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:02:29', '1', 'admin', '2021-12-09 15:02:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3462, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:02:29', '1', 'admin', '2021-12-09 15:02:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3463, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:02:30', '1', 'admin', '2021-12-09 15:02:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3464, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:02:30', '1', 'admin', '2021-12-09 15:02:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3465, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:02:31', '1', 'admin', '2021-12-09 15:02:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3466, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:03:00', '1', 'admin', '2021-12-09 15:03:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3467, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:03:00', '1', 'admin', '2021-12-09 15:03:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3468, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:03:01', '1', 'admin', '2021-12-09 15:03:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3469, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:03:01', '1', 'admin', '2021-12-09 15:03:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3470, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:03:03', '1', 'admin', '2021-12-09 15:03:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3471, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:04:33', '1', 'admin', '2021-12-09 15:04:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3472, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:04:33', '1', 'admin', '2021-12-09 15:04:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3473, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:04:34', '1', 'admin', '2021-12-09 15:04:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3474, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:04:34', '1', 'admin', '2021-12-09 15:04:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3475, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:04:35', '1', 'admin', '2021-12-09 15:04:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3476, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:06:01', '1', 'admin', '2021-12-09 15:06:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3477, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:06:01', '1', 'admin', '2021-12-09 15:06:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3478, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:06:02', '1', 'admin', '2021-12-09 15:06:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3479, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:06:02', '1', 'admin', '2021-12-09 15:06:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3480, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:06:03', '1', 'admin', '2021-12-09 15:06:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3481, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:07:24', '1', 'admin', '2021-12-09 15:07:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3482, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:07:24', '1', 'admin', '2021-12-09 15:07:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3483, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:07:24', '1', 'admin', '2021-12-09 15:07:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3484, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:07:24', '1', 'admin', '2021-12-09 15:07:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3485, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:07:26', '1', 'admin', '2021-12-09 15:07:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3486, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:08:16', '1', 'admin', '2021-12-09 15:08:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3487, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:08:16', '1', 'admin', '2021-12-09 15:08:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3488, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:08:17', '1', 'admin', '2021-12-09 15:08:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3489, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:08:17', '1', 'admin', '2021-12-09 15:08:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3490, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:08:19', '1', 'admin', '2021-12-09 15:08:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3491, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:09:01', '1', 'admin', '2021-12-09 15:09:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3492, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:09:01', '1', 'admin', '2021-12-09 15:09:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3493, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:09:01', '1', 'admin', '2021-12-09 15:09:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3494, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:09:02', '1', 'admin', '2021-12-09 15:09:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3495, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:09:03', '1', 'admin', '2021-12-09 15:09:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3496, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:09:27', '1', 'admin', '2021-12-09 15:09:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3497, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:09:27', '1', 'admin', '2021-12-09 15:09:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3498, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:09:28', '1', 'admin', '2021-12-09 15:09:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3499, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:09:28', '1', 'admin', '2021-12-09 15:09:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3500, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:09:30', '1', 'admin', '2021-12-09 15:09:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3501, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:19:39', '1', 'admin', '2021-12-09 15:19:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3502, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:19:39', '1', 'admin', '2021-12-09 15:19:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3503, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:19:40', '1', 'admin', '2021-12-09 15:19:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3504, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:19:40', '1', 'admin', '2021-12-09 15:19:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3505, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:19:41', '1', 'admin', '2021-12-09 15:19:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3506, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:19:56', '1', 'admin', '2021-12-09 15:19:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3507, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:21:34', '1', 'admin', '2021-12-09 15:21:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3508, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:21:34', '1', 'admin', '2021-12-09 15:21:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3509, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:21:35', '1', 'admin', '2021-12-09 15:21:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3510, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:21:35', '1', 'admin', '2021-12-09 15:21:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3511, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:21:36', '1', 'admin', '2021-12-09 15:21:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3512, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:21:37', '1', 'admin', '2021-12-09 15:21:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3513, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:21:45', '1', 'admin', '2021-12-09 15:21:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3514, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:21:49', '1', 'admin', '2021-12-09 15:21:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3515, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:22:55', '1', 'admin', '2021-12-09 15:22:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3516, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:22:55', '1', 'admin', '2021-12-09 15:22:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3517, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:22:56', '1', 'admin', '2021-12-09 15:22:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3518, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:22:56', '1', 'admin', '2021-12-09 15:22:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3519, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:22:57', '1', 'admin', '2021-12-09 15:22:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3520, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:24:01', '1', 'admin', '2021-12-09 15:24:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3521, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:24:01', '1', 'admin', '2021-12-09 15:24:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3522, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:24:02', '1', 'admin', '2021-12-09 15:24:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3523, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:24:02', '1', 'admin', '2021-12-09 15:24:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3524, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:24:03', '1', 'admin', '2021-12-09 15:24:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3525, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:24:43', '1', 'admin', '2021-12-09 15:24:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3526, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:24:43', '1', 'admin', '2021-12-09 15:24:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3527, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:24:44', '1', 'admin', '2021-12-09 15:24:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3528, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:24:44', '1', 'admin', '2021-12-09 15:24:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3529, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:24:45', '1', 'admin', '2021-12-09 15:24:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3530, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:27:08', '1', 'admin', '2021-12-09 15:27:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3531, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:27:08', '1', 'admin', '2021-12-09 15:27:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3532, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:27:09', '1', 'admin', '2021-12-09 15:27:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3533, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:27:09', '1', 'admin', '2021-12-09 15:27:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3534, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:27:10', '1', 'admin', '2021-12-09 15:27:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3535, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:28:11', '1', 'admin', '2021-12-09 15:28:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3536, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:28:11', '1', 'admin', '2021-12-09 15:28:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3537, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:28:11', '1', 'admin', '2021-12-09 15:28:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3538, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:28:11', '1', 'admin', '2021-12-09 15:28:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3539, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:28:13', '1', 'admin', '2021-12-09 15:28:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3540, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:29:15', '1', 'admin', '2021-12-09 15:29:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3541, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:29:15', '1', 'admin', '2021-12-09 15:29:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3542, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:29:16', '1', 'admin', '2021-12-09 15:29:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3543, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:29:16', '1', 'admin', '2021-12-09 15:29:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3544, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:29:17', '1', 'admin', '2021-12-09 15:29:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3545, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:32:00', '1', 'admin', '2021-12-09 15:32:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3546, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=45', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:32:03', '1', 'admin', '2021-12-09 15:32:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3547, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:32:10', '1', 'admin', '2021-12-09 15:32:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3548, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:33:37', '1', 'admin', '2021-12-09 15:33:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3549, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:34:53', '1', 'admin', '2021-12-09 15:34:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3550, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:34:53', '1', 'admin', '2021-12-09 15:34:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3551, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:34:57', '1', 'admin', '2021-12-09 15:34:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3552, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:34:57', '1', 'admin', '2021-12-09 15:34:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3553, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:34:59', '1', 'admin', '2021-12-09 15:34:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3554, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:35:01', '1', 'admin', '2021-12-09 15:35:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3555, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:35:05', '1', 'admin', '2021-12-09 15:35:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3556, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=46', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:35:07', '1', 'admin', '2021-12-09 15:35:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3557, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:36:03', '1', 'admin', '2021-12-09 15:36:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3558, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:36:03', '1', 'admin', '2021-12-09 15:36:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3559, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:36:04', '1', 'admin', '2021-12-09 15:36:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3560, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:36:04', '1', 'admin', '2021-12-09 15:36:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3561, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:36:05', '1', 'admin', '2021-12-09 15:36:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3562, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:36:07', '1', 'admin', '2021-12-09 15:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3563, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:36:11', '1', 'admin', '2021-12-09 15:36:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3564, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=46', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:36:12', '1', 'admin', '2021-12-09 15:36:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3565, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:36:15', '1', 'admin', '2021-12-09 15:36:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3566, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=45', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:36:17', '1', 'admin', '2021-12-09 15:36:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3567, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-09 15:38:18', '1', 'admin', '2021-12-09 15:38:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3568, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-09 15:38:18', '1', 'admin', '2021-12-09 15:38:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3569, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-09 15:38:20', '1', 'admin', '2021-12-09 15:38:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3570, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-09 15:38:21', '1', 'admin', '2021-12-09 15:38:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3571, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:38:21', '1', 'admin', '2021-12-09 15:38:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3572, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-09 15:38:33', '1', 'admin', '2021-12-09 15:38:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3573, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-09 15:38:33', '1', 'admin', '2021-12-09 15:38:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3574, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-09 15:38:35', '1', 'admin', '2021-12-09 15:38:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3575, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-09 15:38:43', '1', 'admin', '2021-12-09 15:38:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3576, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 11:13:44', '1', 'admin', '2021-12-10 11:13:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3577, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 11:13:44', '1', 'admin', '2021-12-10 11:13:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3578, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 11:13:47', '1', 'admin', '2021-12-10 11:13:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3579, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:13:47', '1', 'admin', '2021-12-10 11:13:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3580, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-10 11:13:51', '1', 'admin', '2021-12-10 11:13:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3581, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-10 11:13:52', '1', 'admin', '2021-12-10 11:13:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3582, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:13:52', '1', 'admin', '2021-12-10 11:13:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3583, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 11:13:54', '1', 'admin', '2021-12-10 11:13:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3584, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-10 11:14:00', '1', 'admin', '2021-12-10 11:14:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3585, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-10 11:15:15', '1', 'admin', '2021-12-10 11:15:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3586, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-10 11:15:15', '1', 'admin', '2021-12-10 11:15:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3587, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-10 11:15:17', '1', 'admin', '2021-12-10 11:15:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3588, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-10 11:15:17', '1', 'admin', '2021-12-10 11:15:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3589, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/download', '2021-12-10 11:15:19', '1', 'admin', '2021-12-10 11:15:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3590, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.100', '/system/user/tablesData', '2021-12-10 11:15:19', '1', 'admin', '2021-12-10 11:15:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3591, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.100', '/system/user/showdown', '2021-12-10 11:15:20', '1', 'admin', '2021-12-10 11:15:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3592, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/showdown?id=47', '192.168.1.100', '/system/user/downfile', '2021-12-10 11:15:22', '1', 'admin', '2021-12-10 11:15:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3593, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/upload', '2021-12-10 11:15:43', '1', 'admin', '2021-12-10 11:15:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3594, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.100', '/system/user/showdown', '2021-12-10 11:15:54', '1', 'admin', '2021-12-10 11:15:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3595, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 11:17:10', '1', 'admin', '2021-12-10 11:17:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3596, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 11:17:10', '1', 'admin', '2021-12-10 11:17:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3597, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-10 11:17:11', '1', 'admin', '2021-12-10 11:17:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3598, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-10 11:17:14', '1', 'admin', '2021-12-10 11:17:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3599, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-10 11:18:17', '1', 'admin', '2021-12-10 11:18:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3600, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:18:17', '1', 'admin', '2021-12-10 11:18:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3601, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:18:25', '1', 'admin', '2021-12-10 11:18:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3602, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:18:28', '1', 'admin', '2021-12-10 11:18:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3603, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 11:18:29', '1', 'admin', '2021-12-10 11:18:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3604, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:18:29', '1', 'admin', '2021-12-10 11:18:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3605, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:18:31', '1', 'admin', '2021-12-10 11:18:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3606, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:18:33', '1', 'admin', '2021-12-10 11:18:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3607, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 11:22:48', '1', 'admin', '2021-12-10 11:22:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3608, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 11:22:48', '1', 'admin', '2021-12-10 11:22:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3609, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 11:22:48', '1', 'admin', '2021-12-10 11:22:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3610, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 11:22:48', '1', 'admin', '2021-12-10 11:22:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3611, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:07:46', '1', 'admin', '2021-12-10 13:07:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3612, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:07:46', '1', 'admin', '2021-12-10 13:07:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3613, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:07:46', '1', 'admin', '2021-12-10 13:07:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3614, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:07:46', '1', 'admin', '2021-12-10 13:07:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3615, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:07:50', '1', 'admin', '2021-12-10 13:07:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3616, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:07:53', '1', 'admin', '2021-12-10 13:07:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3617, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:08:02', '1', 'admin', '2021-12-10 13:08:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3618, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:08:10', '1', 'admin', '2021-12-10 13:08:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3619, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:08:14', '1', 'admin', '2021-12-10 13:08:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3620, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:11:14', '1', 'admin', '2021-12-10 13:11:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3621, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:11:14', '1', 'admin', '2021-12-10 13:11:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3622, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:11:15', '1', 'admin', '2021-12-10 13:11:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3623, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:11:15', '1', 'admin', '2021-12-10 13:11:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3624, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:11:22', '1', 'admin', '2021-12-10 13:11:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3625, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:11:24', '1', 'admin', '2021-12-10 13:11:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3626, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:11:28', '1', 'admin', '2021-12-10 13:11:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3627, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:12:15', '1', 'admin', '2021-12-10 13:12:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3628, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:12:15', '1', 'admin', '2021-12-10 13:12:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3629, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:12:16', '1', 'admin', '2021-12-10 13:12:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3630, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:16', '1', 'admin', '2021-12-10 13:12:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3631, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:17', '1', 'admin', '2021-12-10 13:12:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3632, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:19', '1', 'admin', '2021-12-10 13:12:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:21', '1', 'admin', '2021-12-10 13:12:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:22', '1', 'admin', '2021-12-10 13:12:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:23', '1', 'admin', '2021-12-10 13:12:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3636, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:24', '1', 'admin', '2021-12-10 13:12:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3637, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:25', '1', 'admin', '2021-12-10 13:12:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3638, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:26', '1', 'admin', '2021-12-10 13:12:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3639, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:29', '1', 'admin', '2021-12-10 13:12:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3640, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:12:29', '1', 'admin', '2021-12-10 13:12:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3641, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2021-12-10 13:12:49', '1', 'admin', '2021-12-10 13:12:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3642, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-10 13:12:49', '1', 'admin', '2021-12-10 13:12:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-10 13:12:53', '1', 'admin', '2021-12-10 13:12:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-10 13:12:55', '1', 'admin', '2021-12-10 13:12:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-10 13:12:57', '1', 'admin', '2021-12-10 13:12:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3646, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2021-12-10 13:13:03', '1', 'admin', '2021-12-10 13:13:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3647, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:16:35', '1', 'admin', '2021-12-10 13:16:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3648, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:16:35', '1', 'admin', '2021-12-10 13:16:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:16:36', '1', 'admin', '2021-12-10 13:16:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3650, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:36', '1', 'admin', '2021-12-10 13:16:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3651, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:37', '1', 'admin', '2021-12-10 13:16:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3652, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:38', '1', 'admin', '2021-12-10 13:16:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:39', '1', 'admin', '2021-12-10 13:16:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:40', '1', 'admin', '2021-12-10 13:16:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3655, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:42', '1', 'admin', '2021-12-10 13:16:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3656, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:43', '1', 'admin', '2021-12-10 13:16:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3657, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:44', '1', 'admin', '2021-12-10 13:16:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:16:45', '1', 'admin', '2021-12-10 13:16:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:19:22', '1', 'admin', '2021-12-10 13:19:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3660, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:19:22', '1', 'admin', '2021-12-10 13:19:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3661, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:19:23', '1', 'admin', '2021-12-10 13:19:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3662, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:19:23', '1', 'admin', '2021-12-10 13:19:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:19:25', '1', 'admin', '2021-12-10 13:19:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3664, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:19:25', '1', 'admin', '2021-12-10 13:19:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3665, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:19:26', '1', 'admin', '2021-12-10 13:19:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3666, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:19:27', '1', 'admin', '2021-12-10 13:19:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3667, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:19:52', '1', 'admin', '2021-12-10 13:19:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3668, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:19:52', '1', 'admin', '2021-12-10 13:19:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3669, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:19:52', '1', 'admin', '2021-12-10 13:19:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3670, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:19:52', '1', 'admin', '2021-12-10 13:19:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3671, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:20:49', '1', 'admin', '2021-12-10 13:20:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3672, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:20:49', '1', 'admin', '2021-12-10 13:20:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3673, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:20:50', '1', 'admin', '2021-12-10 13:20:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3674, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:20:50', '1', 'admin', '2021-12-10 13:20:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3675, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:21:30', '1', 'admin', '2021-12-10 13:21:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3676, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:21:30', '1', 'admin', '2021-12-10 13:21:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3677, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:21:31', '1', 'admin', '2021-12-10 13:21:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3678, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:21:31', '1', 'admin', '2021-12-10 13:21:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3679, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:21:34', '1', 'admin', '2021-12-10 13:21:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3680, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:21:36', '1', 'admin', '2021-12-10 13:21:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3681, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:21:40', '1', 'admin', '2021-12-10 13:21:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3682, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:21:41', '1', 'admin', '2021-12-10 13:21:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3683, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:21:42', '1', 'admin', '2021-12-10 13:21:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3684, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:23:10', '1', 'admin', '2021-12-10 13:23:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3685, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:23:10', '1', 'admin', '2021-12-10 13:23:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3686, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 13:23:10', '1', 'admin', '2021-12-10 13:23:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3687, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:23:10', '1', 'admin', '2021-12-10 13:23:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3688, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:23:12', '1', 'admin', '2021-12-10 13:23:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3689, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-10 13:23:14', '1', 'admin', '2021-12-10 13:23:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3690, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:23:14', '1', 'admin', '2021-12-10 13:23:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3691, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:23:15', '1', 'admin', '2021-12-10 13:23:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3692, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:23:17', '1', 'admin', '2021-12-10 13:23:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3693, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:23:24', '1', 'admin', '2021-12-10 13:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3694, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:23:26', '1', 'admin', '2021-12-10 13:23:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3695, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:33:03', '1', 'admin', '2021-12-10 13:33:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3696, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:33:04', '1', 'admin', '2021-12-10 13:33:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3697, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:33:08', '1', 'admin', '2021-12-10 13:33:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3698, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:33:35', '1', 'admin', '2021-12-10 13:33:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3699, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:33:36', '1', 'admin', '2021-12-10 13:33:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3700, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:34:27', '1', 'admin', '2021-12-10 13:34:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3701, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:34:31', '1', 'admin', '2021-12-10 13:34:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3702, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:34:33', '1', 'admin', '2021-12-10 13:34:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3703, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:34:35', '1', 'admin', '2021-12-10 13:34:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:34:37', '1', 'admin', '2021-12-10 13:34:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3705, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:35:36', '1', 'admin', '2021-12-10 13:35:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3706, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:35:39', '1', 'admin', '2021-12-10 13:35:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:35:42', '1', 'admin', '2021-12-10 13:35:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:35:45', '1', 'admin', '2021-12-10 13:35:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3709, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:35:51', '1', 'admin', '2021-12-10 13:35:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3710, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:36:03', '1', 'admin', '2021-12-10 13:36:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3711, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:36:06', '1', 'admin', '2021-12-10 13:36:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3712, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:36:09', '1', 'admin', '2021-12-10 13:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3713, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:37:57', '1', 'admin', '2021-12-10 13:37:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3714, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:37:59', '1', 'admin', '2021-12-10 13:37:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3715, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:38:04', '1', 'admin', '2021-12-10 13:38:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3716, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:38:10', '1', 'admin', '2021-12-10 13:38:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3717, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:38:15', '1', 'admin', '2021-12-10 13:38:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3718, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:38:18', '1', 'admin', '2021-12-10 13:38:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3719, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:38:28', '1', 'admin', '2021-12-10 13:38:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3720, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-10 13:38:31', '1', 'admin', '2021-12-10 13:38:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3721, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:38:37', '1', 'admin', '2021-12-10 13:38:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3722, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-10 13:40:24', '1', 'admin', '2021-12-10 13:40:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3723, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-10 13:40:24', '1', 'admin', '2021-12-10 13:40:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3724, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-10 13:40:24', '1', 'admin', '2021-12-10 13:40:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3725, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 13:40:24', '1', 'admin', '2021-12-10 13:40:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3726, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 13:40:26', '1', 'admin', '2021-12-10 13:40:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3727, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=46', '127.0.0.1', '/system/user/downfile', '2021-12-10 13:40:39', '1', 'admin', '2021-12-10 13:40:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3728, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:09:03', '1', 'admin', '2021-12-10 17:09:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3729, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:09:04', '1', 'admin', '2021-12-10 17:09:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3730, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:09:07', '1', 'admin', '2021-12-10 17:09:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:09:08', '1', 'admin', '2021-12-10 17:09:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3732, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:09:13', '1', 'admin', '2021-12-10 17:09:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:12:32', '1', 'admin', '2021-12-10 17:12:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3734, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:12:33', '1', 'admin', '2021-12-10 17:12:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3735, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:12:53', '1', 'admin', '2021-12-10 17:12:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3736, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:13:04', '1', 'admin', '2021-12-10 17:13:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:13:13', '1', 'admin', '2021-12-10 17:13:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:13:18', '1', 'admin', '2021-12-10 17:13:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3739, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-10 17:13:22', '1', 'admin', '2021-12-10 17:13:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3740, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:13:22', '1', 'admin', '2021-12-10 17:13:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (3741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-10 17:13:24', '1', 'admin', '2021-12-10 17:13:24', '记录日志');
INSERT INTO `sys_log` VALUES (3742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:14:36', '1', 'admin', '2021-12-10 17:14:36', '记录日志');
INSERT INTO `sys_log` VALUES (3743, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:14:38', '1', 'admin', '2021-12-10 17:14:38', '记录日志');
INSERT INTO `sys_log` VALUES (3744, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:14:42', '1', 'admin', '2021-12-10 17:14:42', '记录日志');
INSERT INTO `sys_log` VALUES (3745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:15:01', '1', 'admin', '2021-12-10 17:15:01', '记录日志');
INSERT INTO `sys_log` VALUES (3746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:15:03', '1', 'admin', '2021-12-10 17:15:03', '记录日志');
INSERT INTO `sys_log` VALUES (3747, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:15:28', '1', 'admin', '2021-12-10 17:15:28', '记录日志');
INSERT INTO `sys_log` VALUES (3748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:15:31', '1', 'admin', '2021-12-10 17:15:31', '记录日志');
INSERT INTO `sys_log` VALUES (3749, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:15:37', '1', 'admin', '2021-12-10 17:15:37', '记录日志');
INSERT INTO `sys_log` VALUES (3750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:15:44', '1', 'admin', '2021-12-10 17:15:44', '记录日志');
INSERT INTO `sys_log` VALUES (3751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-10 17:15:45', '1', 'admin', '2021-12-10 17:15:45', '记录日志');
INSERT INTO `sys_log` VALUES (3752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:17:03', '1', 'admin', '2021-12-10 17:17:03', '记录日志');
INSERT INTO `sys_log` VALUES (3753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:17:06', '1', 'admin', '2021-12-10 17:17:06', '记录日志');
INSERT INTO `sys_log` VALUES (3754, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:17:32', '1', 'admin', '2021-12-10 17:17:32', '记录日志');
INSERT INTO `sys_log` VALUES (3755, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-10 17:19:52', '1', 'admin', '2021-12-10 17:19:52', '记录日志');
INSERT INTO `sys_log` VALUES (3756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-10 17:20:17', '1', 'admin', '2021-12-10 17:20:17', '记录日志');
INSERT INTO `sys_log` VALUES (3757, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-10 17:21:42', '1', 'admin', '2021-12-10 17:21:42', '记录日志');
INSERT INTO `sys_log` VALUES (3758, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-10 17:21:42', '1', 'admin', '2021-12-10 17:21:42', '记录日志');
INSERT INTO `sys_log` VALUES (3759, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/download', '2021-12-10 17:21:46', '1', 'admin', '2021-12-10 17:21:46', '记录日志');
INSERT INTO `sys_log` VALUES (3760, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.100', '/system/user/tablesData', '2021-12-10 17:21:46', '1', 'admin', '2021-12-10 17:21:46', '记录日志');
INSERT INTO `sys_log` VALUES (3761, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.100', '/system/user/showdown', '2021-12-10 17:21:48', '1', 'admin', '2021-12-10 17:21:48', '记录日志');
INSERT INTO `sys_log` VALUES (3762, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/download', '192.168.1.100', '/system/user/showdown', '2021-12-10 17:21:55', '1', 'admin', '2021-12-10 17:21:55', '记录日志');
INSERT INTO `sys_log` VALUES (3763, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/showdown?id=47', '192.168.1.100', '/system/user/downfile', '2021-12-10 17:21:56', '1', 'admin', '2021-12-10 17:21:56', '记录日志');
INSERT INTO `sys_log` VALUES (3764, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-12 12:18:42', '1', 'admin', '2021-12-12 12:18:42', '记录日志');
INSERT INTO `sys_log` VALUES (3765, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-12 12:18:42', '1', 'admin', '2021-12-12 12:18:42', '记录日志');
INSERT INTO `sys_log` VALUES (3766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-12 12:18:44', '1', 'admin', '2021-12-12 12:18:44', '记录日志');
INSERT INTO `sys_log` VALUES (3767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:18:44', '1', 'admin', '2021-12-12 12:18:44', '记录日志');
INSERT INTO `sys_log` VALUES (3768, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:18:50', '1', 'admin', '2021-12-12 12:18:50', '记录日志');
INSERT INTO `sys_log` VALUES (3769, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-12 12:18:52', '1', 'admin', '2021-12-12 12:18:52', '记录日志');
INSERT INTO `sys_log` VALUES (3770, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-12 12:18:53', '1', 'admin', '2021-12-12 12:18:53', '记录日志');
INSERT INTO `sys_log` VALUES (3771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:18:54', '1', 'admin', '2021-12-12 12:18:54', '记录日志');
INSERT INTO `sys_log` VALUES (3772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-12 12:18:55', '1', 'admin', '2021-12-12 12:18:55', '记录日志');
INSERT INTO `sys_log` VALUES (3773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:19:00', '1', 'admin', '2021-12-12 12:19:00', '记录日志');
INSERT INTO `sys_log` VALUES (3774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:19:02', '1', 'admin', '2021-12-12 12:19:02', '记录日志');
INSERT INTO `sys_log` VALUES (3775, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-12 12:23:53', '1', 'admin', '2021-12-12 12:23:53', '记录日志');
INSERT INTO `sys_log` VALUES (3776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-12 12:23:53', '1', 'admin', '2021-12-12 12:23:53', '记录日志');
INSERT INTO `sys_log` VALUES (3777, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-12 12:23:58', '1', 'admin', '2021-12-12 12:23:58', '记录日志');
INSERT INTO `sys_log` VALUES (3778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:23:58', '1', 'admin', '2021-12-12 12:23:58', '记录日志');
INSERT INTO `sys_log` VALUES (3779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-12 12:23:59', '1', 'admin', '2021-12-12 12:23:59', '记录日志');
INSERT INTO `sys_log` VALUES (3780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:23:59', '1', 'admin', '2021-12-12 12:23:59', '记录日志');
INSERT INTO `sys_log` VALUES (3781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:24:03', '1', 'admin', '2021-12-12 12:24:03', '记录日志');
INSERT INTO `sys_log` VALUES (3782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-12 12:24:05', '1', 'admin', '2021-12-12 12:24:05', '记录日志');
INSERT INTO `sys_log` VALUES (3783, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-12 12:24:10', '1', 'admin', '2021-12-12 12:24:10', '记录日志');
INSERT INTO `sys_log` VALUES (3784, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:24:21', '1', 'admin', '2021-12-12 12:24:21', '记录日志');
INSERT INTO `sys_log` VALUES (3785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-12 12:24:24', '1', 'admin', '2021-12-12 12:24:24', '记录日志');
INSERT INTO `sys_log` VALUES (3786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2021-12-12 12:25:00', '1', 'admin', '2021-12-12 12:25:00', '记录日志');
INSERT INTO `sys_log` VALUES (3787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-12 15:48:18', '1', 'admin', '2021-12-12 15:48:18', '记录日志');
INSERT INTO `sys_log` VALUES (3788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-12 15:48:18', '1', 'admin', '2021-12-12 15:48:18', '记录日志');
INSERT INTO `sys_log` VALUES (3789, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-12 15:48:29', '1', 'admin', '2021-12-12 15:48:29', '记录日志');
INSERT INTO `sys_log` VALUES (3790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-12 15:48:29', '1', 'admin', '2021-12-12 15:48:29', '记录日志');
INSERT INTO `sys_log` VALUES (3791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-12 15:48:43', '1', 'admin', '2021-12-12 15:48:43', '记录日志');
INSERT INTO `sys_log` VALUES (3792, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-12 15:49:10', '1', 'admin', '2021-12-12 15:49:10', '记录日志');
INSERT INTO `sys_log` VALUES (3793, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-12 15:51:50', '1', 'admin', '2021-12-12 15:51:50', '记录日志');
INSERT INTO `sys_log` VALUES (3794, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-12 15:51:55', '1', 'admin', '2021-12-12 15:51:55', '记录日志');
INSERT INTO `sys_log` VALUES (3795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-12 15:51:55', '1', 'admin', '2021-12-12 15:51:55', '记录日志');
INSERT INTO `sys_log` VALUES (3796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-12 15:51:56', '1', 'admin', '2021-12-12 15:51:56', '记录日志');
INSERT INTO `sys_log` VALUES (3797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-12 15:51:56', '1', 'admin', '2021-12-12 15:51:56', '记录日志');
INSERT INTO `sys_log` VALUES (3798, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuTop', '2021-12-12 15:52:37', '1', 'admin', '2021-12-12 15:52:37', '记录日志');
INSERT INTO `sys_log` VALUES (3799, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/res/menuLeft', '2021-12-12 15:52:37', '1', 'admin', '2021-12-12 15:52:37', '记录日志');
INSERT INTO `sys_log` VALUES (3800, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/check', '2021-12-12 15:52:40', '1', 'admin', '2021-12-12 15:52:40', '记录日志');
INSERT INTO `sys_log` VALUES (3801, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/system/user/check', '192.168.1.100', '/system/user/tablesData', '2021-12-12 15:52:40', '1', 'admin', '2021-12-12 15:52:40', '记录日志');
INSERT INTO `sys_log` VALUES (3802, 3, 'Firefox 7', 'GET', 'http://192.168.1.10:8080/', '192.168.1.100', '/system/user/upload', '2021-12-12 15:52:41', '1', 'admin', '2021-12-12 15:52:41', '记录日志');
INSERT INTO `sys_log` VALUES (3803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-12 15:53:50', '1', 'admin', '2021-12-12 15:53:50', '记录日志');
INSERT INTO `sys_log` VALUES (3804, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-12 15:53:50', '1', 'admin', '2021-12-12 15:53:50', '记录日志');
INSERT INTO `sys_log` VALUES (3805, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-12 15:53:54', '1', 'admin', '2021-12-12 15:53:54', '记录日志');
INSERT INTO `sys_log` VALUES (3806, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-12 15:53:59', '1', 'admin', '2021-12-12 15:53:59', '记录日志');
INSERT INTO `sys_log` VALUES (3807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-12 15:54:03', '1', 'admin', '2021-12-12 15:54:03', '记录日志');
INSERT INTO `sys_log` VALUES (3808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-12 15:54:58', '1', 'admin', '2021-12-12 15:54:58', '记录日志');
INSERT INTO `sys_log` VALUES (3809, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-12 15:55:00', '1', 'admin', '2021-12-12 15:55:00', '记录日志');
INSERT INTO `sys_log` VALUES (3810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=47', '127.0.0.1', '/system/user/downfile', '2021-12-12 15:55:03', '1', 'admin', '2021-12-12 15:55:03', '记录日志');
INSERT INTO `sys_log` VALUES (3811, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-12 16:05:44', '1', 'admin', '2021-12-12 16:05:44', '记录日志');
INSERT INTO `sys_log` VALUES (3812, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:27:23', '1', 'admin', '2021-12-21 16:27:23', '记录日志');
INSERT INTO `sys_log` VALUES (3813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:27:24', '1', 'admin', '2021-12-21 16:27:24', '记录日志');
INSERT INTO `sys_log` VALUES (3814, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-21 16:27:26', '1', 'admin', '2021-12-21 16:27:26', '记录日志');
INSERT INTO `sys_log` VALUES (3815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-21 16:27:27', '1', 'admin', '2021-12-21 16:27:27', '记录日志');
INSERT INTO `sys_log` VALUES (3816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:27:27', '1', 'admin', '2021-12-21 16:27:27', '记录日志');
INSERT INTO `sys_log` VALUES (3817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-21 16:27:33', '1', 'admin', '2021-12-21 16:27:33', '记录日志');
INSERT INTO `sys_log` VALUES (3818, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-21 16:27:43', '1', 'admin', '2021-12-21 16:27:43', '记录日志');
INSERT INTO `sys_log` VALUES (3819, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-21 16:27:48', '1', 'admin', '2021-12-21 16:27:48', '记录日志');
INSERT INTO `sys_log` VALUES (3820, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-21 16:27:50', '1', 'admin', '2021-12-21 16:27:50', '记录日志');
INSERT INTO `sys_log` VALUES (3821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:27:50', '1', 'admin', '2021-12-21 16:27:50', '记录日志');
INSERT INTO `sys_log` VALUES (3822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:27:53', '1', 'admin', '2021-12-21 16:27:53', '记录日志');
INSERT INTO `sys_log` VALUES (3823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:27:53', '1', 'admin', '2021-12-21 16:27:53', '记录日志');
INSERT INTO `sys_log` VALUES (3824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-21 16:27:54', '1', 'admin', '2021-12-21 16:27:54', '记录日志');
INSERT INTO `sys_log` VALUES (3825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:27:55', '1', 'admin', '2021-12-21 16:27:55', '记录日志');
INSERT INTO `sys_log` VALUES (3826, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:34:05', '1', 'admin', '2021-12-21 16:34:05', '记录日志');
INSERT INTO `sys_log` VALUES (3827, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:34:05', '1', 'admin', '2021-12-21 16:34:05', '记录日志');
INSERT INTO `sys_log` VALUES (3828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-21 16:34:06', '1', 'admin', '2021-12-21 16:34:06', '记录日志');
INSERT INTO `sys_log` VALUES (3829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:34:06', '1', 'admin', '2021-12-21 16:34:06', '记录日志');
INSERT INTO `sys_log` VALUES (3830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-21 16:34:08', '1', 'admin', '2021-12-21 16:34:08', '记录日志');
INSERT INTO `sys_log` VALUES (3831, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-21 16:34:11', '1', 'admin', '2021-12-21 16:34:11', '记录日志');
INSERT INTO `sys_log` VALUES (3832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:36:27', '1', 'admin', '2021-12-21 16:36:27', '记录日志');
INSERT INTO `sys_log` VALUES (3833, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:36:27', '1', 'admin', '2021-12-21 16:36:27', '记录日志');
INSERT INTO `sys_log` VALUES (3834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-21 16:36:28', '1', 'admin', '2021-12-21 16:36:28', '记录日志');
INSERT INTO `sys_log` VALUES (3835, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-21 16:36:30', '1', 'admin', '2021-12-21 16:36:30', '记录日志');
INSERT INTO `sys_log` VALUES (3836, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-21 16:36:34', '1', 'admin', '2021-12-21 16:36:34', '记录日志');
INSERT INTO `sys_log` VALUES (3837, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:37:41', '1', 'admin', '2021-12-21 16:37:41', '记录日志');
INSERT INTO `sys_log` VALUES (3838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:37:41', '1', 'admin', '2021-12-21 16:37:41', '记录日志');
INSERT INTO `sys_log` VALUES (3839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-21 16:37:43', '1', 'admin', '2021-12-21 16:37:43', '记录日志');
INSERT INTO `sys_log` VALUES (3840, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-21 16:37:45', '1', 'admin', '2021-12-21 16:37:45', '记录日志');
INSERT INTO `sys_log` VALUES (3841, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-21 16:37:49', '1', 'admin', '2021-12-21 16:37:49', '记录日志');
INSERT INTO `sys_log` VALUES (3842, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-21 16:37:53', '1', 'admin', '2021-12-21 16:37:53', '记录日志');
INSERT INTO `sys_log` VALUES (3843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:37:53', '1', 'admin', '2021-12-21 16:37:53', '记录日志');
INSERT INTO `sys_log` VALUES (3844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:37:56', '1', 'admin', '2021-12-21 16:37:56', '记录日志');
INSERT INTO `sys_log` VALUES (3845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:37:56', '1', 'admin', '2021-12-21 16:37:56', '记录日志');
INSERT INTO `sys_log` VALUES (3846, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-21 16:37:57', '1', 'admin', '2021-12-21 16:37:57', '记录日志');
INSERT INTO `sys_log` VALUES (3847, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:37:57', '1', 'admin', '2021-12-21 16:37:57', '记录日志');
INSERT INTO `sys_log` VALUES (3848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:39:57', '1', 'admin', '2021-12-21 16:39:57', '记录日志');
INSERT INTO `sys_log` VALUES (3849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:39:57', '1', 'admin', '2021-12-21 16:39:57', '记录日志');
INSERT INTO `sys_log` VALUES (3850, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-21 16:39:58', '1', 'admin', '2021-12-21 16:39:58', '记录日志');
INSERT INTO `sys_log` VALUES (3851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:39:58', '1', 'admin', '2021-12-21 16:39:58', '记录日志');
INSERT INTO `sys_log` VALUES (3852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-21 16:40:00', '1', 'admin', '2021-12-21 16:40:00', '记录日志');
INSERT INTO `sys_log` VALUES (3853, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-21 16:40:04', '1', 'admin', '2021-12-21 16:40:04', '记录日志');
INSERT INTO `sys_log` VALUES (3854, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-21 16:40:15', '1', 'admin', '2021-12-21 16:40:15', '记录日志');
INSERT INTO `sys_log` VALUES (3855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-21 16:40:19', '1', 'admin', '2021-12-21 16:40:19', '记录日志');
INSERT INTO `sys_log` VALUES (3856, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:40:19', '1', 'admin', '2021-12-21 16:40:19', '记录日志');
INSERT INTO `sys_log` VALUES (3857, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-21 16:40:23', '1', 'admin', '2021-12-21 16:40:23', '记录日志');
INSERT INTO `sys_log` VALUES (3858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-21 16:40:23', '1', 'admin', '2021-12-21 16:40:23', '记录日志');
INSERT INTO `sys_log` VALUES (3859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-21 16:40:24', '1', 'admin', '2021-12-21 16:40:24', '记录日志');
INSERT INTO `sys_log` VALUES (3860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-21 16:40:24', '1', 'admin', '2021-12-21 16:40:24', '记录日志');
INSERT INTO `sys_log` VALUES (3861, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-21 16:40:31', '1', 'admin', '2021-12-21 16:40:31', '记录日志');
INSERT INTO `sys_log` VALUES (3862, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=52', '127.0.0.1', '/system/user/downfile', '2021-12-21 16:40:33', '1', 'admin', '2021-12-21 16:40:33', '记录日志');
INSERT INTO `sys_log` VALUES (3863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2021-12-22 20:07:38', '1', 'admin', '2021-12-22 20:07:38', '记录日志');
INSERT INTO `sys_log` VALUES (3864, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2021-12-22 20:07:38', '1', 'admin', '2021-12-22 20:07:38', '记录日志');
INSERT INTO `sys_log` VALUES (3865, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-22 20:07:44', '1', 'admin', '2021-12-22 20:07:44', '记录日志');
INSERT INTO `sys_log` VALUES (3866, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-22 20:07:45', '1', 'admin', '2021-12-22 20:07:45', '记录日志');
INSERT INTO `sys_log` VALUES (3867, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2021-12-22 20:08:01', '1', 'admin', '2021-12-22 20:08:01', '记录日志');
INSERT INTO `sys_log` VALUES (3868, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2021-12-22 20:08:23', '1', 'admin', '2021-12-22 20:08:23', '记录日志');
INSERT INTO `sys_log` VALUES (3869, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2021-12-22 20:08:30', '1', 'admin', '2021-12-22 20:08:30', '记录日志');
INSERT INTO `sys_log` VALUES (3870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2021-12-22 20:08:33', '1', 'admin', '2021-12-22 20:08:33', '记录日志');
INSERT INTO `sys_log` VALUES (3871, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2021-12-22 20:08:34', '1', 'admin', '2021-12-22 20:08:34', '记录日志');
INSERT INTO `sys_log` VALUES (3872, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2021-12-22 20:08:41', '1', 'admin', '2021-12-22 20:08:41', '记录日志');
INSERT INTO `sys_log` VALUES (3873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2021-12-22 20:08:41', '1', 'admin', '2021-12-22 20:08:41', '记录日志');
INSERT INTO `sys_log` VALUES (3874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2021-12-22 20:08:50', '1', 'admin', '2021-12-22 20:08:50', '记录日志');
INSERT INTO `sys_log` VALUES (3875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=53', '127.0.0.1', '/system/user/downfile', '2021-12-22 20:08:52', '1', 'admin', '2021-12-22 20:08:52', '记录日志');
INSERT INTO `sys_log` VALUES (3876, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-04 14:15:58', '1', 'admin', '2022-01-04 14:15:58', '记录日志');
INSERT INTO `sys_log` VALUES (3877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:15:58', '1', 'admin', '2022-01-04 14:15:58', '记录日志');
INSERT INTO `sys_log` VALUES (3878, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-04 14:16:04', '1', 'admin', '2022-01-04 14:16:04', '记录日志');
INSERT INTO `sys_log` VALUES (3879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:16:04', '1', 'admin', '2022-01-04 14:16:04', '记录日志');
INSERT INTO `sys_log` VALUES (3880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:16:14', '1', 'admin', '2022-01-04 14:16:14', '记录日志');
INSERT INTO `sys_log` VALUES (3881, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-01-04 14:16:25', '1', 'admin', '2022-01-04 14:16:25', '记录日志');
INSERT INTO `sys_log` VALUES (3882, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2022-01-04 14:16:34', '1', 'admin', '2022-01-04 14:16:34', '记录日志');
INSERT INTO `sys_log` VALUES (3883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-04 14:16:37', '1', 'admin', '2022-01-04 14:16:37', '记录日志');
INSERT INTO `sys_log` VALUES (3884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:16:37', '1', 'admin', '2022-01-04 14:16:37', '记录日志');
INSERT INTO `sys_log` VALUES (3885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-04 14:16:39', '1', 'admin', '2022-01-04 14:16:39', '记录日志');
INSERT INTO `sys_log` VALUES (3886, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:16:39', '1', 'admin', '2022-01-04 14:16:39', '记录日志');
INSERT INTO `sys_log` VALUES (3887, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-04 14:16:40', '1', 'admin', '2022-01-04 14:16:40', '记录日志');
INSERT INTO `sys_log` VALUES (3888, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:16:40', '1', 'admin', '2022-01-04 14:16:40', '记录日志');
INSERT INTO `sys_log` VALUES (3889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-04 14:16:44', '1', 'admin', '2022-01-04 14:16:44', '记录日志');
INSERT INTO `sys_log` VALUES (3890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:16:44', '1', 'admin', '2022-01-04 14:16:44', '记录日志');
INSERT INTO `sys_log` VALUES (3891, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:17:35', '1', 'admin', '2022-01-04 14:17:35', '记录日志');
INSERT INTO `sys_log` VALUES (3892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-01-04 14:17:37', '1', 'admin', '2022-01-04 14:17:37', '记录日志');
INSERT INTO `sys_log` VALUES (3893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-04 14:17:37', '1', 'admin', '2022-01-04 14:17:37', '记录日志');
INSERT INTO `sys_log` VALUES (3894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:17:37', '1', 'admin', '2022-01-04 14:17:37', '记录日志');
INSERT INTO `sys_log` VALUES (3895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-01-04 14:17:44', '1', 'admin', '2022-01-04 14:17:44', '记录日志');
INSERT INTO `sys_log` VALUES (3896, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-04 14:17:44', '1', 'admin', '2022-01-04 14:17:44', '记录日志');
INSERT INTO `sys_log` VALUES (3897, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-01-04 14:17:46', '1', 'admin', '2022-01-04 14:17:46', '记录日志');
INSERT INTO `sys_log` VALUES (3898, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-01-04 14:17:46', '1', 'admin', '2022-01-04 14:17:46', '记录日志');
INSERT INTO `sys_log` VALUES (3899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-04 14:18:04', '1', 'admin', '2022-01-04 14:18:04', '记录日志');
INSERT INTO `sys_log` VALUES (3900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-04 14:18:04', '1', 'admin', '2022-01-04 14:18:04', '记录日志');
INSERT INTO `sys_log` VALUES (3901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-01-04 14:18:20', '1', 'admin', '2022-01-04 14:18:20', '记录日志');
INSERT INTO `sys_log` VALUES (3902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-04 14:18:20', '1', 'admin', '2022-01-04 14:18:20', '记录日志');
INSERT INTO `sys_log` VALUES (3903, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:18:20', '1', 'admin', '2022-01-04 14:18:20', '记录日志');
INSERT INTO `sys_log` VALUES (3904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:46:16', '1', 'admin', '2022-01-04 14:46:16', '记录日志');
INSERT INTO `sys_log` VALUES (3905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:46:18', '1', 'admin', '2022-01-04 14:46:18', '记录日志');
INSERT INTO `sys_log` VALUES (3906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:50:28', '1', 'admin', '2022-01-04 14:50:28', '记录日志');
INSERT INTO `sys_log` VALUES (3907, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-01-04 14:50:30', '1', 'admin', '2022-01-04 14:50:30', '记录日志');
INSERT INTO `sys_log` VALUES (3908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:50:58', '1', 'admin', '2022-01-04 14:50:58', '记录日志');
INSERT INTO `sys_log` VALUES (3909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-04 14:50:58', '1', 'admin', '2022-01-04 14:50:58', '记录日志');
INSERT INTO `sys_log` VALUES (3910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:51:03', '1', 'admin', '2022-01-04 14:51:03', '记录日志');
INSERT INTO `sys_log` VALUES (3911, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:51:06', '1', 'admin', '2022-01-04 14:51:06', '记录日志');
INSERT INTO `sys_log` VALUES (3912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:51:11', '1', 'admin', '2022-01-04 14:51:11', '记录日志');
INSERT INTO `sys_log` VALUES (3913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:51:11', '1', 'admin', '2022-01-04 14:51:11', '记录日志');
INSERT INTO `sys_log` VALUES (3914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:51:12', '1', 'admin', '2022-01-04 14:51:12', '记录日志');
INSERT INTO `sys_log` VALUES (3915, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-01-04 14:51:17', '1', 'admin', '2022-01-04 14:51:17', '记录日志');
INSERT INTO `sys_log` VALUES (3916, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-04 14:51:17', '1', 'admin', '2022-01-04 14:51:17', '记录日志');
INSERT INTO `sys_log` VALUES (3917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-01-04 14:51:35', '1', 'admin', '2022-01-04 14:51:35', '记录日志');
INSERT INTO `sys_log` VALUES (3918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-01-04 14:51:35', '1', 'admin', '2022-01-04 14:51:35', '记录日志');
INSERT INTO `sys_log` VALUES (3919, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-01-04 14:51:42', '1', 'admin', '2022-01-04 14:51:42', '记录日志');
INSERT INTO `sys_log` VALUES (3920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-04 14:51:43', '1', 'admin', '2022-01-04 14:51:43', '记录日志');
INSERT INTO `sys_log` VALUES (3921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2022-01-04 14:51:47', '1', 'admin', '2022-01-04 14:51:47', '记录日志');
INSERT INTO `sys_log` VALUES (3922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2022-01-04 14:51:47', '1', 'admin', '2022-01-04 14:51:47', '记录日志');
INSERT INTO `sys_log` VALUES (3923, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-01-04 14:51:52', '1', 'admin', '2022-01-04 14:51:52', '记录日志');
INSERT INTO `sys_log` VALUES (3924, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2022-01-04 14:51:53', '1', 'admin', '2022-01-04 14:51:53', '记录日志');
INSERT INTO `sys_log` VALUES (3925, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-04 14:52:16', '1', 'admin', '2022-01-04 14:52:16', '记录日志');
INSERT INTO `sys_log` VALUES (3926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-04 14:52:16', '1', 'admin', '2022-01-04 14:52:16', '记录日志');
INSERT INTO `sys_log` VALUES (3927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-04 14:52:23', '1', 'admin', '2022-01-04 14:52:23', '记录日志');
INSERT INTO `sys_log` VALUES (3928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-04 14:52:27', '1', 'admin', '2022-01-04 14:52:27', '记录日志');
INSERT INTO `sys_log` VALUES (3929, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-04 14:52:31', '1', 'admin', '2022-01-04 14:52:31', '记录日志');
INSERT INTO `sys_log` VALUES (3930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-01-04 14:52:32', '1', 'admin', '2022-01-04 14:52:32', '记录日志');
INSERT INTO `sys_log` VALUES (3931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-04 14:52:32', '1', 'admin', '2022-01-04 14:52:32', '记录日志');
INSERT INTO `sys_log` VALUES (3932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-04 14:52:57', '1', 'admin', '2022-01-04 14:52:57', '记录日志');
INSERT INTO `sys_log` VALUES (3933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-04 14:52:57', '1', 'admin', '2022-01-04 14:52:57', '记录日志');
INSERT INTO `sys_log` VALUES (3934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:22', '1', 'admin', '2022-01-04 14:53:22', '记录日志');
INSERT INTO `sys_log` VALUES (3935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:23', '1', 'admin', '2022-01-04 14:53:23', '记录日志');
INSERT INTO `sys_log` VALUES (3936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:34', '1', 'admin', '2022-01-04 14:53:34', '记录日志');
INSERT INTO `sys_log` VALUES (3937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:36', '1', 'admin', '2022-01-04 14:53:36', '记录日志');
INSERT INTO `sys_log` VALUES (3938, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:37', '1', 'admin', '2022-01-04 14:53:37', '记录日志');
INSERT INTO `sys_log` VALUES (3939, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:38', '1', 'admin', '2022-01-04 14:53:38', '记录日志');
INSERT INTO `sys_log` VALUES (3940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:40', '1', 'admin', '2022-01-04 14:53:40', '记录日志');
INSERT INTO `sys_log` VALUES (3941, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:46', '1', 'admin', '2022-01-04 14:53:46', '记录日志');
INSERT INTO `sys_log` VALUES (3942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:53:49', '1', 'admin', '2022-01-04 14:53:49', '记录日志');
INSERT INTO `sys_log` VALUES (3943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-01-04 14:53:58', '1', 'admin', '2022-01-04 14:53:58', '记录日志');
INSERT INTO `sys_log` VALUES (3944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:54:00', '1', 'admin', '2022-01-04 14:54:00', '记录日志');
INSERT INTO `sys_log` VALUES (3945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-04 14:54:00', '1', 'admin', '2022-01-04 14:54:00', '记录日志');
INSERT INTO `sys_log` VALUES (3946, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:54:01', '1', 'admin', '2022-01-04 14:54:01', '记录日志');
INSERT INTO `sys_log` VALUES (3947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:54:03', '1', 'admin', '2022-01-04 14:54:03', '记录日志');
INSERT INTO `sys_log` VALUES (3948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-01-04 14:54:13', '1', 'admin', '2022-01-04 14:54:13', '记录日志');
INSERT INTO `sys_log` VALUES (3949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-04 14:54:18', '1', 'admin', '2022-01-04 14:54:18', '记录日志');
INSERT INTO `sys_log` VALUES (3950, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:54:18', '1', 'admin', '2022-01-04 14:54:18', '记录日志');
INSERT INTO `sys_log` VALUES (3951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-01-04 14:54:27', '1', 'admin', '2022-01-04 14:54:27', '记录日志');
INSERT INTO `sys_log` VALUES (3952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:54:30', '1', 'admin', '2022-01-04 14:54:30', '记录日志');
INSERT INTO `sys_log` VALUES (3953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-04 14:54:30', '1', 'admin', '2022-01-04 14:54:30', '记录日志');
INSERT INTO `sys_log` VALUES (3954, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/unuse', '2022-01-04 14:54:31', '1', 'admin', '2022-01-04 14:54:31', '记录日志');
INSERT INTO `sys_log` VALUES (3955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:54:31', '1', 'admin', '2022-01-04 14:54:31', '记录日志');
INSERT INTO `sys_log` VALUES (3956, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/use', '2022-01-04 14:54:33', '1', 'admin', '2022-01-04 14:54:33', '记录日志');
INSERT INTO `sys_log` VALUES (3957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-04 14:54:33', '1', 'admin', '2022-01-04 14:54:33', '记录日志');
INSERT INTO `sys_log` VALUES (3958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-08 18:48:55', '1', 'admin', '2022-01-08 18:48:55', '记录日志');
INSERT INTO `sys_log` VALUES (3959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-08 18:48:55', '1', 'admin', '2022-01-08 18:48:55', '记录日志');
INSERT INTO `sys_log` VALUES (3960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-01-08 18:49:06', '1', 'admin', '2022-01-08 18:49:06', '记录日志');
INSERT INTO `sys_log` VALUES (3961, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-08 18:49:06', '1', 'admin', '2022-01-08 18:49:06', '记录日志');
INSERT INTO `sys_log` VALUES (3962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 18:49:06', '1', 'admin', '2022-01-08 18:49:06', '记录日志');
INSERT INTO `sys_log` VALUES (3963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 18:49:14', '1', 'admin', '2022-01-08 18:49:14', '记录日志');
INSERT INTO `sys_log` VALUES (3964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:45', '1', 'admin', '2022-01-08 19:14:45', '记录日志');
INSERT INTO `sys_log` VALUES (3965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:46', '1', 'admin', '2022-01-08 19:14:46', '记录日志');
INSERT INTO `sys_log` VALUES (3966, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:47', '1', 'admin', '2022-01-08 19:14:47', '记录日志');
INSERT INTO `sys_log` VALUES (3967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:49', '1', 'admin', '2022-01-08 19:14:49', '记录日志');
INSERT INTO `sys_log` VALUES (3968, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/unuse', '2022-01-08 19:14:53', '1', 'admin', '2022-01-08 19:14:53', '记录日志');
INSERT INTO `sys_log` VALUES (3969, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:53', '1', 'admin', '2022-01-08 19:14:53', '记录日志');
INSERT INTO `sys_log` VALUES (3970, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/use', '2022-01-08 19:14:55', '1', 'admin', '2022-01-08 19:14:55', '记录日志');
INSERT INTO `sys_log` VALUES (3971, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:55', '1', 'admin', '2022-01-08 19:14:55', '记录日志');
INSERT INTO `sys_log` VALUES (3972, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/unuse', '2022-01-08 19:14:56', '1', 'admin', '2022-01-08 19:14:56', '记录日志');
INSERT INTO `sys_log` VALUES (3973, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:56', '1', 'admin', '2022-01-08 19:14:56', '记录日志');
INSERT INTO `sys_log` VALUES (3974, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/use', '2022-01-08 19:14:57', '1', 'admin', '2022-01-08 19:14:57', '记录日志');
INSERT INTO `sys_log` VALUES (3975, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:14:57', '1', 'admin', '2022-01-08 19:14:57', '记录日志');
INSERT INTO `sys_log` VALUES (3976, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:08', '1', 'admin', '2022-01-08 19:15:08', '记录日志');
INSERT INTO `sys_log` VALUES (3977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:10', '1', 'admin', '2022-01-08 19:15:10', '记录日志');
INSERT INTO `sys_log` VALUES (3978, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:14', '1', 'admin', '2022-01-08 19:15:14', '记录日志');
INSERT INTO `sys_log` VALUES (3979, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:22', '1', 'admin', '2022-01-08 19:15:22', '记录日志');
INSERT INTO `sys_log` VALUES (3980, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-01-08 19:15:30', '1', 'admin', '2022-01-08 19:15:30', '记录日志');
INSERT INTO `sys_log` VALUES (3981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:15:30', '1', 'admin', '2022-01-08 19:15:30', '记录日志');
INSERT INTO `sys_log` VALUES (3982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:39', '1', 'admin', '2022-01-08 19:15:39', '记录日志');
INSERT INTO `sys_log` VALUES (3983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:41', '1', 'admin', '2022-01-08 19:15:41', '记录日志');
INSERT INTO `sys_log` VALUES (3984, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:46', '1', 'admin', '2022-01-08 19:15:46', '记录日志');
INSERT INTO `sys_log` VALUES (3985, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:46', '1', 'admin', '2022-01-08 19:15:46', '记录日志');
INSERT INTO `sys_log` VALUES (3986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:47', '1', 'admin', '2022-01-08 19:15:47', '记录日志');
INSERT INTO `sys_log` VALUES (3987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:15:48', '1', 'admin', '2022-01-08 19:15:48', '记录日志');
INSERT INTO `sys_log` VALUES (3988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-01-08 19:15:56', '1', 'admin', '2022-01-08 19:15:56', '记录日志');
INSERT INTO `sys_log` VALUES (3989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-08 19:15:56', '1', 'admin', '2022-01-08 19:15:56', '记录日志');
INSERT INTO `sys_log` VALUES (3990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-08 19:16:06', '1', 'admin', '2022-01-08 19:16:06', '记录日志');
INSERT INTO `sys_log` VALUES (3991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:16:15', '1', 'admin', '2022-01-08 19:16:15', '记录日志');
INSERT INTO `sys_log` VALUES (3992, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:03', '1', 'admin', '2022-01-08 19:17:03', '记录日志');
INSERT INTO `sys_log` VALUES (3993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:06', '1', 'admin', '2022-01-08 19:17:06', '记录日志');
INSERT INTO `sys_log` VALUES (3994, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:09', '1', 'admin', '2022-01-08 19:17:09', '记录日志');
INSERT INTO `sys_log` VALUES (3995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:13', '1', 'admin', '2022-01-08 19:17:13', '记录日志');
INSERT INTO `sys_log` VALUES (3996, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-01-08 19:17:17', '1', 'admin', '2022-01-08 19:17:17', '记录日志');
INSERT INTO `sys_log` VALUES (3997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:24', '1', 'admin', '2022-01-08 19:17:24', '记录日志');
INSERT INTO `sys_log` VALUES (3998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-08 19:17:24', '1', 'admin', '2022-01-08 19:17:24', '记录日志');
INSERT INTO `sys_log` VALUES (3999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:25', '1', 'admin', '2022-01-08 19:17:25', '记录日志');
INSERT INTO `sys_log` VALUES (4000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-01-08 19:17:25', '1', 'admin', '2022-01-08 19:17:25', '记录日志');
INSERT INTO `sys_log` VALUES (4001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:27', '1', 'admin', '2022-01-08 19:17:27', '记录日志');
INSERT INTO `sys_log` VALUES (4002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-08 19:17:27', '1', 'admin', '2022-01-08 19:17:27', '记录日志');
INSERT INTO `sys_log` VALUES (4003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:30', '1', 'admin', '2022-01-08 19:17:30', '记录日志');
INSERT INTO `sys_log` VALUES (4004, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:34', '1', 'admin', '2022-01-08 19:17:34', '记录日志');
INSERT INTO `sys_log` VALUES (4005, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:36', '1', 'admin', '2022-01-08 19:17:36', '记录日志');
INSERT INTO `sys_log` VALUES (4006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-01-08 19:17:39', '1', 'admin', '2022-01-08 19:17:39', '记录日志');
INSERT INTO `sys_log` VALUES (4007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-08 19:17:39', '1', 'admin', '2022-01-08 19:17:39', '记录日志');
INSERT INTO `sys_log` VALUES (4008, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:44', '1', 'admin', '2022-01-08 19:17:44', '记录日志');
INSERT INTO `sys_log` VALUES (4009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-01-08 19:17:45', '1', 'admin', '2022-01-08 19:17:45', '记录日志');
INSERT INTO `sys_log` VALUES (4010, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-08 19:17:49', '1', 'admin', '2022-01-08 19:17:49', '记录日志');
INSERT INTO `sys_log` VALUES (4011, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-08 19:17:49', '1', 'admin', '2022-01-08 19:17:49', '记录日志');
INSERT INTO `sys_log` VALUES (4012, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-01-08 19:17:52', '1', 'admin', '2022-01-08 19:17:52', '记录日志');
INSERT INTO `sys_log` VALUES (4013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-08 19:17:52', '1', 'admin', '2022-01-08 19:17:52', '记录日志');
INSERT INTO `sys_log` VALUES (4014, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-01-08 19:17:56', '1', 'admin', '2022-01-08 19:17:56', '记录日志');
INSERT INTO `sys_log` VALUES (4015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-01-08 19:17:56', '1', 'admin', '2022-01-08 19:17:56', '记录日志');
INSERT INTO `sys_log` VALUES (4016, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-01-08 19:18:02', '1', 'admin', '2022-01-08 19:18:02', '记录日志');
INSERT INTO `sys_log` VALUES (4017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:18:02', '1', 'admin', '2022-01-08 19:18:02', '记录日志');
INSERT INTO `sys_log` VALUES (4018, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2022-01-08 19:18:04', '1', 'admin', '2022-01-08 19:18:04', '记录日志');
INSERT INTO `sys_log` VALUES (4019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2022-01-08 19:18:05', '1', 'admin', '2022-01-08 19:18:05', '记录日志');
INSERT INTO `sys_log` VALUES (4020, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-08 19:18:19', '1', 'admin', '2022-01-08 19:18:19', '记录日志');
INSERT INTO `sys_log` VALUES (4021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-08 19:18:19', '1', 'admin', '2022-01-08 19:18:19', '记录日志');
INSERT INTO `sys_log` VALUES (4022, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-08 19:18:21', '1', 'admin', '2022-01-08 19:18:21', '记录日志');
INSERT INTO `sys_log` VALUES (4023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-01-08 19:18:22', '1', 'admin', '2022-01-08 19:18:22', '记录日志');
INSERT INTO `sys_log` VALUES (4024, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-08 19:18:22', '1', 'admin', '2022-01-08 19:18:22', '记录日志');
INSERT INTO `sys_log` VALUES (4025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:18:39', '1', 'admin', '2022-01-08 19:18:39', '记录日志');
INSERT INTO `sys_log` VALUES (4026, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:18:44', '1', 'admin', '2022-01-08 19:18:44', '记录日志');
INSERT INTO `sys_log` VALUES (4027, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:18:50', '1', 'admin', '2022-01-08 19:18:50', '记录日志');
INSERT INTO `sys_log` VALUES (4028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:18:51', '1', 'admin', '2022-01-08 19:18:51', '记录日志');
INSERT INTO `sys_log` VALUES (4029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:19:01', '1', 'admin', '2022-01-08 19:19:01', '记录日志');
INSERT INTO `sys_log` VALUES (4030, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/cache', '2022-01-08 19:19:08', '1', 'admin', '2022-01-08 19:19:08', '记录日志');
INSERT INTO `sys_log` VALUES (4031, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/cache', '2022-01-08 19:19:12', '1', 'admin', '2022-01-08 19:19:12', '记录日志');
INSERT INTO `sys_log` VALUES (4032, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2022-01-08 19:19:13', '1', 'admin', '2022-01-08 19:19:13', '记录日志');
INSERT INTO `sys_log` VALUES (4033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:19:21', '1', 'admin', '2022-01-08 19:19:21', '记录日志');
INSERT INTO `sys_log` VALUES (4034, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-08 19:19:50', '1', 'admin', '2022-01-08 19:19:50', '记录日志');
INSERT INTO `sys_log` VALUES (4035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-08 19:19:53', '1', 'admin', '2022-01-08 19:19:53', '记录日志');
INSERT INTO `sys_log` VALUES (4036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-08 19:19:55', '1', 'admin', '2022-01-08 19:19:55', '记录日志');
INSERT INTO `sys_log` VALUES (4037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-08 19:20:01', '1', 'admin', '2022-01-08 19:20:01', '记录日志');
INSERT INTO `sys_log` VALUES (4038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-08 19:21:05', '1', 'admin', '2022-01-08 19:21:05', '记录日志');
INSERT INTO `sys_log` VALUES (4039, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-01-08 19:21:15', '1', 'admin', '2022-01-08 19:21:15', '记录日志');
INSERT INTO `sys_log` VALUES (4040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-01-08 19:21:17', '1', 'admin', '2022-01-08 19:21:17', '记录日志');
INSERT INTO `sys_log` VALUES (4041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:21:17', '1', 'admin', '2022-01-08 19:21:17', '记录日志');
INSERT INTO `sys_log` VALUES (4042, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2022-01-08 19:21:19', '1', 'admin', '2022-01-08 19:21:19', '记录日志');
INSERT INTO `sys_log` VALUES (4043, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-08 19:21:27', '1', 'admin', '2022-01-08 19:21:27', '记录日志');
INSERT INTO `sys_log` VALUES (4044, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-01-08 19:21:33', '1', 'admin', '2022-01-08 19:21:33', '记录日志');
INSERT INTO `sys_log` VALUES (4045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-01-08 19:21:33', '1', 'admin', '2022-01-08 19:21:33', '记录日志');
INSERT INTO `sys_log` VALUES (4046, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2022-01-08 19:21:33', '1', 'admin', '2022-01-08 19:21:33', '记录日志');
INSERT INTO `sys_log` VALUES (4047, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-01-08 19:21:35', '1', 'admin', '2022-01-08 19:21:35', '记录日志');
INSERT INTO `sys_log` VALUES (4048, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-11 11:46:21', '1', 'admin', '2022-01-11 11:46:21', '记录日志');
INSERT INTO `sys_log` VALUES (4049, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-11 11:46:21', '1', 'admin', '2022-01-11 11:46:21', '记录日志');
INSERT INTO `sys_log` VALUES (4050, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-11 11:50:56', '1', 'admin', '2022-01-11 11:50:56', '记录日志');
INSERT INTO `sys_log` VALUES (4051, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:50:56', '1', 'admin', '2022-01-11 11:50:56', '记录日志');
INSERT INTO `sys_log` VALUES (4052, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-11 11:53:11', '1', 'admin', '2022-01-11 11:53:11', '记录日志');
INSERT INTO `sys_log` VALUES (4053, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-01-11 11:53:54', '1', 'admin', '2022-01-11 11:53:54', '记录日志');
INSERT INTO `sys_log` VALUES (4054, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-11 11:55:29', '1', 'admin', '2022-01-11 11:55:29', '记录日志');
INSERT INTO `sys_log` VALUES (4055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-11 11:55:44', '1', 'admin', '2022-01-11 11:55:44', '记录日志');
INSERT INTO `sys_log` VALUES (4056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:55:44', '1', 'admin', '2022-01-11 11:55:44', '记录日志');
INSERT INTO `sys_log` VALUES (4057, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:56:19', '1', 'admin', '2022-01-11 11:56:19', '记录日志');
INSERT INTO `sys_log` VALUES (4058, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:56:20', '1', 'admin', '2022-01-11 11:56:20', '记录日志');
INSERT INTO `sys_log` VALUES (4059, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:56:26', '1', 'admin', '2022-01-11 11:56:26', '记录日志');
INSERT INTO `sys_log` VALUES (4060, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:56:33', '1', 'admin', '2022-01-11 11:56:33', '记录日志');
INSERT INTO `sys_log` VALUES (4061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-01-11 11:56:40', '1', 'admin', '2022-01-11 11:56:40', '记录日志');
INSERT INTO `sys_log` VALUES (4062, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:56:40', '1', 'admin', '2022-01-11 11:56:40', '记录日志');
INSERT INTO `sys_log` VALUES (4063, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 11:56:49', '1', 'admin', '2022-01-11 11:56:49', '记录日志');
INSERT INTO `sys_log` VALUES (4064, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 11:56:59', '1', 'admin', '2022-01-11 11:56:59', '记录日志');
INSERT INTO `sys_log` VALUES (4065, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 11:57:05', '1', 'admin', '2022-01-11 11:57:05', '记录日志');
INSERT INTO `sys_log` VALUES (4066, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=53', '127.0.0.1', '/system/user/downfile', '2022-01-11 11:57:06', '1', 'admin', '2022-01-11 11:57:06', '记录日志');
INSERT INTO `sys_log` VALUES (4067, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:57:10', '1', 'admin', '2022-01-11 11:57:10', '记录日志');
INSERT INTO `sys_log` VALUES (4068, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:57:11', '1', 'admin', '2022-01-11 11:57:11', '记录日志');
INSERT INTO `sys_log` VALUES (4069, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 11:57:12', '1', 'admin', '2022-01-11 11:57:12', '记录日志');
INSERT INTO `sys_log` VALUES (4070, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=33', '127.0.0.1', '/system/user/downfile', '2022-01-11 11:57:13', '1', 'admin', '2022-01-11 11:57:13', '记录日志');
INSERT INTO `sys_log` VALUES (4071, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 11:57:16', '1', 'admin', '2022-01-11 11:57:16', '记录日志');
INSERT INTO `sys_log` VALUES (4072, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=32', '127.0.0.1', '/system/user/downfile', '2022-01-11 11:57:19', '1', 'admin', '2022-01-11 11:57:19', '记录日志');
INSERT INTO `sys_log` VALUES (4073, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 11:57:21', '1', 'admin', '2022-01-11 11:57:21', '记录日志');
INSERT INTO `sys_log` VALUES (4074, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 11:57:23', '1', 'admin', '2022-01-11 11:57:23', '记录日志');
INSERT INTO `sys_log` VALUES (4075, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=36', '127.0.0.1', '/system/user/downfile', '2022-01-11 11:57:24', '1', 'admin', '2022-01-11 11:57:24', '记录日志');
INSERT INTO `sys_log` VALUES (4076, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 11:57:27', '1', 'admin', '2022-01-11 11:57:27', '记录日志');
INSERT INTO `sys_log` VALUES (4077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=37', '127.0.0.1', '/system/user/downfile', '2022-01-11 11:57:28', '1', 'admin', '2022-01-11 11:57:28', '记录日志');
INSERT INTO `sys_log` VALUES (4078, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-11 14:33:37', '1', 'admin', '2022-01-11 14:33:37', '记录日志');
INSERT INTO `sys_log` VALUES (4079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-11 14:33:38', '1', 'admin', '2022-01-11 14:33:38', '记录日志');
INSERT INTO `sys_log` VALUES (4080, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-11 14:33:50', '1', 'admin', '2022-01-11 14:33:50', '记录日志');
INSERT INTO `sys_log` VALUES (4081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-11 14:33:50', '1', 'admin', '2022-01-11 14:33:50', '记录日志');
INSERT INTO `sys_log` VALUES (4082, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-11 14:33:51', '1', 'admin', '2022-01-11 14:33:51', '记录日志');
INSERT INTO `sys_log` VALUES (4083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-11 14:33:51', '1', 'admin', '2022-01-11 14:33:51', '记录日志');
INSERT INTO `sys_log` VALUES (4084, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-11 14:33:53', '1', 'admin', '2022-01-11 14:33:53', '记录日志');
INSERT INTO `sys_log` VALUES (4085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-11 14:33:53', '1', 'admin', '2022-01-11 14:33:53', '记录日志');
INSERT INTO `sys_log` VALUES (4086, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-11 14:33:58', '1', 'admin', '2022-01-11 14:33:58', '记录日志');
INSERT INTO `sys_log` VALUES (4087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-11 14:33:58', '1', 'admin', '2022-01-11 14:33:58', '记录日志');
INSERT INTO `sys_log` VALUES (4088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-11 14:34:14', '1', 'admin', '2022-01-11 14:34:14', '记录日志');
INSERT INTO `sys_log` VALUES (4089, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:34:14', '1', 'admin', '2022-01-11 14:34:14', '记录日志');
INSERT INTO `sys_log` VALUES (4090, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:49:04', '1', 'admin', '2022-01-11 14:49:04', '记录日志');
INSERT INTO `sys_log` VALUES (4091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:50:11', '1', 'admin', '2022-01-11 14:50:11', '记录日志');
INSERT INTO `sys_log` VALUES (4092, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:50:32', '1', 'admin', '2022-01-11 14:50:32', '记录日志');
INSERT INTO `sys_log` VALUES (4093, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:50:40', '1', 'admin', '2022-01-11 14:50:40', '记录日志');
INSERT INTO `sys_log` VALUES (4094, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:50:44', '1', 'admin', '2022-01-11 14:50:44', '记录日志');
INSERT INTO `sys_log` VALUES (4095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-11 14:52:37', '1', 'admin', '2022-01-11 14:52:37', '记录日志');
INSERT INTO `sys_log` VALUES (4096, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-01-11 14:52:39', '1', 'admin', '2022-01-11 14:52:39', '记录日志');
INSERT INTO `sys_log` VALUES (4097, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:52:39', '1', 'admin', '2022-01-11 14:52:39', '记录日志');
INSERT INTO `sys_log` VALUES (4098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 14:52:47', '1', 'admin', '2022-01-11 14:52:47', '记录日志');
INSERT INTO `sys_log` VALUES (4099, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:00:01', '1', 'admin', '2022-01-11 15:00:01', '记录日志');
INSERT INTO `sys_log` VALUES (4100, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:00:10', '1', 'admin', '2022-01-11 15:00:10', '记录日志');
INSERT INTO `sys_log` VALUES (4101, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:00:51', '1', 'admin', '2022-01-11 15:00:51', '记录日志');
INSERT INTO `sys_log` VALUES (4102, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:00:53', '1', 'admin', '2022-01-11 15:00:53', '记录日志');
INSERT INTO `sys_log` VALUES (4103, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:00:57', '1', 'admin', '2022-01-11 15:00:57', '记录日志');
INSERT INTO `sys_log` VALUES (4104, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:04', '1', 'admin', '2022-01-11 15:01:04', '记录日志');
INSERT INTO `sys_log` VALUES (4105, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:06', '1', 'admin', '2022-01-11 15:01:06', '记录日志');
INSERT INTO `sys_log` VALUES (4106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:16', '1', 'admin', '2022-01-11 15:01:16', '记录日志');
INSERT INTO `sys_log` VALUES (4107, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:20', '1', 'admin', '2022-01-11 15:01:20', '记录日志');
INSERT INTO `sys_log` VALUES (4108, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:22', '1', 'admin', '2022-01-11 15:01:22', '记录日志');
INSERT INTO `sys_log` VALUES (4109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:31', '1', 'admin', '2022-01-11 15:01:31', '记录日志');
INSERT INTO `sys_log` VALUES (4110, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:40', '1', 'admin', '2022-01-11 15:01:40', '记录日志');
INSERT INTO `sys_log` VALUES (4111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:41', '1', 'admin', '2022-01-11 15:01:41', '记录日志');
INSERT INTO `sys_log` VALUES (4112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:42', '1', 'admin', '2022-01-11 15:01:42', '记录日志');
INSERT INTO `sys_log` VALUES (4113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:45', '1', 'admin', '2022-01-11 15:01:45', '记录日志');
INSERT INTO `sys_log` VALUES (4114, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:49', '1', 'admin', '2022-01-11 15:01:49', '记录日志');
INSERT INTO `sys_log` VALUES (4115, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:56', '1', 'admin', '2022-01-11 15:01:56', '记录日志');
INSERT INTO `sys_log` VALUES (4116, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:01:59', '1', 'admin', '2022-01-11 15:01:59', '记录日志');
INSERT INTO `sys_log` VALUES (4117, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:02:04', '1', 'admin', '2022-01-11 15:02:04', '记录日志');
INSERT INTO `sys_log` VALUES (4118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:02:08', '1', 'admin', '2022-01-11 15:02:08', '记录日志');
INSERT INTO `sys_log` VALUES (4119, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:02:11', '1', 'admin', '2022-01-11 15:02:11', '记录日志');
INSERT INTO `sys_log` VALUES (4120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-01-11 15:02:26', '1', 'admin', '2022-01-11 15:02:26', '记录日志');
INSERT INTO `sys_log` VALUES (4121, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:02:27', '1', 'admin', '2022-01-11 15:02:27', '记录日志');
INSERT INTO `sys_log` VALUES (4122, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:02:28', '1', 'admin', '2022-01-11 15:02:28', '记录日志');
INSERT INTO `sys_log` VALUES (4123, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:02:33', '1', 'admin', '2022-01-11 15:02:33', '记录日志');
INSERT INTO `sys_log` VALUES (4124, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:08:51', '1', 'admin', '2022-01-11 15:08:51', '记录日志');
INSERT INTO `sys_log` VALUES (4125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:08:55', '1', 'admin', '2022-01-11 15:08:55', '记录日志');
INSERT INTO `sys_log` VALUES (4126, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:09:01', '1', 'admin', '2022-01-11 15:09:01', '记录日志');
INSERT INTO `sys_log` VALUES (4127, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:09:04', '1', 'admin', '2022-01-11 15:09:04', '记录日志');
INSERT INTO `sys_log` VALUES (4128, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:09:05', '1', 'admin', '2022-01-11 15:09:05', '记录日志');
INSERT INTO `sys_log` VALUES (4129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:09:07', '1', 'admin', '2022-01-11 15:09:07', '记录日志');
INSERT INTO `sys_log` VALUES (4130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-01-11 15:14:11', '1', 'admin', '2022-01-11 15:14:11', '记录日志');
INSERT INTO `sys_log` VALUES (4131, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-11 15:14:11', '1', 'admin', '2022-01-11 15:14:11', '记录日志');
INSERT INTO `sys_log` VALUES (4132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/add', '2022-01-11 15:14:12', '1', 'admin', '2022-01-11 15:14:12', '记录日志');
INSERT INTO `sys_log` VALUES (4133, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-01-11 15:14:15', '1', 'admin', '2022-01-11 15:14:15', '记录日志');
INSERT INTO `sys_log` VALUES (4134, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-01-11 15:24:58', '1', 'admin', '2022-01-11 15:24:58', '记录日志');
INSERT INTO `sys_log` VALUES (4135, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-01-11 15:24:58', '1', 'admin', '2022-01-11 15:24:58', '记录日志');
INSERT INTO `sys_log` VALUES (4136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-01-11 15:24:58', '1', 'admin', '2022-01-11 15:24:58', '记录日志');
INSERT INTO `sys_log` VALUES (4137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:47:23', '1', 'admin', '2022-01-11 15:47:23', '记录日志');
INSERT INTO `sys_log` VALUES (4138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:47:26', '1', 'admin', '2022-01-11 15:47:26', '记录日志');
INSERT INTO `sys_log` VALUES (4139, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:47:32', '1', 'admin', '2022-01-11 15:47:32', '记录日志');
INSERT INTO `sys_log` VALUES (4140, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:47:34', '1', 'admin', '2022-01-11 15:47:34', '记录日志');
INSERT INTO `sys_log` VALUES (4141, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:47:37', '1', 'admin', '2022-01-11 15:47:37', '记录日志');
INSERT INTO `sys_log` VALUES (4142, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:47:40', '1', 'admin', '2022-01-11 15:47:40', '记录日志');
INSERT INTO `sys_log` VALUES (4143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-11 15:59:52', '1', 'admin', '2022-01-11 15:59:52', '记录日志');
INSERT INTO `sys_log` VALUES (4144, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-01-11 15:59:54', '1', 'admin', '2022-01-11 15:59:54', '记录日志');
INSERT INTO `sys_log` VALUES (4145, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 15:59:54', '1', 'admin', '2022-01-11 15:59:54', '记录日志');
INSERT INTO `sys_log` VALUES (4146, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 16:00:40', '1', 'admin', '2022-01-11 16:00:40', '记录日志');
INSERT INTO `sys_log` VALUES (4147, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=53', '127.0.0.1', '/system/user/downfile', '2022-01-11 16:00:48', '1', 'admin', '2022-01-11 16:00:48', '记录日志');
INSERT INTO `sys_log` VALUES (4148, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 16:00:50', '1', 'admin', '2022-01-11 16:00:50', '记录日志');
INSERT INTO `sys_log` VALUES (4149, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 16:01:50', '1', 'admin', '2022-01-11 16:01:50', '记录日志');
INSERT INTO `sys_log` VALUES (4150, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 16:57:31', '1', 'admin', '2022-01-11 16:57:31', '记录日志');
INSERT INTO `sys_log` VALUES (4151, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-11 16:59:27', '1', 'admin', '2022-01-11 16:59:27', '记录日志');
INSERT INTO `sys_log` VALUES (4152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 16:59:27', '1', 'admin', '2022-01-11 16:59:27', '记录日志');
INSERT INTO `sys_log` VALUES (4153, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-01-11 16:59:54', '1', 'admin', '2022-01-11 16:59:54', '记录日志');
INSERT INTO `sys_log` VALUES (4154, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/ChainAdd', '2022-01-11 17:00:13', '1', 'admin', '2022-01-11 17:00:13', '记录日志');
INSERT INTO `sys_log` VALUES (4155, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 17:00:18', '1', 'admin', '2022-01-11 17:00:18', '记录日志');
INSERT INTO `sys_log` VALUES (4156, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 17:00:21', '1', 'admin', '2022-01-11 17:00:21', '记录日志');
INSERT INTO `sys_log` VALUES (4157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 17:00:22', '1', 'admin', '2022-01-11 17:00:22', '记录日志');
INSERT INTO `sys_log` VALUES (4158, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-11 17:00:25', '1', 'admin', '2022-01-11 17:00:25', '记录日志');
INSERT INTO `sys_log` VALUES (4159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 17:00:25', '1', 'admin', '2022-01-11 17:00:25', '记录日志');
INSERT INTO `sys_log` VALUES (4160, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 17:00:27', '1', 'admin', '2022-01-11 17:00:27', '记录日志');
INSERT INTO `sys_log` VALUES (4161, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-01-11 17:00:45', '1', 'admin', '2022-01-11 17:00:45', '记录日志');
INSERT INTO `sys_log` VALUES (4162, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-01-11 17:00:45', '1', 'admin', '2022-01-11 17:00:45', '记录日志');
INSERT INTO `sys_log` VALUES (4163, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-01-11 17:00:49', '1', 'admin', '2022-01-11 17:00:49', '记录日志');
INSERT INTO `sys_log` VALUES (4164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=54', '127.0.0.1', '/system/user/downfile', '2022-01-11 17:00:50', '1', 'admin', '2022-01-11 17:00:50', '记录日志');
INSERT INTO `sys_log` VALUES (4165, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-11 17:00:55', '1', 'admin', '2022-01-11 17:00:55', '记录日志');
INSERT INTO `sys_log` VALUES (4166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-11 17:00:56', '1', 'admin', '2022-01-11 17:00:56', '记录日志');
INSERT INTO `sys_log` VALUES (4167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-01-18 14:21:13', '1', 'admin', '2022-01-18 14:21:13', '记录日志');
INSERT INTO `sys_log` VALUES (4168, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-01-18 14:21:13', '1', 'admin', '2022-01-18 14:21:13', '记录日志');
INSERT INTO `sys_log` VALUES (4169, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-01-18 14:21:17', '1', 'admin', '2022-01-18 14:21:17', '记录日志');
INSERT INTO `sys_log` VALUES (4170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-18 14:21:17', '1', 'admin', '2022-01-18 14:21:17', '记录日志');
INSERT INTO `sys_log` VALUES (4171, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-01-18 14:21:18', '1', 'admin', '2022-01-18 14:21:18', '记录日志');
INSERT INTO `sys_log` VALUES (4172, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-01-18 14:21:18', '1', 'admin', '2022-01-18 14:21:18', '记录日志');
INSERT INTO `sys_log` VALUES (4173, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-18 14:21:25', '1', 'admin', '2022-01-18 14:21:25', '记录日志');
INSERT INTO `sys_log` VALUES (4174, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-18 14:21:30', '1', 'admin', '2022-01-18 14:21:30', '记录日志');
INSERT INTO `sys_log` VALUES (4175, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-18 14:21:30', '1', 'admin', '2022-01-18 14:21:30', '记录日志');
INSERT INTO `sys_log` VALUES (4176, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-18 14:21:33', '1', 'admin', '2022-01-18 14:21:33', '记录日志');
INSERT INTO `sys_log` VALUES (4177, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2022-01-18 14:21:36', '1', 'admin', '2022-01-18 14:21:36', '记录日志');
INSERT INTO `sys_log` VALUES (4178, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-01-18 14:21:45', '1', 'admin', '2022-01-18 14:21:45', '记录日志');
INSERT INTO `sys_log` VALUES (4179, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-18 14:21:48', '1', 'admin', '2022-01-18 14:21:48', '记录日志');
INSERT INTO `sys_log` VALUES (4180, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-18 14:21:48', '1', 'admin', '2022-01-18 14:21:48', '记录日志');
INSERT INTO `sys_log` VALUES (4181, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-01-18 14:23:19', '1', 'admin', '2022-01-18 14:23:19', '记录日志');
INSERT INTO `sys_log` VALUES (4182, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-18 14:23:19', '1', 'admin', '2022-01-18 14:23:19', '记录日志');
INSERT INTO `sys_log` VALUES (4183, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-18 14:23:25', '1', 'admin', '2022-01-18 14:23:25', '记录日志');
INSERT INTO `sys_log` VALUES (4184, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-01-18 14:23:26', '1', 'admin', '2022-01-18 14:23:26', '记录日志');
INSERT INTO `sys_log` VALUES (4185, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-01-18 14:23:34', '1', 'admin', '2022-01-18 14:23:34', '记录日志');
INSERT INTO `sys_log` VALUES (4186, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-02-15 16:37:46', '1', 'admin', '2022-02-15 16:37:46', '记录日志');
INSERT INTO `sys_log` VALUES (4187, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-02-15 16:37:46', '1', 'admin', '2022-02-15 16:37:46', '记录日志');
INSERT INTO `sys_log` VALUES (4188, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-02-15 16:45:07', '1', 'admin', '2022-02-15 16:45:07', '记录日志');
INSERT INTO `sys_log` VALUES (4189, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-02-15 16:45:07', '1', 'admin', '2022-02-15 16:45:07', '记录日志');
INSERT INTO `sys_log` VALUES (4190, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-02-15 16:45:07', '1', 'admin', '2022-02-15 16:45:07', '记录日志');
INSERT INTO `sys_log` VALUES (4191, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-02-15 16:45:18', '1', 'admin', '2022-02-15 16:45:18', '记录日志');
INSERT INTO `sys_log` VALUES (4192, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-02-15 16:45:19', '1', 'admin', '2022-02-15 16:45:19', '记录日志');
INSERT INTO `sys_log` VALUES (4193, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-02-15 16:47:43', '1', 'admin', '2022-02-15 16:47:43', '记录日志');
INSERT INTO `sys_log` VALUES (4194, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-02-15 16:47:43', '1', 'admin', '2022-02-15 16:47:43', '记录日志');
INSERT INTO `sys_log` VALUES (4195, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-02-15 16:47:44', '1', 'admin', '2022-02-15 16:47:44', '记录日志');
INSERT INTO `sys_log` VALUES (4196, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-02-15 16:47:44', '1', 'admin', '2022-02-15 16:47:44', '记录日志');
INSERT INTO `sys_log` VALUES (4197, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-20 16:30:18', '1', 'admin', '2022-03-20 16:30:18', '记录日志');
INSERT INTO `sys_log` VALUES (4198, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-20 16:30:18', '1', 'admin', '2022-03-20 16:30:18', '记录日志');
INSERT INTO `sys_log` VALUES (4199, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-21 21:29:38', '1', 'admin', '2022-03-21 21:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4200, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-21 21:29:38', '1', 'admin', '2022-03-21 21:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4201, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-21 21:29:49', '1', 'admin', '2022-03-21 21:29:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4202, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-21 21:29:49', '1', 'admin', '2022-03-21 21:29:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4203, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-21 21:29:51', '1', 'admin', '2022-03-21 21:29:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4204, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-21 21:29:51', '1', 'admin', '2022-03-21 21:29:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4205, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-21 21:29:53', '1', 'admin', '2022-03-21 21:29:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4206, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-21 21:29:53', '1', 'admin', '2022-03-21 21:29:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4207, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-21 21:29:56', '1', 'admin', '2022-03-21 21:29:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4208, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-21 21:29:56', '1', 'admin', '2022-03-21 21:29:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4209, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-03-21 21:30:00', '1', 'admin', '2022-03-21 21:30:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4210, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-03-21 21:30:00', '1', 'admin', '2022-03-21 21:30:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4211, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-21 21:30:06', '1', 'admin', '2022-03-21 21:30:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4212, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-21 21:30:06', '1', 'admin', '2022-03-21 21:30:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4213, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-21 21:30:07', '1', 'admin', '2022-03-21 21:30:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4214, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-21 21:30:07', '1', 'admin', '2022-03-21 21:30:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4215, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-21 21:30:09', '1', 'admin', '2022-03-21 21:30:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4216, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-21 21:30:09', '1', 'admin', '2022-03-21 21:30:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4217, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-21 21:37:17', '1', 'admin', '2022-03-21 21:37:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4218, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-21 21:37:17', '1', 'admin', '2022-03-21 21:37:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4219, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:02:16', '1', 'guest', '2022-03-22 11:02:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4220, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:02:16', '1', 'guest', '2022-03-22 11:02:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4221, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:02:21', '1', 'guest', '2022-03-22 11:02:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4222, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:02:21', '1', 'guest', '2022-03-22 11:02:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4223, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:02:26', '1', 'guest', '2022-03-22 11:02:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4224, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:02:26', '1', 'guest', '2022-03-22 11:02:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4225, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:02:33', '1', 'guest', '2022-03-22 11:02:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4226, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:02:33', '1', 'guest', '2022-03-22 11:02:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4227, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:03:27', '1', 'guest', '2022-03-22 11:03:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4228, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:03:27', '1', 'guest', '2022-03-22 11:03:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4229, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:03:35', '1', 'guest', '2022-03-22 11:03:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4230, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:03:35', '1', 'guest', '2022-03-22 11:03:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4231, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:04:11', '1', 'guest', '2022-03-22 11:04:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4232, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:04:11', '1', 'guest', '2022-03-22 11:04:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4233, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:04:12', '1', 'guest', '2022-03-22 11:04:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4234, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:04:12', '1', 'guest', '2022-03-22 11:04:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4235, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:04:26', '1', 'guest', '2022-03-22 11:04:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4236, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:04:26', '1', 'guest', '2022-03-22 11:04:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4237, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:04:32', '1', 'guest', '2022-03-22 11:04:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4238, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:04:32', '1', 'guest', '2022-03-22 11:04:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4239, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:08:23', '1', 'guest', '2022-03-22 11:08:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4240, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:08:23', '1', 'guest', '2022-03-22 11:08:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4241, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:08:29', '1', 'guest', '2022-03-22 11:08:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4242, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:08:29', '1', 'guest', '2022-03-22 11:08:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4243, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:16:27', '1', 'guest', '2022-03-22 11:16:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4244, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:16:27', '1', 'guest', '2022-03-22 11:16:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4245, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:20:23', '1', 'guest', '2022-03-22 11:20:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4246, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:20:23', '1', 'guest', '2022-03-22 11:20:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4247, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:23:34', '1', 'guest', '2022-03-22 11:23:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4248, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:23:34', '1', 'guest', '2022-03-22 11:23:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4249, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:23:50', '1', 'guest', '2022-03-22 11:23:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4250, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:23:50', '1', 'guest', '2022-03-22 11:23:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4251, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:24:47', '1', 'guest', '2022-03-22 11:24:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4252, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:24:47', '1', 'guest', '2022-03-22 11:24:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4253, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:25:09', '1', 'admin', '2022-03-22 11:25:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4254, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:25:09', '1', 'admin', '2022-03-22 11:25:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4255, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:25:14', '1', 'admin', '2022-03-22 11:25:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4256, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:25:14', '1', 'admin', '2022-03-22 11:25:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4257, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 11:25:16', '1', 'admin', '2022-03-22 11:25:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4258, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 11:25:16', '1', 'admin', '2022-03-22 11:25:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4259, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 11:25:19', '1', 'admin', '2022-03-22 11:25:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4260, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 11:25:19', '1', 'admin', '2022-03-22 11:25:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4261, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:25:21', '1', 'admin', '2022-03-22 11:25:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4262, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:25:21', '1', 'admin', '2022-03-22 11:25:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4263, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 11:25:23', '1', 'admin', '2022-03-22 11:25:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4264, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 11:25:23', '1', 'admin', '2022-03-22 11:25:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 11:25:26', '1', 'admin', '2022-03-22 11:25:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4266, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 11:25:26', '1', 'admin', '2022-03-22 11:25:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4267, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:25:29', '1', 'admin', '2022-03-22 11:25:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4268, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:25:29', '1', 'admin', '2022-03-22 11:25:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4269, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 11:25:30', '1', 'admin', '2022-03-22 11:25:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4270, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 11:25:30', '1', 'admin', '2022-03-22 11:25:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4271, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 11:32:35', '1', 'admin', '2022-03-22 11:32:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 11:32:36', '1', 'admin', '2022-03-22 11:32:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4273, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 11:32:38', '1', 'admin', '2022-03-22 11:32:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 11:32:38', '1', 'admin', '2022-03-22 11:32:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 11:32:52', '1', 'admin', '2022-03-22 11:32:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 11:32:58', '1', 'admin', '2022-03-22 11:32:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4277, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:13:12', '1', 'admin', '2022-03-22 13:13:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4278, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:13:12', '1', 'admin', '2022-03-22 13:13:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:13:22', '1', 'admin', '2022-03-22 13:13:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4280, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:13:22', '1', 'admin', '2022-03-22 13:13:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:18:09', '1', 'admin', '2022-03-22 13:18:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:18:09', '1', 'admin', '2022-03-22 13:18:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:18:11', '1', 'admin', '2022-03-22 13:18:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4284, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:18:11', '1', 'admin', '2022-03-22 13:18:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4285, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:18:14', '1', 'admin', '2022-03-22 13:18:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4286, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:18:14', '1', 'admin', '2022-03-22 13:18:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4287, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:18:15', '1', 'admin', '2022-03-22 13:18:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4288, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:18:15', '1', 'admin', '2022-03-22 13:18:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:18:16', '1', 'admin', '2022-03-22 13:18:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:18:16', '1', 'admin', '2022-03-22 13:18:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4291, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:18:17', '1', 'admin', '2022-03-22 13:18:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4292, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:18:17', '1', 'admin', '2022-03-22 13:18:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4293, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:18:28', '1', 'admin', '2022-03-22 13:18:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4294, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:18:28', '1', 'admin', '2022-03-22 13:18:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4295, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:18:30', '1', 'admin', '2022-03-22 13:18:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4296, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:18:30', '1', 'admin', '2022-03-22 13:18:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4297, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:18:32', '1', 'admin', '2022-03-22 13:18:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4298, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:18:32', '1', 'admin', '2022-03-22 13:18:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4299, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:18:33', '1', 'admin', '2022-03-22 13:18:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4300, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:18:33', '1', 'admin', '2022-03-22 13:18:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4301, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:23:47', '1', 'admin', '2022-03-22 13:23:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4302, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:23:47', '1', 'admin', '2022-03-22 13:23:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4303, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:23:48', '1', 'admin', '2022-03-22 13:23:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4304, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:23:48', '1', 'admin', '2022-03-22 13:23:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4305, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:25:51', '1', 'admin', '2022-03-22 13:25:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4306, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:25:51', '1', 'admin', '2022-03-22 13:25:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4307, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:25:53', '1', 'admin', '2022-03-22 13:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4308, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:25:53', '1', 'admin', '2022-03-22 13:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4309, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:25:54', '1', 'admin', '2022-03-22 13:25:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:25:54', '1', 'admin', '2022-03-22 13:25:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4311, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:26:01', '1', 'admin', '2022-03-22 13:26:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4312, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:26:01', '1', 'admin', '2022-03-22 13:26:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4313, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:26:05', '1', 'admin', '2022-03-22 13:26:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:26:05', '1', 'admin', '2022-03-22 13:26:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4315, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:26:07', '1', 'admin', '2022-03-22 13:26:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:26:07', '1', 'admin', '2022-03-22 13:26:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4317, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:26:08', '1', 'admin', '2022-03-22 13:26:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4318, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:26:08', '1', 'admin', '2022-03-22 13:26:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 13:38:24', '1', 'admin', '2022-03-22 13:38:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 13:38:24', '1', 'admin', '2022-03-22 13:38:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4321, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:41:29', '1', 'admin', '2022-03-22 13:41:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4322, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:41:29', '1', 'admin', '2022-03-22 13:41:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:41:33', '1', 'admin', '2022-03-22 13:41:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4324, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:41:33', '1', 'admin', '2022-03-22 13:41:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4325, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:41:36', '1', 'admin', '2022-03-22 13:41:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4326, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:41:36', '1', 'admin', '2022-03-22 13:41:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4327, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:41:36', '1', 'admin', '2022-03-22 13:41:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4328, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:41:36', '1', 'admin', '2022-03-22 13:41:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4329, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:41:37', '1', 'admin', '2022-03-22 13:41:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4330, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:41:37', '1', 'admin', '2022-03-22 13:41:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4331, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:45:09', '1', 'admin', '2022-03-22 13:45:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4332, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:45:09', '1', 'admin', '2022-03-22 13:45:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4333, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:45:10', '1', 'admin', '2022-03-22 13:45:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4334, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:45:10', '1', 'admin', '2022-03-22 13:45:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:45:11', '1', 'admin', '2022-03-22 13:45:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4336, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:45:12', '1', 'admin', '2022-03-22 13:45:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4337, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:45:24', '1', 'admin', '2022-03-22 13:45:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4338, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:45:24', '1', 'admin', '2022-03-22 13:45:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4339, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:45:25', '1', 'admin', '2022-03-22 13:45:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:45:25', '1', 'admin', '2022-03-22 13:45:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:45:28', '1', 'admin', '2022-03-22 13:45:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4342, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:45:28', '1', 'admin', '2022-03-22 13:45:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4343, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 13:45:38', '1', 'admin', '2022-03-22 13:45:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4344, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 13:45:38', '1', 'admin', '2022-03-22 13:45:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4345, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:47:48', '1', 'admin', '2022-03-22 13:47:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:47:48', '1', 'admin', '2022-03-22 13:47:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:47:49', '1', 'admin', '2022-03-22 13:47:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4348, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:47:49', '1', 'admin', '2022-03-22 13:47:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4349, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:47:51', '1', 'admin', '2022-03-22 13:47:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:47:51', '1', 'admin', '2022-03-22 13:47:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:47:52', '1', 'admin', '2022-03-22 13:47:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4352, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:47:52', '1', 'admin', '2022-03-22 13:47:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4353, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:52:10', '1', 'admin', '2022-03-22 13:52:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:52:10', '1', 'admin', '2022-03-22 13:52:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4355, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:52:11', '1', 'admin', '2022-03-22 13:52:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4356, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:52:11', '1', 'admin', '2022-03-22 13:52:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4357, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:52:13', '1', 'admin', '2022-03-22 13:52:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:52:13', '1', 'admin', '2022-03-22 13:52:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4359, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:52:15', '1', 'admin', '2022-03-22 13:52:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4360, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:52:15', '1', 'admin', '2022-03-22 13:52:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4361, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:52:55', '1', 'admin', '2022-03-22 13:52:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:52:55', '1', 'admin', '2022-03-22 13:52:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:52:57', '1', 'admin', '2022-03-22 13:52:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4364, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:52:57', '1', 'admin', '2022-03-22 13:52:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4365, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:54:14', '1', 'admin', '2022-03-22 13:54:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4366, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:54:14', '1', 'admin', '2022-03-22 13:54:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4367, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:16', '1', 'admin', '2022-03-22 13:54:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4368, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:16', '1', 'admin', '2022-03-22 13:54:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4369, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:21', '1', 'admin', '2022-03-22 13:54:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4370, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:21', '1', 'admin', '2022-03-22 13:54:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:23', '1', 'admin', '2022-03-22 13:54:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4372, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:23', '1', 'admin', '2022-03-22 13:54:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4373, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:54:27', '1', 'admin', '2022-03-22 13:54:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:54:27', '1', 'admin', '2022-03-22 13:54:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:28', '1', 'admin', '2022-03-22 13:54:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4376, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:28', '1', 'admin', '2022-03-22 13:54:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:30', '1', 'admin', '2022-03-22 13:54:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4378, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:30', '1', 'admin', '2022-03-22 13:54:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4379, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:38', '1', 'admin', '2022-03-22 13:54:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4380, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:38', '1', 'admin', '2022-03-22 13:54:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:39', '1', 'admin', '2022-03-22 13:54:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4382, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:39', '1', 'admin', '2022-03-22 13:54:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:40', '1', 'admin', '2022-03-22 13:54:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4384, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:40', '1', 'admin', '2022-03-22 13:54:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:42', '1', 'admin', '2022-03-22 13:54:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4386, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:42', '1', 'admin', '2022-03-22 13:54:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4387, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:43', '1', 'admin', '2022-03-22 13:54:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4388, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:43', '1', 'admin', '2022-03-22 13:54:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4389, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:44', '1', 'admin', '2022-03-22 13:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4390, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:44', '1', 'admin', '2022-03-22 13:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4391, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:45', '1', 'admin', '2022-03-22 13:54:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4392, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:45', '1', 'admin', '2022-03-22 13:54:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4393, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:54:47', '1', 'admin', '2022-03-22 13:54:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4394, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:54:47', '1', 'admin', '2022-03-22 13:54:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4395, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:48', '1', 'admin', '2022-03-22 13:54:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4396, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:48', '1', 'admin', '2022-03-22 13:54:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4397, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:50', '1', 'admin', '2022-03-22 13:54:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4398, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:50', '1', 'admin', '2022-03-22 13:54:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4399, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:51', '1', 'admin', '2022-03-22 13:54:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4400, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:51', '1', 'admin', '2022-03-22 13:54:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4401, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:52', '1', 'admin', '2022-03-22 13:54:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4402, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:52', '1', 'admin', '2022-03-22 13:54:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4403, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 13:54:53', '1', 'admin', '2022-03-22 13:54:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4404, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 13:54:53', '1', 'admin', '2022-03-22 13:54:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4405, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:54:54', '1', 'admin', '2022-03-22 13:54:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4406, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:54:54', '1', 'admin', '2022-03-22 13:54:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4407, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 13:55:37', '1', 'admin', '2022-03-22 13:55:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4408, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 13:55:37', '1', 'admin', '2022-03-22 13:55:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4409, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 14:25:53', '1', 'admin', '2022-03-22 14:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4410, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 14:25:53', '1', 'admin', '2022-03-22 14:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4411, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:25:54', '1', 'admin', '2022-03-22 14:25:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4412, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:25:54', '1', 'admin', '2022-03-22 14:25:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4413, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 14:32:07', '1', 'admin', '2022-03-22 14:32:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4414, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 14:32:07', '1', 'admin', '2022-03-22 14:32:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4415, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:32:08', '1', 'admin', '2022-03-22 14:32:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4416, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:32:08', '1', 'admin', '2022-03-22 14:32:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4417, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 14:32:10', '1', 'admin', '2022-03-22 14:32:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4418, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 14:32:10', '1', 'admin', '2022-03-22 14:32:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4419, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:37:10', '1', 'admin', '2022-03-22 14:37:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4420, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:37:10', '1', 'admin', '2022-03-22 14:37:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4421, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:37:11', '1', 'admin', '2022-03-22 14:37:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4422, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:37:12', '1', 'admin', '2022-03-22 14:37:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4423, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:37:13', '1', 'admin', '2022-03-22 14:37:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4424, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:37:13', '1', 'admin', '2022-03-22 14:37:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4425, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 14:37:23', '1', 'admin', '2022-03-22 14:37:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4426, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 14:37:23', '1', 'admin', '2022-03-22 14:37:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4427, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:37:24', '1', 'admin', '2022-03-22 14:37:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4428, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:37:24', '1', 'admin', '2022-03-22 14:37:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4429, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:37:26', '1', 'admin', '2022-03-22 14:37:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4430, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:37:26', '1', 'admin', '2022-03-22 14:37:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4431, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 14:49:19', '1', 'admin', '2022-03-22 14:49:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4432, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 14:49:19', '1', 'admin', '2022-03-22 14:49:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4433, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:49:21', '1', 'admin', '2022-03-22 14:49:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4434, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:49:21', '1', 'admin', '2022-03-22 14:49:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4435, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:49:23', '1', 'admin', '2022-03-22 14:49:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4436, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:49:23', '1', 'admin', '2022-03-22 14:49:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4437, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:49:30', '1', 'admin', '2022-03-22 14:49:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4438, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:49:30', '1', 'admin', '2022-03-22 14:49:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4439, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 14:50:00', '1', 'admin', '2022-03-22 14:50:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4440, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 14:50:00', '1', 'admin', '2022-03-22 14:50:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4441, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:50:09', '1', 'admin', '2022-03-22 14:50:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4442, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:50:09', '1', 'admin', '2022-03-22 14:50:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4443, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 14:50:15', '1', 'admin', '2022-03-22 14:50:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4444, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 14:50:15', '1', 'admin', '2022-03-22 14:50:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4445, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 14:52:25', '1', 'admin', '2022-03-22 14:52:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4446, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 14:52:25', '1', 'admin', '2022-03-22 14:52:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4447, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:52:26', '1', 'admin', '2022-03-22 14:52:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4448, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:52:26', '1', 'admin', '2022-03-22 14:52:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4449, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:52:28', '1', 'admin', '2022-03-22 14:52:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4450, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:52:28', '1', 'admin', '2022-03-22 14:52:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4451, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:52:29', '1', 'admin', '2022-03-22 14:52:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4452, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:52:29', '1', 'admin', '2022-03-22 14:52:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4453, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:52:31', '1', 'admin', '2022-03-22 14:52:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4454, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:52:31', '1', 'admin', '2022-03-22 14:52:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4455, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:53:11', '1', 'admin', '2022-03-22 14:53:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4456, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:53:11', '1', 'admin', '2022-03-22 14:53:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4457, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:53:12', '1', 'admin', '2022-03-22 14:53:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4458, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:53:12', '1', 'admin', '2022-03-22 14:53:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4459, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:53:14', '1', 'admin', '2022-03-22 14:53:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4460, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:53:14', '1', 'admin', '2022-03-22 14:53:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4461, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:53:15', '1', 'admin', '2022-03-22 14:53:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4462, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:53:15', '1', 'admin', '2022-03-22 14:53:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4463, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:53:17', '1', 'admin', '2022-03-22 14:53:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4464, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:53:17', '1', 'admin', '2022-03-22 14:53:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4465, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 14:57:04', '1', 'admin', '2022-03-22 14:57:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4466, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 14:57:04', '1', 'admin', '2022-03-22 14:57:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4467, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:57:05', '1', 'admin', '2022-03-22 14:57:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4468, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:57:05', '1', 'admin', '2022-03-22 14:57:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4469, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:57:08', '1', 'admin', '2022-03-22 14:57:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4470, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:57:08', '1', 'admin', '2022-03-22 14:57:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4471, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:57:09', '1', 'admin', '2022-03-22 14:57:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4472, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:57:09', '1', 'admin', '2022-03-22 14:57:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4473, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:57:10', '1', 'admin', '2022-03-22 14:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4474, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:57:10', '1', 'admin', '2022-03-22 14:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4475, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:57:12', '1', 'admin', '2022-03-22 14:57:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4476, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:57:12', '1', 'admin', '2022-03-22 14:57:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4477, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 14:57:14', '1', 'admin', '2022-03-22 14:57:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4478, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 14:57:14', '1', 'admin', '2022-03-22 14:57:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4479, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:40:53', '1', 'admin', '2022-03-22 15:40:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4480, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:40:53', '1', 'admin', '2022-03-22 15:40:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4481, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 15:40:54', '1', 'admin', '2022-03-22 15:40:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4482, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 15:40:54', '1', 'admin', '2022-03-22 15:40:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4483, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 15:40:57', '1', 'admin', '2022-03-22 15:40:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4484, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 15:40:57', '1', 'admin', '2022-03-22 15:40:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4485, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:42:08', '1', 'admin', '2022-03-22 15:42:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4486, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:42:08', '1', 'admin', '2022-03-22 15:42:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4487, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:42:12', '1', 'admin', '2022-03-22 15:42:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4488, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:42:12', '1', 'admin', '2022-03-22 15:42:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4489, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:42:13', '1', 'admin', '2022-03-22 15:42:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4490, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:42:13', '1', 'admin', '2022-03-22 15:42:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4491, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:42:13', '1', 'admin', '2022-03-22 15:42:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4492, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:42:13', '1', 'admin', '2022-03-22 15:42:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4493, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:42:14', '1', 'admin', '2022-03-22 15:42:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4494, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:42:14', '1', 'admin', '2022-03-22 15:42:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4495, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 15:42:19', '1', 'admin', '2022-03-22 15:42:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4496, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 15:42:19', '1', 'admin', '2022-03-22 15:42:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4497, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:44:47', '1', 'admin', '2022-03-22 15:44:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4498, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:44:47', '1', 'admin', '2022-03-22 15:44:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4499, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:44:49', '1', 'admin', '2022-03-22 15:44:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4500, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:44:50', '1', 'admin', '2022-03-22 15:44:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4501, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 15:44:50', '1', 'admin', '2022-03-22 15:44:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4502, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 15:44:50', '1', 'admin', '2022-03-22 15:44:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4503, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 15:44:52', '1', 'admin', '2022-03-22 15:44:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4504, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 15:44:52', '1', 'admin', '2022-03-22 15:44:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4505, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 15:44:54', '1', 'admin', '2022-03-22 15:44:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4506, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 15:44:54', '1', 'admin', '2022-03-22 15:44:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4507, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 15:44:56', '1', 'admin', '2022-03-22 15:44:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4508, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 15:44:56', '1', 'admin', '2022-03-22 15:44:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4509, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 15:44:57', '1', 'admin', '2022-03-22 15:44:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4510, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 15:44:57', '1', 'admin', '2022-03-22 15:44:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4511, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:01:32', '1', 'admin', '2022-03-22 16:01:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4512, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:01:33', '1', 'admin', '2022-03-22 16:01:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4513, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:01:34', '1', 'admin', '2022-03-22 16:01:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4514, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:01:34', '1', 'admin', '2022-03-22 16:01:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4515, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:01:37', '1', 'admin', '2022-03-22 16:01:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4516, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:01:37', '1', 'admin', '2022-03-22 16:01:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4517, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:03:03', '1', 'admin', '2022-03-22 16:03:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4518, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:03:04', '1', 'admin', '2022-03-22 16:03:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4519, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:03:05', '1', 'admin', '2022-03-22 16:03:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4520, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:03:05', '1', 'admin', '2022-03-22 16:03:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4521, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:03:07', '1', 'admin', '2022-03-22 16:03:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4522, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:03:07', '1', 'admin', '2022-03-22 16:03:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4523, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:03:09', '1', 'admin', '2022-03-22 16:03:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4524, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:03:09', '1', 'admin', '2022-03-22 16:03:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4525, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:03:10', '1', 'admin', '2022-03-22 16:03:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4526, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:03:10', '1', 'admin', '2022-03-22 16:03:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4527, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:03:11', '1', 'admin', '2022-03-22 16:03:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4528, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:03:11', '1', 'admin', '2022-03-22 16:03:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4529, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:03:32', '1', 'admin', '2022-03-22 16:03:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4530, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:03:32', '1', 'admin', '2022-03-22 16:03:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4531, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 16:16:50', '1', 'admin', '2022-03-22 16:16:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4532, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 16:16:50', '1', 'admin', '2022-03-22 16:16:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4533, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:18:06', '1', 'admin', '2022-03-22 16:18:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4534, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:18:06', '1', 'admin', '2022-03-22 16:18:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4535, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:18:08', '1', 'admin', '2022-03-22 16:18:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4536, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:18:08', '1', 'admin', '2022-03-22 16:18:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4537, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:20:29', '1', 'admin', '2022-03-22 16:20:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4538, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:20:29', '1', 'admin', '2022-03-22 16:20:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4539, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:20:30', '1', 'admin', '2022-03-22 16:20:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4540, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:20:30', '1', 'admin', '2022-03-22 16:20:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4541, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:20:31', '1', 'admin', '2022-03-22 16:20:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4542, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:20:31', '1', 'admin', '2022-03-22 16:20:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4543, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:21:12', '1', 'admin', '2022-03-22 16:21:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4544, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:21:12', '1', 'admin', '2022-03-22 16:21:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4545, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:21:56', '1', 'guest', '2022-03-22 16:21:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4546, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:21:57', '1', 'guest', '2022-03-22 16:21:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4547, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:22:17', '1', 'admin', '2022-03-22 16:22:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4548, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:22:17', '1', 'admin', '2022-03-22 16:22:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4549, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:22:19', '1', 'admin', '2022-03-22 16:22:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4550, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:22:19', '1', 'admin', '2022-03-22 16:22:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4551, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:22:47', '1', 'admin', '2022-03-22 16:22:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4552, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:22:47', '1', 'admin', '2022-03-22 16:22:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4553, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:23:53', '1', 'admin', '2022-03-22 16:23:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4554, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:23:53', '1', 'admin', '2022-03-22 16:23:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4555, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:23:56', '1', 'admin', '2022-03-22 16:23:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4556, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:23:56', '1', 'admin', '2022-03-22 16:23:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4557, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:24:23', '1', 'admin', '2022-03-22 16:24:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4558, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:24:23', '1', 'admin', '2022-03-22 16:24:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4559, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:25:52', '1', 'admin', '2022-03-22 16:25:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4560, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:25:52', '1', 'admin', '2022-03-22 16:25:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4561, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:25:53', '1', 'admin', '2022-03-22 16:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4562, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:25:53', '1', 'admin', '2022-03-22 16:25:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4563, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:26:18', '1', 'admin', '2022-03-22 16:26:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4564, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:26:18', '1', 'admin', '2022-03-22 16:26:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4565, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-22 16:26:58', '1', 'admin', '2022-03-22 16:26:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4566, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-22 16:26:58', '1', 'admin', '2022-03-22 16:26:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4567, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:27:00', '1', 'admin', '2022-03-22 16:27:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4568, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:27:00', '1', 'admin', '2022-03-22 16:27:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4569, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:27:01', '1', 'admin', '2022-03-22 16:27:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4570, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:27:01', '1', 'admin', '2022-03-22 16:27:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4571, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:27:35', '1', 'admin', '2022-03-22 16:27:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4572, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:27:35', '1', 'admin', '2022-03-22 16:27:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4573, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:29:07', '1', 'admin', '2022-03-22 16:29:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4574, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:29:07', '1', 'admin', '2022-03-22 16:29:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4575, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:29:10', '1', 'admin', '2022-03-22 16:29:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4576, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:29:10', '1', 'admin', '2022-03-22 16:29:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4577, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:29:11', '1', 'admin', '2022-03-22 16:29:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4578, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:29:11', '1', 'admin', '2022-03-22 16:29:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4579, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:29:14', '1', 'admin', '2022-03-22 16:29:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4580, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:29:14', '1', 'admin', '2022-03-22 16:29:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4581, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:31:41', '1', 'admin', '2022-03-22 16:31:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4582, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:31:41', '1', 'admin', '2022-03-22 16:31:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4583, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:37:56', '1', 'admin', '2022-03-22 16:37:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4584, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:37:56', '1', 'admin', '2022-03-22 16:37:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4585, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:37:59', '1', 'admin', '2022-03-22 16:37:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4586, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:37:59', '1', 'admin', '2022-03-22 16:37:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4587, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:38:02', '1', 'admin', '2022-03-22 16:38:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4588, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:38:02', '1', 'admin', '2022-03-22 16:38:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4589, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:38:03', '1', 'admin', '2022-03-22 16:38:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4590, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:38:03', '1', 'admin', '2022-03-22 16:38:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4591, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:38:05', '1', 'admin', '2022-03-22 16:38:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4592, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:38:05', '1', 'admin', '2022-03-22 16:38:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4593, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:38:23', '1', 'admin', '2022-03-22 16:38:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4594, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:38:23', '1', 'admin', '2022-03-22 16:38:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4595, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:47:55', '1', 'admin', '2022-03-22 16:47:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4596, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:47:55', '1', 'admin', '2022-03-22 16:47:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4597, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:47:56', '1', 'admin', '2022-03-22 16:47:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4598, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:47:56', '1', 'admin', '2022-03-22 16:47:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4599, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 16:48:41', '1', 'admin', '2022-03-22 16:48:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4600, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 16:48:41', '1', 'admin', '2022-03-22 16:48:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4601, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 16:59:34', '1', 'guest', '2022-03-22 16:59:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4602, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 16:59:34', '1', 'guest', '2022-03-22 16:59:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4603, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 17:00:04', '1', 'admin', '2022-03-22 17:00:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4604, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 17:00:04', '1', 'admin', '2022-03-22 17:00:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4605, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 17:00:06', '1', 'admin', '2022-03-22 17:00:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4606, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 17:00:06', '1', 'admin', '2022-03-22 17:00:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4607, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 17:00:08', '1', 'admin', '2022-03-22 17:00:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4608, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 17:00:08', '1', 'admin', '2022-03-22 17:00:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4609, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 17:01:17', '1', 'admin', '2022-03-22 17:01:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4610, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 17:01:17', '1', 'admin', '2022-03-22 17:01:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4611, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-22 17:10:25', '1', 'admin', '2022-03-22 17:10:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4612, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-22 17:10:26', '1', 'admin', '2022-03-22 17:10:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4613, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-22 17:10:27', '1', 'admin', '2022-03-22 17:10:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4614, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-22 17:10:27', '1', 'admin', '2022-03-22 17:10:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4615, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-23 21:10:44', '1', 'admin', '2022-03-23 21:10:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4616, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-23 21:10:44', '1', 'admin', '2022-03-23 21:10:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4617, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-23 21:10:46', '1', 'admin', '2022-03-23 21:10:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4618, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-23 21:10:46', '1', 'admin', '2022-03-23 21:10:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4619, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-23 21:10:48', '1', 'admin', '2022-03-23 21:10:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4620, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-23 21:10:48', '1', 'admin', '2022-03-23 21:10:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4621, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-23 21:11:23', '1', 'admin', '2022-03-23 21:11:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4622, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-23 21:11:24', '1', 'admin', '2022-03-23 21:11:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4623, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-23 21:13:38', '1', 'admin', '2022-03-23 21:13:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4624, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-23 21:13:38', '1', 'admin', '2022-03-23 21:13:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4625, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-23 21:14:53', '1', 'admin', '2022-03-23 21:14:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4626, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-23 21:27:52', '1', 'admin', '2022-03-23 21:27:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4627, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-23 21:27:52', '1', 'admin', '2022-03-23 21:27:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4628, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-23 21:27:54', '1', 'admin', '2022-03-23 21:27:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4629, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-23 21:27:54', '1', 'admin', '2022-03-23 21:27:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4630, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-23 21:27:54', '1', 'admin', '2022-03-23 21:27:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4631, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-23 21:27:54', '1', 'admin', '2022-03-23 21:27:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4632, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-23 21:27:59', '1', 'admin', '2022-03-23 21:27:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-23 21:36:04', '1', 'admin', '2022-03-23 21:36:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-23 21:36:04', '1', 'admin', '2022-03-23 21:36:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-23 21:36:08', '1', 'admin', '2022-03-23 21:36:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4636, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-23 21:36:08', '1', 'admin', '2022-03-23 21:36:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4637, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-23 21:36:21', '1', 'admin', '2022-03-23 21:36:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4638, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 16:47:57', '1', 'admin', '2022-03-24 16:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4639, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 16:47:57', '1', 'admin', '2022-03-24 16:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4640, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 16:47:58', '1', 'admin', '2022-03-24 16:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4641, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 16:47:58', '1', 'admin', '2022-03-24 16:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4642, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 16:48:03', '1', 'admin', '2022-03-24 16:48:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 16:49:23', '1', 'admin', '2022-03-24 16:49:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 16:49:23', '1', 'admin', '2022-03-24 16:49:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 16:49:24', '1', 'admin', '2022-03-24 16:49:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4646, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 16:49:24', '1', 'admin', '2022-03-24 16:49:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4647, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 16:49:28', '1', 'admin', '2022-03-24 16:49:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4648, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 16:56:14', '1', 'admin', '2022-03-24 16:56:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 16:56:15', '1', 'admin', '2022-03-24 16:56:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4650, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 16:56:17', '1', 'admin', '2022-03-24 16:56:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4651, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 16:56:17', '1', 'admin', '2022-03-24 16:56:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4652, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 16:56:21', '1', 'admin', '2022-03-24 16:56:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:02:24', '1', 'admin', '2022-03-24 17:02:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:02:24', '1', 'admin', '2022-03-24 17:02:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4655, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 17:02:25', '1', 'admin', '2022-03-24 17:02:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4656, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 17:02:25', '1', 'admin', '2022-03-24 17:02:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4657, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 17:02:30', '1', 'admin', '2022-03-24 17:02:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:04:41', '1', 'admin', '2022-03-24 17:04:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:04:42', '1', 'admin', '2022-03-24 17:04:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4660, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 17:04:44', '1', 'admin', '2022-03-24 17:04:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4661, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 17:04:44', '1', 'admin', '2022-03-24 17:04:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4662, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 17:04:47', '1', 'admin', '2022-03-24 17:04:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:05:12', '1', 'admin', '2022-03-24 17:05:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4664, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:05:12', '1', 'admin', '2022-03-24 17:05:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4665, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 17:05:13', '1', 'admin', '2022-03-24 17:05:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4666, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 17:05:14', '1', 'admin', '2022-03-24 17:05:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4667, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 17:05:20', '1', 'admin', '2022-03-24 17:05:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4668, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:07:12', '1', 'guest', '2022-03-24 17:07:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4669, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:07:12', '1', 'guest', '2022-03-24 17:07:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4670, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:07:33', '1', 'admin', '2022-03-24 17:07:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4671, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:07:33', '1', 'admin', '2022-03-24 17:07:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4672, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 17:07:34', '1', 'admin', '2022-03-24 17:07:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4673, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 17:07:34', '1', 'admin', '2022-03-24 17:07:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4674, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 17:07:39', '1', 'admin', '2022-03-24 17:07:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4675, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:09:54', '1', 'admin', '2022-03-24 17:09:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4676, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:09:54', '1', 'admin', '2022-03-24 17:09:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4677, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 17:09:55', '1', 'admin', '2022-03-24 17:09:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4678, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 17:09:55', '1', 'admin', '2022-03-24 17:09:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4679, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 17:10:06', '1', 'admin', '2022-03-24 17:10:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4680, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:11:16', '1', 'admin', '2022-03-24 17:11:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4681, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:11:16', '1', 'admin', '2022-03-24 17:11:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4682, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 17:11:17', '1', 'admin', '2022-03-24 17:11:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4683, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 17:11:17', '1', 'admin', '2022-03-24 17:11:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4684, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 17:11:21', '1', 'admin', '2022-03-24 17:11:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4685, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 17:12:03', '1', 'admin', '2022-03-24 17:12:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4686, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 17:12:04', '1', 'admin', '2022-03-24 17:12:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4687, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 17:12:05', '1', 'admin', '2022-03-24 17:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4688, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 17:12:05', '1', 'admin', '2022-03-24 17:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4689, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 17:12:08', '1', 'admin', '2022-03-24 17:12:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4690, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 19:30:01', '1', 'admin', '2022-03-24 19:30:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4691, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 19:30:02', '1', 'admin', '2022-03-24 19:30:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4692, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 19:30:03', '1', 'admin', '2022-03-24 19:30:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4693, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 19:30:03', '1', 'admin', '2022-03-24 19:30:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4694, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 19:30:06', '1', 'admin', '2022-03-24 19:30:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4695, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 19:31:49', '1', 'admin', '2022-03-24 19:31:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4696, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 19:31:49', '1', 'admin', '2022-03-24 19:31:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4697, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 19:31:51', '1', 'admin', '2022-03-24 19:31:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4698, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 19:31:51', '1', 'admin', '2022-03-24 19:31:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4699, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 19:31:55', '1', 'admin', '2022-03-24 19:31:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4700, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 19:37:47', '1', 'guest', '2022-03-24 19:37:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4701, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 19:37:48', '1', 'guest', '2022-03-24 19:37:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4702, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 19:38:13', '1', 'admin', '2022-03-24 19:38:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4703, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 19:38:13', '1', 'admin', '2022-03-24 19:38:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 19:38:14', '1', 'admin', '2022-03-24 19:38:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4705, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 19:38:14', '1', 'admin', '2022-03-24 19:38:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4706, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 19:38:17', '1', 'admin', '2022-03-24 19:38:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 19:39:09', '1', 'admin', '2022-03-24 19:39:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 19:39:10', '1', 'admin', '2022-03-24 19:39:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4709, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 19:39:12', '1', 'admin', '2022-03-24 19:39:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4710, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 19:39:12', '1', 'admin', '2022-03-24 19:39:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4711, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 19:39:16', '1', 'admin', '2022-03-24 19:39:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4712, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 19:39:59', '1', 'admin', '2022-03-24 19:39:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4713, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 19:39:59', '1', 'admin', '2022-03-24 19:39:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4714, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-24 19:42:30', '1', 'admin', '2022-03-24 19:42:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4715, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-24 19:42:30', '1', 'admin', '2022-03-24 19:42:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4716, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-24 19:42:33', '1', 'admin', '2022-03-24 19:42:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4717, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-24 19:42:33', '1', 'admin', '2022-03-24 19:42:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4718, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-24 19:42:36', '1', 'admin', '2022-03-24 19:42:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4719, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-25 17:50:56', '1', 'admin', '2022-03-25 17:50:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4720, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-25 17:50:56', '1', 'admin', '2022-03-25 17:50:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4721, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-25 17:50:58', '1', 'admin', '2022-03-25 17:50:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4722, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-25 17:50:58', '1', 'admin', '2022-03-25 17:50:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4723, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-25 17:51:02', '1', 'admin', '2022-03-25 17:51:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4724, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 15:39:31', '1', 'guest', '2022-03-28 15:39:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4725, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 15:39:32', '1', 'guest', '2022-03-28 15:39:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4726, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 15:39:47', '1', 'admin', '2022-03-28 15:39:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4727, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 15:39:47', '1', 'admin', '2022-03-28 15:39:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4728, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 15:39:48', '1', 'admin', '2022-03-28 15:39:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4729, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 15:39:48', '1', 'admin', '2022-03-28 15:39:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4730, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 15:39:52', '1', 'admin', '2022-03-28 15:39:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 15:42:10', '1', 'admin', '2022-03-28 15:42:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4732, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 15:42:11', '1', 'admin', '2022-03-28 15:42:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 15:42:12', '1', 'admin', '2022-03-28 15:42:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4734, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 15:42:12', '1', 'admin', '2022-03-28 15:42:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4735, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 15:42:15', '1', 'admin', '2022-03-28 15:42:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (4736, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 15:44:56', '1', 'admin', '2022-03-28 15:44:56', '记录日志');
INSERT INTO `sys_log` VALUES (4737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 15:44:56', '1', 'admin', '2022-03-28 15:44:56', '记录日志');
INSERT INTO `sys_log` VALUES (4738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 15:44:57', '1', 'admin', '2022-03-28 15:44:57', '记录日志');
INSERT INTO `sys_log` VALUES (4739, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 15:44:57', '1', 'admin', '2022-03-28 15:44:57', '记录日志');
INSERT INTO `sys_log` VALUES (4740, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 15:45:01', '1', 'admin', '2022-03-28 15:45:01', '记录日志');
INSERT INTO `sys_log` VALUES (4741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 15:48:58', '1', 'admin', '2022-03-28 15:48:58', '记录日志');
INSERT INTO `sys_log` VALUES (4742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 15:48:58', '1', 'admin', '2022-03-28 15:48:58', '记录日志');
INSERT INTO `sys_log` VALUES (4743, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 15:49:15', '1', 'admin', '2022-03-28 15:49:15', '记录日志');
INSERT INTO `sys_log` VALUES (4744, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 15:49:16', '1', 'admin', '2022-03-28 15:49:16', '记录日志');
INSERT INTO `sys_log` VALUES (4745, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 15:49:19', '1', 'admin', '2022-03-28 15:49:19', '记录日志');
INSERT INTO `sys_log` VALUES (4746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 15:50:03', '1', 'admin', '2022-03-28 15:50:03', '记录日志');
INSERT INTO `sys_log` VALUES (4747, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 15:50:03', '1', 'admin', '2022-03-28 15:50:03', '记录日志');
INSERT INTO `sys_log` VALUES (4748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 15:50:05', '1', 'admin', '2022-03-28 15:50:05', '记录日志');
INSERT INTO `sys_log` VALUES (4749, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 15:50:05', '1', 'admin', '2022-03-28 15:50:05', '记录日志');
INSERT INTO `sys_log` VALUES (4750, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 15:50:08', '1', 'admin', '2022-03-28 15:50:08', '记录日志');
INSERT INTO `sys_log` VALUES (4751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:04:56', '1', 'admin', '2022-03-28 16:04:56', '记录日志');
INSERT INTO `sys_log` VALUES (4752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:04:56', '1', 'admin', '2022-03-28 16:04:56', '记录日志');
INSERT INTO `sys_log` VALUES (4753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:10:17', '1', 'admin', '2022-03-28 16:10:17', '记录日志');
INSERT INTO `sys_log` VALUES (4754, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:10:17', '1', 'admin', '2022-03-28 16:10:17', '记录日志');
INSERT INTO `sys_log` VALUES (4755, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:10:23', '1', 'admin', '2022-03-28 16:10:23', '记录日志');
INSERT INTO `sys_log` VALUES (4756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:13:41', '1', 'admin', '2022-03-28 16:13:41', '记录日志');
INSERT INTO `sys_log` VALUES (4757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:13:41', '1', 'admin', '2022-03-28 16:13:41', '记录日志');
INSERT INTO `sys_log` VALUES (4758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:13:43', '1', 'admin', '2022-03-28 16:13:43', '记录日志');
INSERT INTO `sys_log` VALUES (4759, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:13:43', '1', 'admin', '2022-03-28 16:13:43', '记录日志');
INSERT INTO `sys_log` VALUES (4760, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:13:46', '1', 'admin', '2022-03-28 16:13:46', '记录日志');
INSERT INTO `sys_log` VALUES (4761, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:17:09', '1', 'admin', '2022-03-28 16:17:09', '记录日志');
INSERT INTO `sys_log` VALUES (4762, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:17:09', '1', 'admin', '2022-03-28 16:17:09', '记录日志');
INSERT INTO `sys_log` VALUES (4763, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:17:11', '1', 'admin', '2022-03-28 16:17:11', '记录日志');
INSERT INTO `sys_log` VALUES (4764, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:17:11', '1', 'admin', '2022-03-28 16:17:11', '记录日志');
INSERT INTO `sys_log` VALUES (4765, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:17:14', '1', 'admin', '2022-03-28 16:17:14', '记录日志');
INSERT INTO `sys_log` VALUES (4766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:17:37', '1', 'admin', '2022-03-28 16:17:37', '记录日志');
INSERT INTO `sys_log` VALUES (4767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:17:37', '1', 'admin', '2022-03-28 16:17:37', '记录日志');
INSERT INTO `sys_log` VALUES (4768, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:17:39', '1', 'admin', '2022-03-28 16:17:39', '记录日志');
INSERT INTO `sys_log` VALUES (4769, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:17:39', '1', 'admin', '2022-03-28 16:17:39', '记录日志');
INSERT INTO `sys_log` VALUES (4770, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:17:42', '1', 'admin', '2022-03-28 16:17:42', '记录日志');
INSERT INTO `sys_log` VALUES (4771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:18:51', '1', 'admin', '2022-03-28 16:18:51', '记录日志');
INSERT INTO `sys_log` VALUES (4772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:18:51', '1', 'admin', '2022-03-28 16:18:51', '记录日志');
INSERT INTO `sys_log` VALUES (4773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:18:53', '1', 'admin', '2022-03-28 16:18:53', '记录日志');
INSERT INTO `sys_log` VALUES (4774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:18:53', '1', 'admin', '2022-03-28 16:18:53', '记录日志');
INSERT INTO `sys_log` VALUES (4775, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:18:54', '1', 'admin', '2022-03-28 16:18:54', '记录日志');
INSERT INTO `sys_log` VALUES (4776, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:18:54', '1', 'admin', '2022-03-28 16:18:54', '记录日志');
INSERT INTO `sys_log` VALUES (4777, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:18:56', '1', 'admin', '2022-03-28 16:18:56', '记录日志');
INSERT INTO `sys_log` VALUES (4778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:20:25', '1', 'admin', '2022-03-28 16:20:25', '记录日志');
INSERT INTO `sys_log` VALUES (4779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:20:25', '1', 'admin', '2022-03-28 16:20:25', '记录日志');
INSERT INTO `sys_log` VALUES (4780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:20:26', '1', 'admin', '2022-03-28 16:20:26', '记录日志');
INSERT INTO `sys_log` VALUES (4781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:20:26', '1', 'admin', '2022-03-28 16:20:26', '记录日志');
INSERT INTO `sys_log` VALUES (4782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:20:27', '1', 'admin', '2022-03-28 16:20:27', '记录日志');
INSERT INTO `sys_log` VALUES (4783, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:20:27', '1', 'admin', '2022-03-28 16:20:27', '记录日志');
INSERT INTO `sys_log` VALUES (4784, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:20:30', '1', 'admin', '2022-03-28 16:20:30', '记录日志');
INSERT INTO `sys_log` VALUES (4785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:21:05', '1', 'admin', '2022-03-28 16:21:05', '记录日志');
INSERT INTO `sys_log` VALUES (4786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:21:05', '1', 'admin', '2022-03-28 16:21:05', '记录日志');
INSERT INTO `sys_log` VALUES (4787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:21:06', '1', 'admin', '2022-03-28 16:21:06', '记录日志');
INSERT INTO `sys_log` VALUES (4788, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:21:06', '1', 'admin', '2022-03-28 16:21:06', '记录日志');
INSERT INTO `sys_log` VALUES (4789, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:21:09', '1', 'admin', '2022-03-28 16:21:09', '记录日志');
INSERT INTO `sys_log` VALUES (4790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:21:38', '1', 'admin', '2022-03-28 16:21:38', '记录日志');
INSERT INTO `sys_log` VALUES (4791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:21:38', '1', 'admin', '2022-03-28 16:21:38', '记录日志');
INSERT INTO `sys_log` VALUES (4792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:21:39', '1', 'admin', '2022-03-28 16:21:39', '记录日志');
INSERT INTO `sys_log` VALUES (4793, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:21:39', '1', 'admin', '2022-03-28 16:21:39', '记录日志');
INSERT INTO `sys_log` VALUES (4794, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:21:42', '1', 'admin', '2022-03-28 16:21:42', '记录日志');
INSERT INTO `sys_log` VALUES (4795, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:21:55', '1', 'admin', '2022-03-28 16:21:55', '记录日志');
INSERT INTO `sys_log` VALUES (4796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:21:57', '1', 'admin', '2022-03-28 16:21:57', '记录日志');
INSERT INTO `sys_log` VALUES (4797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:21:57', '1', 'admin', '2022-03-28 16:21:57', '记录日志');
INSERT INTO `sys_log` VALUES (4798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:21:58', '1', 'admin', '2022-03-28 16:21:58', '记录日志');
INSERT INTO `sys_log` VALUES (4799, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:21:58', '1', 'admin', '2022-03-28 16:21:58', '记录日志');
INSERT INTO `sys_log` VALUES (4800, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:22:01', '1', 'admin', '2022-03-28 16:22:01', '记录日志');
INSERT INTO `sys_log` VALUES (4801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:23:25', '1', 'admin', '2022-03-28 16:23:25', '记录日志');
INSERT INTO `sys_log` VALUES (4802, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:23:25', '1', 'admin', '2022-03-28 16:23:25', '记录日志');
INSERT INTO `sys_log` VALUES (4803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:23:26', '1', 'admin', '2022-03-28 16:23:26', '记录日志');
INSERT INTO `sys_log` VALUES (4804, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:23:26', '1', 'admin', '2022-03-28 16:23:26', '记录日志');
INSERT INTO `sys_log` VALUES (4805, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:23:29', '1', 'admin', '2022-03-28 16:23:29', '记录日志');
INSERT INTO `sys_log` VALUES (4806, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:23:53', '1', 'admin', '2022-03-28 16:23:53', '记录日志');
INSERT INTO `sys_log` VALUES (4807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:23:53', '1', 'admin', '2022-03-28 16:23:53', '记录日志');
INSERT INTO `sys_log` VALUES (4808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:23:56', '1', 'admin', '2022-03-28 16:23:56', '记录日志');
INSERT INTO `sys_log` VALUES (4809, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:23:56', '1', 'admin', '2022-03-28 16:23:56', '记录日志');
INSERT INTO `sys_log` VALUES (4810, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:23:58', '1', 'admin', '2022-03-28 16:23:58', '记录日志');
INSERT INTO `sys_log` VALUES (4811, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:25:42', '1', 'admin', '2022-03-28 16:25:42', '记录日志');
INSERT INTO `sys_log` VALUES (4812, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:25:42', '1', 'admin', '2022-03-28 16:25:42', '记录日志');
INSERT INTO `sys_log` VALUES (4813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:25:44', '1', 'admin', '2022-03-28 16:25:44', '记录日志');
INSERT INTO `sys_log` VALUES (4814, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:25:44', '1', 'admin', '2022-03-28 16:25:44', '记录日志');
INSERT INTO `sys_log` VALUES (4815, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:25:47', '1', 'admin', '2022-03-28 16:25:47', '记录日志');
INSERT INTO `sys_log` VALUES (4816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:26:45', '1', 'admin', '2022-03-28 16:26:45', '记录日志');
INSERT INTO `sys_log` VALUES (4817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:26:45', '1', 'admin', '2022-03-28 16:26:45', '记录日志');
INSERT INTO `sys_log` VALUES (4818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:26:47', '1', 'admin', '2022-03-28 16:26:47', '记录日志');
INSERT INTO `sys_log` VALUES (4819, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:26:47', '1', 'admin', '2022-03-28 16:26:47', '记录日志');
INSERT INTO `sys_log` VALUES (4820, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:26:50', '1', 'admin', '2022-03-28 16:26:50', '记录日志');
INSERT INTO `sys_log` VALUES (4821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:27:18', '1', 'admin', '2022-03-28 16:27:18', '记录日志');
INSERT INTO `sys_log` VALUES (4822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:27:18', '1', 'admin', '2022-03-28 16:27:18', '记录日志');
INSERT INTO `sys_log` VALUES (4823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:27:19', '1', 'admin', '2022-03-28 16:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (4824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:27:19', '1', 'admin', '2022-03-28 16:27:19', '记录日志');
INSERT INTO `sys_log` VALUES (4825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:27:20', '1', 'admin', '2022-03-28 16:27:20', '记录日志');
INSERT INTO `sys_log` VALUES (4826, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:27:20', '1', 'admin', '2022-03-28 16:27:20', '记录日志');
INSERT INTO `sys_log` VALUES (4827, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:27:23', '1', 'admin', '2022-03-28 16:27:23', '记录日志');
INSERT INTO `sys_log` VALUES (4828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:27:39', '1', 'admin', '2022-03-28 16:27:39', '记录日志');
INSERT INTO `sys_log` VALUES (4829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:27:39', '1', 'admin', '2022-03-28 16:27:39', '记录日志');
INSERT INTO `sys_log` VALUES (4830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:27:40', '1', 'admin', '2022-03-28 16:27:40', '记录日志');
INSERT INTO `sys_log` VALUES (4831, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:27:40', '1', 'admin', '2022-03-28 16:27:40', '记录日志');
INSERT INTO `sys_log` VALUES (4832, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:27:43', '1', 'admin', '2022-03-28 16:27:43', '记录日志');
INSERT INTO `sys_log` VALUES (4833, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 16:31:32', '1', 'admin', '2022-03-28 16:31:32', '记录日志');
INSERT INTO `sys_log` VALUES (4834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 16:31:32', '1', 'admin', '2022-03-28 16:31:32', '记录日志');
INSERT INTO `sys_log` VALUES (4835, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 16:31:34', '1', 'admin', '2022-03-28 16:31:34', '记录日志');
INSERT INTO `sys_log` VALUES (4836, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 16:31:34', '1', 'admin', '2022-03-28 16:31:34', '记录日志');
INSERT INTO `sys_log` VALUES (4837, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 16:31:37', '1', 'admin', '2022-03-28 16:31:37', '记录日志');
INSERT INTO `sys_log` VALUES (4838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 17:06:27', '1', 'admin', '2022-03-28 17:06:27', '记录日志');
INSERT INTO `sys_log` VALUES (4839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 17:06:27', '1', 'admin', '2022-03-28 17:06:27', '记录日志');
INSERT INTO `sys_log` VALUES (4840, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 17:06:28', '1', 'admin', '2022-03-28 17:06:28', '记录日志');
INSERT INTO `sys_log` VALUES (4841, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 17:06:28', '1', 'admin', '2022-03-28 17:06:28', '记录日志');
INSERT INTO `sys_log` VALUES (4842, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 17:06:32', '1', 'admin', '2022-03-28 17:06:32', '记录日志');
INSERT INTO `sys_log` VALUES (4843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 17:53:31', '1', 'admin', '2022-03-28 17:53:31', '记录日志');
INSERT INTO `sys_log` VALUES (4844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 17:53:31', '1', 'admin', '2022-03-28 17:53:31', '记录日志');
INSERT INTO `sys_log` VALUES (4845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 17:53:32', '1', 'admin', '2022-03-28 17:53:32', '记录日志');
INSERT INTO `sys_log` VALUES (4846, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 17:53:32', '1', 'admin', '2022-03-28 17:53:32', '记录日志');
INSERT INTO `sys_log` VALUES (4847, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 17:53:35', '1', 'admin', '2022-03-28 17:53:35', '记录日志');
INSERT INTO `sys_log` VALUES (4848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 17:54:08', '1', 'admin', '2022-03-28 17:54:08', '记录日志');
INSERT INTO `sys_log` VALUES (4849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 17:54:08', '1', 'admin', '2022-03-28 17:54:08', '记录日志');
INSERT INTO `sys_log` VALUES (4850, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 17:54:09', '1', 'admin', '2022-03-28 17:54:09', '记录日志');
INSERT INTO `sys_log` VALUES (4851, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 17:54:10', '1', 'admin', '2022-03-28 17:54:10', '记录日志');
INSERT INTO `sys_log` VALUES (4852, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 17:54:12', '1', 'admin', '2022-03-28 17:54:12', '记录日志');
INSERT INTO `sys_log` VALUES (4853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:01:45', '1', 'admin', '2022-03-28 18:01:45', '记录日志');
INSERT INTO `sys_log` VALUES (4854, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:01:45', '1', 'admin', '2022-03-28 18:01:45', '记录日志');
INSERT INTO `sys_log` VALUES (4855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:01:47', '1', 'admin', '2022-03-28 18:01:47', '记录日志');
INSERT INTO `sys_log` VALUES (4856, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:01:47', '1', 'admin', '2022-03-28 18:01:47', '记录日志');
INSERT INTO `sys_log` VALUES (4857, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:01:50', '1', 'admin', '2022-03-28 18:01:50', '记录日志');
INSERT INTO `sys_log` VALUES (4858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:02:48', '1', 'admin', '2022-03-28 18:02:48', '记录日志');
INSERT INTO `sys_log` VALUES (4859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:02:48', '1', 'admin', '2022-03-28 18:02:48', '记录日志');
INSERT INTO `sys_log` VALUES (4860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:02:49', '1', 'admin', '2022-03-28 18:02:49', '记录日志');
INSERT INTO `sys_log` VALUES (4861, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:02:50', '1', 'admin', '2022-03-28 18:02:50', '记录日志');
INSERT INTO `sys_log` VALUES (4862, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:02:52', '1', 'admin', '2022-03-28 18:02:52', '记录日志');
INSERT INTO `sys_log` VALUES (4863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:05:23', '1', 'admin', '2022-03-28 18:05:23', '记录日志');
INSERT INTO `sys_log` VALUES (4864, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:05:23', '1', 'admin', '2022-03-28 18:05:23', '记录日志');
INSERT INTO `sys_log` VALUES (4865, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:05:25', '1', 'admin', '2022-03-28 18:05:25', '记录日志');
INSERT INTO `sys_log` VALUES (4866, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:05:25', '1', 'admin', '2022-03-28 18:05:25', '记录日志');
INSERT INTO `sys_log` VALUES (4867, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:05:28', '1', 'admin', '2022-03-28 18:05:28', '记录日志');
INSERT INTO `sys_log` VALUES (4868, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:06:20', '1', 'admin', '2022-03-28 18:06:20', '记录日志');
INSERT INTO `sys_log` VALUES (4869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:06:20', '1', 'admin', '2022-03-28 18:06:20', '记录日志');
INSERT INTO `sys_log` VALUES (4870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:06:21', '1', 'admin', '2022-03-28 18:06:21', '记录日志');
INSERT INTO `sys_log` VALUES (4871, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:06:21', '1', 'admin', '2022-03-28 18:06:21', '记录日志');
INSERT INTO `sys_log` VALUES (4872, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:06:24', '1', 'admin', '2022-03-28 18:06:24', '记录日志');
INSERT INTO `sys_log` VALUES (4873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:10:38', '1', 'admin', '2022-03-28 18:10:38', '记录日志');
INSERT INTO `sys_log` VALUES (4874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:10:38', '1', 'admin', '2022-03-28 18:10:38', '记录日志');
INSERT INTO `sys_log` VALUES (4875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:10:39', '1', 'admin', '2022-03-28 18:10:39', '记录日志');
INSERT INTO `sys_log` VALUES (4876, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:10:39', '1', 'admin', '2022-03-28 18:10:39', '记录日志');
INSERT INTO `sys_log` VALUES (4877, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:10:42', '1', 'admin', '2022-03-28 18:10:42', '记录日志');
INSERT INTO `sys_log` VALUES (4878, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:18:56', '1', 'admin', '2022-03-28 18:18:56', '记录日志');
INSERT INTO `sys_log` VALUES (4879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:18:56', '1', 'admin', '2022-03-28 18:18:56', '记录日志');
INSERT INTO `sys_log` VALUES (4880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:18:58', '1', 'admin', '2022-03-28 18:18:58', '记录日志');
INSERT INTO `sys_log` VALUES (4881, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:18:58', '1', 'admin', '2022-03-28 18:18:58', '记录日志');
INSERT INTO `sys_log` VALUES (4882, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:19:01', '1', 'admin', '2022-03-28 18:19:01', '记录日志');
INSERT INTO `sys_log` VALUES (4883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:22:09', '1', 'admin', '2022-03-28 18:22:09', '记录日志');
INSERT INTO `sys_log` VALUES (4884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:22:09', '1', 'admin', '2022-03-28 18:22:09', '记录日志');
INSERT INTO `sys_log` VALUES (4885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:22:11', '1', 'admin', '2022-03-28 18:22:11', '记录日志');
INSERT INTO `sys_log` VALUES (4886, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:22:11', '1', 'admin', '2022-03-28 18:22:11', '记录日志');
INSERT INTO `sys_log` VALUES (4887, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:22:13', '1', 'admin', '2022-03-28 18:22:13', '记录日志');
INSERT INTO `sys_log` VALUES (4888, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-28 18:22:59', '1', 'admin', '2022-03-28 18:22:59', '记录日志');
INSERT INTO `sys_log` VALUES (4889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-28 18:22:59', '1', 'admin', '2022-03-28 18:22:59', '记录日志');
INSERT INTO `sys_log` VALUES (4890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-28 18:23:03', '1', 'admin', '2022-03-28 18:23:03', '记录日志');
INSERT INTO `sys_log` VALUES (4891, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-28 18:23:03', '1', 'admin', '2022-03-28 18:23:03', '记录日志');
INSERT INTO `sys_log` VALUES (4892, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-28 18:23:06', '1', 'admin', '2022-03-28 18:23:06', '记录日志');
INSERT INTO `sys_log` VALUES (4893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 16:51:15', '1', 'admin', '2022-03-29 16:51:15', '记录日志');
INSERT INTO `sys_log` VALUES (4894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 16:51:16', '1', 'admin', '2022-03-29 16:51:16', '记录日志');
INSERT INTO `sys_log` VALUES (4895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 16:51:17', '1', 'admin', '2022-03-29 16:51:17', '记录日志');
INSERT INTO `sys_log` VALUES (4896, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 16:51:17', '1', 'admin', '2022-03-29 16:51:17', '记录日志');
INSERT INTO `sys_log` VALUES (4897, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 16:51:20', '1', 'admin', '2022-03-29 16:51:20', '记录日志');
INSERT INTO `sys_log` VALUES (4898, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 16:54:51', '1', 'admin', '2022-03-29 16:54:51', '记录日志');
INSERT INTO `sys_log` VALUES (4899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 16:54:51', '1', 'admin', '2022-03-29 16:54:51', '记录日志');
INSERT INTO `sys_log` VALUES (4900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 16:54:53', '1', 'admin', '2022-03-29 16:54:53', '记录日志');
INSERT INTO `sys_log` VALUES (4901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 16:54:53', '1', 'admin', '2022-03-29 16:54:53', '记录日志');
INSERT INTO `sys_log` VALUES (4902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 16:54:54', '1', 'admin', '2022-03-29 16:54:54', '记录日志');
INSERT INTO `sys_log` VALUES (4903, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 16:54:54', '1', 'admin', '2022-03-29 16:54:54', '记录日志');
INSERT INTO `sys_log` VALUES (4904, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 16:54:57', '1', 'admin', '2022-03-29 16:54:57', '记录日志');
INSERT INTO `sys_log` VALUES (4905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 16:57:10', '1', 'admin', '2022-03-29 16:57:10', '记录日志');
INSERT INTO `sys_log` VALUES (4906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 16:57:10', '1', 'admin', '2022-03-29 16:57:10', '记录日志');
INSERT INTO `sys_log` VALUES (4907, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 16:57:12', '1', 'admin', '2022-03-29 16:57:12', '记录日志');
INSERT INTO `sys_log` VALUES (4908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 16:57:12', '1', 'admin', '2022-03-29 16:57:12', '记录日志');
INSERT INTO `sys_log` VALUES (4909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 16:57:14', '1', 'admin', '2022-03-29 16:57:14', '记录日志');
INSERT INTO `sys_log` VALUES (4910, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 16:57:14', '1', 'admin', '2022-03-29 16:57:14', '记录日志');
INSERT INTO `sys_log` VALUES (4911, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 16:57:17', '1', 'admin', '2022-03-29 16:57:17', '记录日志');
INSERT INTO `sys_log` VALUES (4912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 17:08:47', '1', 'admin', '2022-03-29 17:08:47', '记录日志');
INSERT INTO `sys_log` VALUES (4913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 17:08:48', '1', 'admin', '2022-03-29 17:08:48', '记录日志');
INSERT INTO `sys_log` VALUES (4914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 17:08:49', '1', 'admin', '2022-03-29 17:08:49', '记录日志');
INSERT INTO `sys_log` VALUES (4915, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:08:49', '1', 'admin', '2022-03-29 17:08:49', '记录日志');
INSERT INTO `sys_log` VALUES (4916, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 17:08:52', '1', 'admin', '2022-03-29 17:08:52', '记录日志');
INSERT INTO `sys_log` VALUES (4917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-29 17:12:20', '1', 'admin', '2022-03-29 17:12:20', '记录日志');
INSERT INTO `sys_log` VALUES (4918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-29 17:12:20', '1', 'admin', '2022-03-29 17:12:20', '记录日志');
INSERT INTO `sys_log` VALUES (4919, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-29 17:12:20', '1', 'admin', '2022-03-29 17:12:20', '记录日志');
INSERT INTO `sys_log` VALUES (4920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 17:23:02', '1', 'admin', '2022-03-29 17:23:02', '记录日志');
INSERT INTO `sys_log` VALUES (4921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 17:23:02', '1', 'admin', '2022-03-29 17:23:02', '记录日志');
INSERT INTO `sys_log` VALUES (4922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 17:23:04', '1', 'admin', '2022-03-29 17:23:04', '记录日志');
INSERT INTO `sys_log` VALUES (4923, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:23:04', '1', 'admin', '2022-03-29 17:23:04', '记录日志');
INSERT INTO `sys_log` VALUES (4924, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 17:23:07', '1', 'admin', '2022-03-29 17:23:07', '记录日志');
INSERT INTO `sys_log` VALUES (4925, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 17:30:40', '1', 'admin', '2022-03-29 17:30:40', '记录日志');
INSERT INTO `sys_log` VALUES (4926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 17:30:40', '1', 'admin', '2022-03-29 17:30:40', '记录日志');
INSERT INTO `sys_log` VALUES (4927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 17:30:41', '1', 'admin', '2022-03-29 17:30:41', '记录日志');
INSERT INTO `sys_log` VALUES (4928, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:30:41', '1', 'admin', '2022-03-29 17:30:41', '记录日志');
INSERT INTO `sys_log` VALUES (4929, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 17:30:44', '1', 'admin', '2022-03-29 17:30:44', '记录日志');
INSERT INTO `sys_log` VALUES (4930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 17:31:29', '1', 'admin', '2022-03-29 17:31:29', '记录日志');
INSERT INTO `sys_log` VALUES (4931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 17:31:29', '1', 'admin', '2022-03-29 17:31:29', '记录日志');
INSERT INTO `sys_log` VALUES (4932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 17:31:30', '1', 'admin', '2022-03-29 17:31:30', '记录日志');
INSERT INTO `sys_log` VALUES (4933, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:31:30', '1', 'admin', '2022-03-29 17:31:30', '记录日志');
INSERT INTO `sys_log` VALUES (4934, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 17:31:33', '1', 'admin', '2022-03-29 17:31:33', '记录日志');
INSERT INTO `sys_log` VALUES (4935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 17:51:05', '1', 'admin', '2022-03-29 17:51:05', '记录日志');
INSERT INTO `sys_log` VALUES (4936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 17:51:05', '1', 'admin', '2022-03-29 17:51:05', '记录日志');
INSERT INTO `sys_log` VALUES (4937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 17:52:09', '1', 'admin', '2022-03-29 17:52:09', '记录日志');
INSERT INTO `sys_log` VALUES (4938, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:52:09', '1', 'admin', '2022-03-29 17:52:09', '记录日志');
INSERT INTO `sys_log` VALUES (4939, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 17:52:25', '1', 'admin', '2022-03-29 17:52:25', '记录日志');
INSERT INTO `sys_log` VALUES (4940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-03-29 17:52:59', '1', 'admin', '2022-03-29 17:52:59', '记录日志');
INSERT INTO `sys_log` VALUES (4941, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=window%E6%95%B0%E6%8D%AE&url=AAA&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:52:59', '1', 'admin', '2022-03-29 17:52:59', '记录日志');
INSERT INTO `sys_log` VALUES (4942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 17:53:05', '1', 'admin', '2022-03-29 17:53:05', '记录日志');
INSERT INTO `sys_log` VALUES (4943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 17:53:05', '1', 'admin', '2022-03-29 17:53:05', '记录日志');
INSERT INTO `sys_log` VALUES (4944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 17:53:07', '1', 'admin', '2022-03-29 17:53:07', '记录日志');
INSERT INTO `sys_log` VALUES (4945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 17:53:07', '1', 'admin', '2022-03-29 17:53:07', '记录日志');
INSERT INTO `sys_log` VALUES (4946, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 17:53:39', '1', 'admin', '2022-03-29 17:53:39', '记录日志');
INSERT INTO `sys_log` VALUES (4947, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:53:39', '1', 'admin', '2022-03-29 17:53:39', '记录日志');
INSERT INTO `sys_log` VALUES (4948, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 17:56:07', '1', 'admin', '2022-03-29 17:56:07', '记录日志');
INSERT INTO `sys_log` VALUES (4949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-03-29 17:56:13', '1', 'admin', '2022-03-29 17:56:13', '记录日志');
INSERT INTO `sys_log` VALUES (4950, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=A&url=A&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-03-29 17:56:13', '1', 'admin', '2022-03-29 17:56:13', '记录日志');
INSERT INTO `sys_log` VALUES (4951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 17:57:58', '1', 'admin', '2022-03-29 17:57:58', '记录日志');
INSERT INTO `sys_log` VALUES (4952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 17:57:58', '1', 'admin', '2022-03-29 17:57:58', '记录日志');
INSERT INTO `sys_log` VALUES (4953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 17:57:59', '1', 'admin', '2022-03-29 17:57:59', '记录日志');
INSERT INTO `sys_log` VALUES (4954, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 17:57:59', '1', 'admin', '2022-03-29 17:57:59', '记录日志');
INSERT INTO `sys_log` VALUES (4955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-29 17:58:05', '1', 'admin', '2022-03-29 17:58:05', '记录日志');
INSERT INTO `sys_log` VALUES (4956, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-29 17:58:06', '1', 'admin', '2022-03-29 17:58:06', '记录日志');
INSERT INTO `sys_log` VALUES (4957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-29 17:58:06', '1', 'admin', '2022-03-29 17:58:06', '记录日志');
INSERT INTO `sys_log` VALUES (4958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-03-29 17:58:09', '1', 'admin', '2022-03-29 17:58:09', '记录日志');
INSERT INTO `sys_log` VALUES (4959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-03-29 17:58:10', '1', 'admin', '2022-03-29 17:58:10', '记录日志');
INSERT INTO `sys_log` VALUES (4960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-29 17:58:14', '1', 'admin', '2022-03-29 17:58:14', '记录日志');
INSERT INTO `sys_log` VALUES (4961, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-29 17:58:18', '1', 'admin', '2022-03-29 17:58:18', '记录日志');
INSERT INTO `sys_log` VALUES (4962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 17:58:46', '1', 'admin', '2022-03-29 17:58:46', '记录日志');
INSERT INTO `sys_log` VALUES (4963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 17:58:46', '1', 'admin', '2022-03-29 17:58:46', '记录日志');
INSERT INTO `sys_log` VALUES (4964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 17:58:47', '1', 'admin', '2022-03-29 17:58:47', '记录日志');
INSERT INTO `sys_log` VALUES (4965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 17:58:47', '1', 'admin', '2022-03-29 17:58:47', '记录日志');
INSERT INTO `sys_log` VALUES (4966, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 18:10:11', '1', 'admin', '2022-03-29 18:10:11', '记录日志');
INSERT INTO `sys_log` VALUES (4967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 18:10:11', '1', 'admin', '2022-03-29 18:10:11', '记录日志');
INSERT INTO `sys_log` VALUES (4968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 18:10:12', '1', 'admin', '2022-03-29 18:10:12', '记录日志');
INSERT INTO `sys_log` VALUES (4969, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 18:10:12', '1', 'admin', '2022-03-29 18:10:12', '记录日志');
INSERT INTO `sys_log` VALUES (4970, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-29 18:10:16', '1', 'admin', '2022-03-29 18:10:16', '记录日志');
INSERT INTO `sys_log` VALUES (4971, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 18:11:00', '1', 'admin', '2022-03-29 18:11:00', '记录日志');
INSERT INTO `sys_log` VALUES (4972, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 18:11:00', '1', 'admin', '2022-03-29 18:11:00', '记录日志');
INSERT INTO `sys_log` VALUES (4973, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 18:11:02', '1', 'admin', '2022-03-29 18:11:02', '记录日志');
INSERT INTO `sys_log` VALUES (4974, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 18:11:02', '1', 'admin', '2022-03-29 18:11:02', '记录日志');
INSERT INTO `sys_log` VALUES (4975, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-03-29 18:11:34', '1', 'admin', '2022-03-29 18:11:34', '记录日志');
INSERT INTO `sys_log` VALUES (4976, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=WINOOWS&url=A&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-03-29 18:11:34', '1', 'admin', '2022-03-29 18:11:34', '记录日志');
INSERT INTO `sys_log` VALUES (4977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 18:12:06', '1', 'admin', '2022-03-29 18:12:06', '记录日志');
INSERT INTO `sys_log` VALUES (4978, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 18:12:06', '1', 'admin', '2022-03-29 18:12:06', '记录日志');
INSERT INTO `sys_log` VALUES (4979, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 18:12:13', '1', 'admin', '2022-03-29 18:12:13', '记录日志');
INSERT INTO `sys_log` VALUES (4980, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 18:12:13', '1', 'admin', '2022-03-29 18:12:13', '记录日志');
INSERT INTO `sys_log` VALUES (4981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:03:47', '1', 'admin', '2022-03-29 21:03:47', '记录日志');
INSERT INTO `sys_log` VALUES (4982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:03:47', '1', 'admin', '2022-03-29 21:03:47', '记录日志');
INSERT INTO `sys_log` VALUES (4983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:03:48', '1', 'admin', '2022-03-29 21:03:48', '记录日志');
INSERT INTO `sys_log` VALUES (4984, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:03:48', '1', 'admin', '2022-03-29 21:03:48', '记录日志');
INSERT INTO `sys_log` VALUES (4985, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:04:18', '1', 'admin', '2022-03-29 21:04:18', '记录日志');
INSERT INTO `sys_log` VALUES (4986, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:04:18', '1', 'admin', '2022-03-29 21:04:18', '记录日志');
INSERT INTO `sys_log` VALUES (4987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:07:24', '1', 'admin', '2022-03-29 21:07:24', '记录日志');
INSERT INTO `sys_log` VALUES (4988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:07:24', '1', 'admin', '2022-03-29 21:07:24', '记录日志');
INSERT INTO `sys_log` VALUES (4989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:07:25', '1', 'admin', '2022-03-29 21:07:25', '记录日志');
INSERT INTO `sys_log` VALUES (4990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:07:25', '1', 'admin', '2022-03-29 21:07:25', '记录日志');
INSERT INTO `sys_log` VALUES (4991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:07:26', '1', 'admin', '2022-03-29 21:07:26', '记录日志');
INSERT INTO `sys_log` VALUES (4992, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:07:26', '1', 'admin', '2022-03-29 21:07:26', '记录日志');
INSERT INTO `sys_log` VALUES (4993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:07:29', '1', 'admin', '2022-03-29 21:07:29', '记录日志');
INSERT INTO `sys_log` VALUES (4994, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:07:29', '1', 'admin', '2022-03-29 21:07:29', '记录日志');
INSERT INTO `sys_log` VALUES (4995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:07:30', '1', 'admin', '2022-03-29 21:07:30', '记录日志');
INSERT INTO `sys_log` VALUES (4996, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:07:30', '1', 'admin', '2022-03-29 21:07:30', '记录日志');
INSERT INTO `sys_log` VALUES (4997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:07:32', '1', 'admin', '2022-03-29 21:07:32', '记录日志');
INSERT INTO `sys_log` VALUES (4998, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:07:32', '1', 'admin', '2022-03-29 21:07:32', '记录日志');
INSERT INTO `sys_log` VALUES (4999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:08:27', '1', 'admin', '2022-03-29 21:08:27', '记录日志');
INSERT INTO `sys_log` VALUES (5000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:08:27', '1', 'admin', '2022-03-29 21:08:27', '记录日志');
INSERT INTO `sys_log` VALUES (5001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:08:28', '1', 'admin', '2022-03-29 21:08:28', '记录日志');
INSERT INTO `sys_log` VALUES (5002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:08:28', '1', 'admin', '2022-03-29 21:08:28', '记录日志');
INSERT INTO `sys_log` VALUES (5003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:08:29', '1', 'admin', '2022-03-29 21:08:29', '记录日志');
INSERT INTO `sys_log` VALUES (5004, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:08:29', '1', 'admin', '2022-03-29 21:08:29', '记录日志');
INSERT INTO `sys_log` VALUES (5005, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:08:32', '1', 'admin', '2022-03-29 21:08:32', '记录日志');
INSERT INTO `sys_log` VALUES (5006, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:08:32', '1', 'admin', '2022-03-29 21:08:32', '记录日志');
INSERT INTO `sys_log` VALUES (5007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:09:52', '1', 'admin', '2022-03-29 21:09:52', '记录日志');
INSERT INTO `sys_log` VALUES (5008, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:09:52', '1', 'admin', '2022-03-29 21:09:52', '记录日志');
INSERT INTO `sys_log` VALUES (5009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:07', '1', 'admin', '2022-03-29 21:10:07', '记录日志');
INSERT INTO `sys_log` VALUES (5010, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:07', '1', 'admin', '2022-03-29 21:10:07', '记录日志');
INSERT INTO `sys_log` VALUES (5011, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:09', '1', 'admin', '2022-03-29 21:10:09', '记录日志');
INSERT INTO `sys_log` VALUES (5012, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:09', '1', 'admin', '2022-03-29 21:10:09', '记录日志');
INSERT INTO `sys_log` VALUES (5013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:11', '1', 'admin', '2022-03-29 21:10:11', '记录日志');
INSERT INTO `sys_log` VALUES (5014, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:11', '1', 'admin', '2022-03-29 21:10:11', '记录日志');
INSERT INTO `sys_log` VALUES (5015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:12', '1', 'admin', '2022-03-29 21:10:12', '记录日志');
INSERT INTO `sys_log` VALUES (5016, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:12', '1', 'admin', '2022-03-29 21:10:12', '记录日志');
INSERT INTO `sys_log` VALUES (5017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:14', '1', 'admin', '2022-03-29 21:10:14', '记录日志');
INSERT INTO `sys_log` VALUES (5018, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:14', '1', 'admin', '2022-03-29 21:10:14', '记录日志');
INSERT INTO `sys_log` VALUES (5019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:15', '1', 'admin', '2022-03-29 21:10:15', '记录日志');
INSERT INTO `sys_log` VALUES (5020, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:15', '1', 'admin', '2022-03-29 21:10:15', '记录日志');
INSERT INTO `sys_log` VALUES (5021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:17', '1', 'admin', '2022-03-29 21:10:17', '记录日志');
INSERT INTO `sys_log` VALUES (5022, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:17', '1', 'admin', '2022-03-29 21:10:17', '记录日志');
INSERT INTO `sys_log` VALUES (5023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:18', '1', 'admin', '2022-03-29 21:10:18', '记录日志');
INSERT INTO `sys_log` VALUES (5024, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:18', '1', 'admin', '2022-03-29 21:10:18', '记录日志');
INSERT INTO `sys_log` VALUES (5025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:10:19', '1', 'admin', '2022-03-29 21:10:19', '记录日志');
INSERT INTO `sys_log` VALUES (5026, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:10:19', '1', 'admin', '2022-03-29 21:10:19', '记录日志');
INSERT INTO `sys_log` VALUES (5027, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:11:05', '1', 'admin', '2022-03-29 21:11:05', '记录日志');
INSERT INTO `sys_log` VALUES (5028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:11:05', '1', 'admin', '2022-03-29 21:11:05', '记录日志');
INSERT INTO `sys_log` VALUES (5029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:11:06', '1', 'admin', '2022-03-29 21:11:06', '记录日志');
INSERT INTO `sys_log` VALUES (5030, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:11:06', '1', 'admin', '2022-03-29 21:11:06', '记录日志');
INSERT INTO `sys_log` VALUES (5031, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:11:07', '1', 'admin', '2022-03-29 21:11:07', '记录日志');
INSERT INTO `sys_log` VALUES (5032, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:11:07', '1', 'admin', '2022-03-29 21:11:07', '记录日志');
INSERT INTO `sys_log` VALUES (5033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:11:29', '1', 'admin', '2022-03-29 21:11:29', '记录日志');
INSERT INTO `sys_log` VALUES (5034, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:11:29', '1', 'admin', '2022-03-29 21:11:29', '记录日志');
INSERT INTO `sys_log` VALUES (5035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:11:57', '1', 'admin', '2022-03-29 21:11:57', '记录日志');
INSERT INTO `sys_log` VALUES (5036, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:11:57', '1', 'admin', '2022-03-29 21:11:57', '记录日志');
INSERT INTO `sys_log` VALUES (5037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:11:59', '1', 'admin', '2022-03-29 21:11:59', '记录日志');
INSERT INTO `sys_log` VALUES (5038, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:11:59', '1', 'admin', '2022-03-29 21:11:59', '记录日志');
INSERT INTO `sys_log` VALUES (5039, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:12:53', '1', 'admin', '2022-03-29 21:12:53', '记录日志');
INSERT INTO `sys_log` VALUES (5040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:12:53', '1', 'admin', '2022-03-29 21:12:53', '记录日志');
INSERT INTO `sys_log` VALUES (5041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:12:54', '1', 'admin', '2022-03-29 21:12:54', '记录日志');
INSERT INTO `sys_log` VALUES (5042, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:12:55', '1', 'admin', '2022-03-29 21:12:55', '记录日志');
INSERT INTO `sys_log` VALUES (5043, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:13:22', '1', 'admin', '2022-03-29 21:13:22', '记录日志');
INSERT INTO `sys_log` VALUES (5044, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:13:22', '1', 'admin', '2022-03-29 21:13:22', '记录日志');
INSERT INTO `sys_log` VALUES (5045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:14:04', '1', 'admin', '2022-03-29 21:14:04', '记录日志');
INSERT INTO `sys_log` VALUES (5046, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:14:04', '1', 'admin', '2022-03-29 21:14:04', '记录日志');
INSERT INTO `sys_log` VALUES (5047, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:14:06', '1', 'admin', '2022-03-29 21:14:06', '记录日志');
INSERT INTO `sys_log` VALUES (5048, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:14:06', '1', 'admin', '2022-03-29 21:14:06', '记录日志');
INSERT INTO `sys_log` VALUES (5049, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 21:14:07', '1', 'admin', '2022-03-29 21:14:07', '记录日志');
INSERT INTO `sys_log` VALUES (5050, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 21:14:07', '1', 'admin', '2022-03-29 21:14:07', '记录日志');
INSERT INTO `sys_log` VALUES (5051, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:14:10', '1', 'admin', '2022-03-29 21:14:10', '记录日志');
INSERT INTO `sys_log` VALUES (5052, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:14:10', '1', 'admin', '2022-03-29 21:14:10', '记录日志');
INSERT INTO `sys_log` VALUES (5053, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:14:13', '1', 'admin', '2022-03-29 21:14:13', '记录日志');
INSERT INTO `sys_log` VALUES (5054, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:14:13', '1', 'admin', '2022-03-29 21:14:13', '记录日志');
INSERT INTO `sys_log` VALUES (5055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:15:32', '1', 'admin', '2022-03-29 21:15:32', '记录日志');
INSERT INTO `sys_log` VALUES (5056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:15:32', '1', 'admin', '2022-03-29 21:15:32', '记录日志');
INSERT INTO `sys_log` VALUES (5057, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:15:33', '1', 'admin', '2022-03-29 21:15:33', '记录日志');
INSERT INTO `sys_log` VALUES (5058, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:15:33', '1', 'admin', '2022-03-29 21:15:33', '记录日志');
INSERT INTO `sys_log` VALUES (5059, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:15:36', '1', 'admin', '2022-03-29 21:15:36', '记录日志');
INSERT INTO `sys_log` VALUES (5060, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:15:36', '1', 'admin', '2022-03-29 21:15:36', '记录日志');
INSERT INTO `sys_log` VALUES (5061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:16:29', '1', 'admin', '2022-03-29 21:16:29', '记录日志');
INSERT INTO `sys_log` VALUES (5062, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:16:29', '1', 'admin', '2022-03-29 21:16:29', '记录日志');
INSERT INTO `sys_log` VALUES (5063, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:23:06', '1', 'admin', '2022-03-29 21:23:06', '记录日志');
INSERT INTO `sys_log` VALUES (5064, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:23:06', '1', 'admin', '2022-03-29 21:23:06', '记录日志');
INSERT INTO `sys_log` VALUES (5065, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:23:08', '1', 'admin', '2022-03-29 21:23:08', '记录日志');
INSERT INTO `sys_log` VALUES (5066, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:23:08', '1', 'admin', '2022-03-29 21:23:08', '记录日志');
INSERT INTO `sys_log` VALUES (5067, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:23:09', '1', 'admin', '2022-03-29 21:23:09', '记录日志');
INSERT INTO `sys_log` VALUES (5068, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:23:09', '1', 'admin', '2022-03-29 21:23:09', '记录日志');
INSERT INTO `sys_log` VALUES (5069, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:30:16', '1', 'admin', '2022-03-29 21:30:16', '记录日志');
INSERT INTO `sys_log` VALUES (5070, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:30:16', '1', 'admin', '2022-03-29 21:30:16', '记录日志');
INSERT INTO `sys_log` VALUES (5071, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:30:17', '1', 'admin', '2022-03-29 21:30:17', '记录日志');
INSERT INTO `sys_log` VALUES (5072, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:30:17', '1', 'admin', '2022-03-29 21:30:17', '记录日志');
INSERT INTO `sys_log` VALUES (5073, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:30:19', '1', 'admin', '2022-03-29 21:30:19', '记录日志');
INSERT INTO `sys_log` VALUES (5074, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:30:19', '1', 'admin', '2022-03-29 21:30:19', '记录日志');
INSERT INTO `sys_log` VALUES (5075, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:30:20', '1', 'admin', '2022-03-29 21:30:20', '记录日志');
INSERT INTO `sys_log` VALUES (5076, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:30:20', '1', 'admin', '2022-03-29 21:30:20', '记录日志');
INSERT INTO `sys_log` VALUES (5077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:30:43', '1', 'admin', '2022-03-29 21:30:43', '记录日志');
INSERT INTO `sys_log` VALUES (5078, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:30:43', '1', 'admin', '2022-03-29 21:30:43', '记录日志');
INSERT INTO `sys_log` VALUES (5079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:30:45', '1', 'admin', '2022-03-29 21:30:45', '记录日志');
INSERT INTO `sys_log` VALUES (5080, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:30:45', '1', 'admin', '2022-03-29 21:30:45', '记录日志');
INSERT INTO `sys_log` VALUES (5081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:36:52', '1', 'admin', '2022-03-29 21:36:52', '记录日志');
INSERT INTO `sys_log` VALUES (5082, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:36:53', '1', 'admin', '2022-03-29 21:36:53', '记录日志');
INSERT INTO `sys_log` VALUES (5083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:36:54', '1', 'admin', '2022-03-29 21:36:54', '记录日志');
INSERT INTO `sys_log` VALUES (5084, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:36:54', '1', 'admin', '2022-03-29 21:36:54', '记录日志');
INSERT INTO `sys_log` VALUES (5085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-29 21:36:58', '1', 'admin', '2022-03-29 21:36:58', '记录日志');
INSERT INTO `sys_log` VALUES (5086, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-29 21:36:58', '1', 'admin', '2022-03-29 21:36:58', '记录日志');
INSERT INTO `sys_log` VALUES (5087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:44:32', '1', 'admin', '2022-03-29 21:44:32', '记录日志');
INSERT INTO `sys_log` VALUES (5088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:44:32', '1', 'admin', '2022-03-29 21:44:32', '记录日志');
INSERT INTO `sys_log` VALUES (5089, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:44:34', '1', 'admin', '2022-03-29 21:44:34', '记录日志');
INSERT INTO `sys_log` VALUES (5090, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:44:34', '1', 'admin', '2022-03-29 21:44:34', '记录日志');
INSERT INTO `sys_log` VALUES (5091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:45:33', '1', 'admin', '2022-03-29 21:45:33', '记录日志');
INSERT INTO `sys_log` VALUES (5092, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:45:33', '1', 'admin', '2022-03-29 21:45:33', '记录日志');
INSERT INTO `sys_log` VALUES (5093, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:45:34', '1', 'admin', '2022-03-29 21:45:34', '记录日志');
INSERT INTO `sys_log` VALUES (5094, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:45:34', '1', 'admin', '2022-03-29 21:45:34', '记录日志');
INSERT INTO `sys_log` VALUES (5095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:46:09', '1', 'admin', '2022-03-29 21:46:09', '记录日志');
INSERT INTO `sys_log` VALUES (5096, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:46:09', '1', 'admin', '2022-03-29 21:46:09', '记录日志');
INSERT INTO `sys_log` VALUES (5097, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:47:36', '1', 'admin', '2022-03-29 21:47:36', '记录日志');
INSERT INTO `sys_log` VALUES (5098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:47:37', '1', 'admin', '2022-03-29 21:47:37', '记录日志');
INSERT INTO `sys_log` VALUES (5099, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:47:38', '1', 'admin', '2022-03-29 21:47:38', '记录日志');
INSERT INTO `sys_log` VALUES (5100, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:47:38', '1', 'admin', '2022-03-29 21:47:38', '记录日志');
INSERT INTO `sys_log` VALUES (5101, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:47:41', '1', 'admin', '2022-03-29 21:47:41', '记录日志');
INSERT INTO `sys_log` VALUES (5102, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:47:41', '1', 'admin', '2022-03-29 21:47:41', '记录日志');
INSERT INTO `sys_log` VALUES (5103, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:49:30', '1', 'admin', '2022-03-29 21:49:30', '记录日志');
INSERT INTO `sys_log` VALUES (5104, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:49:30', '1', 'admin', '2022-03-29 21:49:30', '记录日志');
INSERT INTO `sys_log` VALUES (5105, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:50:00', '1', 'admin', '2022-03-29 21:50:00', '记录日志');
INSERT INTO `sys_log` VALUES (5106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:50:00', '1', 'admin', '2022-03-29 21:50:00', '记录日志');
INSERT INTO `sys_log` VALUES (5107, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-29 21:50:04', '1', 'admin', '2022-03-29 21:50:04', '记录日志');
INSERT INTO `sys_log` VALUES (5108, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-29 21:50:04', '1', 'admin', '2022-03-29 21:50:04', '记录日志');
INSERT INTO `sys_log` VALUES (5109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-29 21:50:05', '1', 'admin', '2022-03-29 21:50:05', '记录日志');
INSERT INTO `sys_log` VALUES (5110, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-29 21:50:05', '1', 'admin', '2022-03-29 21:50:05', '记录日志');
INSERT INTO `sys_log` VALUES (5111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:40:03', '1', 'admin', '2022-03-30 13:40:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:40:03', '1', 'admin', '2022-03-30 13:40:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:40:04', '1', 'admin', '2022-03-30 13:40:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5114, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:40:04', '1', 'admin', '2022-03-30 13:40:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5115, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 13:40:08', '1', 'admin', '2022-03-30 13:40:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5116, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:40:30', '1', 'guest', '2022-03-30 13:40:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5117, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:40:30', '1', 'guest', '2022-03-30 13:40:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:40:51', '1', 'admin', '2022-03-30 13:40:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5119, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:40:51', '1', 'admin', '2022-03-30 13:40:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:40:54', '1', 'admin', '2022-03-30 13:40:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5121, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:40:54', '1', 'admin', '2022-03-30 13:40:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5122, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 13:40:57', '1', 'admin', '2022-03-30 13:40:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5123, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:45:58', '1', 'admin', '2022-03-30 13:45:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5124, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:45:59', '1', 'admin', '2022-03-30 13:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:46:00', '1', 'admin', '2022-03-30 13:46:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5126, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:46:00', '1', 'admin', '2022-03-30 13:46:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5127, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 13:46:03', '1', 'admin', '2022-03-30 13:46:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5128, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:53:07', '1', 'admin', '2022-03-30 13:53:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:53:07', '1', 'admin', '2022-03-30 13:53:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:53:08', '1', 'admin', '2022-03-30 13:53:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5131, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:53:08', '1', 'admin', '2022-03-30 13:53:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:53:40', '1', 'admin', '2022-03-30 13:53:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5133, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:53:40', '1', 'admin', '2022-03-30 13:53:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5134, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:53:41', '1', 'admin', '2022-03-30 13:53:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5135, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:53:41', '1', 'admin', '2022-03-30 13:53:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:56:21', '1', 'admin', '2022-03-30 13:56:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:56:21', '1', 'admin', '2022-03-30 13:56:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:56:22', '1', 'admin', '2022-03-30 13:56:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5139, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:56:22', '1', 'admin', '2022-03-30 13:56:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5140, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 13:56:29', '1', 'admin', '2022-03-30 13:56:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5141, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 13:56:35', '1', 'admin', '2022-03-30 13:56:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5142, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 13:56:41', '1', 'admin', '2022-03-30 13:56:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:57:53', '1', 'admin', '2022-03-30 13:57:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5144, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:57:54', '1', 'admin', '2022-03-30 13:57:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5145, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:57:54', '1', 'admin', '2022-03-30 13:57:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5146, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:57:54', '1', 'admin', '2022-03-30 13:57:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5147, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 13:58:13', '1', 'admin', '2022-03-30 13:58:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5148, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 13:58:14', '1', 'admin', '2022-03-30 13:58:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5149, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 13:58:15', '1', 'admin', '2022-03-30 13:58:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5150, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 13:58:15', '1', 'admin', '2022-03-30 13:58:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5151, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 13:58:21', '1', 'admin', '2022-03-30 13:58:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 14:05:32', '1', 'admin', '2022-03-30 14:05:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5153, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 14:05:32', '1', 'admin', '2022-03-30 14:05:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5154, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 14:05:33', '1', 'admin', '2022-03-30 14:05:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5155, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 14:05:33', '1', 'admin', '2022-03-30 14:05:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5156, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 14:05:36', '1', 'admin', '2022-03-30 14:05:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 18:15:41', '1', 'admin', '2022-03-30 18:15:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5158, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 18:15:41', '1', 'admin', '2022-03-30 18:15:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 18:15:42', '1', 'admin', '2022-03-30 18:15:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5160, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 18:15:42', '1', 'admin', '2022-03-30 18:15:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5161, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 18:23:38', '1', 'admin', '2022-03-30 18:23:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5162, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 18:25:02', '1', 'admin', '2022-03-30 18:25:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5163, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upfile', '2022-03-30 18:25:21', '1', 'admin', '2022-03-30 18:25:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 19:03:17', '1', 'admin', '2022-03-30 19:03:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5165, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 19:03:17', '1', 'admin', '2022-03-30 19:03:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 19:03:20', '1', 'admin', '2022-03-30 19:03:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-30 19:03:22', '1', 'admin', '2022-03-30 19:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5168, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-30 19:03:22', '1', 'admin', '2022-03-30 19:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5169, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-30 19:15:45', '1', 'admin', '2022-03-30 19:15:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-30 19:15:45', '1', 'admin', '2022-03-30 19:15:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5171, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-30 19:15:46', '1', 'admin', '2022-03-30 19:15:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5172, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-30 19:15:46', '1', 'admin', '2022-03-30 19:15:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5173, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 10:15:22', '1', 'admin', '2022-03-31 10:15:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5174, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 10:15:22', '1', 'admin', '2022-03-31 10:15:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5175, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 10:15:23', '1', 'admin', '2022-03-31 10:15:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5176, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 10:15:23', '1', 'admin', '2022-03-31 10:15:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5177, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 10:44:00', '1', 'admin', '2022-03-31 10:44:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5178, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 10:44:00', '1', 'admin', '2022-03-31 10:44:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5179, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 10:44:10', '1', 'admin', '2022-03-31 10:44:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5180, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 10:44:10', '1', 'admin', '2022-03-31 10:44:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5181, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 10:57:02', '1', 'admin', '2022-03-31 10:57:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5182, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 10:57:02', '1', 'admin', '2022-03-31 10:57:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5183, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 10:57:07', '1', 'admin', '2022-03-31 10:57:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5184, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 10:57:07', '1', 'admin', '2022-03-31 10:57:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5185, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 10:57:08', '1', 'admin', '2022-03-31 10:57:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5186, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 10:57:08', '1', 'admin', '2022-03-31 10:57:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5187, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 11:08:04', '1', 'admin', '2022-03-31 11:08:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5188, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 11:08:04', '1', 'admin', '2022-03-31 11:08:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5189, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 11:12:35', '1', 'admin', '2022-03-31 11:12:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5190, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 11:12:35', '1', 'admin', '2022-03-31 11:12:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5191, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 11:14:10', '1', 'admin', '2022-03-31 11:14:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5192, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 11:14:10', '1', 'admin', '2022-03-31 11:14:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5193, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 11:14:11', '1', 'admin', '2022-03-31 11:14:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5194, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 11:14:11', '1', 'admin', '2022-03-31 11:14:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5195, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 11:23:32', '1', 'admin', '2022-03-31 11:23:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5196, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 11:23:32', '1', 'admin', '2022-03-31 11:23:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5197, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 11:23:34', '1', 'admin', '2022-03-31 11:23:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5198, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 11:23:34', '1', 'admin', '2022-03-31 11:23:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5199, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 11:23:36', '1', 'admin', '2022-03-31 11:23:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5200, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 11:23:37', '1', 'admin', '2022-03-31 11:23:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5201, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 11:23:37', '1', 'admin', '2022-03-31 11:23:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5202, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-03-31 11:33:05', '1', 'admin', '2022-03-31 11:33:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5203, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-31 11:43:00', '1', 'admin', '2022-03-31 11:43:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5204, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-31 11:43:00', '1', 'admin', '2022-03-31 11:43:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5205, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-31 11:47:14', '1', 'admin', '2022-03-31 11:47:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5206, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 11:47:15', '1', 'admin', '2022-03-31 11:47:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5207, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 11:47:15', '1', 'admin', '2022-03-31 11:47:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5208, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 11:48:10', '1', 'admin', '2022-03-31 11:48:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5209, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 11:49:04', '1', 'admin', '2022-03-31 11:49:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5210, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 11:49:07', '1', 'admin', '2022-03-31 11:49:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5211, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-03-31 11:50:31', '1', 'admin', '2022-03-31 11:50:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5212, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 11:50:36', '1', 'admin', '2022-03-31 11:50:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5213, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 11:50:36', '1', 'admin', '2022-03-31 11:50:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5214, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:47:34', '1', 'admin', '2022-03-31 13:47:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5215, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:47:35', '1', 'admin', '2022-03-31 13:47:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5216, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 13:48:18', '1', 'admin', '2022-03-31 13:48:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5217, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 13:48:18', '1', 'admin', '2022-03-31 13:48:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5218, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:48:21', '1', 'admin', '2022-03-31 13:48:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5219, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:48:21', '1', 'admin', '2022-03-31 13:48:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5220, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 13:48:23', '1', 'admin', '2022-03-31 13:48:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5221, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 13:48:23', '1', 'admin', '2022-03-31 13:48:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5222, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:49:56', '1', 'admin', '2022-03-31 13:49:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5223, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:49:57', '1', 'admin', '2022-03-31 13:49:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5224, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:49:58', '1', 'admin', '2022-03-31 13:49:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5225, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:49:58', '1', 'admin', '2022-03-31 13:49:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5226, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 13:49:59', '1', 'admin', '2022-03-31 13:49:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5227, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 13:49:59', '1', 'admin', '2022-03-31 13:49:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5228, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-31 13:50:00', '1', 'admin', '2022-03-31 13:50:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5229, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-31 13:50:00', '1', 'admin', '2022-03-31 13:50:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5230, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-03-31 13:51:47', '1', 'admin', '2022-03-31 13:51:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5231, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-03-31 13:51:47', '1', 'admin', '2022-03-31 13:51:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5232, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:53:46', '1', 'admin', '2022-03-31 13:53:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5233, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:53:46', '1', 'admin', '2022-03-31 13:53:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5234, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:53:47', '1', 'admin', '2022-03-31 13:53:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5235, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:53:47', '1', 'admin', '2022-03-31 13:53:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5236, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 13:53:49', '1', 'admin', '2022-03-31 13:53:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5237, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 13:53:49', '1', 'admin', '2022-03-31 13:53:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5238, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-03-31 13:53:50', '1', 'admin', '2022-03-31 13:53:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5239, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-03-31 13:53:50', '1', 'admin', '2022-03-31 13:53:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5240, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-31 13:53:52', '1', 'admin', '2022-03-31 13:53:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5241, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-31 13:53:52', '1', 'admin', '2022-03-31 13:53:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5242, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-03-31 13:53:55', '1', 'admin', '2022-03-31 13:53:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5243, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-31 13:53:57', '1', 'admin', '2022-03-31 13:53:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5244, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 13:53:57', '1', 'admin', '2022-03-31 13:53:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5245, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 13:53:57', '1', 'admin', '2022-03-31 13:53:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5246, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-31 13:54:36', '1', 'admin', '2022-03-31 13:54:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5247, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 13:54:36', '1', 'admin', '2022-03-31 13:54:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5248, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 13:54:36', '1', 'admin', '2022-03-31 13:54:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5249, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:58:06', '1', 'admin', '2022-03-31 13:58:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5250, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:58:06', '1', 'admin', '2022-03-31 13:58:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5251, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 13:58:08', '1', 'admin', '2022-03-31 13:58:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5252, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 13:58:08', '1', 'admin', '2022-03-31 13:58:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5253, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 13:58:09', '1', 'admin', '2022-03-31 13:58:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5254, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 13:58:09', '1', 'admin', '2022-03-31 13:58:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5255, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-31 14:00:30', '1', 'admin', '2022-03-31 14:00:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5256, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 14:00:30', '1', 'admin', '2022-03-31 14:00:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5257, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:00:30', '1', 'admin', '2022-03-31 14:00:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5258, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:00:33', '1', 'admin', '2022-03-31 14:00:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5259, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:00:35', '1', 'admin', '2022-03-31 14:00:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5260, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:00:46', '1', 'admin', '2022-03-31 14:00:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5261, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-03-31 14:00:51', '1', 'admin', '2022-03-31 14:00:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5262, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:02:26', '1', 'admin', '2022-03-31 14:02:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5263, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 14:02:26', '1', 'admin', '2022-03-31 14:02:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5264, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:03:52', '1', 'admin', '2022-03-31 14:03:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:04:00', '1', 'admin', '2022-03-31 14:04:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5266, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:04:04', '1', 'admin', '2022-03-31 14:04:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5267, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:04:13', '1', 'admin', '2022-03-31 14:04:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5268, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-03-31 14:04:16', '1', 'admin', '2022-03-31 14:04:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5269, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 14:04:23', '1', 'admin', '2022-03-31 14:04:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5270, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:04:23', '1', 'admin', '2022-03-31 14:04:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5271, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:05:08', '1', 'admin', '2022-03-31 14:05:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:05:10', '1', 'admin', '2022-03-31 14:05:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5273, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-03-31 14:05:13', '1', 'admin', '2022-03-31 14:05:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:05:16', '1', 'admin', '2022-03-31 14:05:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 14:05:16', '1', 'admin', '2022-03-31 14:05:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-03-31 14:06:43', '1', 'admin', '2022-03-31 14:06:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5277, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:06:45', '1', 'admin', '2022-03-31 14:06:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5278, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 14:06:45', '1', 'admin', '2022-03-31 14:06:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-31 14:07:56', '1', 'admin', '2022-03-31 14:07:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5280, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 14:07:56', '1', 'admin', '2022-03-31 14:07:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:07:56', '1', 'admin', '2022-03-31 14:07:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-03-31 14:07:58', '1', 'admin', '2022-03-31 14:07:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-03-31 14:07:58', '1', 'admin', '2022-03-31 14:07:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5284, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-03-31 14:08:01', '1', 'admin', '2022-03-31 14:08:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5285, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-03-31 14:08:01', '1', 'admin', '2022-03-31 14:08:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5286, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:08:01', '1', 'admin', '2022-03-31 14:08:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5287, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-03-31 14:08:13', '1', 'admin', '2022-03-31 14:08:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5288, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-03-31 14:09:20', '1', 'admin', '2022-03-31 14:09:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-03-31 14:09:20', '1', 'admin', '2022-03-31 14:09:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 14:15:49', '1', 'admin', '2022-03-31 14:15:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5291, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 14:15:49', '1', 'admin', '2022-03-31 14:15:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5292, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-03-31 14:15:51', '1', 'admin', '2022-03-31 14:15:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5293, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-03-31 14:15:52', '1', 'admin', '2022-03-31 14:15:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5294, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:15:52', '1', 'admin', '2022-03-31 14:15:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5295, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:15:56', '1', 'admin', '2022-03-31 14:15:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5296, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:16:22', '1', 'admin', '2022-03-31 14:16:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5297, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:16:27', '1', 'admin', '2022-03-31 14:16:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5298, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:16:39', '1', 'admin', '2022-03-31 14:16:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5299, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:18:31', '1', 'admin', '2022-03-31 14:18:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5300, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-03-31 14:39:52', '1', 'admin', '2022-03-31 14:39:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5301, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-03-31 14:39:52', '1', 'admin', '2022-03-31 14:39:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5302, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2022-03-31 14:39:54', '1', 'admin', '2022-03-31 14:39:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5303, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-03-31 14:39:58', '1', 'admin', '2022-03-31 14:39:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5304, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:40:15', '1', 'admin', '2022-03-31 14:40:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5305, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-03-31 14:45:24', '1', 'admin', '2022-03-31 14:45:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5306, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-03-31 16:10:02', '1', 'admin', '2022-03-31 16:10:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5307, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-03-31 16:10:02', '1', 'admin', '2022-03-31 16:10:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5308, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-03-31 16:10:07', '1', 'admin', '2022-03-31 16:10:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5309, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-03-31 16:10:07', '1', 'admin', '2022-03-31 16:10:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-01 12:01:23', '1', 'admin', '2022-04-01 12:01:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5311, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-01 12:01:23', '1', 'admin', '2022-04-01 12:01:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5312, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-01 12:01:24', '1', 'admin', '2022-04-01 12:01:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5313, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-01 12:01:24', '1', 'admin', '2022-04-01 12:01:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-01 12:02:21', '1', 'admin', '2022-04-01 12:02:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5315, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-01 12:02:21', '1', 'admin', '2022-04-01 12:02:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-01 12:02:22', '1', 'admin', '2022-04-01 12:02:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5317, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-01 12:02:23', '1', 'admin', '2022-04-01 12:02:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5318, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-02 12:40:16', '1', 'admin', '2022-04-02 12:40:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-02 12:40:16', '1', 'admin', '2022-04-02 12:40:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-02 12:40:18', '1', 'admin', '2022-04-02 12:40:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5321, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-02 12:40:18', '1', 'admin', '2022-04-02 12:40:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5322, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 17:34:29', '1', 'admin', '2022-04-03 17:34:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 17:34:29', '1', 'admin', '2022-04-03 17:34:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5324, NULL, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 17:34:36', '1', 'guest', '2022-04-03 17:34:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5325, NULL, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 17:34:36', '1', 'guest', '2022-04-03 17:34:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5326, NULL, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 17:34:40', '1', 'guest', '2022-04-03 17:34:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5327, NULL, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 17:34:40', '1', 'guest', '2022-04-03 17:34:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5328, NULL, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 17:34:41', '1', 'guest', '2022-04-03 17:34:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5329, NULL, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 17:34:41', '1', 'guest', '2022-04-03 17:34:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5330, 3, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 17:34:58', '1', 'admin', '2022-04-03 17:34:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5331, 3, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 17:34:58', '1', 'admin', '2022-04-03 17:34:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5332, 3, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/user/upload', '2022-04-03 17:35:01', '1', 'admin', '2022-04-03 17:35:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5333, 3, 'Chrome 9', 'POST', 'http://10.19.34.33:8080/system/user/upload', '10.19.34.33', '/system/user/upload', '2022-04-03 17:35:01', '1', 'admin', '2022-04-03 17:35:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5334, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 17:53:32', '1', 'admin', '2022-04-03 17:53:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 17:53:32', '1', 'admin', '2022-04-03 17:53:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5336, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 17:53:36', '1', 'admin', '2022-04-03 17:53:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5337, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 17:53:36', '1', 'admin', '2022-04-03 17:53:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5338, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 17:54:02', '1', 'admin', '2022-04-03 17:54:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5339, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 17:54:02', '1', 'admin', '2022-04-03 17:54:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-03 17:54:04', '1', 'admin', '2022-04-03 17:54:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-03 17:54:04', '1', 'admin', '2022-04-03 17:54:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5342, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 17:54:15', '1', 'admin', '2022-04-03 17:54:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5343, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 17:54:15', '1', 'admin', '2022-04-03 17:54:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5344, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 17:54:16', '1', 'admin', '2022-04-03 17:54:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5345, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 17:54:16', '1', 'admin', '2022-04-03 17:54:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 17:54:44', '1', 'admin', '2022-04-03 17:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 17:54:44', '1', 'admin', '2022-04-03 17:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5348, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 17:54:44', '1', 'admin', '2022-04-03 17:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5349, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 17:54:45', '1', 'admin', '2022-04-03 17:54:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 17:58:28', '1', 'admin', '2022-04-03 17:58:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 17:58:29', '1', 'admin', '2022-04-03 17:58:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5352, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 17:58:29', '1', 'admin', '2022-04-03 17:58:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5353, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 17:58:30', '1', 'admin', '2022-04-03 17:58:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 18:01:56', '1', 'admin', '2022-04-03 18:01:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5355, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 18:01:56', '1', 'admin', '2022-04-03 18:01:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5356, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 18:01:57', '1', 'admin', '2022-04-03 18:01:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5357, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 18:01:57', '1', 'admin', '2022-04-03 18:01:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-03 18:02:11', '1', 'admin', '2022-04-03 18:02:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5359, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-03 18:02:11', '1', 'admin', '2022-04-03 18:02:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5360, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 18:03:10', '1', 'admin', '2022-04-03 18:03:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5361, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 18:03:10', '1', 'admin', '2022-04-03 18:03:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 18:09:13', '1', 'admin', '2022-04-03 18:09:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 18:09:13', '1', 'admin', '2022-04-03 18:09:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5364, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 18:09:14', '1', 'admin', '2022-04-03 18:09:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5365, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 18:09:14', '1', 'admin', '2022-04-03 18:09:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5366, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 18:10:21', '1', 'admin', '2022-04-03 18:10:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5367, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 18:10:21', '1', 'admin', '2022-04-03 18:10:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5368, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 18:10:22', '1', 'admin', '2022-04-03 18:10:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5369, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-03 18:10:22', '1', 'admin', '2022-04-03 18:10:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5370, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 18:27:54', '1', 'admin', '2022-04-03 18:27:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 18:27:54', '1', 'admin', '2022-04-03 18:27:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5372, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 18:27:57', '1', 'admin', '2022-04-03 18:27:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5373, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-03 18:27:57', '1', 'admin', '2022-04-03 18:27:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-03 18:28:41', '1', 'admin', '2022-04-03 18:28:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-03 18:28:41', '1', 'admin', '2022-04-03 18:28:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5376, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-03 18:28:41', '1', 'admin', '2022-04-03 18:28:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-03 18:28:44', '1', 'admin', '2022-04-03 18:28:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5378, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-03 18:28:47', '1', 'admin', '2022-04-03 18:28:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5379, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-03 18:28:51', '1', 'admin', '2022-04-03 18:28:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5380, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-03 18:28:53', '1', 'admin', '2022-04-03 18:28:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-03 18:28:53', '1', 'admin', '2022-04-03 18:28:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5382, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 18:28:56', '1', 'admin', '2022-04-03 18:28:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 18:30:49', '1', 'admin', '2022-04-03 18:30:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5384, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E6%97%BA%E4%BB%94&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-04-03 18:30:49', '1', 'admin', '2022-04-03 18:30:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-03 18:30:51', '1', 'admin', '2022-04-03 18:30:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5386, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-03 18:30:51', '1', 'admin', '2022-04-03 18:30:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5387, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 18:30:54', '1', 'admin', '2022-04-03 18:30:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5388, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 18:30:54', '1', 'admin', '2022-04-03 18:30:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5389, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-03 18:30:56', '1', 'admin', '2022-04-03 18:30:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5390, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-03 18:30:56', '1', 'admin', '2022-04-03 18:30:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5391, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 18:33:06', '1', 'admin', '2022-04-03 18:33:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5392, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-03 18:33:06', '1', 'admin', '2022-04-03 18:33:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5393, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 18:33:45', '1', 'admin', '2022-04-03 18:33:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5394, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E6%97%BA%E4%BB%94&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-04-03 18:33:45', '1', 'admin', '2022-04-03 18:33:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5395, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-03 18:36:33', '1', 'admin', '2022-04-03 18:36:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5396, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 18:36:39', '1', 'admin', '2022-04-03 18:36:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5397, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 18:36:39', '1', 'admin', '2022-04-03 18:36:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5398, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-03 18:36:41', '1', 'admin', '2022-04-03 18:36:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5399, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-03 18:36:41', '1', 'admin', '2022-04-03 18:36:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5400, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 18:37:11', '1', 'admin', '2022-04-03 18:37:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5401, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-03 18:37:11', '1', 'admin', '2022-04-03 18:37:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5402, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-03 19:43:08', '1', 'admin', '2022-04-03 19:43:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5403, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-03 19:43:08', '1', 'admin', '2022-04-03 19:43:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5404, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-03 19:43:09', '1', 'admin', '2022-04-03 19:43:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5405, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-03 19:43:09', '1', 'admin', '2022-04-03 19:43:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5406, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-03 19:43:32', '1', 'admin', '2022-04-03 19:43:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5407, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windwos&url=%E6%97%BA%E4%BB%94&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-04-03 19:43:32', '1', 'admin', '2022-04-03 19:43:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5408, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-03 19:43:35', '1', 'admin', '2022-04-03 19:43:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5409, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-03 19:43:35', '1', 'admin', '2022-04-03 19:43:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5410, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-03 19:44:52', '1', 'admin', '2022-04-03 19:44:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5411, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-03 19:44:53', '1', 'admin', '2022-04-03 19:44:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5412, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-03 19:45:59', '1', 'admin', '2022-04-03 19:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5413, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-03 19:46:14', '1', 'admin', '2022-04-03 19:46:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5414, 3, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 20:36:17', '1', 'admin', '2022-04-03 20:36:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5415, 3, 'Chrome 9', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 20:36:17', '1', 'admin', '2022-04-03 20:36:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5416, NULL, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 20:36:35', '1', 'guest', '2022-04-03 20:36:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5417, NULL, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 20:36:35', '1', 'guest', '2022-04-03 20:36:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5418, 3, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 20:37:17', '1', 'admin', '2022-04-03 20:37:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5419, 3, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 20:37:17', '1', 'admin', '2022-04-03 20:37:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5420, 3, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 20:37:19', '1', 'admin', '2022-04-03 20:37:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5421, 3, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 20:37:19', '1', 'admin', '2022-04-03 20:37:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5422, 3, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuTop', '2022-04-03 20:37:21', '1', 'admin', '2022-04-03 20:37:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5423, 3, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/res/menuLeft', '2022-04-03 20:37:21', '1', 'admin', '2022-04-03 20:37:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5424, 3, 'Firefox 6', 'GET', 'http://10.19.34.33:8080/', '10.19.34.33', '/system/user/upload', '2022-04-03 20:37:23', '1', 'admin', '2022-04-03 20:37:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5425, 3, 'Firefox 6', 'POST', 'http://10.19.34.33:8080/system/user/upload', '10.19.34.33', '/system/user/uploada', '2022-04-03 20:37:23', '1', 'admin', '2022-04-03 20:37:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5426, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-04 14:59:37', '1', 'admin', '2022-04-04 14:59:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5427, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-04 14:59:37', '1', 'admin', '2022-04-04 14:59:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5428, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-04 14:59:39', '1', 'admin', '2022-04-04 14:59:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5429, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-04 14:59:39', '1', 'admin', '2022-04-04 14:59:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5430, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-04 14:59:40', '1', 'admin', '2022-04-04 14:59:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5431, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-04 14:59:40', '1', 'admin', '2022-04-04 14:59:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5432, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-04 14:59:41', '1', 'admin', '2022-04-04 14:59:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5433, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-04 14:59:41', '1', 'admin', '2022-04-04 14:59:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5434, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-04 14:59:53', '1', 'admin', '2022-04-04 14:59:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5435, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-04 14:59:53', '1', 'admin', '2022-04-04 14:59:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5436, NULL, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-04 19:50:59', '1', 'guest', '2022-04-04 19:50:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5437, NULL, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-04 19:50:59', '1', 'guest', '2022-04-04 19:50:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5438, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-04 20:01:42', '1', 'admin', '2022-04-04 20:01:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5439, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-04 20:01:42', '1', 'admin', '2022-04-04 20:01:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5440, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-04 20:01:46', '1', 'admin', '2022-04-04 20:01:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5441, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-04 20:01:47', '1', 'admin', '2022-04-04 20:01:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5442, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-04-04 20:01:54', '1', 'admin', '2022-04-04 20:01:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5443, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-04-04 20:01:54', '1', 'admin', '2022-04-04 20:01:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5444, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-04-04 20:02:02', '1', 'admin', '2022-04-04 20:02:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5445, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-04-04 20:02:13', '1', 'admin', '2022-04-04 20:02:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5446, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-04 20:02:31', '1', 'admin', '2022-04-04 20:02:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5447, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-04 20:02:31', '1', 'admin', '2022-04-04 20:02:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5448, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-04-04 20:02:40', '1', 'admin', '2022-04-04 20:02:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5449, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-04 20:14:04', '1', 'admin', '2022-04-04 20:14:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5450, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-04 20:14:04', '1', 'admin', '2022-04-04 20:14:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5451, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-04 20:14:13', '1', 'guest', '2022-04-04 20:14:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5452, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-04 20:14:13', '1', 'guest', '2022-04-04 20:14:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5453, NULL, 'Firefox 6', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-04 20:15:09', '1', 'guest', '2022-04-04 20:15:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5454, NULL, 'Firefox 6', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-04 20:15:09', '1', 'guest', '2022-04-04 20:15:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5455, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-04 20:15:17', '1', 'admin', '2022-04-04 20:15:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5456, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-04 20:15:17', '1', 'admin', '2022-04-04 20:15:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5457, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-04 20:21:53', '1', 'admin', '2022-04-04 20:21:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5458, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-04 20:21:54', '1', 'admin', '2022-04-04 20:21:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5459, NULL, 'Firefox 6', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-04 20:22:07', '1', 'guest', '2022-04-04 20:22:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5460, NULL, 'Firefox 6', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-04 20:22:07', '1', 'guest', '2022-04-04 20:22:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5461, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-04 20:22:23', '1', 'admin', '2022-04-04 20:22:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5462, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-04 20:22:23', '1', 'admin', '2022-04-04 20:22:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5463, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-05 10:59:05', '1', 'admin', '2022-04-05 10:59:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5464, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-05 10:59:05', '1', 'admin', '2022-04-05 10:59:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5465, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-05 10:59:18', '1', 'guest', '2022-04-05 10:59:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5466, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-05 10:59:18', '1', 'guest', '2022-04-05 10:59:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5467, NULL, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuTop', '2022-04-05 10:59:34', '1', 'guest', '2022-04-05 10:59:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5468, NULL, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuLeft', '2022-04-05 10:59:34', '1', 'guest', '2022-04-05 10:59:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5469, NULL, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuTop', '2022-04-05 11:15:26', '1', 'guest', '2022-04-05 11:15:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5470, NULL, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuLeft', '2022-04-05 11:15:26', '1', 'guest', '2022-04-05 11:15:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5471, NULL, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuTop', '2022-04-05 11:15:29', '1', 'guest', '2022-04-05 11:15:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5472, NULL, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuLeft', '2022-04-05 11:15:29', '1', 'guest', '2022-04-05 11:15:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5473, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuTop', '2022-04-05 11:15:49', '1', 'admin', '2022-04-05 11:15:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5474, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/res/menuLeft', '2022-04-05 11:15:49', '1', 'admin', '2022-04-05 11:15:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5475, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/user/check', '2022-04-05 11:15:52', '1', 'admin', '2022-04-05 11:15:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5476, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.1', '/system/user/tablesData', '2022-04-05 11:15:52', '1', 'admin', '2022-04-05 11:15:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5477, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/user/upload', '2022-04-05 11:16:15', '1', 'admin', '2022-04-05 11:16:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5478, 3, 'Chrome 9', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.1', '/system/user/uploada', '2022-04-05 11:16:15', '1', 'admin', '2022-04-05 11:16:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5479, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.1', '/system/user/download', '2022-04-05 11:16:17', '1', 'admin', '2022-04-05 11:16:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5480, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.1', '/system/user/tablesData', '2022-04-05 11:16:17', '1', 'admin', '2022-04-05 11:16:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5481, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.1', '/system/user/showdown', '2022-04-05 11:26:43', '1', 'admin', '2022-04-05 11:26:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5482, 3, 'Chrome 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.1', '/system/user/showdown', '2022-04-05 11:32:05', '1', 'admin', '2022-04-05 11:32:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5483, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-05 20:41:35', '1', 'admin', '2022-04-05 20:41:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5484, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-05 20:41:35', '1', 'admin', '2022-04-05 20:41:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5485, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-05 20:41:37', '1', 'admin', '2022-04-05 20:41:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5486, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-05 20:41:37', '1', 'admin', '2022-04-05 20:41:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5487, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-04-05 20:47:14', '1', 'admin', '2022-04-05 20:47:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5488, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-04-05 20:47:14', '1', 'admin', '2022-04-05 20:47:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5489, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-04-05 20:47:15', '1', 'admin', '2022-04-05 20:47:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5490, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-05 20:47:15', '1', 'admin', '2022-04-05 20:47:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5491, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-04-05 20:47:18', '1', 'admin', '2022-04-05 20:47:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5492, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-04-05 20:47:18', '1', 'admin', '2022-04-05 20:47:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5493, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-05 20:47:26', '1', 'admin', '2022-04-05 20:47:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5494, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-04-05 20:47:28', '1', 'admin', '2022-04-05 20:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5495, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-04-05 20:47:28', '1', 'admin', '2022-04-05 20:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5496, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-05 20:47:41', '1', 'admin', '2022-04-05 20:47:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5497, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-04-05 20:49:37', '1', 'admin', '2022-04-05 20:49:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5498, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-04-05 20:49:37', '1', 'admin', '2022-04-05 20:49:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5499, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-05 20:49:40', '1', 'admin', '2022-04-05 20:49:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5500, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-06 11:43:55', '1', 'admin', '2022-04-06 11:43:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5501, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-06 11:43:55', '1', 'admin', '2022-04-06 11:43:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5502, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-06 11:44:24', '1', 'guest', '2022-04-06 11:44:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5503, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-06 11:44:24', '1', 'guest', '2022-04-06 11:44:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5504, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-06 11:45:20', '1', 'guest', '2022-04-06 11:45:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5505, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-06 11:45:20', '1', 'guest', '2022-04-06 11:45:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5506, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-06 11:45:23', '1', 'guest', '2022-04-06 11:45:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5507, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-06 11:45:23', '1', 'guest', '2022-04-06 11:45:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5508, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-06 11:45:24', '1', 'guest', '2022-04-06 11:45:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5509, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-06 11:45:24', '1', 'guest', '2022-04-06 11:45:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5510, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-06 11:45:31', '1', 'guest', '2022-04-06 11:45:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5511, NULL, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-06 11:45:31', '1', 'guest', '2022-04-06 11:45:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5512, 3, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuTop', '2022-04-06 11:46:34', '1', 'admin', '2022-04-06 11:46:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5513, 3, 'Chrome 9', 'GET', 'http://192.168.2.3:8080/', '192.168.2.3', '/system/res/menuLeft', '2022-04-06 11:46:34', '1', 'admin', '2022-04-06 11:46:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5514, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-06 13:15:26', '1', 'admin', '2022-04-06 13:15:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5515, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-06 13:15:26', '1', 'admin', '2022-04-06 13:15:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5516, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-06 13:15:34', '1', 'guest', '2022-04-06 13:15:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5517, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-06 13:15:34', '1', 'guest', '2022-04-06 13:15:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5518, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-06 20:00:53', '1', 'admin', '2022-04-06 20:00:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5519, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-06 20:00:53', '1', 'admin', '2022-04-06 20:00:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5520, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-06 20:00:54', '1', 'admin', '2022-04-06 20:00:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5521, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-06 20:00:54', '1', 'admin', '2022-04-06 20:00:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5522, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 10:17:42', '1', 'admin', '2022-04-07 10:17:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5523, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 10:17:42', '1', 'admin', '2022-04-07 10:17:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5524, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 10:17:43', '1', 'admin', '2022-04-07 10:17:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5525, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 10:17:43', '1', 'admin', '2022-04-07 10:17:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5526, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:05:08', '1', 'admin', '2022-04-07 11:05:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5527, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:05:08', '1', 'admin', '2022-04-07 11:05:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5528, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 11:05:16', '1', 'admin', '2022-04-07 11:05:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5529, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:05:16', '1', 'admin', '2022-04-07 11:05:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5530, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:12:35', '1', 'guest', '2022-04-07 11:12:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5531, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:12:35', '1', 'guest', '2022-04-07 11:12:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5532, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:12:54', '1', 'admin', '2022-04-07 11:12:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5533, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:12:54', '1', 'admin', '2022-04-07 11:12:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5534, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 11:12:55', '1', 'admin', '2022-04-07 11:12:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5535, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:12:55', '1', 'admin', '2022-04-07 11:12:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5536, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:16:51', '1', 'admin', '2022-04-07 11:16:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5537, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:16:51', '1', 'admin', '2022-04-07 11:16:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5538, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 11:16:52', '1', 'admin', '2022-04-07 11:16:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5539, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:16:52', '1', 'admin', '2022-04-07 11:16:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5540, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:18:03', '1', 'admin', '2022-04-07 11:18:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5541, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:18:04', '1', 'admin', '2022-04-07 11:18:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5542, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 11:18:05', '1', 'admin', '2022-04-07 11:18:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5543, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:18:05', '1', 'admin', '2022-04-07 11:18:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5544, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:19:43', '1', 'admin', '2022-04-07 11:19:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5545, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:19:43', '1', 'admin', '2022-04-07 11:19:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5546, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 11:19:45', '1', 'admin', '2022-04-07 11:19:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5547, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:19:45', '1', 'admin', '2022-04-07 11:19:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5548, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-07 11:23:44', '1', 'admin', '2022-04-07 11:23:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5549, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E4%BD%A0%E5%A5%BD&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:23:45', '1', 'admin', '2022-04-07 11:23:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5550, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-07 11:23:45', '1', 'admin', '2022-04-07 11:23:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5551, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-07 11:23:45', '1', 'admin', '2022-04-07 11:23:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5552, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:23:47', '1', 'admin', '2022-04-07 11:23:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5553, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:23:47', '1', 'admin', '2022-04-07 11:23:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5554, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-07 11:23:49', '1', 'admin', '2022-04-07 11:23:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5555, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-07 11:23:49', '1', 'admin', '2022-04-07 11:23:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5556, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:33:55', '1', 'admin', '2022-04-07 11:33:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5557, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:33:55', '1', 'admin', '2022-04-07 11:33:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5558, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 11:33:56', '1', 'admin', '2022-04-07 11:33:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5559, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:33:56', '1', 'admin', '2022-04-07 11:33:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5560, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-07 11:34:14', '1', 'admin', '2022-04-07 11:34:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5561, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E5%93%88%E5%93%88%E5%93%88&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:34:14', '1', 'admin', '2022-04-07 11:34:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5562, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-07 11:34:29', '1', 'admin', '2022-04-07 11:34:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5563, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-07 11:34:29', '1', 'admin', '2022-04-07 11:34:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5564, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:36:56', '1', 'admin', '2022-04-07 11:36:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5565, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:36:56', '1', 'admin', '2022-04-07 11:36:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5566, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-07 11:36:57', '1', 'admin', '2022-04-07 11:36:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5567, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-07 11:36:57', '1', 'admin', '2022-04-07 11:36:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5568, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 11:36:58', '1', 'admin', '2022-04-07 11:36:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5569, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:36:58', '1', 'admin', '2022-04-07 11:36:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5570, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-07 11:38:26', '1', 'admin', '2022-04-07 11:38:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5571, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E8%BF%99%E6%98%AF%E6%96%B0%E5%A2%9E%E6%93%8D%E4%BD%9C&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '127.0.0.1', '/system/user/uploada', '2022-04-07 11:38:26', '1', 'admin', '2022-04-07 11:38:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5572, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 11:38:53', '1', 'admin', '2022-04-07 11:38:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5573, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 11:38:53', '1', 'admin', '2022-04-07 11:38:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5574, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-07 11:38:54', '1', 'admin', '2022-04-07 11:38:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5575, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-07 11:38:55', '1', 'admin', '2022-04-07 11:38:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5576, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 20:50:24', '1', 'admin', '2022-04-07 20:50:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5577, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 20:50:24', '1', 'admin', '2022-04-07 20:50:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5578, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 20:50:29', '1', 'admin', '2022-04-07 20:50:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5579, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 20:50:29', '1', 'admin', '2022-04-07 20:50:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5580, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 20:50:32', '1', 'admin', '2022-04-07 20:50:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5581, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 20:50:32', '1', 'admin', '2022-04-07 20:50:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5582, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 20:50:39', '1', 'admin', '2022-04-07 20:50:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5583, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 20:53:45', '1', 'admin', '2022-04-07 20:53:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5584, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 20:53:45', '1', 'admin', '2022-04-07 20:53:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5585, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-07 20:53:47', '1', 'admin', '2022-04-07 20:53:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5586, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-07 20:53:47', '1', 'admin', '2022-04-07 20:53:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5587, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 20:53:49', '1', 'admin', '2022-04-07 20:53:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5588, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 20:53:49', '1', 'admin', '2022-04-07 20:53:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5589, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 20:53:51', '1', 'admin', '2022-04-07 20:53:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5590, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:00:47', '1', 'guest', '2022-04-07 21:00:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5591, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:00:47', '1', 'guest', '2022-04-07 21:00:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5592, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-07 21:00:55', '1', 'guest', '2022-04-07 21:00:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5593, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-07 21:00:55', '1', 'guest', '2022-04-07 21:00:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5594, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-07 21:01:14', '1', 'admin', '2022-04-07 21:01:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5595, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-07 21:01:14', '1', 'admin', '2022-04-07 21:01:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5596, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/download', '2022-04-07 21:01:18', '1', 'admin', '2022-04-07 21:01:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5597, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/tablesData', '2022-04-07 21:01:18', '1', 'admin', '2022-04-07 21:01:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5598, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-07 21:02:17', '1', 'admin', '2022-04-07 21:02:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5599, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-07 21:02:17', '1', 'admin', '2022-04-07 21:02:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5600, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/showdown', '2022-04-07 21:02:42', '1', 'admin', '2022-04-07 21:02:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5601, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/showdown', '2022-04-07 21:03:01', '1', 'admin', '2022-04-07 21:03:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5602, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/showdown', '2022-04-07 21:03:06', '1', 'admin', '2022-04-07 21:03:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5603, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:04:14', '1', 'guest', '2022-04-07 21:04:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5604, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:04:14', '1', 'guest', '2022-04-07 21:04:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5605, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:04:30', '1', 'admin', '2022-04-07 21:04:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5606, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:04:30', '1', 'admin', '2022-04-07 21:04:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5607, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:05:13', '1', 'admin', '2022-04-07 21:05:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5608, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:05:13', '1', 'admin', '2022-04-07 21:05:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5609, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:19', '1', 'admin', '2022-04-07 21:05:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5610, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:22', '1', 'admin', '2022-04-07 21:05:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5611, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:24', '1', 'admin', '2022-04-07 21:05:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5612, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:26', '1', 'admin', '2022-04-07 21:05:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5613, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:27', '1', 'admin', '2022-04-07 21:05:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5614, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:33', '1', 'admin', '2022-04-07 21:05:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5615, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:35', '1', 'admin', '2022-04-07 21:05:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5616, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:36', '1', 'admin', '2022-04-07 21:05:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5617, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:05:38', '1', 'admin', '2022-04-07 21:05:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5618, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:06:44', '1', 'admin', '2022-04-07 21:06:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5619, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:06:44', '1', 'admin', '2022-04-07 21:06:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5620, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:06:46', '1', 'admin', '2022-04-07 21:06:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5621, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:06:46', '1', 'admin', '2022-04-07 21:06:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5622, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:06:48', '1', 'admin', '2022-04-07 21:06:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5623, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-07 21:07:25', '1', 'admin', '2022-04-07 21:07:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5624, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 21:07:25', '1', 'admin', '2022-04-07 21:07:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5625, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 21:07:25', '1', 'admin', '2022-04-07 21:07:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5626, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 21:07:28', '1', 'admin', '2022-04-07 21:07:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5627, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 21:07:32', '1', 'admin', '2022-04-07 21:07:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5628, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-07 21:07:35', '1', 'admin', '2022-04-07 21:07:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5629, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 21:07:40', '1', 'admin', '2022-04-07 21:07:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5630, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 21:07:40', '1', 'admin', '2022-04-07 21:07:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5631, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:10:29', '1', 'admin', '2022-04-07 21:10:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5632, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:10:29', '1', 'admin', '2022-04-07 21:10:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:10:37', '1', 'admin', '2022-04-07 21:10:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:10:37', '1', 'admin', '2022-04-07 21:10:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:10:38', '1', 'admin', '2022-04-07 21:10:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5636, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:11:07', '1', 'admin', '2022-04-07 21:11:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5637, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:11:14', '1', 'admin', '2022-04-07 21:11:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5638, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:13:37', '1', 'admin', '2022-04-07 21:13:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5639, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:14:59', '1', 'admin', '2022-04-07 21:14:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5640, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:17:19', '1', 'admin', '2022-04-07 21:17:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5641, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:19:26', '1', 'admin', '2022-04-07 21:19:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5642, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:19:26', '1', 'admin', '2022-04-07 21:19:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:19:29', '1', 'admin', '2022-04-07 21:19:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:19:33', '1', 'admin', '2022-04-07 21:19:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:19:33', '1', 'admin', '2022-04-07 21:19:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5646, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:19:35', '1', 'admin', '2022-04-07 21:19:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5647, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:19:41', '1', 'admin', '2022-04-07 21:19:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5648, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:19:41', '1', 'admin', '2022-04-07 21:19:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:19:43', '1', 'admin', '2022-04-07 21:19:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5650, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:20:26', '1', 'admin', '2022-04-07 21:20:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5651, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:20:26', '1', 'admin', '2022-04-07 21:20:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5652, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:20:28', '1', 'admin', '2022-04-07 21:20:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:20:28', '1', 'admin', '2022-04-07 21:20:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:21:04', '1', 'admin', '2022-04-07 21:21:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5655, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:23:24', '1', 'admin', '2022-04-07 21:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5656, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:24:51', '1', 'admin', '2022-04-07 21:24:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5657, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:24:51', '1', 'admin', '2022-04-07 21:24:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:24:52', '1', 'admin', '2022-04-07 21:24:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:24:52', '1', 'admin', '2022-04-07 21:24:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5660, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:24:54', '1', 'admin', '2022-04-07 21:24:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5661, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:25:37', '1', 'admin', '2022-04-07 21:25:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5662, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:26:06', '1', 'admin', '2022-04-07 21:26:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:28:42', '1', 'admin', '2022-04-07 21:28:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5664, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:28:42', '1', 'admin', '2022-04-07 21:28:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5665, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:28:44', '1', 'admin', '2022-04-07 21:28:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5666, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:28:44', '1', 'admin', '2022-04-07 21:28:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5667, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:28:45', '1', 'admin', '2022-04-07 21:28:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5668, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:29:21', '1', 'admin', '2022-04-07 21:29:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5669, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:30:30', '1', 'admin', '2022-04-07 21:30:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5670, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:30:48', '1', 'admin', '2022-04-07 21:30:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5671, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:31:04', '1', 'admin', '2022-04-07 21:31:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5672, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:32:06', '1', 'admin', '2022-04-07 21:32:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5673, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:32:06', '1', 'admin', '2022-04-07 21:32:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5674, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:32:08', '1', 'admin', '2022-04-07 21:32:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5675, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:32:08', '1', 'admin', '2022-04-07 21:32:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5676, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:32:11', '1', 'admin', '2022-04-07 21:32:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5677, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:32:33', '1', 'admin', '2022-04-07 21:32:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5678, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:32:59', '1', 'admin', '2022-04-07 21:32:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5679, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:46:01', '1', 'admin', '2022-04-07 21:46:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5680, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:49:01', '1', 'admin', '2022-04-07 21:49:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5681, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:49:01', '1', 'admin', '2022-04-07 21:49:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5682, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:49:03', '1', 'admin', '2022-04-07 21:49:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5683, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:49:07', '1', 'admin', '2022-04-07 21:49:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5684, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:49:07', '1', 'admin', '2022-04-07 21:49:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5685, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:49:09', '1', 'admin', '2022-04-07 21:49:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5686, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:49:12', '1', 'admin', '2022-04-07 21:49:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5687, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:49:16', '1', 'admin', '2022-04-07 21:49:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5688, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:49:16', '1', 'admin', '2022-04-07 21:49:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5689, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:49:18', '1', 'admin', '2022-04-07 21:49:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5690, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:49:50', '1', 'admin', '2022-04-07 21:49:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5691, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:49:50', '1', 'admin', '2022-04-07 21:49:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5692, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:49:52', '1', 'admin', '2022-04-07 21:49:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5693, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:49:56', '1', 'admin', '2022-04-07 21:49:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5694, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:49:56', '1', 'admin', '2022-04-07 21:49:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5695, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:49:57', '1', 'admin', '2022-04-07 21:49:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5696, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:49:57', '1', 'admin', '2022-04-07 21:49:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5697, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:49:58', '1', 'admin', '2022-04-07 21:49:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5698, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:50:55', '1', 'guest', '2022-04-07 21:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5699, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:50:56', '1', 'guest', '2022-04-07 21:50:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5700, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:51:12', '1', 'admin', '2022-04-07 21:51:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5701, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:51:12', '1', 'admin', '2022-04-07 21:51:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5702, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:51:13', '1', 'admin', '2022-04-07 21:51:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5703, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:51:45', '1', 'admin', '2022-04-07 21:51:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:51:45', '1', 'admin', '2022-04-07 21:51:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5705, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:51:46', '1', 'admin', '2022-04-07 21:51:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5706, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:53:44', '1', 'admin', '2022-04-07 21:53:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:53:44', '1', 'admin', '2022-04-07 21:53:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:53:46', '1', 'admin', '2022-04-07 21:53:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5709, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:53:46', '1', 'admin', '2022-04-07 21:53:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5710, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:53:51', '1', 'admin', '2022-04-07 21:53:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5711, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:53:59', '1', 'admin', '2022-04-07 21:53:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5712, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 21:56:17', '1', 'admin', '2022-04-07 21:56:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5713, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 21:56:17', '1', 'admin', '2022-04-07 21:56:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5714, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 21:56:18', '1', 'admin', '2022-04-07 21:56:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5715, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 21:56:18', '1', 'admin', '2022-04-07 21:56:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5716, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:56:27', '1', 'admin', '2022-04-07 21:56:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5717, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 21:56:35', '1', 'admin', '2022-04-07 21:56:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5718, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 22:03:00', '1', 'admin', '2022-04-07 22:03:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5719, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 22:03:00', '1', 'admin', '2022-04-07 22:03:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5720, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 22:03:02', '1', 'admin', '2022-04-07 22:03:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5721, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 22:03:02', '1', 'admin', '2022-04-07 22:03:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5722, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 22:03:04', '1', 'admin', '2022-04-07 22:03:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5723, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 22:05:06', '1', 'admin', '2022-04-07 22:05:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5724, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 22:06:18', '1', 'admin', '2022-04-07 22:06:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5725, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 22:06:21', '1', 'admin', '2022-04-07 22:06:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5726, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 22:06:56', '1', 'admin', '2022-04-07 22:06:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5727, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 22:09:16', '1', 'admin', '2022-04-07 22:09:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5728, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 22:13:12', '1', 'admin', '2022-04-07 22:13:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5729, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 22:13:12', '1', 'admin', '2022-04-07 22:13:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5730, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-07 22:13:14', '1', 'admin', '2022-04-07 22:13:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-07 22:13:14', '1', 'admin', '2022-04-07 22:13:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5732, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 22:13:16', '1', 'admin', '2022-04-07 22:13:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 22:13:16', '1', 'admin', '2022-04-07 22:13:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5734, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 22:13:19', '1', 'admin', '2022-04-07 22:13:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5735, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-07 22:16:04', '1', 'admin', '2022-04-07 22:16:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5736, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:16:04', '1', 'admin', '2022-04-07 22:16:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:04', '1', 'admin', '2022-04-07 22:16:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:07', '1', 'admin', '2022-04-07 22:16:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5739, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-04-07 22:16:10', '1', 'admin', '2022-04-07 22:16:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5740, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:16:21', '1', 'admin', '2022-04-07 22:16:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:21', '1', 'admin', '2022-04-07 22:16:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:24', '1', 'admin', '2022-04-07 22:16:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5743, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-07 22:16:27', '1', 'admin', '2022-04-07 22:16:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5744, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:16:33', '1', 'admin', '2022-04-07 22:16:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:33', '1', 'admin', '2022-04-07 22:16:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:34', '1', 'admin', '2022-04-07 22:16:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5747, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-04-07 22:16:36', '1', 'admin', '2022-04-07 22:16:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:37', '1', 'admin', '2022-04-07 22:16:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5749, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:16:37', '1', 'admin', '2022-04-07 22:16:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:38', '1', 'admin', '2022-04-07 22:16:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:42', '1', 'admin', '2022-04-07 22:16:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:16:43', '1', 'admin', '2022-04-07 22:16:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-04-07 22:16:45', '1', 'admin', '2022-04-07 22:16:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5754, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=104', '127.0.0.1', '/system/res/postAdd', '2022-04-07 22:18:10', '1', 'admin', '2022-04-07 22:18:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5755, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:18:11', '1', 'admin', '2022-04-07 22:18:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:18:11', '1', 'admin', '2022-04-07 22:18:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-07 22:18:15', '1', 'admin', '2022-04-07 22:18:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:18:25', '1', 'admin', '2022-04-07 22:18:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5759, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:18:25', '1', 'admin', '2022-04-07 22:18:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5760, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-04-07 22:18:37', '1', 'admin', '2022-04-07 22:18:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5761, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-07 22:18:47', '1', 'admin', '2022-04-07 22:18:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5762, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:18:48', '1', 'admin', '2022-04-07 22:18:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5763, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:18:48', '1', 'admin', '2022-04-07 22:18:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5764, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:18:53', '1', 'admin', '2022-04-07 22:18:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5765, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:18:57', '1', 'admin', '2022-04-07 22:18:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-07 22:19:01', '1', 'admin', '2022-04-07 22:19:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-07 22:19:01', '1', 'admin', '2022-04-07 22:19:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5768, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-07 22:19:05', '1', 'admin', '2022-04-07 22:19:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5769, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-07 22:24:12', '1', 'admin', '2022-04-07 22:24:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5770, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:24:12', '1', 'admin', '2022-04-07 22:24:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:24:12', '1', 'admin', '2022-04-07 22:24:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:24:18', '1', 'admin', '2022-04-07 22:24:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5773, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2022-04-07 22:24:21', '1', 'admin', '2022-04-07 22:24:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-07 22:24:21', '1', 'admin', '2022-04-07 22:24:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5775, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-07 22:24:21', '1', 'admin', '2022-04-07 22:24:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 10:18:58', '1', 'admin', '2022-04-08 10:18:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5777, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 10:18:58', '1', 'admin', '2022-04-08 10:18:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 10:19:00', '1', 'admin', '2022-04-08 10:19:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 10:19:00', '1', 'admin', '2022-04-08 10:19:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 10:19:09', '1', 'admin', '2022-04-08 10:19:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 10:19:22', '1', 'admin', '2022-04-08 10:19:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 10:23:18', '1', 'admin', '2022-04-08 10:23:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5783, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 10:23:18', '1', 'admin', '2022-04-08 10:23:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5784, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 10:23:20', '1', 'admin', '2022-04-08 10:23:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 10:23:20', '1', 'admin', '2022-04-08 10:23:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 10:23:23', '1', 'admin', '2022-04-08 10:23:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 10:23:39', '1', 'admin', '2022-04-08 10:23:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 10:45:38', '1', 'admin', '2022-04-08 10:45:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5789, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 10:45:38', '1', 'admin', '2022-04-08 10:45:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 10:45:40', '1', 'admin', '2022-04-08 10:45:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 10:45:40', '1', 'admin', '2022-04-08 10:45:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 10:45:54', '1', 'admin', '2022-04-08 10:45:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5793, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 10:46:03', '1', 'admin', '2022-04-08 10:46:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5794, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 10:48:35', '1', 'admin', '2022-04-08 10:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 10:48:35', '1', 'admin', '2022-04-08 10:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 10:48:37', '1', 'admin', '2022-04-08 10:48:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 10:48:37', '1', 'admin', '2022-04-08 10:48:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 10:48:38', '1', 'admin', '2022-04-08 10:48:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5799, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 10:48:38', '1', 'admin', '2022-04-08 10:48:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5800, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 10:48:39', '1', 'admin', '2022-04-08 10:48:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:00:33', '1', 'admin', '2022-04-08 11:00:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5802, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:00:33', '1', 'admin', '2022-04-08 11:00:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:00:41', '1', 'admin', '2022-04-08 11:00:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5804, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:00:41', '1', 'admin', '2022-04-08 11:00:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5805, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:00:43', '1', 'admin', '2022-04-08 11:00:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5806, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:01:09', '1', 'admin', '2022-04-08 11:01:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:01:19', '1', 'admin', '2022-04-08 11:01:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:01:59', '1', 'admin', '2022-04-08 11:01:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5809, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:07:26', '1', 'admin', '2022-04-08 11:07:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:07:26', '1', 'admin', '2022-04-08 11:07:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5811, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:07:36', '1', 'admin', '2022-04-08 11:07:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5812, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:07:36', '1', 'admin', '2022-04-08 11:07:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:07:39', '1', 'admin', '2022-04-08 11:07:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5814, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:07:49', '1', 'admin', '2022-04-08 11:07:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:08:03', '1', 'admin', '2022-04-08 11:08:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:09:53', '1', 'admin', '2022-04-08 11:09:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:09:53', '1', 'admin', '2022-04-08 11:09:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:09:55', '1', 'admin', '2022-04-08 11:09:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5819, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:09:55', '1', 'admin', '2022-04-08 11:09:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5820, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:09:57', '1', 'admin', '2022-04-08 11:09:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:17:16', '1', 'admin', '2022-04-08 11:17:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:17:16', '1', 'admin', '2022-04-08 11:17:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:17:18', '1', 'admin', '2022-04-08 11:17:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:17:18', '1', 'admin', '2022-04-08 11:17:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:17:19', '1', 'admin', '2022-04-08 11:17:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5826, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-08 11:24:21', '1', 'admin', '2022-04-08 11:24:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5827, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-08 11:24:21', '1', 'admin', '2022-04-08 11:24:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 11:24:21', '1', 'admin', '2022-04-08 11:24:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 11:24:24', '1', 'admin', '2022-04-08 11:24:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-08 11:24:26', '1', 'admin', '2022-04-08 11:24:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5831, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 11:24:29', '1', 'admin', '2022-04-08 11:24:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-08 11:24:29', '1', 'admin', '2022-04-08 11:24:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5833, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 11:24:31', '1', 'admin', '2022-04-08 11:24:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-08 11:24:33', '1', 'admin', '2022-04-08 11:24:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5835, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 11:24:37', '1', 'admin', '2022-04-08 11:24:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5836, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-08 11:24:37', '1', 'admin', '2022-04-08 11:24:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5837, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:26:03', '1', 'admin', '2022-04-08 11:26:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:26:03', '1', 'admin', '2022-04-08 11:26:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:26:05', '1', 'admin', '2022-04-08 11:26:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5840, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:26:05', '1', 'admin', '2022-04-08 11:26:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5841, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:26:07', '1', 'admin', '2022-04-08 11:26:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5842, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/download', '2022-04-08 11:26:08', '1', 'admin', '2022-04-08 11:26:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:28:07', '1', 'admin', '2022-04-08 11:28:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:28:07', '1', 'admin', '2022-04-08 11:28:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:28:09', '1', 'admin', '2022-04-08 11:28:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5846, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:28:09', '1', 'admin', '2022-04-08 11:28:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5847, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:28:11', '1', 'admin', '2022-04-08 11:28:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:28:11', '1', 'admin', '2022-04-08 11:28:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:28:12', '1', 'admin', '2022-04-08 11:28:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5850, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/download', '2022-04-08 11:28:13', '1', 'admin', '2022-04-08 11:28:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:36:06', '1', 'admin', '2022-04-08 11:36:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:36:06', '1', 'admin', '2022-04-08 11:36:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:36:07', '1', 'admin', '2022-04-08 11:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5854, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:36:07', '1', 'admin', '2022-04-08 11:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:36:09', '1', 'admin', '2022-04-08 11:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5856, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/download', '2022-04-08 11:36:09', '1', 'admin', '2022-04-08 11:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5857, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:36:50', '1', 'admin', '2022-04-08 11:36:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:36:51', '1', 'admin', '2022-04-08 11:36:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:36:52', '1', 'admin', '2022-04-08 11:36:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:36:52', '1', 'admin', '2022-04-08 11:36:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5861, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:36:53', '1', 'admin', '2022-04-08 11:36:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5862, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/download', '2022-04-08 11:36:53', '1', 'admin', '2022-04-08 11:36:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:37:04', '1', 'admin', '2022-04-08 11:37:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5864, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=21', '127.0.0.1', '/system/user/download', '2022-04-08 11:37:04', '1', 'admin', '2022-04-08 11:37:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5865, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 11:38:57', '1', 'admin', '2022-04-08 11:38:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5866, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 11:38:57', '1', 'admin', '2022-04-08 11:38:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5867, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:38:59', '1', 'admin', '2022-04-08 11:38:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5868, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:38:59', '1', 'admin', '2022-04-08 11:38:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:39:01', '1', 'admin', '2022-04-08 11:39:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 11:39:13', '1', 'admin', '2022-04-08 11:39:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5871, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 11:41:14', '1', 'admin', '2022-04-08 11:41:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5872, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:41:14', '1', 'admin', '2022-04-08 11:41:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-08 11:41:17', '1', 'admin', '2022-04-08 11:41:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5874, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-08 11:41:17', '1', 'admin', '2022-04-08 11:41:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 11:50:52', '1', 'admin', '2022-04-08 11:50:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5876, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:50:52', '1', 'admin', '2022-04-08 11:50:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:53:28', '1', 'admin', '2022-04-08 11:53:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5878, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:53:40', '1', 'admin', '2022-04-08 11:53:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:55:26', '1', 'admin', '2022-04-08 11:55:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:55:39', '1', 'admin', '2022-04-08 11:55:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5881, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:55:48', '1', 'admin', '2022-04-08 11:55:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5882, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 11:56:19', '1', 'admin', '2022-04-08 11:56:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-08 12:02:36', '1', 'admin', '2022-04-08 12:02:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-08 12:02:36', '1', 'admin', '2022-04-08 12:02:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 12:02:36', '1', 'admin', '2022-04-08 12:02:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5886, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 12:02:38', '1', 'admin', '2022-04-08 12:02:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5887, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-08 12:02:40', '1', 'admin', '2022-04-08 12:02:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5888, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-08 12:02:43', '1', 'admin', '2022-04-08 12:02:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-08 12:02:43', '1', 'admin', '2022-04-08 12:02:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:01:43', '1', 'admin', '2022-04-08 15:01:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5891, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:01:43', '1', 'admin', '2022-04-08 15:01:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:01:44', '1', 'admin', '2022-04-08 15:01:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:01:44', '1', 'admin', '2022-04-08 15:01:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:02:00', '1', 'admin', '2022-04-08 15:02:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:04:39', '1', 'admin', '2022-04-08 15:04:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5896, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:04:39', '1', 'admin', '2022-04-08 15:04:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5897, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:04:42', '1', 'admin', '2022-04-08 15:04:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5898, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:04:42', '1', 'admin', '2022-04-08 15:04:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:04:55', '1', 'admin', '2022-04-08 15:04:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:09:27', '1', 'admin', '2022-04-08 15:09:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:09:27', '1', 'admin', '2022-04-08 15:09:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:09:29', '1', 'admin', '2022-04-08 15:09:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5903, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:09:29', '1', 'admin', '2022-04-08 15:09:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:09:37', '1', 'admin', '2022-04-08 15:09:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:11:22', '1', 'admin', '2022-04-08 15:11:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:11:23', '1', 'admin', '2022-04-08 15:11:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5907, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:11:24', '1', 'admin', '2022-04-08 15:11:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:11:24', '1', 'admin', '2022-04-08 15:11:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:11:32', '1', 'admin', '2022-04-08 15:11:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:12:49', '1', 'admin', '2022-04-08 15:12:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5911, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:12:50', '1', 'admin', '2022-04-08 15:12:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:12:51', '1', 'admin', '2022-04-08 15:12:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:12:51', '1', 'admin', '2022-04-08 15:12:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:12:54', '1', 'admin', '2022-04-08 15:12:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5915, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:14:43', '1', 'admin', '2022-04-08 15:14:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5916, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:16:07', '1', 'admin', '2022-04-08 15:16:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:16:07', '1', 'admin', '2022-04-08 15:16:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:16:09', '1', 'admin', '2022-04-08 15:16:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5919, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:16:09', '1', 'admin', '2022-04-08 15:16:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:16:16', '1', 'admin', '2022-04-08 15:16:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:21:29', '1', 'admin', '2022-04-08 15:21:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:21:29', '1', 'admin', '2022-04-08 15:21:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5923, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:21:48', '1', 'admin', '2022-04-08 15:21:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5924, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:21:56', '1', 'admin', '2022-04-08 15:21:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5925, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:36:04', '1', 'admin', '2022-04-08 15:36:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:36:05', '1', 'admin', '2022-04-08 15:36:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:36:06', '1', 'admin', '2022-04-08 15:36:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:36:06', '1', 'admin', '2022-04-08 15:36:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5929, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:36:11', '1', 'admin', '2022-04-08 15:36:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:38:01', '1', 'admin', '2022-04-08 15:38:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:38:01', '1', 'admin', '2022-04-08 15:38:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:38:02', '1', 'admin', '2022-04-08 15:38:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:38:02', '1', 'admin', '2022-04-08 15:38:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:38:13', '1', 'admin', '2022-04-08 15:38:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:38:18', '1', 'admin', '2022-04-08 15:38:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:38:20', '1', 'admin', '2022-04-08 15:38:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 15:39:13', '1', 'admin', '2022-04-08 15:39:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5938, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 15:39:13', '1', 'admin', '2022-04-08 15:39:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5939, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-08 15:39:14', '1', 'admin', '2022-04-08 15:39:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:14', '1', 'admin', '2022-04-08 15:39:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5941, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:23', '1', 'admin', '2022-04-08 15:39:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:23', '1', 'admin', '2022-04-08 15:39:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:28', '1', 'admin', '2022-04-08 15:39:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:28', '1', 'admin', '2022-04-08 15:39:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:33', '1', 'admin', '2022-04-08 15:39:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5946, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:33', '1', 'admin', '2022-04-08 15:39:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:35', '1', 'admin', '2022-04-08 15:39:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:35', '1', 'admin', '2022-04-08 15:39:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:37', '1', 'admin', '2022-04-08 15:39:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5950, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:37', '1', 'admin', '2022-04-08 15:39:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:51', '1', 'admin', '2022-04-08 15:39:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:51', '1', 'admin', '2022-04-08 15:39:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:56', '1', 'admin', '2022-04-08 15:39:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5954, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-08 15:39:56', '1', 'admin', '2022-04-08 15:39:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 16:29:31', '1', 'admin', '2022-04-08 16:29:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5956, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 16:29:31', '1', 'admin', '2022-04-08 16:29:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 16:30:09', '1', 'admin', '2022-04-08 16:30:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 16:30:09', '1', 'admin', '2022-04-08 16:30:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 16:30:14', '1', 'admin', '2022-04-08 16:30:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 16:46:22', '1', 'admin', '2022-04-08 16:46:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5961, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 16:46:22', '1', 'admin', '2022-04-08 16:46:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 16:46:31', '1', 'admin', '2022-04-08 16:46:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 16:46:31', '1', 'admin', '2022-04-08 16:46:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 16:46:51', '1', 'admin', '2022-04-08 16:46:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5965, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 16:46:51', '1', 'admin', '2022-04-08 16:46:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5966, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 16:57:58', '1', 'admin', '2022-04-08 16:57:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 16:57:58', '1', 'admin', '2022-04-08 16:57:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 16:58:13', '1', 'admin', '2022-04-08 16:58:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5969, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 16:58:13', '1', 'admin', '2022-04-08 16:58:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5970, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 16:58:40', '1', 'admin', '2022-04-08 16:58:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5971, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=21', '127.0.0.1', '/system/user/downDataload', '2022-04-08 16:58:40', '1', 'admin', '2022-04-08 16:58:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5972, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:00:12', '1', 'admin', '2022-04-08 17:00:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5973, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:00:12', '1', 'admin', '2022-04-08 17:00:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5974, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:00:14', '1', 'admin', '2022-04-08 17:00:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5975, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:00:14', '1', 'admin', '2022-04-08 17:00:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5976, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:00:15', '1', 'admin', '2022-04-08 17:00:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:00:15', '1', 'admin', '2022-04-08 17:00:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5978, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:00:18', '1', 'admin', '2022-04-08 17:00:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5979, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:00:18', '1', 'admin', '2022-04-08 17:00:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5980, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:09:13', '1', 'admin', '2022-04-08 17:09:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:09:13', '1', 'admin', '2022-04-08 17:09:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:09:14', '1', 'admin', '2022-04-08 17:09:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:09:14', '1', 'admin', '2022-04-08 17:09:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5984, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:09:16', '1', 'admin', '2022-04-08 17:09:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5985, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:09:16', '1', 'admin', '2022-04-08 17:09:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:09:18', '1', 'admin', '2022-04-08 17:09:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5987, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:09:19', '1', 'admin', '2022-04-08 17:09:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:13:48', '1', 'admin', '2022-04-08 17:13:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:13:48', '1', 'admin', '2022-04-08 17:13:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:13:49', '1', 'admin', '2022-04-08 17:13:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:13:49', '1', 'admin', '2022-04-08 17:13:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5992, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:13:50', '1', 'admin', '2022-04-08 17:13:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5993, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:13:51', '1', 'admin', '2022-04-08 17:13:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5994, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:44:37', '1', 'admin', '2022-04-08 17:44:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:44:37', '1', 'admin', '2022-04-08 17:44:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5996, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:44:39', '1', 'admin', '2022-04-08 17:44:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:44:39', '1', 'admin', '2022-04-08 17:44:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:44:41', '1', 'admin', '2022-04-08 17:44:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (5999, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:44:41', '1', 'admin', '2022-04-08 17:44:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:45:33', '1', 'admin', '2022-04-08 17:45:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:45:33', '1', 'admin', '2022-04-08 17:45:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:45:35', '1', 'admin', '2022-04-08 17:45:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:45:35', '1', 'admin', '2022-04-08 17:45:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6004, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:45:37', '1', 'admin', '2022-04-08 17:45:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6005, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:45:37', '1', 'admin', '2022-04-08 17:45:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:48:35', '1', 'admin', '2022-04-08 17:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:48:36', '1', 'admin', '2022-04-08 17:48:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6008, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:48:37', '1', 'admin', '2022-04-08 17:48:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:48:37', '1', 'admin', '2022-04-08 17:48:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6010, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:48:38', '1', 'admin', '2022-04-08 17:48:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6011, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:48:39', '1', 'admin', '2022-04-08 17:48:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6012, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:52:00', '1', 'admin', '2022-04-08 17:52:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:52:00', '1', 'admin', '2022-04-08 17:52:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6014, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:52:04', '1', 'admin', '2022-04-08 17:52:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:52:04', '1', 'admin', '2022-04-08 17:52:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6016, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:52:05', '1', 'admin', '2022-04-08 17:52:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:52:06', '1', 'admin', '2022-04-08 17:52:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6018, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:55:40', '1', 'admin', '2022-04-08 17:55:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:55:41', '1', 'admin', '2022-04-08 17:55:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6020, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:55:51', '1', 'admin', '2022-04-08 17:55:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:55:51', '1', 'admin', '2022-04-08 17:55:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6022, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:55:52', '1', 'admin', '2022-04-08 17:55:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:55:52', '1', 'admin', '2022-04-08 17:55:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6024, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:55:53', '1', 'admin', '2022-04-08 17:55:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:55:53', '1', 'admin', '2022-04-08 17:55:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6026, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-08 17:58:06', '1', 'admin', '2022-04-08 17:58:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6027, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-08 17:58:06', '1', 'admin', '2022-04-08 17:58:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-08 17:58:14', '1', 'admin', '2022-04-08 17:58:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-08 17:58:14', '1', 'admin', '2022-04-08 17:58:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6030, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:58:17', '1', 'admin', '2022-04-08 17:58:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6031, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:58:18', '1', 'admin', '2022-04-08 17:58:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6032, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-08 17:58:23', '1', 'admin', '2022-04-08 17:58:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-08 17:58:23', '1', 'admin', '2022-04-08 17:58:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6034, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-09 10:44:23', '1', 'admin', '2022-04-09 10:44:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-09 10:44:23', '1', 'admin', '2022-04-09 10:44:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-04-09 10:44:34', '1', 'admin', '2022-04-09 10:44:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-04-09 10:44:34', '1', 'admin', '2022-04-09 10:44:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-04-09 10:44:39', '1', 'admin', '2022-04-09 10:44:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6039, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-09 10:44:39', '1', 'admin', '2022-04-09 10:44:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-04-09 10:44:43', '1', 'admin', '2022-04-09 10:44:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-04-09 10:44:43', '1', 'admin', '2022-04-09 10:44:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6042, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-09 10:44:52', '1', 'admin', '2022-04-09 10:44:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6043, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-09 10:45:00', '1', 'admin', '2022-04-09 10:45:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6044, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-09 10:45:00', '1', 'admin', '2022-04-09 10:45:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2022-04-09 10:46:03', '1', 'admin', '2022-04-09 10:46:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6046, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2022-04-09 10:46:50', '1', 'admin', '2022-04-09 10:46:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6047, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-04-09 10:46:50', '1', 'admin', '2022-04-09 10:46:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6048, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-09 10:47:08', '1', 'test', '2022-04-09 10:47:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6049, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-09 10:47:08', '1', 'test', '2022-04-09 10:47:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6050, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-09 10:47:13', '1', 'test', '2022-04-09 10:47:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6051, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-09 10:47:13', '1', 'test', '2022-04-09 10:47:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6052, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-09 10:47:29', '1', 'admin', '2022-04-09 10:47:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6053, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-09 10:47:29', '1', 'admin', '2022-04-09 10:47:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6054, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-09 10:47:30', '1', 'admin', '2022-04-09 10:47:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-09 10:47:30', '1', 'admin', '2022-04-09 10:47:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-04-09 10:47:31', '1', 'admin', '2022-04-09 10:47:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6057, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-09 10:47:32', '1', 'admin', '2022-04-09 10:47:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6058, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-04-09 10:47:33', '1', 'admin', '2022-04-09 10:47:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6059, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-04-09 10:47:33', '1', 'admin', '2022-04-09 10:47:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6060, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/role/postAuth', '2022-04-09 10:47:45', '1', 'admin', '2022-04-09 10:47:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-09 10:47:45', '1', 'admin', '2022-04-09 10:47:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6062, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-09 10:47:57', '1', 'test', '2022-04-09 10:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6063, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-09 10:47:57', '1', 'test', '2022-04-09 10:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6064, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-09 10:47:58', '1', 'test', '2022-04-09 10:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6065, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-09 10:47:58', '1', 'test', '2022-04-09 10:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6066, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-09 15:07:41', '1', 'test', '2022-04-09 15:07:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6067, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-09 15:07:41', '1', 'test', '2022-04-09 15:07:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6068, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-09 15:08:16', '1', 'test', '2022-04-09 15:08:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6069, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-09 15:08:16', '1', 'test', '2022-04-09 15:08:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6070, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 11:06:07', '1', 'test', '2022-04-10 11:06:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6071, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 11:06:07', '1', 'test', '2022-04-10 11:06:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6072, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 11:06:23', '1', 'admin', '2022-04-10 11:06:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6073, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 11:06:23', '1', 'admin', '2022-04-10 11:06:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6074, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-10 11:06:30', '1', 'admin', '2022-04-10 11:06:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6075, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:06:30', '1', 'admin', '2022-04-10 11:06:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6076, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:06:30', '1', 'admin', '2022-04-10 11:06:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:06:43', '1', 'admin', '2022-04-10 11:06:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6078, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-10 11:06:47', '1', 'admin', '2022-04-10 11:06:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 11:07:26', '1', 'admin', '2022-04-10 11:07:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6080, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 11:07:26', '1', 'admin', '2022-04-10 11:07:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-10 11:07:29', '1', 'admin', '2022-04-10 11:07:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6082, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:07:29', '1', 'admin', '2022-04-10 11:07:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:07:29', '1', 'admin', '2022-04-10 11:07:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6084, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:07:32', '1', 'admin', '2022-04-10 11:07:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-10 11:07:34', '1', 'admin', '2022-04-10 11:07:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6086, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:07:39', '1', 'admin', '2022-04-10 11:07:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:07:39', '1', 'admin', '2022-04-10 11:07:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-04-10 11:08:02', '1', 'admin', '2022-04-10 11:08:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6089, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2022-04-10 11:09:19', '1', 'admin', '2022-04-10 11:09:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6090, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:09:19', '1', 'admin', '2022-04-10 11:09:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:09:19', '1', 'admin', '2022-04-10 11:09:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6092, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-10 11:09:23', '1', 'admin', '2022-04-10 11:09:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6093, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:09:26', '1', 'admin', '2022-04-10 11:09:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6094, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:09:26', '1', 'admin', '2022-04-10 11:09:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-04-10 11:09:31', '1', 'admin', '2022-04-10 11:09:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6096, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-10 11:09:31', '1', 'admin', '2022-04-10 11:09:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6097, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-04-10 11:09:33', '1', 'admin', '2022-04-10 11:09:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-04-10 11:09:33', '1', 'admin', '2022-04-10 11:09:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6099, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-04-10 11:09:37', '1', 'admin', '2022-04-10 11:09:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6100, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-04-10 11:09:37', '1', 'admin', '2022-04-10 11:09:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6101, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 11:09:40', '1', 'admin', '2022-04-10 11:09:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6102, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 11:09:40', '1', 'admin', '2022-04-10 11:09:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6103, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 11:09:45', '1', 'admin', '2022-04-10 11:09:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6104, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/tablesData', '2022-04-10 11:09:45', '1', 'admin', '2022-04-10 11:09:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6105, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-04-10 11:09:54', '1', 'admin', '2022-04-10 11:09:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:09:54', '1', 'admin', '2022-04-10 11:09:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6107, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:09:54', '1', 'admin', '2022-04-10 11:09:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6108, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:09:59', '1', 'admin', '2022-04-10 11:09:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:10:02', '1', 'admin', '2022-04-10 11:10:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6110, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-10 11:10:06', '1', 'admin', '2022-04-10 11:10:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:10:09', '1', 'admin', '2022-04-10 11:10:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:10:09', '1', 'admin', '2022-04-10 11:10:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-10 11:10:13', '1', 'admin', '2022-04-10 11:10:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6114, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:10:17', '1', 'admin', '2022-04-10 11:10:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6115, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:10:17', '1', 'admin', '2022-04-10 11:10:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6116, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:10:18', '1', 'admin', '2022-04-10 11:10:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6117, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-10 11:10:19', '1', 'admin', '2022-04-10 11:10:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:10:26', '1', 'admin', '2022-04-10 11:10:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6119, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:10:26', '1', 'admin', '2022-04-10 11:10:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:10:28', '1', 'admin', '2022-04-10 11:10:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6121, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:10:31', '1', 'admin', '2022-04-10 11:10:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6122, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-04-10 11:10:34', '1', 'admin', '2022-04-10 11:10:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6123, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=106', '127.0.0.1', '/system/res/postUpdate', '2022-04-10 11:10:50', '1', 'admin', '2022-04-10 11:10:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6124, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=106', '127.0.0.1', '/system/res/postUpdate', '2022-04-10 11:10:58', '1', 'admin', '2022-04-10 11:10:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-04-10 11:11:00', '1', 'admin', '2022-04-10 11:11:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6126, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-04-10 11:11:00', '1', 'admin', '2022-04-10 11:11:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6127, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 11:11:01', '1', 'admin', '2022-04-10 11:11:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6128, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 11:11:01', '1', 'admin', '2022-04-10 11:11:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 11:11:07', '1', 'admin', '2022-04-10 11:11:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/tablesData', '2022-04-10 11:11:07', '1', 'admin', '2022-04-10 11:11:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6131, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 11:13:37', '1', 'admin', '2022-04-10 11:13:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 11:13:37', '1', 'admin', '2022-04-10 11:13:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6133, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 11:13:40', '1', 'admin', '2022-04-10 11:13:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6134, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 11:13:40', '1', 'admin', '2022-04-10 11:13:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6135, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 12:40:58', '1', 'admin', '2022-04-10 12:40:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 12:40:58', '1', 'admin', '2022-04-10 12:40:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 12:49:43', '1', 'admin', '2022-04-10 12:49:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 12:49:43', '1', 'admin', '2022-04-10 12:49:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6139, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 12:56:35', '1', 'admin', '2022-04-10 12:56:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6140, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 12:56:35', '1', 'admin', '2022-04-10 12:56:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6141, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 13:00:13', '1', 'admin', '2022-04-10 13:00:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6142, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 13:00:13', '1', 'admin', '2022-04-10 13:00:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 13:02:45', '1', 'admin', '2022-04-10 13:02:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6144, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 13:02:45', '1', 'admin', '2022-04-10 13:02:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6145, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 13:04:32', '1', 'admin', '2022-04-10 13:04:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6146, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 13:04:32', '1', 'admin', '2022-04-10 13:04:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6147, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 13:09:12', '1', 'admin', '2022-04-10 13:09:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6148, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 13:09:12', '1', 'admin', '2022-04-10 13:09:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6149, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:20:56', '1', 'admin', '2022-04-10 16:20:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6150, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:20:56', '1', 'admin', '2022-04-10 16:20:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6151, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:23:37', '1', 'admin', '2022-04-10 16:23:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:23:38', '1', 'admin', '2022-04-10 16:23:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6153, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:24:38', '1', 'admin', '2022-04-10 16:24:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6154, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:24:38', '1', 'admin', '2022-04-10 16:24:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6155, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 16:24:39', '1', 'admin', '2022-04-10 16:24:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6156, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 16:24:39', '1', 'admin', '2022-04-10 16:24:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-10 16:24:43', '1', 'admin', '2022-04-10 16:24:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6158, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-10 16:24:44', '1', 'admin', '2022-04-10 16:24:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-10 16:24:46', '1', 'admin', '2022-04-10 16:24:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6160, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-10 16:24:46', '1', 'admin', '2022-04-10 16:24:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6161, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 16:24:50', '1', 'admin', '2022-04-10 16:24:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6162, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:24:50', '1', 'admin', '2022-04-10 16:24:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6163, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:27:24', '1', 'admin', '2022-04-10 16:27:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:27:24', '1', 'admin', '2022-04-10 16:27:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6165, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:33:26', '1', 'admin', '2022-04-10 16:33:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:33:26', '1', 'admin', '2022-04-10 16:33:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 16:33:27', '1', 'admin', '2022-04-10 16:33:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6168, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 16:33:27', '1', 'admin', '2022-04-10 16:33:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6169, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 16:33:29', '1', 'admin', '2022-04-10 16:33:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:33:29', '1', 'admin', '2022-04-10 16:33:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6171, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 16:35:17', '1', 'admin', '2022-04-10 16:35:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6172, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:35:17', '1', 'admin', '2022-04-10 16:35:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6173, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:39:10', '1', 'admin', '2022-04-10 16:39:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6174, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:39:11', '1', 'admin', '2022-04-10 16:39:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6175, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:39:11', '1', 'admin', '2022-04-10 16:39:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6176, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:39:15', '1', 'admin', '2022-04-10 16:39:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6177, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:39:28', '1', 'admin', '2022-04-10 16:39:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6178, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:42:15', '1', 'admin', '2022-04-10 16:42:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6179, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:42:15', '1', 'admin', '2022-04-10 16:42:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6180, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 16:42:16', '1', 'admin', '2022-04-10 16:42:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6181, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 16:42:16', '1', 'admin', '2022-04-10 16:42:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6182, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 16:42:19', '1', 'admin', '2022-04-10 16:42:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6183, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:42:20', '1', 'admin', '2022-04-10 16:42:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6184, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:58:11', '1', 'admin', '2022-04-10 16:58:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6185, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:58:11', '1', 'admin', '2022-04-10 16:58:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6186, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 16:58:12', '1', 'admin', '2022-04-10 16:58:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6187, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 16:58:12', '1', 'admin', '2022-04-10 16:58:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6188, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 16:58:14', '1', 'admin', '2022-04-10 16:58:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6189, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:58:14', '1', 'admin', '2022-04-10 16:58:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6190, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 16:58:38', '1', 'admin', '2022-04-10 16:58:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6191, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 16:59:58', '1', 'admin', '2022-04-10 16:59:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6192, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 16:59:58', '1', 'admin', '2022-04-10 16:59:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6193, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 17:00:00', '1', 'admin', '2022-04-10 17:00:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6194, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 17:00:00', '1', 'admin', '2022-04-10 17:00:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6195, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 17:00:01', '1', 'admin', '2022-04-10 17:00:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6196, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:00:01', '1', 'admin', '2022-04-10 17:00:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6197, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:00:14', '1', 'admin', '2022-04-10 17:00:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6198, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 17:00:28', '1', 'admin', '2022-04-10 17:00:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6199, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 17:00:28', '1', 'admin', '2022-04-10 17:00:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6200, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 17:00:36', '1', 'admin', '2022-04-10 17:00:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6201, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 17:05:50', '1', 'admin', '2022-04-10 17:05:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6202, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 17:05:50', '1', 'admin', '2022-04-10 17:05:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6203, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 17:05:52', '1', 'admin', '2022-04-10 17:05:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6204, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 17:05:52', '1', 'admin', '2022-04-10 17:05:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6205, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 17:05:58', '1', 'admin', '2022-04-10 17:05:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6206, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 17:07:53', '1', 'admin', '2022-04-10 17:07:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6207, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 17:07:53', '1', 'admin', '2022-04-10 17:07:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6208, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 17:07:56', '1', 'admin', '2022-04-10 17:07:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6209, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:07:56', '1', 'admin', '2022-04-10 17:07:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6210, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:08:01', '1', 'admin', '2022-04-10 17:08:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6211, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:08:06', '1', 'admin', '2022-04-10 17:08:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6212, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:08:17', '1', 'admin', '2022-04-10 17:08:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6213, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 17:44:35', '1', 'admin', '2022-04-10 17:44:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6214, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 17:44:36', '1', 'admin', '2022-04-10 17:44:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6215, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 17:51:10', '1', 'admin', '2022-04-10 17:51:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6216, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 17:51:10', '1', 'admin', '2022-04-10 17:51:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6217, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 17:52:11', '1', 'admin', '2022-04-10 17:52:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6218, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 17:52:12', '1', 'admin', '2022-04-10 17:52:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6219, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 17:52:13', '1', 'admin', '2022-04-10 17:52:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6220, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 17:52:13', '1', 'admin', '2022-04-10 17:52:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6221, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 17:52:18', '1', 'admin', '2022-04-10 17:52:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6222, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:18', '1', 'admin', '2022-04-10 17:52:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6223, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:25', '1', 'admin', '2022-04-10 17:52:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6224, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:26', '1', 'admin', '2022-04-10 17:52:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6225, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:27', '1', 'admin', '2022-04-10 17:52:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6226, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:28', '1', 'admin', '2022-04-10 17:52:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6227, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:34', '1', 'admin', '2022-04-10 17:52:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6228, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:35', '1', 'admin', '2022-04-10 17:52:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6229, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:36', '1', 'admin', '2022-04-10 17:52:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6230, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:48', '1', 'admin', '2022-04-10 17:52:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6231, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:49', '1', 'admin', '2022-04-10 17:52:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6232, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:50', '1', 'admin', '2022-04-10 17:52:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6233, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:53', '1', 'admin', '2022-04-10 17:52:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6234, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:52:54', '1', 'admin', '2022-04-10 17:52:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6235, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:53:03', '1', 'admin', '2022-04-10 17:53:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6236, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:55:53', '1', 'admin', '2022-04-10 17:55:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6237, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 17:56:00', '1', 'admin', '2022-04-10 17:56:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6238, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 18:01:26', '1', 'test', '2022-04-10 18:01:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6239, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 18:01:26', '1', 'test', '2022-04-10 18:01:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6240, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 18:01:27', '1', 'test', '2022-04-10 18:01:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6241, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:01:27', '1', 'test', '2022-04-10 18:01:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6242, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:04:09', '1', 'test', '2022-04-10 18:04:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6243, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:04:14', '1', 'test', '2022-04-10 18:04:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6244, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:04:23', '1', 'test', '2022-04-10 18:04:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6245, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-10 18:04:35', '1', 'admin', '2022-04-10 18:04:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6246, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-10 18:04:35', '1', 'admin', '2022-04-10 18:04:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6247, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-10 18:04:36', '1', 'admin', '2022-04-10 18:04:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6248, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:04:37', '1', 'admin', '2022-04-10 18:04:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6249, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:04:43', '1', 'admin', '2022-04-10 18:04:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6250, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:04:47', '1', 'admin', '2022-04-10 18:04:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6251, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-10 18:04:51', '1', 'admin', '2022-04-10 18:04:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6252, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-10 18:04:54', '1', 'admin', '2022-04-10 18:04:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6253, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 18:04:54', '1', 'admin', '2022-04-10 18:04:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6254, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 18:04:56', '1', 'admin', '2022-04-10 18:04:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6255, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 18:05:01', '1', 'admin', '2022-04-10 18:05:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6256, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-10 18:05:02', '1', 'admin', '2022-04-10 18:05:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6257, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 12:09:49', '1', 'guest', '2022-04-11 12:09:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6258, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 12:09:50', '1', 'guest', '2022-04-11 12:09:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6259, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 12:10:55', '1', 'admin', '2022-04-11 12:10:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6260, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 12:10:55', '1', 'admin', '2022-04-11 12:10:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6261, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 12:10:57', '1', 'admin', '2022-04-11 12:10:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6262, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:10:57', '1', 'admin', '2022-04-11 12:10:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6263, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:11:10', '1', 'admin', '2022-04-11 12:11:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6264, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:11:13', '1', 'admin', '2022-04-11 12:11:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:11:19', '1', 'admin', '2022-04-11 12:11:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6266, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:11:21', '1', 'admin', '2022-04-11 12:11:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6267, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:11:28', '1', 'admin', '2022-04-11 12:11:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6268, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:11:48', '1', 'admin', '2022-04-11 12:11:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6269, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 12:17:28', '1', 'admin', '2022-04-11 12:17:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6270, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 12:17:28', '1', 'admin', '2022-04-11 12:17:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6271, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 12:17:29', '1', 'admin', '2022-04-11 12:17:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:17:29', '1', 'admin', '2022-04-11 12:17:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6273, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:17:31', '1', 'admin', '2022-04-11 12:17:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:17:45', '1', 'admin', '2022-04-11 12:17:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 12:19:38', '1', 'admin', '2022-04-11 12:19:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 12:19:38', '1', 'admin', '2022-04-11 12:19:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6277, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 12:20:02', '1', 'admin', '2022-04-11 12:20:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6278, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:20:02', '1', 'admin', '2022-04-11 12:20:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:20:43', '1', 'admin', '2022-04-11 12:20:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6280, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 12:21:09', '1', 'admin', '2022-04-11 12:21:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 14:49:47', '1', 'admin', '2022-04-11 14:49:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 14:49:48', '1', 'admin', '2022-04-11 14:49:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 14:49:50', '1', 'admin', '2022-04-11 14:49:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6284, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 14:49:50', '1', 'admin', '2022-04-11 14:49:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6285, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-11 14:49:53', '1', 'admin', '2022-04-11 14:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6286, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-11 14:49:53', '1', 'admin', '2022-04-11 14:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6287, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-11 14:49:55', '1', 'admin', '2022-04-11 14:49:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6288, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-11 14:49:55', '1', 'admin', '2022-04-11 14:49:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 14:50:23', '1', 'admin', '2022-04-11 14:50:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 14:50:23', '1', 'admin', '2022-04-11 14:50:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6291, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 14:50:24', '1', 'admin', '2022-04-11 14:50:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6292, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 14:50:24', '1', 'admin', '2022-04-11 14:50:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6293, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 14:51:39', '1', 'admin', '2022-04-11 14:51:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6294, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 14:55:57', '1', 'admin', '2022-04-11 14:55:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6295, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 14:55:57', '1', 'admin', '2022-04-11 14:55:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6296, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 14:55:58', '1', 'admin', '2022-04-11 14:55:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6297, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 14:55:58', '1', 'admin', '2022-04-11 14:55:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6298, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 14:57:27', '1', 'admin', '2022-04-11 14:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6299, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 14:57:27', '1', 'admin', '2022-04-11 14:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6300, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 14:57:28', '1', 'admin', '2022-04-11 14:57:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6301, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 14:57:28', '1', 'admin', '2022-04-11 14:57:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6302, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 15:03:31', '1', 'admin', '2022-04-11 15:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6303, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 15:03:31', '1', 'admin', '2022-04-11 15:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6304, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 15:03:32', '1', 'admin', '2022-04-11 15:03:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6305, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:03:33', '1', 'admin', '2022-04-11 15:03:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6306, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 15:14:45', '1', 'admin', '2022-04-11 15:14:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6307, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 15:14:45', '1', 'admin', '2022-04-11 15:14:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6308, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 15:14:47', '1', 'admin', '2022-04-11 15:14:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6309, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:14:47', '1', 'admin', '2022-04-11 15:14:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:14:50', '1', 'admin', '2022-04-11 15:14:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6311, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:14:57', '1', 'admin', '2022-04-11 15:14:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6312, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:15:02', '1', 'admin', '2022-04-11 15:15:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6313, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:15:07', '1', 'admin', '2022-04-11 15:15:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:15:08', '1', 'admin', '2022-04-11 15:15:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6315, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:15:09', '1', 'admin', '2022-04-11 15:15:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:15:11', '1', 'admin', '2022-04-11 15:15:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6317, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:15:12', '1', 'admin', '2022-04-11 15:15:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6318, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-11 15:15:35', '1', 'admin', '2022-04-11 15:15:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-11 15:15:35', '1', 'admin', '2022-04-11 15:15:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:31:40', '1', 'admin', '2022-04-11 15:31:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6321, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:35:44', '1', 'admin', '2022-04-11 15:35:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6322, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:36:35', '1', 'admin', '2022-04-11 15:36:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:37:07', '1', 'admin', '2022-04-11 15:37:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6324, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:39:45', '1', 'admin', '2022-04-11 15:39:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6325, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:40:23', '1', 'admin', '2022-04-11 15:40:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6326, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 15:47:24', '1', 'admin', '2022-04-11 15:47:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6327, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 15:47:25', '1', 'admin', '2022-04-11 15:47:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6328, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 15:47:27', '1', 'admin', '2022-04-11 15:47:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6329, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 15:47:27', '1', 'admin', '2022-04-11 15:47:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6330, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 15:47:28', '1', 'admin', '2022-04-11 15:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6331, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:47:28', '1', 'admin', '2022-04-11 15:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6332, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:47:37', '1', 'admin', '2022-04-11 15:47:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6333, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/check', '2022-04-11 15:47:37', '1', 'admin', '2022-04-11 15:47:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6334, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check?name=127', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:47:37', '1', 'admin', '2022-04-11 15:47:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 15:48:00', '1', 'admin', '2022-04-11 15:48:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6336, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 15:48:00', '1', 'admin', '2022-04-11 15:48:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6337, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 15:48:03', '1', 'admin', '2022-04-11 15:48:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6338, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:48:03', '1', 'admin', '2022-04-11 15:48:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6339, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:48:08', '1', 'admin', '2022-04-11 15:48:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 15:50:43', '1', 'admin', '2022-04-11 15:50:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 15:50:43', '1', 'admin', '2022-04-11 15:50:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6342, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 15:50:49', '1', 'admin', '2022-04-11 15:50:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6343, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:50:49', '1', 'admin', '2022-04-11 15:50:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6344, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:50:57', '1', 'admin', '2022-04-11 15:50:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6345, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:51:07', '1', 'admin', '2022-04-11 15:51:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-11 15:51:49', '1', 'admin', '2022-04-11 15:51:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-11 15:51:49', '1', 'admin', '2022-04-11 15:51:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6348, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 15:51:57', '1', 'admin', '2022-04-11 15:51:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6349, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:51:57', '1', 'admin', '2022-04-11 15:51:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:52:02', '1', 'admin', '2022-04-11 15:52:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:52:07', '1', 'admin', '2022-04-11 15:52:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6352, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:58:00', '1', 'admin', '2022-04-11 15:58:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6353, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 15:59:34', '1', 'admin', '2022-04-11 15:59:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 16:00:40', '1', 'admin', '2022-04-11 16:00:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6355, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 16:00:56', '1', 'admin', '2022-04-11 16:00:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6356, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-11 16:01:16', '1', 'admin', '2022-04-11 16:01:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6357, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-11 16:01:16', '1', 'admin', '2022-04-11 16:01:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-13 11:56:48', '1', 'admin', '2022-04-13 11:56:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6359, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-13 11:56:48', '1', 'admin', '2022-04-13 11:56:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6360, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-13 11:57:03', '1', 'admin', '2022-04-13 11:57:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6361, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-13 11:57:03', '1', 'admin', '2022-04-13 11:57:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-13 11:57:19', '1', 'admin', '2022-04-13 11:57:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-13 11:57:19', '1', 'admin', '2022-04-13 11:57:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6364, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-13 12:00:20', '1', 'admin', '2022-04-13 12:00:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6365, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-13 12:00:21', '1', 'admin', '2022-04-13 12:00:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6366, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-13 12:01:07', '1', 'admin', '2022-04-13 12:01:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6367, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-13 12:01:07', '1', 'admin', '2022-04-13 12:01:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6368, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-13 12:01:15', '1', 'admin', '2022-04-13 12:01:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6369, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-13 12:01:15', '1', 'admin', '2022-04-13 12:01:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6370, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-13 12:01:17', '1', 'admin', '2022-04-13 12:01:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-13 12:01:17', '1', 'admin', '2022-04-13 12:01:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6372, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-13 12:01:33', '1', 'admin', '2022-04-13 12:01:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6373, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-13 12:01:34', '1', 'admin', '2022-04-13 12:01:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-13 12:02:13', '1', 'admin', '2022-04-13 12:02:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-13 12:02:13', '1', 'admin', '2022-04-13 12:02:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6376, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-04-13 12:02:55', '1', 'admin', '2022-04-13 12:02:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-04-13 12:02:55', '1', 'admin', '2022-04-13 12:02:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6378, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-04-13 12:03:05', '1', 'admin', '2022-04-13 12:03:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6379, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=22', '127.0.0.1', '/system/user/downDataload', '2022-04-13 12:03:05', '1', 'admin', '2022-04-13 12:03:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6380, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-13 12:03:29', '1', 'admin', '2022-04-13 12:03:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-13 12:03:29', '1', 'admin', '2022-04-13 12:03:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6382, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-13 12:03:31', '1', 'admin', '2022-04-13 12:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-13 12:03:31', '1', 'admin', '2022-04-13 12:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6384, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-13 15:41:26', '1', 'admin', '2022-04-13 15:41:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-13 15:41:26', '1', 'admin', '2022-04-13 15:41:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6386, NULL, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:41:42', '1', 'guest', '2022-04-13 15:41:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6387, NULL, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:41:42', '1', 'guest', '2022-04-13 15:41:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6388, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:42:22', '1', 'admin', '2022-04-13 15:42:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6389, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:42:22', '1', 'admin', '2022-04-13 15:42:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6390, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-13 15:42:30', '1', 'admin', '2022-04-13 15:42:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6391, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:42:31', '1', 'admin', '2022-04-13 15:42:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6392, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:42:38', '1', 'admin', '2022-04-13 15:42:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6393, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:42:41', '1', 'admin', '2022-04-13 15:42:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6394, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:42:41', '1', 'admin', '2022-04-13 15:42:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6395, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:42:44', '1', 'admin', '2022-04-13 15:42:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6396, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:42:44', '1', 'admin', '2022-04-13 15:42:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6397, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:42:46', '1', 'admin', '2022-04-13 15:42:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6398, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:42:47', '1', 'admin', '2022-04-13 15:42:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6399, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:43:00', '1', 'admin', '2022-04-13 15:43:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6400, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:43:00', '1', 'admin', '2022-04-13 15:43:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6401, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:43:03', '1', 'admin', '2022-04-13 15:43:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6402, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:43:04', '1', 'admin', '2022-04-13 15:43:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6403, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-13 15:43:20', '1', 'admin', '2022-04-13 15:43:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6404, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:43:20', '1', 'admin', '2022-04-13 15:43:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6405, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:43:30', '1', 'admin', '2022-04-13 15:43:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6406, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:43:40', '1', 'admin', '2022-04-13 15:43:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6407, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:43:40', '1', 'admin', '2022-04-13 15:43:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6408, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:43:43', '1', 'admin', '2022-04-13 15:43:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6409, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:43:43', '1', 'admin', '2022-04-13 15:43:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6410, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:43:46', '1', 'admin', '2022-04-13 15:43:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6411, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:43:47', '1', 'admin', '2022-04-13 15:43:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6412, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:43:51', '1', 'admin', '2022-04-13 15:43:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6413, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:43:51', '1', 'admin', '2022-04-13 15:43:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6414, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:43:54', '1', 'admin', '2022-04-13 15:43:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6415, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:43:54', '1', 'admin', '2022-04-13 15:43:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6416, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:44:01', '1', 'admin', '2022-04-13 15:44:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6417, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:44:01', '1', 'admin', '2022-04-13 15:44:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6418, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:44:06', '1', 'admin', '2022-04-13 15:44:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6419, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:44:06', '1', 'admin', '2022-04-13 15:44:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6420, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-13 15:45:00', '1', 'admin', '2022-04-13 15:45:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6421, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:45:01', '1', 'admin', '2022-04-13 15:45:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6422, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:45:03', '1', 'admin', '2022-04-13 15:45:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6423, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:45:31', '1', 'admin', '2022-04-13 15:45:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6424, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:45:31', '1', 'admin', '2022-04-13 15:45:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6425, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:45:33', '1', 'admin', '2022-04-13 15:45:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6426, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:45:34', '1', 'admin', '2022-04-13 15:45:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6427, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:45:47', '1', 'admin', '2022-04-13 15:45:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6428, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:45:48', '1', 'admin', '2022-04-13 15:45:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6429, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/opeCheck', '2022-04-13 15:45:51', '1', 'admin', '2022-04-13 15:45:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6430, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/opeCheck', '192.168.3.2', '/system/user/opeTablesData', '2022-04-13 15:45:51', '1', 'admin', '2022-04-13 15:45:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6431, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 15:49:08', '1', 'admin', '2022-04-13 15:49:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6432, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 15:49:08', '1', 'admin', '2022-04-13 15:49:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6433, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/upload', '2022-04-13 15:49:13', '1', 'admin', '2022-04-13 15:49:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6434, 3, 'Firefox 6', 'POST', 'http://192.168.3.2:8080/system/user/upload', '192.168.3.2', '/system/user/uploada', '2022-04-13 15:49:13', '1', 'admin', '2022-04-13 15:49:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6435, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/download', '2022-04-13 15:49:18', '1', 'admin', '2022-04-13 15:49:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6436, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:49:18', '1', 'admin', '2022-04-13 15:49:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6437, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/showdown', '2022-04-13 15:49:36', '1', 'admin', '2022-04-13 15:49:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6438, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/showdown?id=22', '192.168.3.2', '/system/user/downDataload', '2022-04-13 15:49:37', '1', 'admin', '2022-04-13 15:49:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6439, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-13 15:50:49', '1', 'admin', '2022-04-13 15:50:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6440, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:50:50', '1', 'admin', '2022-04-13 15:50:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6441, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 15:50:53', '1', 'admin', '2022-04-13 15:50:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6442, NULL, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 15:56:09', '1', 'guest', '2022-04-13 15:56:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6443, NULL, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 15:56:09', '1', 'guest', '2022-04-13 15:56:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6444, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 15:56:30', '1', 'admin', '2022-04-13 15:56:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6445, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 15:56:31', '1', 'admin', '2022-04-13 15:56:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6446, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 15:56:35', '1', 'admin', '2022-04-13 15:56:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6447, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 15:56:35', '1', 'admin', '2022-04-13 15:56:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6448, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 15:56:40', '1', 'admin', '2022-04-13 15:56:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6449, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 15:56:40', '1', 'admin', '2022-04-13 15:56:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6450, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 15:56:44', '1', 'admin', '2022-04-13 15:56:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6451, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 15:56:44', '1', 'admin', '2022-04-13 15:56:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6452, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 15:56:53', '1', 'admin', '2022-04-13 15:56:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6453, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 16:01:55', '1', 'admin', '2022-04-13 16:01:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6454, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 16:01:55', '1', 'admin', '2022-04-13 16:01:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6455, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/data', '2022-04-13 16:01:59', '1', 'admin', '2022-04-13 16:01:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6456, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/data', '192.168.3.2', '/system/data/tableData', '2022-04-13 16:02:00', '1', 'admin', '2022-04-13 16:02:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6457, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-13 16:02:02', '1', 'admin', '2022-04-13 16:02:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6458, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 16:02:03', '1', 'admin', '2022-04-13 16:02:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6459, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 16:02:07', '1', 'admin', '2022-04-13 16:02:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6460, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:02:28', '1', 'admin', '2022-04-13 16:02:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6461, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:02:28', '1', 'admin', '2022-04-13 16:02:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6462, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:02:40', '1', 'admin', '2022-04-13 16:02:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6463, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:02:41', '1', 'admin', '2022-04-13 16:02:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6464, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:02:47', '1', 'admin', '2022-04-13 16:02:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6465, NULL, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:03:36', '1', 'guest', '2022-04-13 16:03:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6466, NULL, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:03:37', '1', 'guest', '2022-04-13 16:03:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6467, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:03:59', '1', 'admin', '2022-04-13 16:03:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6468, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:03:59', '1', 'admin', '2022-04-13 16:03:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6469, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:04:36', '1', 'admin', '2022-04-13 16:04:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6470, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:04:37', '1', 'admin', '2022-04-13 16:04:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6471, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:04:40', '1', 'admin', '2022-04-13 16:04:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6472, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 16:05:21', '1', 'admin', '2022-04-13 16:05:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6473, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 16:05:22', '1', 'admin', '2022-04-13 16:05:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6474, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:05:27', '1', 'admin', '2022-04-13 16:05:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6475, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:05:27', '1', 'admin', '2022-04-13 16:05:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6476, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 16:05:30', '1', 'admin', '2022-04-13 16:05:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6477, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 16:05:31', '1', 'admin', '2022-04-13 16:05:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6478, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:05:40', '1', 'admin', '2022-04-13 16:05:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6479, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:05:40', '1', 'admin', '2022-04-13 16:05:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6480, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:05:50', '1', 'admin', '2022-04-13 16:05:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6481, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 16:07:06', '1', 'admin', '2022-04-13 16:07:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6482, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 16:07:07', '1', 'admin', '2022-04-13 16:07:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6483, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upfile', '2022-04-13 16:09:50', '1', 'admin', '2022-04-13 16:09:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6484, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 16:10:38', '1', 'admin', '2022-04-13 16:10:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6485, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-04-13 16:11:56', '1', 'admin', '2022-04-13 16:11:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6486, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:11:56', '1', 'admin', '2022-04-13 16:11:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6487, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:11:58', '1', 'admin', '2022-04-13 16:11:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6488, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:11:58', '1', 'admin', '2022-04-13 16:11:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6489, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:12:01', '1', 'admin', '2022-04-13 16:12:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6490, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:12:01', '1', 'admin', '2022-04-13 16:12:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6491, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:12:02', '1', 'admin', '2022-04-13 16:12:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6492, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:12:02', '1', 'admin', '2022-04-13 16:12:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6493, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 16:14:21', '1', 'admin', '2022-04-13 16:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6494, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 16:14:21', '1', 'admin', '2022-04-13 16:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6495, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 16:14:53', '1', 'admin', '2022-04-13 16:14:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6496, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 16:14:54', '1', 'admin', '2022-04-13 16:14:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6497, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:15:27', '1', 'admin', '2022-04-13 16:15:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6498, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:15:28', '1', 'admin', '2022-04-13 16:15:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6499, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:15:30', '1', 'admin', '2022-04-13 16:15:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6500, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:15:31', '1', 'admin', '2022-04-13 16:15:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6501, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:31:21', '1', 'admin', '2022-04-13 16:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6502, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:31:21', '1', 'admin', '2022-04-13 16:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6503, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:31:25', '1', 'admin', '2022-04-13 16:31:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6504, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:31:25', '1', 'admin', '2022-04-13 16:31:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6505, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:31:37', '1', 'admin', '2022-04-13 16:31:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6506, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:34:15', '1', 'admin', '2022-04-13 16:34:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6507, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:34:15', '1', 'admin', '2022-04-13 16:34:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6508, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 16:34:19', '1', 'admin', '2022-04-13 16:34:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6509, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:34:19', '1', 'admin', '2022-04-13 16:34:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6510, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 16:34:30', '1', 'admin', '2022-04-13 16:34:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6511, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 16:36:07', '1', 'admin', '2022-04-13 16:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6512, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 16:36:07', '1', 'admin', '2022-04-13 16:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6513, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 16:36:11', '1', 'admin', '2022-04-13 16:36:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6514, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 16:36:11', '1', 'admin', '2022-04-13 16:36:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6515, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 16:36:14', '1', 'admin', '2022-04-13 16:36:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6516, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 16:36:14', '1', 'admin', '2022-04-13 16:36:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6517, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 17:24:26', '1', 'admin', '2022-04-13 17:24:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6518, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 17:24:26', '1', 'admin', '2022-04-13 17:24:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6519, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 17:24:31', '1', 'admin', '2022-04-13 17:24:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6520, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 17:24:31', '1', 'admin', '2022-04-13 17:24:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6521, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 17:24:34', '1', 'admin', '2022-04-13 17:24:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6522, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 17:29:08', '1', 'admin', '2022-04-13 17:29:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6523, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 17:29:09', '1', 'admin', '2022-04-13 17:29:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6524, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 17:29:18', '1', 'admin', '2022-04-13 17:29:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6525, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 17:29:19', '1', 'admin', '2022-04-13 17:29:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6526, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/profile', '2022-04-13 17:29:37', '1', 'admin', '2022-04-13 17:29:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6527, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 17:29:40', '1', 'admin', '2022-04-13 17:29:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6528, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 17:29:40', '1', 'admin', '2022-04-13 17:29:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6529, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 17:43:56', '1', 'admin', '2022-04-13 17:43:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6530, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 17:43:56', '1', 'admin', '2022-04-13 17:43:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6531, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 17:43:57', '1', 'admin', '2022-04-13 17:43:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6532, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 17:43:57', '1', 'admin', '2022-04-13 17:43:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6533, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 17:44:04', '1', 'admin', '2022-04-13 17:44:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6534, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 18:21:44', '1', 'admin', '2022-04-13 18:21:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6535, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 18:21:44', '1', 'admin', '2022-04-13 18:21:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6536, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 18:22:07', '1', 'admin', '2022-04-13 18:22:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6537, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 18:22:08', '1', 'admin', '2022-04-13 18:22:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6538, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 18:23:22', '1', 'admin', '2022-04-13 18:23:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6539, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 18:23:22', '1', 'admin', '2022-04-13 18:23:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6540, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 18:23:25', '1', 'admin', '2022-04-13 18:23:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6541, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 18:23:26', '1', 'admin', '2022-04-13 18:23:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6542, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 18:23:40', '1', 'admin', '2022-04-13 18:23:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6543, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 18:23:42', '1', 'admin', '2022-04-13 18:23:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6544, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 20:48:34', '1', 'admin', '2022-04-13 20:48:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6545, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 20:48:34', '1', 'admin', '2022-04-13 20:48:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6546, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 20:49:53', '1', 'admin', '2022-04-13 20:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6547, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 20:49:53', '1', 'admin', '2022-04-13 20:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6548, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 20:49:56', '1', 'admin', '2022-04-13 20:49:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6549, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 20:54:51', '1', 'admin', '2022-04-13 20:54:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6550, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 20:54:51', '1', 'admin', '2022-04-13 20:54:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6551, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:00:33', '1', 'admin', '2022-04-13 21:00:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6552, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:01:32', '1', 'admin', '2022-04-13 21:01:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6553, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:05:46', '1', 'admin', '2022-04-13 21:05:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6554, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 21:07:59', '1', 'admin', '2022-04-13 21:07:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6555, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 21:07:59', '1', 'admin', '2022-04-13 21:07:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6556, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:08:27', '1', 'admin', '2022-04-13 21:08:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6557, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 21:13:00', '1', 'admin', '2022-04-13 21:13:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6558, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 21:13:00', '1', 'admin', '2022-04-13 21:13:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6559, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/opeCheck', '2022-04-13 21:13:03', '1', 'admin', '2022-04-13 21:13:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6560, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/opeCheck', '192.168.32.128', '/system/user/opeTablesData', '2022-04-13 21:13:03', '1', 'admin', '2022-04-13 21:13:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6561, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 21:13:06', '1', 'admin', '2022-04-13 21:13:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6562, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:13:06', '1', 'admin', '2022-04-13 21:13:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6563, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:13:12', '1', 'admin', '2022-04-13 21:13:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6564, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 21:15:40', '1', 'admin', '2022-04-13 21:15:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6565, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 21:15:40', '1', 'admin', '2022-04-13 21:15:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6566, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 21:16:25', '1', 'admin', '2022-04-13 21:16:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6567, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 21:16:25', '1', 'admin', '2022-04-13 21:16:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6568, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 21:16:30', '1', 'admin', '2022-04-13 21:16:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6569, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 21:16:30', '1', 'admin', '2022-04-13 21:16:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6570, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 21:16:32', '1', 'admin', '2022-04-13 21:16:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6571, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:16:32', '1', 'admin', '2022-04-13 21:16:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6572, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 21:17:46', '1', 'admin', '2022-04-13 21:17:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6573, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 21:17:46', '1', 'admin', '2022-04-13 21:17:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6574, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 21:18:05', '1', 'admin', '2022-04-13 21:18:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6575, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 21:18:05', '1', 'admin', '2022-04-13 21:18:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6576, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 21:18:43', '1', 'admin', '2022-04-13 21:18:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6577, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 21:18:43', '1', 'admin', '2022-04-13 21:18:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6578, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 21:18:45', '1', 'admin', '2022-04-13 21:18:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6579, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:18:45', '1', 'admin', '2022-04-13 21:18:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6580, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 21:20:12', '1', 'admin', '2022-04-13 21:20:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6581, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 21:20:12', '1', 'admin', '2022-04-13 21:20:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6582, NULL, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 21:22:08', '1', 'guest', '2022-04-13 21:22:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6583, NULL, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 21:22:08', '1', 'guest', '2022-04-13 21:22:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6584, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 21:22:24', '1', 'admin', '2022-04-13 21:22:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6585, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 21:22:24', '1', 'admin', '2022-04-13 21:22:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6586, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/upload', '2022-04-13 21:22:26', '1', 'admin', '2022-04-13 21:22:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6587, 3, 'Firefox 6', 'POST', 'http://192.168.3.2:8080/system/user/upload', '192.168.3.2', '/system/user/uploada', '2022-04-13 21:22:26', '1', 'admin', '2022-04-13 21:22:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6588, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-13 21:22:33', '1', 'admin', '2022-04-13 21:22:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6589, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 21:22:33', '1', 'admin', '2022-04-13 21:22:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6590, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 21:22:37', '1', 'admin', '2022-04-13 21:22:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6591, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-13 21:32:16', '1', 'admin', '2022-04-13 21:32:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6592, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-13 21:32:16', '1', 'admin', '2022-04-13 21:32:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6593, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-13 21:32:18', '1', 'admin', '2022-04-13 21:32:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6594, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 21:32:18', '1', 'admin', '2022-04-13 21:32:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6595, 3, 'Firefox 6', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-13 21:32:25', '1', 'admin', '2022-04-13 21:32:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6596, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 21:32:55', '1', 'admin', '2022-04-13 21:32:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6597, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 21:32:55', '1', 'admin', '2022-04-13 21:32:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6598, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 21:32:56', '1', 'admin', '2022-04-13 21:32:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6599, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:32:57', '1', 'admin', '2022-04-13 21:32:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6600, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:33:00', '1', 'admin', '2022-04-13 21:33:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6601, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 21:38:04', '1', 'admin', '2022-04-13 21:38:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6602, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 21:38:04', '1', 'admin', '2022-04-13 21:38:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6603, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 21:38:06', '1', 'admin', '2022-04-13 21:38:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6604, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:38:06', '1', 'admin', '2022-04-13 21:38:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6605, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 21:38:09', '1', 'admin', '2022-04-13 21:38:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6606, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 22:19:33', '1', 'admin', '2022-04-13 22:19:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6607, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 22:19:33', '1', 'admin', '2022-04-13 22:19:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6608, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 22:19:35', '1', 'admin', '2022-04-13 22:19:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6609, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 22:19:35', '1', 'admin', '2022-04-13 22:19:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6610, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 22:19:36', '1', 'admin', '2022-04-13 22:19:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6611, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 22:20:03', '1', 'admin', '2022-04-13 22:20:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6612, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 22:20:03', '1', 'admin', '2022-04-13 22:20:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6613, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 22:20:19', '1', 'admin', '2022-04-13 22:20:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6614, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 22:20:19', '1', 'admin', '2022-04-13 22:20:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6615, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-13 22:20:41', '1', 'admin', '2022-04-13 22:20:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6616, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-13 22:20:41', '1', 'admin', '2022-04-13 22:20:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6617, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 22:20:42', '1', 'admin', '2022-04-13 22:20:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6618, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 22:20:42', '1', 'admin', '2022-04-13 22:20:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6619, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-13 22:22:13', '1', 'admin', '2022-04-13 22:22:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6620, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-13 22:22:13', '1', 'admin', '2022-04-13 22:22:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6621, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-13 22:22:25', '1', 'admin', '2022-04-13 22:22:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6622, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=1231312&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 22:22:26', '1', 'admin', '2022-04-13 22:22:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6623, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 22:22:41', '1', 'admin', '2022-04-13 22:22:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6624, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 22:22:42', '1', 'admin', '2022-04-13 22:22:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6625, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=1231312&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/upload', '2022-04-13 22:23:48', '1', 'admin', '2022-04-13 22:23:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6626, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=liux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 22:23:48', '1', 'admin', '2022-04-13 22:23:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6627, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 22:23:55', '1', 'admin', '2022-04-13 22:23:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6628, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 22:23:55', '1', 'admin', '2022-04-13 22:23:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6629, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=liux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/upload', '2022-04-13 22:24:21', '1', 'admin', '2022-04-13 22:24:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6630, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-13 22:24:22', '1', 'admin', '2022-04-13 22:24:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6631, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-13 22:25:05', '1', 'admin', '2022-04-13 22:25:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6632, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-13 22:25:07', '1', 'admin', '2022-04-13 22:25:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-14 09:55:57', '1', 'admin', '2022-04-14 09:55:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-14 09:55:57', '1', 'admin', '2022-04-14 09:55:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-14 09:56:03', '1', 'admin', '2022-04-14 09:56:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6636, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-14 09:56:03', '1', 'admin', '2022-04-14 09:56:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6637, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-14 09:56:07', '1', 'admin', '2022-04-14 09:56:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6638, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-14 09:56:07', '1', 'admin', '2022-04-14 09:56:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6639, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-14 09:57:05', '1', 'admin', '2022-04-14 09:57:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6640, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E8%BF%99%E6%98%AF%E4%B8%80%E6%9D%A1%E6%96%B0%E6%95%B0%E6%8D%AE&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E7%B3%BB%E7%BB%9F%E9%97%AE%E9%A2%98.txt&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '127.0.0.1', '/system/user/uploada', '2022-04-14 09:57:05', '1', 'admin', '2022-04-14 09:57:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6641, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-14 09:57:10', '1', 'admin', '2022-04-14 09:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6642, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-14 09:57:10', '1', 'admin', '2022-04-14 09:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-14 09:57:25', '1', 'admin', '2022-04-14 09:57:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-14 09:57:25', '1', 'admin', '2022-04-14 09:57:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-14 09:57:27', '1', 'admin', '2022-04-14 09:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6646, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-14 09:57:27', '1', 'admin', '2022-04-14 09:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6647, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-14 10:02:10', '1', 'admin', '2022-04-14 10:02:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6648, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-14 10:02:10', '1', 'admin', '2022-04-14 10:02:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-14 10:02:50', '1', 'admin', '2022-04-14 10:02:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6650, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E5%93%88%E5%93%88&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '127.0.0.1', '/system/user/uploada', '2022-04-14 10:02:50', '1', 'admin', '2022-04-14 10:02:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6651, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-14 10:03:15', '1', 'admin', '2022-04-14 10:03:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6652, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-14 10:03:15', '1', 'admin', '2022-04-14 10:03:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-14 10:03:18', '1', 'admin', '2022-04-14 10:03:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-14 10:03:18', '1', 'admin', '2022-04-14 10:03:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6655, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-14 10:03:22', '1', 'admin', '2022-04-14 10:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6656, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-14 10:03:22', '1', 'admin', '2022-04-14 10:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6657, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-14 10:03:24', '1', 'admin', '2022-04-14 10:03:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-14 10:03:24', '1', 'admin', '2022-04-14 10:03:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-14 10:05:10', '1', 'admin', '2022-04-14 10:05:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6660, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-14 10:05:10', '1', 'admin', '2022-04-14 10:05:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6661, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-04-14 10:05:14', '1', 'admin', '2022-04-14 10:05:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6662, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-04-14 10:05:14', '1', 'admin', '2022-04-14 10:05:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-04-14 10:05:32', '1', 'admin', '2022-04-14 10:05:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6664, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=windows&url=%E5%93%88%E5%93%88%E5%93%88&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '127.0.0.1', '/system/user/uploada', '2022-04-14 10:05:32', '1', 'admin', '2022-04-14 10:05:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6665, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-14 10:05:34', '1', 'admin', '2022-04-14 10:05:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6666, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-14 10:05:34', '1', 'admin', '2022-04-14 10:05:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6667, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-14 10:05:37', '1', 'admin', '2022-04-14 10:05:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6668, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-14 10:05:37', '1', 'admin', '2022-04-14 10:05:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6669, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-04-14 10:11:08', '1', 'admin', '2022-04-14 10:11:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6670, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-04-14 10:11:08', '1', 'admin', '2022-04-14 10:11:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6671, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/upload', '2022-04-14 10:11:16', '1', 'admin', '2022-04-14 10:11:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6672, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:11:16', '1', 'admin', '2022-04-14 10:11:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6673, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload', '192.168.32.128', '/system/user/upload', '2022-04-14 10:11:51', '1', 'admin', '2022-04-14 10:11:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6674, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:11:51', '1', 'admin', '2022-04-14 10:11:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6675, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-14 10:11:54', '1', 'admin', '2022-04-14 10:11:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6676, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-14 10:11:54', '1', 'admin', '2022-04-14 10:11:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6677, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-14 10:12:14', '1', 'admin', '2022-04-14 10:12:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6678, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-14 10:12:14', '1', 'admin', '2022-04-14 10:12:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6679, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/upload', '2022-04-14 10:13:46', '1', 'admin', '2022-04-14 10:13:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6680, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:13:47', '1', 'admin', '2022-04-14 10:13:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6681, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/upload', '2022-04-14 10:16:44', '1', 'admin', '2022-04-14 10:16:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6682, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:16:45', '1', 'admin', '2022-04-14 10:16:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6683, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/upload', '2022-04-14 10:18:06', '1', 'admin', '2022-04-14 10:18:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6684, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:18:06', '1', 'admin', '2022-04-14 10:18:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6685, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '192.168.32.128', '/system/user/upload', '2022-04-14 10:22:17', '1', 'admin', '2022-04-14 10:22:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6686, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:22:18', '1', 'admin', '2022-04-14 10:22:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6687, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '192.168.32.128', '/system/user/upload', '2022-04-14 10:22:33', '1', 'admin', '2022-04-14 10:22:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6688, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:22:34', '1', 'admin', '2022-04-14 10:22:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6689, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user', '2022-04-14 10:28:21', '1', 'admin', '2022-04-14 10:28:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6690, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user', '192.168.32.128', '/system/user/tableData', '2022-04-14 10:28:21', '1', 'admin', '2022-04-14 10:28:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6691, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/check', '2022-04-14 10:28:33', '1', 'admin', '2022-04-14 10:28:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6692, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-14 10:28:33', '1', 'admin', '2022-04-14 10:28:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6693, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-14 10:28:50', '1', 'admin', '2022-04-14 10:28:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6694, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/check', '192.168.32.128', '/system/user/tablesData', '2022-04-14 10:29:25', '1', 'admin', '2022-04-14 10:29:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6695, 3, 'Firefox 6', 'GET', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/upload', '2022-04-14 10:30:40', '1', 'admin', '2022-04-14 10:30:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6696, 3, 'Firefox 6', 'POST', 'http://192.168.32.1:8080/system/user/upload?pid=&name=linux&url=aaa&file=&des=%2Fhome%2Fcentos7%2F%E6%A8%A1%E6%9D%BF%2F%E7%A9%BA%E7%99%BD%E6%96%87%E4%BB%B6&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '192.168.32.128', '/system/user/uploada', '2022-04-14 10:30:40', '1', 'admin', '2022-04-14 10:30:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6697, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-24 18:38:30', '1', 'guest', '2022-04-24 18:38:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6698, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-24 18:38:30', '1', 'guest', '2022-04-24 18:38:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6699, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-25 18:56:27', '1', 'guest', '2022-04-25 18:56:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6700, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-25 18:56:27', '1', 'guest', '2022-04-25 18:56:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6701, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-25 18:56:48', '1', 'guest', '2022-04-25 18:56:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6702, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-25 18:56:48', '1', 'guest', '2022-04-25 18:56:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6703, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-25 18:57:10', '1', 'admin', '2022-04-25 18:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-25 18:57:10', '1', 'admin', '2022-04-25 18:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6705, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-25 18:57:12', '1', 'admin', '2022-04-25 18:57:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6706, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-25 18:57:12', '1', 'admin', '2022-04-25 18:57:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-25 18:57:14', '1', 'admin', '2022-04-25 18:57:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-25 18:57:14', '1', 'admin', '2022-04-25 18:57:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6709, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-25 19:22:10', '1', 'admin', '2022-04-25 19:22:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6710, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-25 19:22:10', '1', 'admin', '2022-04-25 19:22:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6711, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-04-25 19:22:14', '1', 'admin', '2022-04-25 19:22:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6712, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-04-25 19:22:14', '1', 'admin', '2022-04-25 19:22:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6713, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-04-25 19:22:15', '1', 'admin', '2022-04-25 19:22:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6714, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-04-25 19:22:15', '1', 'admin', '2022-04-25 19:22:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6715, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-25 19:26:44', '1', 'admin', '2022-04-25 19:26:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6716, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-25 19:26:44', '1', 'admin', '2022-04-25 19:26:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6717, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-30 17:17:23', '1', 'guest', '2022-04-30 17:17:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6718, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-30 17:17:23', '1', 'guest', '2022-04-30 17:17:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6719, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-04-30 17:17:41', '1', 'admin', '2022-04-30 17:17:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6720, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-04-30 17:17:41', '1', 'admin', '2022-04-30 17:17:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6721, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-30 17:18:57', '1', 'guest', '2022-04-30 17:18:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6722, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-30 17:18:57', '1', 'guest', '2022-04-30 17:18:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6723, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-04-30 17:19:17', '1', 'admin', '2022-04-30 17:19:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6724, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-04-30 17:19:17', '1', 'admin', '2022-04-30 17:19:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6725, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/check', '2022-04-30 17:19:19', '1', 'admin', '2022-04-30 17:19:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6726, 3, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/system/user/check', '192.168.3.2', '/system/user/tablesData', '2022-04-30 17:19:19', '1', 'admin', '2022-04-30 17:19:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6727, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-01 10:40:22', '1', 'admin', '2022-05-01 10:40:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6728, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-01 10:40:22', '1', 'admin', '2022-05-01 10:40:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6729, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-01 10:40:37', '1', 'admin', '2022-05-01 10:40:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6730, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-01 10:40:37', '1', 'admin', '2022-05-01 10:40:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-01 10:40:42', '1', 'admin', '2022-05-01 10:40:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6732, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-01 10:40:42', '1', 'admin', '2022-05-01 10:40:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-01 10:43:55', '1', 'admin', '2022-05-01 10:43:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6734, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=23', '127.0.0.1', '/system/user/downDataload', '2022-05-01 10:43:55', '1', 'admin', '2022-05-01 10:43:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6735, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-01 10:44:48', '1', 'admin', '2022-05-01 10:44:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6736, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=23', '127.0.0.1', '/system/user/downDataload', '2022-05-01 10:44:48', '1', 'admin', '2022-05-01 10:44:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-01 11:02:41', '1', 'admin', '2022-05-01 11:02:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-01 11:02:42', '1', 'admin', '2022-05-01 11:02:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6739, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-01 11:02:45', '1', 'admin', '2022-05-01 11:02:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6740, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-01 11:02:45', '1', 'admin', '2022-05-01 11:02:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-05-01 11:03:13', '1', 'admin', '2022-05-01 11:03:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-05-01 11:03:13', '1', 'admin', '2022-05-01 11:03:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6743, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-01 11:03:31', '1', 'admin', '2022-05-01 11:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6744, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=27', '127.0.0.1', '/system/user/downDataload', '2022-05-01 11:03:31', '1', 'admin', '2022-05-01 11:03:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-05-01 11:04:09', '1', 'admin', '2022-05-01 11:04:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-05-01 11:04:09', '1', 'admin', '2022-05-01 11:04:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6747, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-05-01 11:04:15', '1', 'admin', '2022-05-01 11:04:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-05-01 11:04:15', '1', 'admin', '2022-05-01 11:04:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6749, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-01 11:05:29', '1', 'admin', '2022-05-01 11:05:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-05-01 11:05:29', '1', 'admin', '2022-05-01 11:05:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-05-01 11:06:06', '1', 'admin', '2022-05-01 11:06:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-05-01 11:06:07', '1', 'admin', '2022-05-01 11:06:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-01 11:13:50', '1', 'admin', '2022-05-01 11:13:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6754, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-05-01 11:13:50', '1', 'admin', '2022-05-01 11:13:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6755, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-01 11:15:03', '1', 'admin', '2022-05-01 11:15:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-05-01 11:15:03', '1', 'admin', '2022-05-01 11:15:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-01 11:19:31', '1', 'admin', '2022-05-01 11:19:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-05-01 11:19:31', '1', 'admin', '2022-05-01 11:19:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6759, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-12 21:02:29', '1', 'guest', '2022-05-12 21:02:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6760, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-12 21:02:29', '1', 'guest', '2022-05-12 21:02:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6761, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-13 10:05:09', '1', 'guest', '2022-05-13 10:05:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6762, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-13 10:05:09', '1', 'guest', '2022-05-13 10:05:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6763, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-13 10:47:57', '1', 'guest', '2022-05-13 10:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6764, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-13 10:47:57', '1', 'guest', '2022-05-13 10:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6765, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-13 11:22:35', '1', 'guest', '2022-05-13 11:22:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6766, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-13 11:22:35', '1', 'guest', '2022-05-13 11:22:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6767, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 14:56:22', '1', 'guest', '2022-05-14 14:56:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6768, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 14:56:22', '1', 'guest', '2022-05-14 14:56:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6769, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 14:57:10', '1', 'guest', '2022-05-14 14:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6770, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 14:57:10', '1', 'guest', '2022-05-14 14:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 14:57:27', '1', 'admin', '2022-05-14 14:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 14:57:27', '1', 'admin', '2022-05-14 14:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 14:57:29', '1', 'admin', '2022-05-14 14:57:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 14:57:29', '1', 'admin', '2022-05-14 14:57:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6775, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 14:57:32', '1', 'admin', '2022-05-14 14:57:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-05-14 14:57:32', '1', 'admin', '2022-05-14 14:57:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6777, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/socketClient', '2022-05-14 14:57:34', '1', 'admin', '2022-05-14 14:57:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 14:58:31', '1', 'admin', '2022-05-14 14:58:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 14:58:31', '1', 'admin', '2022-05-14 14:58:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 14:58:33', '1', 'admin', '2022-05-14 14:58:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 14:58:33', '1', 'admin', '2022-05-14 14:58:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 14:58:57', '1', 'admin', '2022-05-14 14:58:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6783, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 14:58:57', '1', 'admin', '2022-05-14 14:58:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6784, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 14:59:06', '1', 'admin', '2022-05-14 14:59:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 15:04:38', '1', 'admin', '2022-05-14 15:04:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 15:04:38', '1', 'admin', '2022-05-14 15:04:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 15:04:41', '1', 'admin', '2022-05-14 15:04:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 15:04:41', '1', 'admin', '2022-05-14 15:04:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6789, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 15:04:43', '1', 'admin', '2022-05-14 15:04:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-05-14 15:04:43', '1', 'admin', '2022-05-14 15:04:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6791, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/socketClient', '2022-05-14 15:04:46', '1', 'admin', '2022-05-14 15:04:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 15:05:12', '1', 'admin', '2022-05-14 15:05:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6793, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 15:05:12', '1', 'admin', '2022-05-14 15:05:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6794, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 15:05:19', '1', 'admin', '2022-05-14 15:05:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 15:07:19', '1', 'admin', '2022-05-14 15:07:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 15:07:19', '1', 'admin', '2022-05-14 15:07:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 15:07:23', '1', 'admin', '2022-05-14 15:07:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 15:07:23', '1', 'admin', '2022-05-14 15:07:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6799, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 15:07:24', '1', 'admin', '2022-05-14 15:07:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6800, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-05-14 15:07:24', '1', 'admin', '2022-05-14 15:07:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 15:07:35', '1', 'admin', '2022-05-14 15:07:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6802, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 15:07:35', '1', 'admin', '2022-05-14 15:07:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6803, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 15:07:36', '1', 'admin', '2022-05-14 15:07:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6804, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 15:08:11', '1', 'admin', '2022-05-14 15:08:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6805, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 15:15:02', '1', 'admin', '2022-05-14 15:15:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6806, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 15:15:03', '1', 'admin', '2022-05-14 15:15:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 15:15:04', '1', 'admin', '2022-05-14 15:15:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 15:15:04', '1', 'admin', '2022-05-14 15:15:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6809, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 15:15:08', '1', 'admin', '2022-05-14 15:15:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 15:15:08', '1', 'admin', '2022-05-14 15:15:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6811, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 15:15:16', '1', 'admin', '2022-05-14 15:15:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6812, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 15:15:53', '1', 'admin', '2022-05-14 15:15:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:00:36', '1', 'admin', '2022-05-14 16:00:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6814, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:00:36', '1', 'admin', '2022-05-14 16:00:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:00:38', '1', 'admin', '2022-05-14 16:00:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:00:38', '1', 'admin', '2022-05-14 16:00:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:00:40', '1', 'admin', '2022-05-14 16:00:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:00:40', '1', 'admin', '2022-05-14 16:00:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6819, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:00:50', '1', 'admin', '2022-05-14 16:00:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6820, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:04:03', '1', 'admin', '2022-05-14 16:04:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:04:03', '1', 'admin', '2022-05-14 16:04:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:04:05', '1', 'admin', '2022-05-14 16:04:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:04:05', '1', 'admin', '2022-05-14 16:04:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:04:09', '1', 'admin', '2022-05-14 16:04:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:04:09', '1', 'admin', '2022-05-14 16:04:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6826, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:04:11', '1', 'admin', '2022-05-14 16:04:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6827, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:04:37', '1', 'admin', '2022-05-14 16:04:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:04:37', '1', 'admin', '2022-05-14 16:04:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:04:43', '1', 'admin', '2022-05-14 16:04:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:04:43', '1', 'admin', '2022-05-14 16:04:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6831, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:04:48', '1', 'admin', '2022-05-14 16:04:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:04:48', '1', 'admin', '2022-05-14 16:04:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6833, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:04:54', '1', 'admin', '2022-05-14 16:04:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:14:17', '1', 'admin', '2022-05-14 16:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6835, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:14:17', '1', 'admin', '2022-05-14 16:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6836, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:14:21', '1', 'admin', '2022-05-14 16:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6837, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:14:22', '1', 'admin', '2022-05-14 16:14:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:14:24', '1', 'admin', '2022-05-14 16:14:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:14:24', '1', 'admin', '2022-05-14 16:14:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6840, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:14:28', '1', 'admin', '2022-05-14 16:14:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6841, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:16:08', '1', 'admin', '2022-05-14 16:16:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6842, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:16:08', '1', 'admin', '2022-05-14 16:16:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:16:10', '1', 'admin', '2022-05-14 16:16:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:16:10', '1', 'admin', '2022-05-14 16:16:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:16:12', '1', 'admin', '2022-05-14 16:16:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6846, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:16:12', '1', 'admin', '2022-05-14 16:16:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6847, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:16:14', '1', 'admin', '2022-05-14 16:16:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:22:37', '1', 'admin', '2022-05-14 16:22:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:22:37', '1', 'admin', '2022-05-14 16:22:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6850, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:22:38', '1', 'admin', '2022-05-14 16:22:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:22:38', '1', 'admin', '2022-05-14 16:22:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:22:41', '1', 'admin', '2022-05-14 16:22:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:22:41', '1', 'admin', '2022-05-14 16:22:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6854, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:22:42', '1', 'admin', '2022-05-14 16:22:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:52:12', '1', 'admin', '2022-05-14 16:52:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6856, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:52:12', '1', 'admin', '2022-05-14 16:52:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6857, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:52:14', '1', 'admin', '2022-05-14 16:52:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:52:14', '1', 'admin', '2022-05-14 16:52:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:52:19', '1', 'admin', '2022-05-14 16:52:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:52:20', '1', 'admin', '2022-05-14 16:52:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6861, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:52:21', '1', 'admin', '2022-05-14 16:52:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6862, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 16:58:43', '1', 'admin', '2022-05-14 16:58:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 16:58:43', '1', 'admin', '2022-05-14 16:58:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6864, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 16:58:45', '1', 'admin', '2022-05-14 16:58:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6865, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 16:58:45', '1', 'admin', '2022-05-14 16:58:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6866, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 16:58:48', '1', 'admin', '2022-05-14 16:58:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6867, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 16:58:48', '1', 'admin', '2022-05-14 16:58:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6868, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 16:58:50', '1', 'admin', '2022-05-14 16:58:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 17:19:03', '1', 'admin', '2022-05-14 17:19:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 17:19:04', '1', 'admin', '2022-05-14 17:19:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6871, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 17:19:08', '1', 'admin', '2022-05-14 17:19:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6872, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 17:19:08', '1', 'admin', '2022-05-14 17:19:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 17:19:11', '1', 'admin', '2022-05-14 17:19:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 17:19:11', '1', 'admin', '2022-05-14 17:19:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6875, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 17:19:26', '1', 'admin', '2022-05-14 17:19:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6876, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 17:29:38', '1', 'admin', '2022-05-14 17:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 17:29:38', '1', 'admin', '2022-05-14 17:29:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6878, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 17:29:40', '1', 'admin', '2022-05-14 17:29:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 17:29:40', '1', 'admin', '2022-05-14 17:29:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 17:29:42', '1', 'admin', '2022-05-14 17:29:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6881, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 17:29:42', '1', 'admin', '2022-05-14 17:29:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6882, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 17:29:43', '1', 'admin', '2022-05-14 17:29:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 17:33:45', '1', 'admin', '2022-05-14 17:33:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 17:33:46', '1', 'admin', '2022-05-14 17:33:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 17:33:48', '1', 'admin', '2022-05-14 17:33:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6886, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 17:33:48', '1', 'admin', '2022-05-14 17:33:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6887, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 17:33:52', '1', 'admin', '2022-05-14 17:33:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6888, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 17:33:52', '1', 'admin', '2022-05-14 17:33:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6889, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 17:34:06', '1', 'admin', '2022-05-14 17:34:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 17:38:34', '1', 'admin', '2022-05-14 17:38:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6891, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 17:38:34', '1', 'admin', '2022-05-14 17:38:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 17:38:35', '1', 'admin', '2022-05-14 17:38:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 17:38:35', '1', 'admin', '2022-05-14 17:38:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 17:38:37', '1', 'admin', '2022-05-14 17:38:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 17:38:37', '1', 'admin', '2022-05-14 17:38:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6896, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 17:38:40', '1', 'admin', '2022-05-14 17:38:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6897, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 17:39:45', '1', 'admin', '2022-05-14 17:39:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6898, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 17:42:34', '1', 'admin', '2022-05-14 17:42:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 18:13:13', '1', 'admin', '2022-05-14 18:13:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 18:13:13', '1', 'admin', '2022-05-14 18:13:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 18:13:15', '1', 'admin', '2022-05-14 18:13:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 18:13:15', '1', 'admin', '2022-05-14 18:13:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6903, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 18:13:18', '1', 'admin', '2022-05-14 18:13:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 18:13:18', '1', 'admin', '2022-05-14 18:13:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6905, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 18:13:20', '1', 'admin', '2022-05-14 18:13:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6906, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 18:14:37', '1', 'admin', '2022-05-14 18:14:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6907, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 20:42:15', '1', 'admin', '2022-05-14 20:42:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 20:42:15', '1', 'admin', '2022-05-14 20:42:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 20:42:19', '1', 'admin', '2022-05-14 20:42:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 20:42:19', '1', 'admin', '2022-05-14 20:42:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6911, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 20:42:20', '1', 'admin', '2022-05-14 20:42:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 20:42:20', '1', 'admin', '2022-05-14 20:42:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 20:42:21', '1', 'admin', '2022-05-14 20:42:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 20:42:21', '1', 'admin', '2022-05-14 20:42:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6915, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 20:42:24', '1', 'admin', '2022-05-14 20:42:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6916, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 20:42:24', '1', 'admin', '2022-05-14 20:42:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6917, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 20:42:26', '1', 'admin', '2022-05-14 20:42:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 20:50:55', '1', 'admin', '2022-05-14 20:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6919, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 20:50:55', '1', 'admin', '2022-05-14 20:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 20:50:57', '1', 'admin', '2022-05-14 20:50:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 20:50:57', '1', 'admin', '2022-05-14 20:50:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 20:51:04', '1', 'admin', '2022-05-14 20:51:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6923, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 20:51:04', '1', 'admin', '2022-05-14 20:51:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6924, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 20:51:06', '1', 'admin', '2022-05-14 20:51:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6925, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 20:57:48', '1', 'admin', '2022-05-14 20:57:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 20:57:49', '1', 'admin', '2022-05-14 20:57:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 20:57:52', '1', 'admin', '2022-05-14 20:57:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 20:57:52', '1', 'admin', '2022-05-14 20:57:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6929, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 20:57:55', '1', 'admin', '2022-05-14 20:57:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 20:57:55', '1', 'admin', '2022-05-14 20:57:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6931, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 20:57:56', '1', 'admin', '2022-05-14 20:57:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 21:06:57', '1', 'admin', '2022-05-14 21:06:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 21:06:57', '1', 'admin', '2022-05-14 21:06:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 21:06:58', '1', 'admin', '2022-05-14 21:06:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 21:06:59', '1', 'admin', '2022-05-14 21:06:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 21:07:03', '1', 'admin', '2022-05-14 21:07:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 21:07:03', '1', 'admin', '2022-05-14 21:07:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6938, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 21:07:04', '1', 'admin', '2022-05-14 21:07:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6939, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 21:09:38', '1', 'admin', '2022-05-14 21:09:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 21:09:38', '1', 'admin', '2022-05-14 21:09:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6941, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 21:09:46', '1', 'admin', '2022-05-14 21:09:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 21:46:08', '1', 'admin', '2022-05-14 21:46:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 21:46:08', '1', 'admin', '2022-05-14 21:46:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 21:47:28', '1', 'admin', '2022-05-14 21:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 21:47:28', '1', 'admin', '2022-05-14 21:47:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6946, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 21:47:30', '1', 'admin', '2022-05-14 21:47:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 21:47:30', '1', 'admin', '2022-05-14 21:47:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 21:47:33', '1', 'admin', '2022-05-14 21:47:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 21:47:33', '1', 'admin', '2022-05-14 21:47:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6950, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 21:47:36', '1', 'admin', '2022-05-14 21:47:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 21:50:09', '1', 'admin', '2022-05-14 21:50:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 21:50:09', '1', 'admin', '2022-05-14 21:50:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 21:50:11', '1', 'admin', '2022-05-14 21:50:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6954, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 21:50:11', '1', 'admin', '2022-05-14 21:50:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 21:50:13', '1', 'admin', '2022-05-14 21:50:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6956, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 21:50:13', '1', 'admin', '2022-05-14 21:50:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6957, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 21:50:16', '1', 'admin', '2022-05-14 21:50:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 21:52:56', '1', 'admin', '2022-05-14 21:52:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 21:52:56', '1', 'admin', '2022-05-14 21:52:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 21:53:06', '1', 'admin', '2022-05-14 21:53:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6961, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 21:53:06', '1', 'admin', '2022-05-14 21:53:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 21:53:09', '1', 'admin', '2022-05-14 21:53:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 21:53:09', '1', 'admin', '2022-05-14 21:53:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6964, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 21:53:10', '1', 'admin', '2022-05-14 21:53:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 21:55:01', '1', 'admin', '2022-05-14 21:55:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6966, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 21:55:01', '1', 'admin', '2022-05-14 21:55:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 21:55:06', '1', 'admin', '2022-05-14 21:55:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 21:55:06', '1', 'admin', '2022-05-14 21:55:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6969, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 21:55:09', '1', 'admin', '2022-05-14 21:55:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6970, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 21:55:09', '1', 'admin', '2022-05-14 21:55:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6971, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 21:55:11', '1', 'admin', '2022-05-14 21:55:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6972, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 21:56:57', '1', 'admin', '2022-05-14 21:56:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6973, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 21:56:58', '1', 'admin', '2022-05-14 21:56:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6974, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 21:56:59', '1', 'admin', '2022-05-14 21:56:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6975, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 21:56:59', '1', 'admin', '2022-05-14 21:56:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6976, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 21:57:02', '1', 'admin', '2022-05-14 21:57:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 21:57:03', '1', 'admin', '2022-05-14 21:57:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6978, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 21:57:04', '1', 'admin', '2022-05-14 21:57:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6979, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 22:00:37', '1', 'admin', '2022-05-14 22:00:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6980, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 22:00:37', '1', 'admin', '2022-05-14 22:00:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 22:00:39', '1', 'admin', '2022-05-14 22:00:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 22:00:39', '1', 'admin', '2022-05-14 22:00:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 22:00:42', '1', 'admin', '2022-05-14 22:00:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6984, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 22:00:42', '1', 'admin', '2022-05-14 22:00:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6985, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 22:00:43', '1', 'admin', '2022-05-14 22:00:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 22:06:47', '1', 'admin', '2022-05-14 22:06:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 22:06:47', '1', 'admin', '2022-05-14 22:06:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 22:06:48', '1', 'admin', '2022-05-14 22:06:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 22:06:48', '1', 'admin', '2022-05-14 22:06:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 22:06:49', '1', 'admin', '2022-05-14 22:06:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 22:06:49', '1', 'admin', '2022-05-14 22:06:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6992, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 22:07:12', '1', 'admin', '2022-05-14 22:07:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 22:07:12', '1', 'admin', '2022-05-14 22:07:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6994, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 22:07:34', '1', 'admin', '2022-05-14 22:07:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 22:12:11', '1', 'admin', '2022-05-14 22:12:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6996, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 22:12:11', '1', 'admin', '2022-05-14 22:12:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 22:12:13', '1', 'admin', '2022-05-14 22:12:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 22:12:13', '1', 'admin', '2022-05-14 22:12:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (6999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 22:12:14', '1', 'admin', '2022-05-14 22:12:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 22:12:14', '1', 'admin', '2022-05-14 22:12:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 22:12:16', '1', 'admin', '2022-05-14 22:12:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 22:12:17', '1', 'admin', '2022-05-14 22:12:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7003, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 22:12:24', '1', 'admin', '2022-05-14 22:12:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7004, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-14 22:19:16', '1', 'admin', '2022-05-14 22:19:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7005, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-14 22:19:16', '1', 'admin', '2022-05-14 22:19:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-14 22:19:18', '1', 'admin', '2022-05-14 22:19:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-14 22:19:18', '1', 'admin', '2022-05-14 22:19:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7008, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-14 22:19:27', '1', 'admin', '2022-05-14 22:19:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-14 22:19:27', '1', 'admin', '2022-05-14 22:19:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7010, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-14 22:19:28', '1', 'admin', '2022-05-14 22:19:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7011, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-17 11:51:26', '1', 'guest', '2022-05-17 11:51:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7012, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-17 11:51:27', '1', 'guest', '2022-05-17 11:51:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-17 11:51:45', '1', 'admin', '2022-05-17 11:51:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7014, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-17 11:51:45', '1', 'admin', '2022-05-17 11:51:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-17 11:51:46', '1', 'admin', '2022-05-17 11:51:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7016, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-17 11:51:47', '1', 'admin', '2022-05-17 11:51:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-17 11:51:48', '1', 'admin', '2022-05-17 11:51:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7018, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-17 11:51:48', '1', 'admin', '2022-05-17 11:51:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7019, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-17 11:51:49', '1', 'admin', '2022-05-17 11:51:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7020, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-18 16:05:49', '1', 'admin', '2022-05-18 16:05:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-18 16:05:49', '1', 'admin', '2022-05-18 16:05:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7022, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-18 16:05:54', '1', 'admin', '2022-05-18 16:05:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-18 16:05:54', '1', 'admin', '2022-05-18 16:05:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7024, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-05-18 16:06:14', '1', 'admin', '2022-05-18 16:06:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7025, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-05-18 16:06:14', '1', 'admin', '2022-05-18 16:06:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7026, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-18 16:06:23', '1', 'admin', '2022-05-18 16:06:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7027, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-18 16:06:23', '1', 'admin', '2022-05-18 16:06:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-18 16:06:24', '1', 'admin', '2022-05-18 16:06:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-18 16:06:25', '1', 'admin', '2022-05-18 16:06:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7030, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-18 16:06:46', '1', 'admin', '2022-05-18 16:06:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7031, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-18 16:06:46', '1', 'admin', '2022-05-18 16:06:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7032, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-18 16:06:47', '1', 'admin', '2022-05-18 16:06:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7033, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-18 16:07:47', '1', 'admin', '2022-05-18 16:07:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7034, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-18 17:12:04', '1', 'admin', '2022-05-18 17:12:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-18 17:12:04', '1', 'admin', '2022-05-18 17:12:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-18 17:12:05', '1', 'admin', '2022-05-18 17:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-18 17:12:05', '1', 'admin', '2022-05-18 17:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-18 17:12:07', '1', 'admin', '2022-05-18 17:12:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7039, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-18 17:12:07', '1', 'admin', '2022-05-18 17:12:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-18 17:12:09', '1', 'admin', '2022-05-18 17:12:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-18 17:12:09', '1', 'admin', '2022-05-18 17:12:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7042, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-18 17:12:10', '1', 'admin', '2022-05-18 17:12:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7043, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-18 17:13:02', '1', 'admin', '2022-05-18 17:13:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7044, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-18 17:51:22', '1', 'admin', '2022-05-18 17:51:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-18 17:51:22', '1', 'admin', '2022-05-18 17:51:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7046, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-18 17:51:32', '1', 'admin', '2022-05-18 17:51:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7047, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-18 17:51:32', '1', 'admin', '2022-05-18 17:51:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7048, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-18 17:51:40', '1', 'admin', '2022-05-18 17:51:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7049, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-18 17:51:40', '1', 'admin', '2022-05-18 17:51:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7050, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-18 17:51:45', '1', 'admin', '2022-05-18 17:51:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7051, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-19 16:07:27', '1', 'admin', '2022-05-19 16:07:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7052, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-19 16:07:28', '1', 'admin', '2022-05-19 16:07:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7053, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-19 16:07:33', '1', 'admin', '2022-05-19 16:07:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7054, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-19 16:07:33', '1', 'admin', '2022-05-19 16:07:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-19 16:07:37', '1', 'admin', '2022-05-19 16:07:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-19 16:07:37', '1', 'admin', '2022-05-19 16:07:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7057, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-19 16:07:38', '1', 'admin', '2022-05-19 16:07:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7058, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-22 13:37:28', '1', 'guest', '2022-05-22 13:37:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7059, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-22 13:37:28', '1', 'guest', '2022-05-22 13:37:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7060, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-22 13:38:01', '1', 'admin', '2022-05-22 13:38:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-22 13:38:01', '1', 'admin', '2022-05-22 13:38:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7062, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-22 13:38:04', '1', 'admin', '2022-05-22 13:38:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7063, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-22 13:38:04', '1', 'admin', '2022-05-22 13:38:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7064, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-22 13:38:09', '1', 'admin', '2022-05-22 13:38:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7065, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-22 13:38:09', '1', 'admin', '2022-05-22 13:38:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7066, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-22 13:38:10', '1', 'admin', '2022-05-22 13:38:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7067, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-22 14:01:23', '1', 'admin', '2022-05-22 14:01:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7068, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-22 14:01:23', '1', 'admin', '2022-05-22 14:01:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7069, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-22 14:01:25', '1', 'admin', '2022-05-22 14:01:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7070, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-22 14:01:25', '1', 'admin', '2022-05-22 14:01:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7071, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-22 14:01:28', '1', 'admin', '2022-05-22 14:01:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7072, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-22 14:01:28', '1', 'admin', '2022-05-22 14:01:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7073, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-22 14:02:33', '1', 'admin', '2022-05-22 14:02:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7074, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-05-22 14:17:58', '1', 'admin', '2022-05-22 14:17:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7075, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-05-22 14:17:58', '1', 'admin', '2022-05-22 14:17:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7076, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-05-22 14:18:09', '1', 'admin', '2022-05-22 14:18:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-05-22 14:18:09', '1', 'admin', '2022-05-22 14:18:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7078, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-05-22 14:18:15', '1', 'admin', '2022-05-22 14:18:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-05-22 14:18:15', '1', 'admin', '2022-05-22 14:18:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7080, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-05-22 14:18:26', '1', 'admin', '2022-05-22 14:18:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-05-22 14:18:26', '1', 'admin', '2022-05-22 14:18:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7082, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-05-22 14:18:33', '1', 'admin', '2022-05-22 14:18:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2022-05-22 14:19:33', '1', 'admin', '2022-05-22 14:19:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7084, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-05-22 14:19:46', '1', 'admin', '2022-05-22 14:19:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-05-22 14:19:54', '1', 'admin', '2022-05-22 14:19:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7086, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-05-22 14:19:54', '1', 'admin', '2022-05-22 14:19:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-22 17:40:10', '1', 'admin', '2022-05-22 17:40:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-22 17:40:10', '1', 'admin', '2022-05-22 17:40:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7089, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-22 17:40:16', '1', 'admin', '2022-05-22 17:40:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7090, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-22 17:40:16', '1', 'admin', '2022-05-22 17:40:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-22 17:40:18', '1', 'admin', '2022-05-22 17:40:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7092, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-22 17:40:18', '1', 'admin', '2022-05-22 17:40:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7093, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-22 17:40:20', '1', 'admin', '2022-05-22 17:40:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7094, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-22 17:40:32', '1', 'admin', '2022-05-22 17:40:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-22 17:47:25', '1', 'admin', '2022-05-22 17:47:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7096, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-22 17:47:25', '1', 'admin', '2022-05-22 17:47:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7097, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-22 17:47:52', '1', 'admin', '2022-05-22 17:47:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-22 17:47:52', '1', 'admin', '2022-05-22 17:47:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7099, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-22 17:47:57', '1', 'admin', '2022-05-22 17:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7100, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-22 17:47:57', '1', 'admin', '2022-05-22 17:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7101, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-22 17:47:58', '1', 'admin', '2022-05-22 17:47:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7102, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-22 17:50:07', '1', 'admin', '2022-05-22 17:50:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7103, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-22 17:50:07', '1', 'admin', '2022-05-22 17:50:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7104, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-22 17:50:33', '1', 'admin', '2022-05-22 17:50:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7105, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-22 17:50:34', '1', 'admin', '2022-05-22 17:50:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-22 17:50:39', '1', 'admin', '2022-05-22 17:50:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7107, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-22 17:50:39', '1', 'admin', '2022-05-22 17:50:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7108, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-22 17:50:40', '1', 'admin', '2022-05-22 17:50:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 10:28:17', '1', 'admin', '2022-05-23 10:28:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7110, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 10:28:17', '1', 'admin', '2022-05-23 10:28:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 10:28:22', '1', 'admin', '2022-05-23 10:28:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 10:28:22', '1', 'admin', '2022-05-23 10:28:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 10:30:19', '1', 'admin', '2022-05-23 10:30:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7114, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 10:30:19', '1', 'admin', '2022-05-23 10:30:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7115, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 10:30:21', '1', 'admin', '2022-05-23 10:30:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7116, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 10:30:21', '1', 'admin', '2022-05-23 10:30:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7117, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 10:30:29', '1', 'admin', '2022-05-23 10:30:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 10:30:29', '1', 'admin', '2022-05-23 10:30:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7119, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 10:30:30', '1', 'admin', '2022-05-23 10:30:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 10:33:21', '1', 'admin', '2022-05-23 10:33:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7121, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 10:33:21', '1', 'admin', '2022-05-23 10:33:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7122, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 10:33:26', '1', 'admin', '2022-05-23 10:33:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7123, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 10:33:26', '1', 'admin', '2022-05-23 10:33:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7124, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 10:33:27', '1', 'admin', '2022-05-23 10:33:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 10:33:27', '1', 'admin', '2022-05-23 10:33:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7126, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 10:33:28', '1', 'admin', '2022-05-23 10:33:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7127, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 10:48:45', '1', 'admin', '2022-05-23 10:48:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7128, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 10:48:45', '1', 'admin', '2022-05-23 10:48:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 10:48:47', '1', 'admin', '2022-05-23 10:48:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 10:48:47', '1', 'admin', '2022-05-23 10:48:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7131, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 10:48:49', '1', 'admin', '2022-05-23 10:48:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 10:48:49', '1', 'admin', '2022-05-23 10:48:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7133, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 10:48:50', '1', 'admin', '2022-05-23 10:48:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7134, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 10:49:53', '1', 'admin', '2022-05-23 10:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7135, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 10:49:53', '1', 'admin', '2022-05-23 10:49:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 10:49:56', '1', 'admin', '2022-05-23 10:49:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 10:49:56', '1', 'admin', '2022-05-23 10:49:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 10:49:57', '1', 'admin', '2022-05-23 10:49:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7139, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 10:49:57', '1', 'admin', '2022-05-23 10:49:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7140, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 10:49:58', '1', 'admin', '2022-05-23 10:49:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7141, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 12:25:00', '1', 'admin', '2022-05-23 12:25:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7142, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 12:25:00', '1', 'admin', '2022-05-23 12:25:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 12:25:03', '1', 'admin', '2022-05-23 12:25:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7144, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 12:25:04', '1', 'admin', '2022-05-23 12:25:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7145, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 12:25:07', '1', 'admin', '2022-05-23 12:25:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7146, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 12:25:07', '1', 'admin', '2022-05-23 12:25:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7147, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 12:25:10', '1', 'admin', '2022-05-23 12:25:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7148, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 14:48:19', '1', 'admin', '2022-05-23 14:48:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7149, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 14:48:19', '1', 'admin', '2022-05-23 14:48:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7150, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 14:48:25', '1', 'admin', '2022-05-23 14:48:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7151, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 14:48:25', '1', 'admin', '2022-05-23 14:48:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 14:48:26', '1', 'admin', '2022-05-23 14:48:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7153, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 14:48:26', '1', 'admin', '2022-05-23 14:48:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7154, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 14:48:27', '1', 'admin', '2022-05-23 14:48:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7155, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 14:51:08', '1', 'admin', '2022-05-23 14:51:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7156, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 14:51:08', '1', 'admin', '2022-05-23 14:51:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 14:51:27', '1', 'admin', '2022-05-23 14:51:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7158, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 14:51:27', '1', 'admin', '2022-05-23 14:51:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 14:51:30', '1', 'admin', '2022-05-23 14:51:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7160, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 14:51:30', '1', 'admin', '2022-05-23 14:51:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7161, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 14:51:32', '1', 'admin', '2022-05-23 14:51:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7162, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 15:40:11', '1', 'admin', '2022-05-23 15:40:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7163, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 15:40:11', '1', 'admin', '2022-05-23 15:40:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 15:40:16', '1', 'admin', '2022-05-23 15:40:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7165, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 15:40:17', '1', 'admin', '2022-05-23 15:40:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 15:40:18', '1', 'admin', '2022-05-23 15:40:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 15:40:18', '1', 'admin', '2022-05-23 15:40:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7168, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 15:40:19', '1', 'admin', '2022-05-23 15:40:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7169, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 15:55:51', '1', 'admin', '2022-05-23 15:55:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 15:55:51', '1', 'admin', '2022-05-23 15:55:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7171, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 15:55:56', '1', 'admin', '2022-05-23 15:55:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7172, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 15:55:57', '1', 'admin', '2022-05-23 15:55:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7173, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 15:55:58', '1', 'admin', '2022-05-23 15:55:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7174, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 15:55:58', '1', 'admin', '2022-05-23 15:55:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7175, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 15:56:00', '1', 'admin', '2022-05-23 15:56:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7176, NULL, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 15:58:13', '1', 'guest', '2022-05-23 15:58:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7177, NULL, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 15:58:13', '1', 'guest', '2022-05-23 15:58:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7178, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-05-23 15:58:47', '1', 'admin', '2022-05-23 15:58:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7179, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-05-23 15:58:47', '1', 'admin', '2022-05-23 15:58:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7180, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/download', '2022-05-23 15:59:15', '1', 'admin', '2022-05-23 15:59:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7181, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/tablesData', '2022-05-23 15:59:16', '1', 'admin', '2022-05-23 15:59:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7182, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/showdown', '2022-05-23 15:59:27', '1', 'admin', '2022-05-23 15:59:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7183, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/system/user/showdown?id=26', '192.168.3.2', '/system/user/downDataload', '2022-05-23 15:59:27', '1', 'admin', '2022-05-23 15:59:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7184, 3, 'Firefox 9', 'POST', 'http://192.168.3.2:8080/system/user/showdown?id=26', '192.168.3.2', '/system/user/socketClient', '2022-05-23 15:59:29', '1', 'admin', '2022-05-23 15:59:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7185, 3, 'Firefox 9', 'POST', 'http://192.168.3.2:8080/system/user/showdown?id=26', '192.168.3.2', '/system/user/socketClient', '2022-05-23 16:00:17', '1', 'admin', '2022-05-23 16:00:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7186, NULL, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 16:05:17', '1', 'guest', '2022-05-23 16:05:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7187, NULL, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 16:05:17', '1', 'guest', '2022-05-23 16:05:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7188, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-05-23 16:05:23', '1', 'admin', '2022-05-23 16:05:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7189, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-05-23 16:05:23', '1', 'admin', '2022-05-23 16:05:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7190, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/user/download', '2022-05-23 16:05:38', '1', 'admin', '2022-05-23 16:05:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7191, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/tablesData', '2022-05-23 16:05:38', '1', 'admin', '2022-05-23 16:05:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7192, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.2', '/system/user/showdown', '2022-05-23 16:05:43', '1', 'admin', '2022-05-23 16:05:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7193, 3, 'Firefox 9', 'GET', 'http://192.168.3.2:8080/system/user/showdown?id=26', '192.168.3.2', '/system/user/downDataload', '2022-05-23 16:05:44', '1', 'admin', '2022-05-23 16:05:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7194, 3, 'Firefox 9', 'POST', 'http://192.168.3.2:8080/system/user/showdown?id=26', '192.168.3.2', '/system/user/socketClient', '2022-05-23 16:05:55', '1', 'admin', '2022-05-23 16:05:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7195, NULL, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 16:16:49', '1', 'guest', '2022-05-23 16:16:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7196, NULL, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 16:16:50', '1', 'guest', '2022-05-23 16:16:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7197, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 16:17:22', '1', 'admin', '2022-05-23 16:17:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7198, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 16:17:22', '1', 'admin', '2022-05-23 16:17:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7199, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-05-23 16:17:36', '1', 'admin', '2022-05-23 16:17:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7200, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-05-23 16:17:36', '1', 'admin', '2022-05-23 16:17:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7201, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-05-23 16:17:52', '1', 'admin', '2022-05-23 16:17:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7202, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/downDataload', '2022-05-23 16:17:52', '1', 'admin', '2022-05-23 16:17:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7203, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 16:19:50', '1', 'admin', '2022-05-23 16:19:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7204, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 16:19:50', '1', 'admin', '2022-05-23 16:19:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7205, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-05-23 16:19:59', '1', 'admin', '2022-05-23 16:19:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7206, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-05-23 16:20:00', '1', 'admin', '2022-05-23 16:20:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7207, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-05-23 16:20:14', '1', 'admin', '2022-05-23 16:20:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7208, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/downDataload', '2022-05-23 16:20:14', '1', 'admin', '2022-05-23 16:20:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7209, 3, 'Firefox 9', 'POST', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/socketClient', '2022-05-23 16:22:13', '1', 'admin', '2022-05-23 16:22:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7210, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 16:23:06', '1', 'admin', '2022-05-23 16:23:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7211, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 16:23:06', '1', 'admin', '2022-05-23 16:23:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7212, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-05-23 16:23:12', '1', 'admin', '2022-05-23 16:23:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7213, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-05-23 16:23:12', '1', 'admin', '2022-05-23 16:23:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7214, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-05-23 16:24:41', '1', 'admin', '2022-05-23 16:24:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7215, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/downDataload', '2022-05-23 16:24:42', '1', 'admin', '2022-05-23 16:24:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7216, 3, 'Firefox 9', 'POST', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/socketClient', '2022-05-23 16:24:47', '1', 'admin', '2022-05-23 16:24:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7217, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 16:54:02', '1', 'admin', '2022-05-23 16:54:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7218, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 16:54:02', '1', 'admin', '2022-05-23 16:54:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7219, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 16:54:07', '1', 'admin', '2022-05-23 16:54:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7220, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 16:54:07', '1', 'admin', '2022-05-23 16:54:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7221, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-05-23 16:54:16', '1', 'admin', '2022-05-23 16:54:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7222, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-05-23 16:54:17', '1', 'admin', '2022-05-23 16:54:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7223, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 16:54:31', '1', 'admin', '2022-05-23 16:54:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7224, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 16:54:31', '1', 'admin', '2022-05-23 16:54:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7225, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 16:54:32', '1', 'admin', '2022-05-23 16:54:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7226, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 16:55:54', '1', 'admin', '2022-05-23 16:55:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7227, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 16:55:54', '1', 'admin', '2022-05-23 16:55:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7228, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-05-23 16:56:03', '1', 'admin', '2022-05-23 16:56:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7229, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-05-23 16:56:04', '1', 'admin', '2022-05-23 16:56:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7230, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-05-23 16:56:06', '1', 'admin', '2022-05-23 16:56:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7231, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/downDataload', '2022-05-23 16:56:06', '1', 'admin', '2022-05-23 16:56:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7232, 3, 'Firefox 9', 'POST', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/socketClient', '2022-05-23 16:56:08', '1', 'admin', '2022-05-23 16:56:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7233, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 17:05:15', '1', 'admin', '2022-05-23 17:05:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7234, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 17:05:16', '1', 'admin', '2022-05-23 17:05:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7235, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-05-23 17:05:17', '1', 'admin', '2022-05-23 17:05:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7236, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-05-23 17:05:17', '1', 'admin', '2022-05-23 17:05:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7237, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-05-23 17:05:20', '1', 'admin', '2022-05-23 17:05:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7238, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/downDataload', '2022-05-23 17:05:20', '1', 'admin', '2022-05-23 17:05:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7239, 3, 'Firefox 9', 'POST', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/socketClient', '2022-05-23 17:05:21', '1', 'admin', '2022-05-23 17:05:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7240, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 17:55:04', '1', 'admin', '2022-05-23 17:55:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7241, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 17:55:04', '1', 'admin', '2022-05-23 17:55:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7242, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 17:55:10', '1', 'admin', '2022-05-23 17:55:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7243, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 17:55:10', '1', 'admin', '2022-05-23 17:55:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7244, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 17:55:12', '1', 'admin', '2022-05-23 17:55:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7245, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 17:55:12', '1', 'admin', '2022-05-23 17:55:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7246, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 17:55:13', '1', 'admin', '2022-05-23 17:55:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7247, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 17:56:45', '1', 'admin', '2022-05-23 17:56:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7248, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 17:56:45', '1', 'admin', '2022-05-23 17:56:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7249, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 17:56:51', '1', 'admin', '2022-05-23 17:56:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7250, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 17:56:51', '1', 'admin', '2022-05-23 17:56:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7251, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-23 17:56:53', '1', 'admin', '2022-05-23 17:56:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7252, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-23 17:56:53', '1', 'admin', '2022-05-23 17:56:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7253, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-23 17:56:58', '1', 'admin', '2022-05-23 17:56:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7254, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-23 17:56:58', '1', 'admin', '2022-05-23 17:56:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7255, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 17:56:58', '1', 'admin', '2022-05-23 17:56:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7256, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-23 17:57:07', '1', 'admin', '2022-05-23 17:57:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7257, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-23 18:02:21', '1', 'admin', '2022-05-23 18:02:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7258, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-23 18:02:22', '1', 'admin', '2022-05-23 18:02:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7259, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-05-23 18:02:31', '1', 'admin', '2022-05-23 18:02:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7260, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-05-23 18:02:31', '1', 'admin', '2022-05-23 18:02:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7261, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-05-23 18:02:33', '1', 'admin', '2022-05-23 18:02:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7262, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/downDataload', '2022-05-23 18:02:33', '1', 'admin', '2022-05-23 18:02:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7263, 3, 'Firefox 9', 'POST', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/socketClient', '2022-05-23 18:02:42', '1', 'admin', '2022-05-23 18:02:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7264, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-23 20:04:31', '1', 'admin', '2022-05-23 20:04:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-23 20:04:31', '1', 'admin', '2022-05-23 20:04:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7266, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuTop', '2022-05-23 20:04:50', '1', 'guest', '2022-05-23 20:04:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7267, NULL, 'Chrome 9', 'GET', 'http://192.168.3.2:8080/', '192.168.3.2', '/system/res/menuLeft', '2022-05-23 20:04:50', '1', 'guest', '2022-05-23 20:04:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7268, NULL, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/', '192.168.3.15', '/system/res/menuTop', '2022-05-23 20:05:26', '1', 'guest', '2022-05-23 20:05:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7269, NULL, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/', '192.168.3.15', '/system/res/menuLeft', '2022-05-23 20:05:26', '1', 'guest', '2022-05-23 20:05:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7270, NULL, 'Mobile Safari', 'GET', 'http://192.168.3.2:8080/', '192.168.3.26', '/system/res/menuTop', '2022-05-23 20:05:39', '1', 'guest', '2022-05-23 20:05:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7271, NULL, 'Mobile Safari', 'GET', 'http://192.168.3.2:8080/', '192.168.3.26', '/system/res/menuLeft', '2022-05-23 20:05:39', '1', 'guest', '2022-05-23 20:05:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-24 16:17:47', '1', 'admin', '2022-05-24 16:17:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7273, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-24 16:17:47', '1', 'admin', '2022-05-24 16:17:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-24 16:17:49', '1', 'admin', '2022-05-24 16:17:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-24 16:17:49', '1', 'admin', '2022-05-24 16:17:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-24 16:17:50', '1', 'admin', '2022-05-24 16:17:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7277, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-24 16:17:51', '1', 'admin', '2022-05-24 16:17:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7278, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-24 16:17:51', '1', 'admin', '2022-05-24 16:17:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-24 16:18:35', '1', 'admin', '2022-05-24 16:18:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7280, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-24 16:18:35', '1', 'admin', '2022-05-24 16:18:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-24 16:18:47', '1', 'admin', '2022-05-24 16:18:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-24 16:18:47', '1', 'admin', '2022-05-24 16:18:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-24 16:18:50', '1', 'admin', '2022-05-24 16:18:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7284, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-24 16:18:50', '1', 'admin', '2022-05-24 16:18:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7285, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-24 16:18:51', '1', 'admin', '2022-05-24 16:18:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7286, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-24 16:22:13', '1', 'admin', '2022-05-24 16:22:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7287, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-24 16:22:13', '1', 'admin', '2022-05-24 16:22:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7288, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-24 16:22:18', '1', 'admin', '2022-05-24 16:22:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-24 16:22:19', '1', 'admin', '2022-05-24 16:22:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-24 16:22:21', '1', 'admin', '2022-05-24 16:22:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7291, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-24 16:22:22', '1', 'admin', '2022-05-24 16:22:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7292, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-24 16:22:23', '1', 'admin', '2022-05-24 16:22:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7293, NULL, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/', '192.168.3.15', '/system/res/menuTop', '2022-05-24 16:22:58', '1', 'guest', '2022-05-24 16:22:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7294, NULL, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/', '192.168.3.15', '/system/res/menuLeft', '2022-05-24 16:22:58', '1', 'guest', '2022-05-24 16:22:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7295, 3, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/', '192.168.3.15', '/system/res/menuTop', '2022-05-24 16:23:53', '1', 'admin', '2022-05-24 16:23:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7296, 3, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/', '192.168.3.15', '/system/res/menuLeft', '2022-05-24 16:23:53', '1', 'admin', '2022-05-24 16:23:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7297, 3, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/', '192.168.3.15', '/system/user/download', '2022-05-24 16:23:56', '1', 'admin', '2022-05-24 16:23:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7298, 3, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.15', '/system/user/tablesData', '2022-05-24 16:23:56', '1', 'admin', '2022-05-24 16:23:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7299, 3, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/system/user/download', '192.168.3.15', '/system/user/showdown', '2022-05-24 16:23:58', '1', 'admin', '2022-05-24 16:23:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7300, 3, 'Chrome Mobile', 'GET', 'http://192.168.3.2:8080/system/user/showdown?id=26', '192.168.3.15', '/system/user/downDataload', '2022-05-24 16:23:58', '1', 'admin', '2022-05-24 16:23:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7301, 3, 'Chrome Mobile', 'POST', 'http://192.168.3.2:8080/system/user/showdown?id=26', '192.168.3.15', '/system/user/socketClient', '2022-05-24 16:23:59', '1', 'admin', '2022-05-24 16:23:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7302, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuTop', '2022-05-24 16:28:07', '1', 'admin', '2022-05-24 16:28:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7303, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/res/menuLeft', '2022-05-24 16:28:07', '1', 'admin', '2022-05-24 16:28:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7304, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/', '192.168.32.128', '/system/user/download', '2022-05-24 16:28:10', '1', 'admin', '2022-05-24 16:28:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7305, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/tablesData', '2022-05-24 16:28:11', '1', 'admin', '2022-05-24 16:28:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7306, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/download', '192.168.32.128', '/system/user/showdown', '2022-05-24 16:28:13', '1', 'admin', '2022-05-24 16:28:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7307, 3, 'Firefox 9', 'GET', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/downDataload', '2022-05-24 16:28:13', '1', 'admin', '2022-05-24 16:28:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7308, 3, 'Firefox 9', 'POST', 'http://192.168.32.1:8080/system/user/showdown?id=26', '192.168.32.128', '/system/user/socketClient', '2022-05-24 16:28:14', '1', 'admin', '2022-05-24 16:28:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7309, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-24 16:28:39', '1', 'admin', '2022-05-24 16:28:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-24 16:28:39', '1', 'admin', '2022-05-24 16:28:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7311, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-24 16:28:42', '1', 'admin', '2022-05-24 16:28:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7312, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-24 16:28:42', '1', 'admin', '2022-05-24 16:28:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7313, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-24 16:28:44', '1', 'admin', '2022-05-24 16:28:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-24 16:28:44', '1', 'admin', '2022-05-24 16:28:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7315, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-24 16:28:45', '1', 'admin', '2022-05-24 16:28:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-24 19:59:15', '1', 'admin', '2022-05-24 19:59:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7317, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-24 19:59:15', '1', 'admin', '2022-05-24 19:59:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7318, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-24 19:59:20', '1', 'admin', '2022-05-24 19:59:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-24 19:59:20', '1', 'admin', '2022-05-24 19:59:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-24 19:59:22', '1', 'admin', '2022-05-24 19:59:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7321, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-24 19:59:22', '1', 'admin', '2022-05-24 19:59:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7322, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-24 19:59:24', '1', 'admin', '2022-05-24 19:59:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-26 15:14:14', '1', 'admin', '2022-05-26 15:14:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7324, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-26 15:14:14', '1', 'admin', '2022-05-26 15:14:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7325, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-26 15:14:21', '1', 'admin', '2022-05-26 15:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7326, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-26 15:14:21', '1', 'admin', '2022-05-26 15:14:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7327, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-26 15:14:23', '1', 'admin', '2022-05-26 15:14:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7328, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-26 15:14:23', '1', 'admin', '2022-05-26 15:14:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7329, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-26 15:14:24', '1', 'admin', '2022-05-26 15:14:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7330, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-26 15:15:34', '1', 'admin', '2022-05-26 15:15:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7331, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-26 15:15:34', '1', 'admin', '2022-05-26 15:15:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7332, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-26 15:17:37', '1', 'admin', '2022-05-26 15:17:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7333, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-26 15:17:37', '1', 'admin', '2022-05-26 15:17:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7334, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-26 15:17:50', '1', 'admin', '2022-05-26 15:17:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-26 15:17:50', '1', 'admin', '2022-05-26 15:17:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7336, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-26 15:17:51', '1', 'admin', '2022-05-26 15:17:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7337, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-26 15:17:51', '1', 'admin', '2022-05-26 15:17:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7338, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-26 15:17:54', '1', 'admin', '2022-05-26 15:17:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7339, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 11:15:14', '1', 'admin', '2022-05-27 11:15:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 11:15:15', '1', 'admin', '2022-05-27 11:15:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 11:15:19', '1', 'admin', '2022-05-27 11:15:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7342, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 11:15:19', '1', 'admin', '2022-05-27 11:15:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7343, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 11:15:21', '1', 'admin', '2022-05-27 11:15:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7344, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 11:15:21', '1', 'admin', '2022-05-27 11:15:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7345, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 11:15:23', '1', 'admin', '2022-05-27 11:15:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 11:21:11', '1', 'admin', '2022-05-27 11:21:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 11:21:11', '1', 'admin', '2022-05-27 11:21:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7348, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 11:21:15', '1', 'admin', '2022-05-27 11:21:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7349, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 11:21:16', '1', 'admin', '2022-05-27 11:21:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 11:21:18', '1', 'admin', '2022-05-27 11:21:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 11:21:18', '1', 'admin', '2022-05-27 11:21:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7352, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 11:21:19', '1', 'admin', '2022-05-27 11:21:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7353, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 11:28:41', '1', 'admin', '2022-05-27 11:28:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 11:28:41', '1', 'admin', '2022-05-27 11:28:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7355, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 11:28:46', '1', 'admin', '2022-05-27 11:28:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7356, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 11:28:47', '1', 'admin', '2022-05-27 11:28:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7357, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 11:28:50', '1', 'admin', '2022-05-27 11:28:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 11:28:50', '1', 'admin', '2022-05-27 11:28:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7359, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 11:28:53', '1', 'admin', '2022-05-27 11:28:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7360, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 11:35:36', '1', 'admin', '2022-05-27 11:35:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7361, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 11:35:36', '1', 'admin', '2022-05-27 11:35:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 11:35:46', '1', 'admin', '2022-05-27 11:35:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 11:35:46', '1', 'admin', '2022-05-27 11:35:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7364, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 11:35:48', '1', 'admin', '2022-05-27 11:35:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7365, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 11:35:48', '1', 'admin', '2022-05-27 11:35:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7366, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 11:35:49', '1', 'admin', '2022-05-27 11:35:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7367, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 11:41:24', '1', 'admin', '2022-05-27 11:41:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7368, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 11:41:24', '1', 'admin', '2022-05-27 11:41:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7369, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 11:41:30', '1', 'admin', '2022-05-27 11:41:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7370, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 11:41:30', '1', 'admin', '2022-05-27 11:41:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 11:41:32', '1', 'admin', '2022-05-27 11:41:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7372, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 11:41:32', '1', 'admin', '2022-05-27 11:41:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7373, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 11:41:33', '1', 'admin', '2022-05-27 11:41:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 11:54:58', '1', 'admin', '2022-05-27 11:54:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 11:54:58', '1', 'admin', '2022-05-27 11:54:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7376, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 11:55:01', '1', 'admin', '2022-05-27 11:55:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 11:55:01', '1', 'admin', '2022-05-27 11:55:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7378, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 11:55:04', '1', 'admin', '2022-05-27 11:55:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7379, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 11:55:04', '1', 'admin', '2022-05-27 11:55:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7380, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 11:55:07', '1', 'admin', '2022-05-27 11:55:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 11:56:54', '1', 'admin', '2022-05-27 11:56:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7382, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 11:56:55', '1', 'admin', '2022-05-27 11:56:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 11:57:03', '1', 'admin', '2022-05-27 11:57:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7384, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 11:57:03', '1', 'admin', '2022-05-27 11:57:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 11:57:10', '1', 'admin', '2022-05-27 11:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7386, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 11:57:10', '1', 'admin', '2022-05-27 11:57:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7387, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 11:57:12', '1', 'admin', '2022-05-27 11:57:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7388, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-05-27 12:00:19', '1', 'admin', '2022-05-27 12:00:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7389, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-05-27 12:00:20', '1', 'admin', '2022-05-27 12:00:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7390, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-05-27 12:00:23', '1', 'admin', '2022-05-27 12:00:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7391, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-05-27 12:00:23', '1', 'admin', '2022-05-27 12:00:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7392, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-05-27 12:00:25', '1', 'admin', '2022-05-27 12:00:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7393, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-05-27 12:00:25', '1', 'admin', '2022-05-27 12:00:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7394, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-05-27 12:00:29', '1', 'admin', '2022-05-27 12:00:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7395, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 17:59:49', '1', 'guest', '2022-06-12 17:59:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7396, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 17:59:49', '1', 'guest', '2022-06-12 17:59:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7397, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 17:59:51', '1', 'guest', '2022-06-12 17:59:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7398, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 17:59:51', '1', 'guest', '2022-06-12 17:59:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7399, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 18:00:09', '1', 'admin', '2022-06-12 18:00:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7400, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 18:00:09', '1', 'admin', '2022-06-12 18:00:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7401, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-12 18:00:12', '1', 'admin', '2022-06-12 18:00:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7402, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-12 18:00:12', '1', 'admin', '2022-06-12 18:00:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7403, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-12 18:00:14', '1', 'admin', '2022-06-12 18:00:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7404, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-06-12 18:00:14', '1', 'admin', '2022-06-12 18:00:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7405, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-06-12 18:00:15', '1', 'admin', '2022-06-12 18:00:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7406, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 18:01:51', '1', 'admin', '2022-06-12 18:01:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7407, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 18:01:51', '1', 'admin', '2022-06-12 18:01:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7408, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 18:01:52', '1', 'admin', '2022-06-12 18:01:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7409, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 18:01:53', '1', 'admin', '2022-06-12 18:01:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7410, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-12 18:01:55', '1', 'admin', '2022-06-12 18:01:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7411, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-12 18:01:55', '1', 'admin', '2022-06-12 18:01:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7412, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-12 18:01:59', '1', 'admin', '2022-06-12 18:01:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7413, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-06-12 18:01:59', '1', 'admin', '2022-06-12 18:01:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7414, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-06-12 18:02:01', '1', 'admin', '2022-06-12 18:02:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7415, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 18:25:36', '1', 'admin', '2022-06-12 18:25:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7416, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 18:25:36', '1', 'admin', '2022-06-12 18:25:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7417, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-12 18:25:38', '1', 'admin', '2022-06-12 18:25:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7418, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-12 18:25:38', '1', 'admin', '2022-06-12 18:25:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7419, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-12 18:25:40', '1', 'admin', '2022-06-12 18:25:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7420, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=25', '127.0.0.1', '/system/user/downDataload', '2022-06-12 18:25:40', '1', 'admin', '2022-06-12 18:25:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7421, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 18:30:42', '1', 'admin', '2022-06-12 18:30:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7422, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 18:30:42', '1', 'admin', '2022-06-12 18:30:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7423, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-12 18:30:44', '1', 'admin', '2022-06-12 18:30:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7424, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-12 18:30:44', '1', 'admin', '2022-06-12 18:30:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7425, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-12 18:30:46', '1', 'admin', '2022-06-12 18:30:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7426, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=25', '127.0.0.1', '/system/user/downDataload', '2022-06-12 18:30:46', '1', 'admin', '2022-06-12 18:30:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7427, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=25', '127.0.0.1', '/system/user/socketClient', '2022-06-12 18:30:52', '1', 'admin', '2022-06-12 18:30:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7428, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-12 18:31:33', '1', 'admin', '2022-06-12 18:31:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7429, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-12 18:31:33', '1', 'admin', '2022-06-12 18:31:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7430, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-12 18:31:36', '1', 'admin', '2022-06-12 18:31:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7431, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-12 18:31:36', '1', 'admin', '2022-06-12 18:31:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7432, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-12 18:31:38', '1', 'admin', '2022-06-12 18:31:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7433, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/downDataload', '2022-06-12 18:31:38', '1', 'admin', '2022-06-12 18:31:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7434, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=26', '127.0.0.1', '/system/user/socketClient', '2022-06-12 18:31:42', '1', 'admin', '2022-06-12 18:31:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7435, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:10:01', '1', 'admin', '2022-06-13 10:10:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7436, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:10:01', '1', 'admin', '2022-06-13 10:10:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7437, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:10:03', '1', 'admin', '2022-06-13 10:10:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7438, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:10:03', '1', 'admin', '2022-06-13 10:10:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7439, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-13 10:10:10', '1', 'admin', '2022-06-13 10:10:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7440, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:10:10', '1', 'admin', '2022-06-13 10:10:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7441, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:11:38', '1', 'admin', '2022-06-13 10:11:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7442, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:11:38', '1', 'admin', '2022-06-13 10:11:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7443, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-13 10:11:43', '1', 'admin', '2022-06-13 10:11:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7444, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:11:43', '1', 'admin', '2022-06-13 10:11:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7445, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:17:49', '1', 'admin', '2022-06-13 10:17:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7446, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:17:50', '1', 'admin', '2022-06-13 10:17:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7447, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-13 10:17:51', '1', 'admin', '2022-06-13 10:17:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7448, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:17:51', '1', 'admin', '2022-06-13 10:17:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7449, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:18:50', '1', 'admin', '2022-06-13 10:18:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7450, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:18:50', '1', 'admin', '2022-06-13 10:18:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7451, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-13 10:18:53', '1', 'admin', '2022-06-13 10:18:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7452, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:18:53', '1', 'admin', '2022-06-13 10:18:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7453, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:19:01', '1', 'admin', '2022-06-13 10:19:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7454, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:19:01', '1', 'admin', '2022-06-13 10:19:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7455, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-13 10:19:03', '1', 'admin', '2022-06-13 10:19:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7456, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:19:03', '1', 'admin', '2022-06-13 10:19:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7457, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:21:38', '1', 'admin', '2022-06-13 10:21:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7458, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:21:38', '1', 'admin', '2022-06-13 10:21:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7459, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:21:41', '1', 'admin', '2022-06-13 10:21:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7460, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:21:41', '1', 'admin', '2022-06-13 10:21:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7461, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-13 10:21:44', '1', 'admin', '2022-06-13 10:21:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7462, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:21:44', '1', 'admin', '2022-06-13 10:21:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7463, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-13 10:21:49', '1', 'admin', '2022-06-13 10:21:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7464, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:21:49', '1', 'admin', '2022-06-13 10:21:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7465, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:22:16', '1', 'admin', '2022-06-13 10:22:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7466, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:22:16', '1', 'admin', '2022-06-13 10:22:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7467, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-13 10:22:17', '1', 'admin', '2022-06-13 10:22:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7468, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:22:18', '1', 'admin', '2022-06-13 10:22:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7469, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:22:54', '1', 'admin', '2022-06-13 10:22:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7470, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:22:55', '1', 'admin', '2022-06-13 10:22:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7471, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-13 10:22:56', '1', 'admin', '2022-06-13 10:22:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7472, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:22:56', '1', 'admin', '2022-06-13 10:22:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7473, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:23:28', '1', 'admin', '2022-06-13 10:23:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7474, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:23:29', '1', 'admin', '2022-06-13 10:23:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7475, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-13 10:23:30', '1', 'admin', '2022-06-13 10:23:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7476, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:23:30', '1', 'admin', '2022-06-13 10:23:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7477, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-13 10:23:52', '1', 'admin', '2022-06-13 10:23:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7478, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-06-13 10:23:52', '1', 'admin', '2022-06-13 10:23:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7479, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/socketClient', '2022-06-13 10:23:58', '1', 'admin', '2022-06-13 10:23:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7480, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:26:29', '1', 'admin', '2022-06-13 10:26:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7481, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:26:29', '1', 'admin', '2022-06-13 10:26:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7482, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-13 10:26:31', '1', 'admin', '2022-06-13 10:26:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7483, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-13 10:26:31', '1', 'admin', '2022-06-13 10:26:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7484, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-13 10:26:32', '1', 'admin', '2022-06-13 10:26:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7485, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:26:32', '1', 'admin', '2022-06-13 10:26:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7486, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-13 10:26:56', '1', 'admin', '2022-06-13 10:26:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7487, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-13 10:26:56', '1', 'admin', '2022-06-13 10:26:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7488, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-06-13 10:26:59', '1', 'admin', '2022-06-13 10:26:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7489, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-06-13 10:26:59', '1', 'admin', '2022-06-13 10:26:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7490, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:01:01', '1', 'guest', '2022-06-20 21:01:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7491, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:01:01', '1', 'guest', '2022-06-20 21:01:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7492, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:01:22', '1', 'admin', '2022-06-20 21:01:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7493, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:01:22', '1', 'admin', '2022-06-20 21:01:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7494, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-20 21:01:56', '1', 'admin', '2022-06-20 21:01:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7495, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:01:56', '1', 'admin', '2022-06-20 21:01:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7496, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-06-20 21:05:42', '1', 'admin', '2022-06-20 21:05:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7497, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-06-20 21:05:43', '1', 'admin', '2022-06-20 21:05:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7498, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:07:43', '1', 'admin', '2022-06-20 21:07:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7499, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:07:43', '1', 'admin', '2022-06-20 21:07:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7500, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:07:52', '1', 'admin', '2022-06-20 21:07:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7501, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:07:52', '1', 'admin', '2022-06-20 21:07:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7502, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:08:02', '1', 'admin', '2022-06-20 21:08:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7503, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:08:02', '1', 'admin', '2022-06-20 21:08:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7504, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:08:38', '1', 'admin', '2022-06-20 21:08:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7505, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:08:38', '1', 'admin', '2022-06-20 21:08:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7506, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:08:44', '1', 'admin', '2022-06-20 21:08:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7507, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:08:44', '1', 'admin', '2022-06-20 21:08:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7508, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:08:58', '1', 'admin', '2022-06-20 21:08:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7509, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:08:58', '1', 'admin', '2022-06-20 21:08:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7510, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:09:29', '1', 'test', '2022-06-20 21:09:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7511, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:09:29', '1', 'test', '2022-06-20 21:09:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7512, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-20 21:09:33', '1', 'test', '2022-06-20 21:09:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7513, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:09:33', '1', 'test', '2022-06-20 21:09:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7514, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-20 21:09:36', '1', 'test', '2022-06-20 21:09:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7515, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:09:36', '1', 'test', '2022-06-20 21:09:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7516, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-06-20 21:10:07', '1', 'admin', '2022-06-20 21:10:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7517, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-06-20 21:10:07', '1', 'admin', '2022-06-20 21:10:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7518, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-20 21:10:09', '1', 'admin', '2022-06-20 21:10:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7519, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:10:09', '1', 'admin', '2022-06-20 21:10:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7520, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:10:21', '1', 'admin', '2022-06-20 21:10:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7521, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:10:25', '1', 'admin', '2022-06-20 21:10:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7522, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/upload', '2022-06-20 21:12:05', '1', 'admin', '2022-06-20 21:12:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7523, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/uploada', '2022-06-20 21:12:06', '1', 'admin', '2022-06-20 21:12:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7524, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-20 21:12:08', '1', 'admin', '2022-06-20 21:12:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7525, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:12:08', '1', 'admin', '2022-06-20 21:12:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7526, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-20 21:12:11', '1', 'admin', '2022-06-20 21:12:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7527, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-06-20 21:12:11', '1', 'admin', '2022-06-20 21:12:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7528, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-06-20 21:12:14', '1', 'admin', '2022-06-20 21:12:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7529, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-06-20 21:12:15', '1', 'admin', '2022-06-20 21:12:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7530, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/upload', '127.0.0.1', '/system/user/upload', '2022-06-20 21:23:45', '1', 'admin', '2022-06-20 21:23:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7531, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/upload?pid=&name=win11&url=%E4%B8%80%E5%BC%A0%E6%97%BA%E4%BB%94%E5%9B%BE%E7%89%87&file=&des=C%3A%5CUsers%5CLENOVO%5CDesktop%5C%E6%97%BA%E4%BB%94.jpg&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploada', '2022-06-20 21:23:45', '1', 'admin', '2022-06-20 21:23:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7532, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-06-20 21:24:44', '1', 'admin', '2022-06-20 21:24:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7533, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:24:44', '1', 'admin', '2022-06-20 21:24:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7534, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-06-20 21:28:56', '1', 'admin', '2022-06-20 21:28:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7535, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-06-20 21:28:56', '1', 'admin', '2022-06-20 21:28:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7536, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-20 21:31:07', '1', 'admin', '2022-06-20 21:31:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7537, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/downDataload', '2022-06-20 21:31:07', '1', 'admin', '2022-06-20 21:31:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7538, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=29', '127.0.0.1', '/system/user/socketClient', '2022-06-20 21:31:08', '1', 'admin', '2022-06-20 21:31:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7539, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-06-20 21:31:43', '1', 'admin', '2022-06-20 21:31:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7540, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-06-20 21:31:43', '1', 'admin', '2022-06-20 21:31:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7541, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-06-20 21:32:12', '1', 'admin', '2022-06-20 21:32:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7542, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=30', '127.0.0.1', '/system/user/downDataload', '2022-06-20 21:32:13', '1', 'admin', '2022-06-20 21:32:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7543, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/showdown?id=30', '127.0.0.1', '/system/user/socketClient', '2022-06-20 21:32:14', '1', 'admin', '2022-06-20 21:32:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7544, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 11:22:40', '1', 'guest', '2022-08-07 11:22:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7545, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 11:22:40', '1', 'guest', '2022-08-07 11:22:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7546, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 11:23:09', '1', 'admin', '2022-08-07 11:23:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7547, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 11:23:09', '1', 'admin', '2022-08-07 11:23:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7548, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-07 11:23:15', '1', 'admin', '2022-08-07 11:23:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7549, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 11:23:15', '1', 'admin', '2022-08-07 11:23:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7550, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-07 11:23:24', '1', 'admin', '2022-08-07 11:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7551, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 11:23:24', '1', 'admin', '2022-08-07 11:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7552, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 11:23:24', '1', 'admin', '2022-08-07 11:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7553, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 11:23:26', '1', 'admin', '2022-08-07 11:23:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7554, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-08-07 11:23:38', '1', 'admin', '2022-08-07 11:23:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7555, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 11:23:38', '1', 'admin', '2022-08-07 11:23:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7556, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 11:24:00', '1', 'admin', '2022-08-07 11:24:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7557, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/update', '2022-08-07 11:24:13', '1', 'admin', '2022-08-07 11:24:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7558, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 11:24:16', '1', 'admin', '2022-08-07 11:24:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7559, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/add', '2022-08-07 11:24:27', '1', 'admin', '2022-08-07 11:24:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7560, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 11:24:56', '1', 'admin', '2022-08-07 11:24:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7561, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:48:10', '1', 'admin', '2022-08-07 15:48:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7562, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:48:10', '1', 'admin', '2022-08-07 15:48:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7563, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:48:16', '1', 'admin', '2022-08-07 15:48:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7564, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:48:16', '1', 'admin', '2022-08-07 15:48:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7565, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:48:17', '1', 'admin', '2022-08-07 15:48:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7566, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:48:17', '1', 'admin', '2022-08-07 15:48:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7567, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-07 15:48:21', '1', 'admin', '2022-08-07 15:48:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7568, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 15:48:21', '1', 'admin', '2022-08-07 15:48:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7569, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-07 15:48:33', '1', 'admin', '2022-08-07 15:48:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7570, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:48:33', '1', 'admin', '2022-08-07 15:48:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7571, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:48:33', '1', 'admin', '2022-08-07 15:48:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7572, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:48:46', '1', 'admin', '2022-08-07 15:48:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7573, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-07 15:48:49', '1', 'admin', '2022-08-07 15:48:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7574, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:49:46', '1', 'admin', '2022-08-07 15:49:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7575, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:49:46', '1', 'admin', '2022-08-07 15:49:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7576, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 15:49:48', '1', 'admin', '2022-08-07 15:49:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7577, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:49:52', '1', 'admin', '2022-08-07 15:49:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7578, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:49:52', '1', 'admin', '2022-08-07 15:49:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7579, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 15:49:59', '1', 'admin', '2022-08-07 15:49:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7580, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:50:04', '1', 'admin', '2022-08-07 15:50:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7581, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:50:04', '1', 'admin', '2022-08-07 15:50:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7582, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:50:23', '1', 'admin', '2022-08-07 15:50:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7583, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-07 15:50:32', '1', 'admin', '2022-08-07 15:50:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7584, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:50:32', '1', 'admin', '2022-08-07 15:50:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7585, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:50:32', '1', 'admin', '2022-08-07 15:50:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7586, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:50:34', '1', 'admin', '2022-08-07 15:50:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7587, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 15:50:44', '1', 'admin', '2022-08-07 15:50:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7588, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=106', '127.0.0.1', '/system/res/postUpdate', '2022-08-07 15:50:47', '1', 'admin', '2022-08-07 15:50:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7589, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:50:47', '1', 'admin', '2022-08-07 15:50:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7590, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:50:47', '1', 'admin', '2022-08-07 15:50:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7591, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:50:53', '1', 'admin', '2022-08-07 15:50:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7592, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:50:53', '1', 'admin', '2022-08-07 15:50:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7593, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:50:55', '1', 'admin', '2022-08-07 15:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7594, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:50:55', '1', 'admin', '2022-08-07 15:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7595, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-08-07 15:51:00', '1', 'admin', '2022-08-07 15:51:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7596, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:51:00', '1', 'admin', '2022-08-07 15:51:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7597, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-08-07 15:51:10', '1', 'admin', '2022-08-07 15:51:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7598, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:51:10', '1', 'admin', '2022-08-07 15:51:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7599, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:51:28', '1', 'admin', '2022-08-07 15:51:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7600, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:51:31', '1', 'admin', '2022-08-07 15:51:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7601, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:51:32', '1', 'admin', '2022-08-07 15:51:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7602, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:51:38', '1', 'admin', '2022-08-07 15:51:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7603, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:51:44', '1', 'admin', '2022-08-07 15:51:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7604, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-07 15:51:48', '1', 'admin', '2022-08-07 15:51:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7605, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:51:48', '1', 'admin', '2022-08-07 15:51:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7606, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:51:48', '1', 'admin', '2022-08-07 15:51:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7607, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:52:01', '1', 'admin', '2022-08-07 15:52:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7608, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:52:02', '1', 'admin', '2022-08-07 15:52:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7609, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 15:52:04', '1', 'admin', '2022-08-07 15:52:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7610, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:52:25', '1', 'admin', '2022-08-07 15:52:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7611, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:52:25', '1', 'admin', '2022-08-07 15:52:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7612, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:52:28', '1', 'admin', '2022-08-07 15:52:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7613, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-07 15:52:43', '1', 'admin', '2022-08-07 15:52:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7614, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 15:52:43', '1', 'admin', '2022-08-07 15:52:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7615, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:53:04', '1', 'admin', '2022-08-07 15:53:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7616, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:53:12', '1', 'admin', '2022-08-07 15:53:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7617, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 15:53:14', '1', 'admin', '2022-08-07 15:53:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7618, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-07 15:54:33', '1', 'admin', '2022-08-07 15:54:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7619, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:54:34', '1', 'admin', '2022-08-07 15:54:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7620, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:54:34', '1', 'admin', '2022-08-07 15:54:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7621, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 15:54:41', '1', 'admin', '2022-08-07 15:54:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7622, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-07 15:54:44', '1', 'admin', '2022-08-07 15:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7623, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 15:54:44', '1', 'admin', '2022-08-07 15:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7624, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 15:54:44', '1', 'admin', '2022-08-07 15:54:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7625, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-08-07 15:54:46', '1', 'admin', '2022-08-07 15:54:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7626, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:54:47', '1', 'admin', '2022-08-07 15:54:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7627, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:56:10', '1', 'admin', '2022-08-07 15:56:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7628, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:56:10', '1', 'admin', '2022-08-07 15:56:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7629, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-07 15:56:13', '1', 'admin', '2022-08-07 15:56:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7630, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:57:27', '1', 'admin', '2022-08-07 15:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7631, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:57:27', '1', 'admin', '2022-08-07 15:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7632, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-07 15:57:29', '1', 'admin', '2022-08-07 15:57:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-08-07 15:57:51', '1', 'admin', '2022-08-07 15:57:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-07 15:57:51', '1', 'admin', '2022-08-07 15:57:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-07 15:57:56', '1', 'admin', '2022-08-07 15:57:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7636, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 15:59:09', '1', 'admin', '2022-08-07 15:59:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7637, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 15:59:09', '1', 'admin', '2022-08-07 15:59:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7638, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity', '2022-08-07 15:59:26', '1', 'admin', '2022-08-07 15:59:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7639, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/role', '2022-08-07 15:59:31', '1', 'admin', '2022-08-07 15:59:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7640, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 15:59:31', '1', 'admin', '2022-08-07 15:59:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7641, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 16:03:55', '1', 'admin', '2022-08-07 16:03:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7642, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 16:03:55', '1', 'admin', '2022-08-07 16:03:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-07 16:03:56', '1', 'admin', '2022-08-07 16:03:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 16:05:22', '1', 'admin', '2022-08-07 16:05:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 16:05:22', '1', 'admin', '2022-08-07 16:05:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7646, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 16:05:28', '1', 'admin', '2022-08-07 16:05:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7647, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 16:05:28', '1', 'admin', '2022-08-07 16:05:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7648, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-07 16:05:30', '1', 'admin', '2022-08-07 16:05:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 16:05:43', '1', 'admin', '2022-08-07 16:05:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7650, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 16:05:43', '1', 'admin', '2022-08-07 16:05:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7651, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-07 16:05:44', '1', 'admin', '2022-08-07 16:05:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7652, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-07 16:05:44', '1', 'admin', '2022-08-07 16:05:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:02:52', '1', 'admin', '2022-08-07 18:02:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:02:52', '1', 'admin', '2022-08-07 18:02:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7655, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:02:59', '1', 'admin', '2022-08-07 18:02:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7656, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:02:59', '1', 'admin', '2022-08-07 18:02:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7657, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:03:12', '1', 'admin', '2022-08-07 18:03:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:03:13', '1', 'admin', '2022-08-07 18:03:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:03:20', '1', 'admin', '2022-08-07 18:03:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7660, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:03:20', '1', 'admin', '2022-08-07 18:03:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7661, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-07 18:03:48', '1', 'admin', '2022-08-07 18:03:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7662, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 18:03:48', '1', 'admin', '2022-08-07 18:03:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 18:03:48', '1', 'admin', '2022-08-07 18:03:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7664, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 18:03:52', '1', 'admin', '2022-08-07 18:03:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7665, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 18:03:55', '1', 'admin', '2022-08-07 18:03:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7666, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=103', '127.0.0.1', '/system/res/postUpdate', '2022-08-07 18:04:03', '1', 'admin', '2022-08-07 18:04:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7667, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 18:04:04', '1', 'admin', '2022-08-07 18:04:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7668, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 18:04:04', '1', 'admin', '2022-08-07 18:04:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7669, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:04:05', '1', 'admin', '2022-08-07 18:04:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7670, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:04:05', '1', 'admin', '2022-08-07 18:04:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7671, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/upload', '2022-08-07 18:04:07', '1', 'admin', '2022-08-07 18:04:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7672, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-08-07 18:04:07', '1', 'admin', '2022-08-07 18:04:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7673, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/test', '2022-08-07 18:04:21', '1', 'admin', '2022-08-07 18:04:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7674, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-08-07 18:04:21', '1', 'admin', '2022-08-07 18:04:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7675, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=entity-0&name=333&des=333&file=&url=333&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploadRole', '2022-08-07 18:04:21', '1', 'admin', '2022-08-07 18:04:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7676, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-07 18:05:02', '1', 'admin', '2022-08-07 18:05:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7677, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 18:05:02', '1', 'admin', '2022-08-07 18:05:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7678, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 18:05:02', '1', 'admin', '2022-08-07 18:05:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7679, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 18:05:04', '1', 'admin', '2022-08-07 18:05:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7680, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-07 18:05:09', '1', 'admin', '2022-08-07 18:05:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7681, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=103', '127.0.0.1', '/system/res/postUpdate', '2022-08-07 18:05:11', '1', 'admin', '2022-08-07 18:05:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7682, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-07 18:05:11', '1', 'admin', '2022-08-07 18:05:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7683, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-07 18:05:11', '1', 'admin', '2022-08-07 18:05:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7684, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:05:14', '1', 'admin', '2022-08-07 18:05:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7685, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:05:14', '1', 'admin', '2022-08-07 18:05:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7686, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:41:18', '1', 'admin', '2022-08-07 18:41:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7687, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:41:18', '1', 'admin', '2022-08-07 18:41:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7688, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-07 18:41:21', '1', 'admin', '2022-08-07 18:41:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7689, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 18:41:21', '1', 'admin', '2022-08-07 18:41:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7690, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:42:20', '1', 'admin', '2022-08-07 18:42:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7691, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:42:20', '1', 'admin', '2022-08-07 18:42:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7692, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:42:21', '1', 'admin', '2022-08-07 18:42:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7693, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:42:22', '1', 'admin', '2022-08-07 18:42:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7694, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-07 18:42:25', '1', 'admin', '2022-08-07 18:42:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7695, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 18:42:25', '1', 'admin', '2022-08-07 18:42:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7696, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:44:26', '1', 'admin', '2022-08-07 18:44:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7697, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:44:26', '1', 'admin', '2022-08-07 18:44:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7698, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:44:30', '1', 'admin', '2022-08-07 18:44:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7699, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:44:30', '1', 'admin', '2022-08-07 18:44:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7700, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:44:44', '1', 'admin', '2022-08-07 18:44:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7701, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:44:44', '1', 'admin', '2022-08-07 18:44:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7702, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-07 18:44:46', '1', 'admin', '2022-08-07 18:44:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7703, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 18:44:46', '1', 'admin', '2022-08-07 18:44:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-08-07 18:44:52', '1', 'admin', '2022-08-07 18:44:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7705, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-07 18:44:52', '1', 'admin', '2022-08-07 18:44:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7706, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-07 18:47:01', '1', 'admin', '2022-08-07 18:47:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-07 18:47:01', '1', 'admin', '2022-08-07 18:47:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-07 18:47:03', '1', 'admin', '2022-08-07 18:47:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7709, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-07 18:47:03', '1', 'admin', '2022-08-07 18:47:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7710, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-08 11:26:31', '1', 'admin', '2022-08-08 11:26:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7711, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-08 11:26:31', '1', 'admin', '2022-08-08 11:26:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7712, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-08 11:26:32', '1', 'admin', '2022-08-08 11:26:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7713, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-08 11:26:32', '1', 'admin', '2022-08-08 11:26:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7714, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-08-08 11:26:37', '1', 'admin', '2022-08-08 11:26:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7715, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-08 11:26:37', '1', 'admin', '2022-08-08 11:26:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7716, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-08-08 11:26:39', '1', 'admin', '2022-08-08 11:26:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7717, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-08-08 11:26:39', '1', 'admin', '2022-08-08 11:26:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7718, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-08 11:27:20', '1', 'admin', '2022-08-08 11:27:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7719, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-08 11:27:20', '1', 'admin', '2022-08-08 11:27:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7720, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-08 11:28:49', '1', 'guest', '2022-08-08 11:28:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7721, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-08 11:28:49', '1', 'guest', '2022-08-08 11:28:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7722, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-08 11:29:09', '1', 'admin', '2022-08-08 11:29:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7723, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-08 11:29:09', '1', 'admin', '2022-08-08 11:29:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7724, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-08-08 11:29:54', '1', 'admin', '2022-08-08 11:29:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7725, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-08 11:29:54', '1', 'admin', '2022-08-08 11:29:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7726, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-08-08 11:29:59', '1', 'admin', '2022-08-08 11:29:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7727, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=30', '127.0.0.1', '/system/user/downDataload', '2022-08-08 11:29:59', '1', 'admin', '2022-08-08 11:29:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7728, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-08-08 11:32:37', '1', 'admin', '2022-08-08 11:32:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7729, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-08 11:32:37', '1', 'admin', '2022-08-08 11:32:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7730, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2022-08-08 11:32:39', '1', 'admin', '2022-08-08 11:32:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-08 11:32:41', '1', 'admin', '2022-08-08 11:32:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7732, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-08 11:38:52', '1', 'admin', '2022-08-08 11:38:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-08 11:38:52', '1', 'admin', '2022-08-08 11:38:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7734, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/download', '2022-08-08 11:38:54', '1', 'admin', '2022-08-08 11:38:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7735, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-08 11:38:54', '1', 'admin', '2022-08-08 11:38:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7736, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-08 11:38:57', '1', 'admin', '2022-08-08 11:38:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-08 11:39:12', '1', 'admin', '2022-08-08 11:39:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-08 11:39:13', '1', 'admin', '2022-08-08 11:39:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7739, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-08-08 11:39:19', '1', 'admin', '2022-08-08 11:39:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7740, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=11', '127.0.0.1', '/system/user/downDataload', '2022-08-08 11:39:19', '1', 'admin', '2022-08-08 11:39:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-08-08 11:39:47', '1', 'admin', '2022-08-08 11:39:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=11', '127.0.0.1', '/system/user/downDataload', '2022-08-08 11:39:47', '1', 'admin', '2022-08-08 11:39:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7743, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/tablesData', '2022-08-08 11:40:53', '1', 'admin', '2022-08-08 11:40:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7744, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/download', '127.0.0.1', '/system/user/showdown', '2022-08-08 11:40:55', '1', 'admin', '2022-08-08 11:40:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/showdown?id=30', '127.0.0.1', '/system/user/downDataload', '2022-08-08 11:40:55', '1', 'admin', '2022-08-08 11:40:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 12:32:41', '1', 'admin', '2022-08-09 12:32:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7747, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 12:32:41', '1', 'admin', '2022-08-09 12:32:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 12:32:51', '1', 'admin', '2022-08-09 12:32:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7749, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 12:32:51', '1', 'admin', '2022-08-09 12:32:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 12:33:00', '1', 'admin', '2022-08-09 12:33:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 12:33:00', '1', 'admin', '2022-08-09 12:33:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 12:35:24', '1', 'admin', '2022-08-09 12:35:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 12:35:24', '1', 'admin', '2022-08-09 12:35:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7754, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 12:35:27', '1', 'admin', '2022-08-09 12:35:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7755, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 12:35:27', '1', 'admin', '2022-08-09 12:35:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 12:37:09', '1', 'admin', '2022-08-09 12:37:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 12:37:09', '1', 'admin', '2022-08-09 12:37:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 12:37:11', '1', 'admin', '2022-08-09 12:37:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7759, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 12:37:11', '1', 'admin', '2022-08-09 12:37:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7760, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 12:39:15', '1', 'admin', '2022-08-09 12:39:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7761, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 12:39:15', '1', 'admin', '2022-08-09 12:39:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7762, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 12:39:17', '1', 'admin', '2022-08-09 12:39:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7763, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 12:39:17', '1', 'admin', '2022-08-09 12:39:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7764, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:10:45', '1', 'admin', '2022-08-09 17:10:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7765, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:10:46', '1', 'admin', '2022-08-09 17:10:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:11:11', '1', 'admin', '2022-08-09 17:11:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:11:11', '1', 'admin', '2022-08-09 17:11:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7768, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:15:55', '1', 'guest', '2022-08-09 17:15:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7769, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:15:55', '1', 'guest', '2022-08-09 17:15:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7770, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:16:21', '1', 'admin', '2022-08-09 17:16:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:16:21', '1', 'admin', '2022-08-09 17:16:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:28:44', '1', 'admin', '2022-08-09 17:28:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:28:44', '1', 'admin', '2022-08-09 17:28:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:28:54', '1', 'admin', '2022-08-09 17:28:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7775, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:28:54', '1', 'admin', '2022-08-09 17:28:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:29:06', '1', 'admin', '2022-08-09 17:29:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7777, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:29:06', '1', 'admin', '2022-08-09 17:29:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7778, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-08-09 17:29:13', '1', 'admin', '2022-08-09 17:29:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-08-09 17:29:13', '1', 'admin', '2022-08-09 17:29:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:33:45', '1', 'admin', '2022-08-09 17:33:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7781, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:33:45', '1', 'admin', '2022-08-09 17:33:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:35:01', '1', 'admin', '2022-08-09 17:35:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7783, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:35:01', '1', 'admin', '2022-08-09 17:35:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7784, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 17:35:03', '1', 'admin', '2022-08-09 17:35:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:35:03', '1', 'admin', '2022-08-09 17:35:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:35:04', '1', 'admin', '2022-08-09 17:35:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:35:05', '1', 'admin', '2022-08-09 17:35:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:35:14', '1', 'admin', '2022-08-09 17:35:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7789, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-09 17:35:15', '1', 'admin', '2022-08-09 17:35:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7790, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2022-08-09 17:36:09', '1', 'admin', '2022-08-09 17:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:36:09', '1', 'admin', '2022-08-09 17:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:36:09', '1', 'admin', '2022-08-09 17:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7793, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 17:36:18', '1', 'admin', '2022-08-09 17:36:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7794, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 17:36:18', '1', 'admin', '2022-08-09 17:36:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-08-09 17:36:26', '1', 'admin', '2022-08-09 17:36:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-09 17:36:26', '1', 'admin', '2022-08-09 17:36:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-08-09 17:36:35', '1', 'admin', '2022-08-09 17:36:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:36:48', '1', 'admin', '2022-08-09 17:36:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7799, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:37:12', '1', 'admin', '2022-08-09 17:37:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7800, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:37:13', '1', 'admin', '2022-08-09 17:37:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 17:37:26', '1', 'admin', '2022-08-09 17:37:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7802, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 17:37:26', '1', 'admin', '2022-08-09 17:37:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-08-09 17:37:27', '1', 'admin', '2022-08-09 17:37:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7804, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-08-09 17:37:27', '1', 'admin', '2022-08-09 17:37:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7805, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-08-09 17:37:31', '1', 'admin', '2022-08-09 17:37:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7806, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 17:37:31', '1', 'admin', '2022-08-09 17:37:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:37:46', '1', 'admin', '2022-08-09 17:37:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7808, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:37:46', '1', 'admin', '2022-08-09 17:37:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7809, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:37:48', '1', 'admin', '2022-08-09 17:37:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:37:48', '1', 'admin', '2022-08-09 17:37:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7811, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:40:40', '1', 'guest', '2022-08-09 17:40:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7812, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:40:40', '1', 'guest', '2022-08-09 17:40:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7813, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:41:00', '1', 'admin', '2022-08-09 17:41:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7814, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:41:00', '1', 'admin', '2022-08-09 17:41:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 17:41:18', '1', 'admin', '2022-08-09 17:41:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7816, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:41:18', '1', 'admin', '2022-08-09 17:41:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:41:18', '1', 'admin', '2022-08-09 17:41:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:41:21', '1', 'admin', '2022-08-09 17:41:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7819, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:41:24', '1', 'admin', '2022-08-09 17:41:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7820, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2022-08-09 17:41:30', '1', 'admin', '2022-08-09 17:41:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:41:30', '1', 'admin', '2022-08-09 17:41:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7822, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:41:30', '1', 'admin', '2022-08-09 17:41:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7823, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:44:28', '1', 'admin', '2022-08-09 17:44:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7824, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 17:44:49', '1', 'admin', '2022-08-09 17:44:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:44:49', '1', 'admin', '2022-08-09 17:44:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7826, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:44:49', '1', 'admin', '2022-08-09 17:44:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7827, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-08-09 17:44:59', '1', 'admin', '2022-08-09 17:44:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-08-09 17:45:05', '1', 'admin', '2022-08-09 17:45:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7829, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-09 17:45:05', '1', 'admin', '2022-08-09 17:45:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7830, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2022-08-09 17:45:07', '1', 'admin', '2022-08-09 17:45:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7831, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-09 17:45:09', '1', 'admin', '2022-08-09 17:45:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 17:45:10', '1', 'admin', '2022-08-09 17:45:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7833, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 17:45:10', '1', 'admin', '2022-08-09 17:45:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7834, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-08-09 17:45:13', '1', 'admin', '2022-08-09 17:45:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7835, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-08-09 17:45:13', '1', 'admin', '2022-08-09 17:45:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7836, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-08-09 17:45:18', '1', 'admin', '2022-08-09 17:45:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7837, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 17:45:18', '1', 'admin', '2022-08-09 17:45:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:45:21', '1', 'admin', '2022-08-09 17:45:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:45:21', '1', 'admin', '2022-08-09 17:45:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7840, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/tablesData', '2022-08-09 17:45:22', '1', 'admin', '2022-08-09 17:45:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7841, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 17:45:44', '1', 'admin', '2022-08-09 17:45:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7842, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 17:45:44', '1', 'admin', '2022-08-09 17:45:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7843, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-08-09 17:45:45', '1', 'admin', '2022-08-09 17:45:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7844, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-09 17:45:45', '1', 'admin', '2022-08-09 17:45:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 17:45:48', '1', 'admin', '2022-08-09 17:45:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7846, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:45:48', '1', 'admin', '2022-08-09 17:45:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7847, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:45:48', '1', 'admin', '2022-08-09 17:45:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:45:52', '1', 'admin', '2022-08-09 17:45:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:45:56', '1', 'admin', '2022-08-09 17:45:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7850, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 17:45:59', '1', 'admin', '2022-08-09 17:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:45:59', '1', 'admin', '2022-08-09 17:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:45:59', '1', 'admin', '2022-08-09 17:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:46:06', '1', 'admin', '2022-08-09 17:46:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7854, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:46:06', '1', 'admin', '2022-08-09 17:46:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7855, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/tablesData', '2022-08-09 17:46:07', '1', 'admin', '2022-08-09 17:46:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7856, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 17:48:05', '1', 'admin', '2022-08-09 17:48:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7857, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:48:05', '1', 'admin', '2022-08-09 17:48:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7858, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:48:05', '1', 'admin', '2022-08-09 17:48:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:48:08', '1', 'admin', '2022-08-09 17:48:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7860, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:48:10', '1', 'admin', '2022-08-09 17:48:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7861, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 17:48:18', '1', 'admin', '2022-08-09 17:48:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7862, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:48:18', '1', 'admin', '2022-08-09 17:48:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:48:18', '1', 'admin', '2022-08-09 17:48:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7864, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:48:22', '1', 'admin', '2022-08-09 17:48:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7865, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 17:48:25', '1', 'admin', '2022-08-09 17:48:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7866, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:48:25', '1', 'admin', '2022-08-09 17:48:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7867, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:48:25', '1', 'admin', '2022-08-09 17:48:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7868, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:48:26', '1', 'admin', '2022-08-09 17:48:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:48:26', '1', 'admin', '2022-08-09 17:48:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/check', '2022-08-09 17:48:27', '1', 'admin', '2022-08-09 17:48:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7871, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/check', '127.0.0.1', '/system/user/tablesData', '2022-08-09 17:48:28', '1', 'admin', '2022-08-09 17:48:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7872, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 17:49:01', '1', 'admin', '2022-08-09 17:49:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:49:01', '1', 'admin', '2022-08-09 17:49:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:49:01', '1', 'admin', '2022-08-09 17:49:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:49:16', '1', 'admin', '2022-08-09 17:49:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7876, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:49:26', '1', 'admin', '2022-08-09 17:49:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:49:34', '1', 'admin', '2022-08-09 17:49:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7878, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:49:40', '1', 'admin', '2022-08-09 17:49:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:49:40', '1', 'admin', '2022-08-09 17:49:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7880, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 17:53:07', '1', 'admin', '2022-08-09 17:53:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7881, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 17:53:07', '1', 'admin', '2022-08-09 17:53:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7882, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 17:53:08', '1', 'admin', '2022-08-09 17:53:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:53:08', '1', 'admin', '2022-08-09 17:53:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:53:08', '1', 'admin', '2022-08-09 17:53:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7885, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:53:10', '1', 'admin', '2022-08-09 17:53:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7886, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:53:16', '1', 'admin', '2022-08-09 17:53:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7887, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:53:21', '1', 'admin', '2022-08-09 17:53:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7888, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:53:30', '1', 'admin', '2022-08-09 17:53:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:53:34', '1', 'admin', '2022-08-09 17:53:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:53:34', '1', 'admin', '2022-08-09 17:53:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7891, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:53:42', '1', 'admin', '2022-08-09 17:53:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:53:54', '1', 'admin', '2022-08-09 17:53:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:54:01', '1', 'admin', '2022-08-09 17:54:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:54:25', '1', 'admin', '2022-08-09 17:54:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:54:28', '1', 'admin', '2022-08-09 17:54:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7896, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:55:09', '1', 'admin', '2022-08-09 17:55:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7897, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:55:16', '1', 'admin', '2022-08-09 17:55:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7898, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:55:19', '1', 'admin', '2022-08-09 17:55:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:55:42', '1', 'admin', '2022-08-09 17:55:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:55:45', '1', 'admin', '2022-08-09 17:55:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:55:48', '1', 'admin', '2022-08-09 17:55:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:55:48', '1', 'admin', '2022-08-09 17:55:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7903, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:55:58', '1', 'admin', '2022-08-09 17:55:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:56:01', '1', 'admin', '2022-08-09 17:56:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:56:07', '1', 'admin', '2022-08-09 17:56:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:56:19', '1', 'admin', '2022-08-09 17:56:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7907, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:56:19', '1', 'admin', '2022-08-09 17:56:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:59:39', '1', 'admin', '2022-08-09 17:59:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7909, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 17:59:47', '1', 'admin', '2022-08-09 17:59:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:59:48', '1', 'admin', '2022-08-09 17:59:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7911, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:59:48', '1', 'admin', '2022-08-09 17:59:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:59:50', '1', 'admin', '2022-08-09 17:59:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 17:59:55', '1', 'admin', '2022-08-09 17:59:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 17:59:55', '1', 'admin', '2022-08-09 17:59:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7915, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 17:59:57', '1', 'admin', '2022-08-09 17:59:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7916, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 17:59:59', '1', 'admin', '2022-08-09 17:59:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:00:00', '1', 'admin', '2022-08-09 18:00:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:00:00', '1', 'admin', '2022-08-09 18:00:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7919, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:00:02', '1', 'admin', '2022-08-09 18:00:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:00:02', '1', 'admin', '2022-08-09 18:00:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:09:26', '1', 'admin', '2022-08-09 18:09:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:09:26', '1', 'admin', '2022-08-09 18:09:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7923, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 18:09:32', '1', 'admin', '2022-08-09 18:09:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7924, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:09:32', '1', 'admin', '2022-08-09 18:09:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7925, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:09:32', '1', 'admin', '2022-08-09 18:09:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:09:34', '1', 'admin', '2022-08-09 18:09:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7927, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:09:39', '1', 'admin', '2022-08-09 18:09:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 18:09:41', '1', 'admin', '2022-08-09 18:09:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7929, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 18:10:05', '1', 'admin', '2022-08-09 18:10:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:10:05', '1', 'admin', '2022-08-09 18:10:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:10:05', '1', 'admin', '2022-08-09 18:10:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:10:08', '1', 'admin', '2022-08-09 18:10:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:10:08', '1', 'admin', '2022-08-09 18:10:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:10:13', '1', 'admin', '2022-08-09 18:10:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:10:13', '1', 'admin', '2022-08-09 18:10:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 18:10:15', '1', 'admin', '2022-08-09 18:10:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:10:15', '1', 'admin', '2022-08-09 18:10:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7938, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:10:15', '1', 'admin', '2022-08-09 18:10:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7939, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:10:18', '1', 'admin', '2022-08-09 18:10:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:10:18', '1', 'admin', '2022-08-09 18:10:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7941, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:10:26', '1', 'admin', '2022-08-09 18:10:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:10:28', '1', 'admin', '2022-08-09 18:10:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:10:40', '1', 'admin', '2022-08-09 18:10:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 18:11:34', '1', 'admin', '2022-08-09 18:11:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:11:36', '1', 'admin', '2022-08-09 18:11:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7946, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:11:36', '1', 'admin', '2022-08-09 18:11:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:12:02', '1', 'admin', '2022-08-09 18:12:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:12:22', '1', 'admin', '2022-08-09 18:12:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:12:25', '1', 'admin', '2022-08-09 18:12:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7950, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:13:43', '1', 'admin', '2022-08-09 18:13:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:13:43', '1', 'admin', '2022-08-09 18:13:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-09 18:13:48', '1', 'admin', '2022-08-09 18:13:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:13:48', '1', 'admin', '2022-08-09 18:13:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7954, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:13:48', '1', 'admin', '2022-08-09 18:13:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:13:53', '1', 'admin', '2022-08-09 18:13:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7956, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:13:57', '1', 'admin', '2022-08-09 18:13:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 18:13:59', '1', 'admin', '2022-08-09 18:13:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7958, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 18:14:07', '1', 'admin', '2022-08-09 18:14:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:14:07', '1', 'admin', '2022-08-09 18:14:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:14:07', '1', 'admin', '2022-08-09 18:14:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7961, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-09 18:14:10', '1', 'admin', '2022-08-09 18:14:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7962, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=102', '127.0.0.1', '/system/res/postUpdate', '2022-08-09 18:14:12', '1', 'admin', '2022-08-09 18:14:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-09 18:14:12', '1', 'admin', '2022-08-09 18:14:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-09 18:14:12', '1', 'admin', '2022-08-09 18:14:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:22:35', '1', 'admin', '2022-08-09 18:22:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7966, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:22:35', '1', 'admin', '2022-08-09 18:22:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:22:57', '1', 'admin', '2022-08-09 18:22:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:22:57', '1', 'admin', '2022-08-09 18:22:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7969, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 18:23:00', '1', 'admin', '2022-08-09 18:23:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7970, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 18:23:00', '1', 'admin', '2022-08-09 18:23:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7971, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-08-09 18:23:08', '1', 'admin', '2022-08-09 18:23:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7972, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-08-09 18:23:08', '1', 'admin', '2022-08-09 18:23:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7973, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:28:19', '1', 'guest', '2022-08-09 18:28:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7974, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:28:19', '1', 'guest', '2022-08-09 18:28:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7975, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:28:50', '1', 'admin', '2022-08-09 18:28:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7976, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:28:50', '1', 'admin', '2022-08-09 18:28:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-09 18:28:51', '1', 'admin', '2022-08-09 18:28:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7978, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:29:08', '1', 'admin', '2022-08-09 18:29:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7979, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:29:09', '1', 'admin', '2022-08-09 18:29:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7980, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-09 18:29:10', '1', 'admin', '2022-08-09 18:29:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:33:01', '1', 'admin', '2022-08-09 18:33:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:33:01', '1', 'admin', '2022-08-09 18:33:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:33:03', '1', 'admin', '2022-08-09 18:33:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7984, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:33:03', '1', 'admin', '2022-08-09 18:33:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7985, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-09 18:33:09', '1', 'admin', '2022-08-09 18:33:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:34:14', '1', 'admin', '2022-08-09 18:34:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:34:14', '1', 'admin', '2022-08-09 18:34:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7988, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-09 18:34:21', '1', 'admin', '2022-08-09 18:34:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:37:21', '1', 'admin', '2022-08-09 18:37:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:37:21', '1', 'admin', '2022-08-09 18:37:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-09 18:37:29', '1', 'admin', '2022-08-09 18:37:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7992, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-09 18:37:29', '1', 'admin', '2022-08-09 18:37:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:40:44', '1', 'admin', '2022-08-09 18:40:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7994, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:40:44', '1', 'admin', '2022-08-09 18:40:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-09 18:40:46', '1', 'admin', '2022-08-09 18:40:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7996, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:43:33', '1', 'admin', '2022-08-09 18:43:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:43:33', '1', 'admin', '2022-08-09 18:43:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-09 18:43:34', '1', 'admin', '2022-08-09 18:43:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (7999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-09 18:47:36', '1', 'admin', '2022-08-09 18:47:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8000, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-09 18:47:36', '1', 'admin', '2022-08-09 18:47:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-09 18:47:38', '1', 'admin', '2022-08-09 18:47:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity', '2022-08-09 18:47:57', '1', 'admin', '2022-08-09 18:47:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:44:44', '1', 'admin', '2022-08-10 10:44:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8004, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:44:44', '1', 'admin', '2022-08-10 10:44:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8005, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:44:46', '1', 'admin', '2022-08-10 10:44:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:44:51', '1', 'admin', '2022-08-10 10:44:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:44:51', '1', 'admin', '2022-08-10 10:44:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8008, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:44:52', '1', 'admin', '2022-08-10 10:44:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 10:46:35', '1', 'admin', '2022-08-10 10:46:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8010, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 10:46:35', '1', 'admin', '2022-08-10 10:46:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8011, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:50:29', '1', 'admin', '2022-08-10 10:50:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8012, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:50:29', '1', 'admin', '2022-08-10 10:50:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:50:30', '1', 'admin', '2022-08-10 10:50:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8014, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:51:53', '1', 'admin', '2022-08-10 10:51:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:51:53', '1', 'admin', '2022-08-10 10:51:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8016, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:51:55', '1', 'admin', '2022-08-10 10:51:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:53:34', '1', 'admin', '2022-08-10 10:53:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8018, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:53:34', '1', 'admin', '2022-08-10 10:53:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:53:36', '1', 'admin', '2022-08-10 10:53:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8020, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/role/tableData', '2022-08-10 10:53:36', '1', 'admin', '2022-08-10 10:53:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:55:29', '1', 'admin', '2022-08-10 10:55:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8022, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:55:29', '1', 'admin', '2022-08-10 10:55:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:55:31', '1', 'admin', '2022-08-10 10:55:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8024, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData_2', '2022-08-10 10:55:31', '1', 'admin', '2022-08-10 10:55:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:56:28', '1', 'admin', '2022-08-10 10:56:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8026, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:56:28', '1', 'admin', '2022-08-10 10:56:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8027, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:56:31', '1', 'admin', '2022-08-10 10:56:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 10:56:31', '1', 'admin', '2022-08-10 10:56:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 10:57:45', '1', 'admin', '2022-08-10 10:57:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8030, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 10:57:45', '1', 'admin', '2022-08-10 10:57:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8031, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 10:57:47', '1', 'admin', '2022-08-10 10:57:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8032, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:00:10', '1', 'admin', '2022-08-10 11:00:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:00:10', '1', 'admin', '2022-08-10 11:00:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8034, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:00:12', '1', 'admin', '2022-08-10 11:00:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:03:06', '1', 'admin', '2022-08-10 11:03:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:03:07', '1', 'admin', '2022-08-10 11:03:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:03:08', '1', 'admin', '2022-08-10 11:03:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData_2', '2022-08-10 11:03:08', '1', 'admin', '2022-08-10 11:03:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8039, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:03:22', '1', 'admin', '2022-08-10 11:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8040, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:03:22', '1', 'admin', '2022-08-10 11:03:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8041, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:03:23', '1', 'admin', '2022-08-10 11:03:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8042, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData_2', '2022-08-10 11:03:23', '1', 'admin', '2022-08-10 11:03:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8043, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:04:51', '1', 'admin', '2022-08-10 11:04:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8044, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:04:51', '1', 'admin', '2022-08-10 11:04:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8045, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:04:53', '1', 'admin', '2022-08-10 11:04:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8046, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData_2', '2022-08-10 11:04:53', '1', 'admin', '2022-08-10 11:04:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8047, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:05:46', '1', 'admin', '2022-08-10 11:05:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8048, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:05:46', '1', 'admin', '2022-08-10 11:05:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8049, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:05:47', '1', 'admin', '2022-08-10 11:05:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8050, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:06:45', '1', 'admin', '2022-08-10 11:06:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8051, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:06:45', '1', 'admin', '2022-08-10 11:06:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8052, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:06:47', '1', 'admin', '2022-08-10 11:06:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8053, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:08:19', '1', 'admin', '2022-08-10 11:08:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8054, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:08:19', '1', 'admin', '2022-08-10 11:08:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8055, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:08:21', '1', 'admin', '2022-08-10 11:08:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8056, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:09:53', '1', 'admin', '2022-08-10 11:09:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8057, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:09:53', '1', 'admin', '2022-08-10 11:09:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8058, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:09:55', '1', 'admin', '2022-08-10 11:09:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8059, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:11:08', '1', 'admin', '2022-08-10 11:11:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8060, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:11:08', '1', 'admin', '2022-08-10 11:11:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8061, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:11:10', '1', 'admin', '2022-08-10 11:11:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8062, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 11:11:10', '1', 'admin', '2022-08-10 11:11:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8063, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:13:39', '1', 'admin', '2022-08-10 11:13:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8064, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:13:39', '1', 'admin', '2022-08-10 11:13:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8065, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:13:41', '1', 'admin', '2022-08-10 11:13:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8066, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:14:19', '1', 'admin', '2022-08-10 11:14:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8067, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:14:19', '1', 'admin', '2022-08-10 11:14:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8068, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:14:20', '1', 'admin', '2022-08-10 11:14:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8069, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:16:18', '1', 'admin', '2022-08-10 11:16:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8070, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:16:18', '1', 'admin', '2022-08-10 11:16:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8071, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:16:20', '1', 'admin', '2022-08-10 11:16:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8072, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:16:20', '1', 'admin', '2022-08-10 11:16:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8073, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:16:21', '1', 'admin', '2022-08-10 11:16:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8074, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 11:16:21', '1', 'admin', '2022-08-10 11:16:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8075, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 11:17:07', '1', 'admin', '2022-08-10 11:17:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8076, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 11:17:07', '1', 'admin', '2022-08-10 11:17:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8077, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 11:17:08', '1', 'admin', '2022-08-10 11:17:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8078, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 11:17:09', '1', 'admin', '2022-08-10 11:17:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8079, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 15:36:45', '1', 'admin', '2022-08-10 15:36:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8080, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 15:36:45', '1', 'admin', '2022-08-10 15:36:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8081, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 15:37:03', '1', 'admin', '2022-08-10 15:37:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8082, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 15:37:04', '1', 'admin', '2022-08-10 15:37:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8083, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 15:44:46', '1', 'admin', '2022-08-10 15:44:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8084, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 15:44:46', '1', 'admin', '2022-08-10 15:44:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8085, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 15:44:47', '1', 'admin', '2022-08-10 15:44:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8086, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 15:45:00', '1', 'admin', '2022-08-10 15:45:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8087, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 15:45:00', '1', 'admin', '2022-08-10 15:45:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8088, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 15:45:03', '1', 'admin', '2022-08-10 15:45:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8089, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 15:45:19', '1', 'admin', '2022-08-10 15:45:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8090, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 15:45:19', '1', 'admin', '2022-08-10 15:45:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8091, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 15:45:22', '1', 'admin', '2022-08-10 15:45:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8092, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 15:58:38', '1', 'admin', '2022-08-10 15:58:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8093, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 15:58:38', '1', 'admin', '2022-08-10 15:58:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8094, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 15:58:39', '1', 'admin', '2022-08-10 15:58:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8095, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 15:58:39', '1', 'admin', '2022-08-10 15:58:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8096, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 15:58:41', '1', 'admin', '2022-08-10 15:58:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8097, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 15:58:41', '1', 'admin', '2022-08-10 15:58:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8098, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:01:35', '1', 'admin', '2022-08-10 16:01:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8099, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:01:50', '1', 'admin', '2022-08-10 16:01:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8100, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/upload', '2022-08-10 16:01:57', '1', 'admin', '2022-08-10 16:01:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8101, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 16:01:58', '1', 'admin', '2022-08-10 16:01:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8102, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/upfile', '2022-08-10 16:02:30', '1', 'admin', '2022-08-10 16:02:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8103, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-08-10 16:02:46', '1', 'admin', '2022-08-10 16:02:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8104, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-08-10 16:02:46', '1', 'admin', '2022-08-10 16:02:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8105, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=entity-3&name=666&des=666&file=&url=E%3A%5C%E5%8C%BA%E5%9D%97%E9%93%BE3.0%5C20200713175723934.png&userRole=%E7%AE%A1%E7%90%86%E5%91%98&userRole=%E6%B5%8B%E8%AF%95', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 16:02:46', '1', 'admin', '2022-08-10 16:02:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8106, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:02:56', '1', 'admin', '2022-08-10 16:02:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8107, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/download', '2022-08-10 16:04:45', '1', 'admin', '2022-08-10 16:04:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8108, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/download', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:04:45', '1', 'admin', '2022-08-10 16:04:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8109, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/download', '127.0.0.1', '/system/entity/showdown', '2022-08-10 16:04:49', '1', 'admin', '2022-08-10 16:04:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8110, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/download', '127.0.0.1', '/system/entity/showdown', '2022-08-10 16:05:07', '1', 'admin', '2022-08-10 16:05:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8111, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/download', '127.0.0.1', '/system/entity/showdown', '2022-08-10 16:06:05', '1', 'admin', '2022-08-10 16:06:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8112, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:11:34', '1', 'admin', '2022-08-10 16:11:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8113, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:11:34', '1', 'admin', '2022-08-10 16:11:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8114, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:13:02', '1', 'admin', '2022-08-10 16:13:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8115, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:13:02', '1', 'admin', '2022-08-10 16:13:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8116, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:17:15', '1', 'admin', '2022-08-10 16:17:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8117, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:17:16', '1', 'admin', '2022-08-10 16:17:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8118, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/download', '2022-08-10 16:17:20', '1', 'admin', '2022-08-10 16:17:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8119, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/download', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:17:20', '1', 'admin', '2022-08-10 16:17:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8120, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/download', '127.0.0.1', '/system/entity/showdown', '2022-08-10 16:17:30', '1', 'admin', '2022-08-10 16:17:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8121, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/download', '127.0.0.1', '/system/entity/showdown', '2022-08-10 16:21:16', '1', 'admin', '2022-08-10 16:21:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8122, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/showdown?id=entity-3', '127.0.0.1', '/system/user/downDataload', '2022-08-10 16:21:16', '1', 'admin', '2022-08-10 16:21:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8123, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:24:04', '1', 'admin', '2022-08-10 16:24:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8124, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:24:04', '1', 'admin', '2022-08-10 16:24:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8125, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-08-10 16:24:12', '1', 'admin', '2022-08-10 16:24:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8126, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-08-10 16:24:12', '1', 'admin', '2022-08-10 16:24:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8127, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:24:20', '1', 'admin', '2022-08-10 16:24:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8128, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:24:20', '1', 'admin', '2022-08-10 16:24:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8129, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:24:22', '1', 'admin', '2022-08-10 16:24:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8130, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:24:22', '1', 'admin', '2022-08-10 16:24:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8131, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:24:23', '1', 'admin', '2022-08-10 16:24:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8132, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:24:23', '1', 'admin', '2022-08-10 16:24:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8133, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-10 16:27:19', '1', 'admin', '2022-08-10 16:27:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8134, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:27:19', '1', 'admin', '2022-08-10 16:27:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8135, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:27:19', '1', 'admin', '2022-08-10 16:27:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8136, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:27:25', '1', 'admin', '2022-08-10 16:27:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8137, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:27:28', '1', 'admin', '2022-08-10 16:27:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8138, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:27:30', '1', 'admin', '2022-08-10 16:27:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8139, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:27:31', '1', 'admin', '2022-08-10 16:27:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8140, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:27:57', '1', 'admin', '2022-08-10 16:27:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8141, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-10 16:28:22', '1', 'admin', '2022-08-10 16:28:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8142, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:29:32', '1', 'admin', '2022-08-10 16:29:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8143, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:29:32', '1', 'admin', '2022-08-10 16:29:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8144, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-10 16:29:40', '1', 'admin', '2022-08-10 16:29:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8145, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:29:44', '1', 'admin', '2022-08-10 16:29:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8146, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:29:44', '1', 'admin', '2022-08-10 16:29:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8147, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-10 16:29:45', '1', 'admin', '2022-08-10 16:29:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8148, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2022-08-10 16:30:45', '1', 'admin', '2022-08-10 16:30:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8149, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:30:46', '1', 'admin', '2022-08-10 16:30:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8150, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:30:46', '1', 'admin', '2022-08-10 16:30:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8151, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 16:30:53', '1', 'admin', '2022-08-10 16:30:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8152, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 16:30:53', '1', 'admin', '2022-08-10 16:30:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8153, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:31:18', '1', 'admin', '2022-08-10 16:31:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8154, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-10 16:31:21', '1', 'admin', '2022-08-10 16:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8155, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:31:21', '1', 'admin', '2022-08-10 16:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8156, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:31:21', '1', 'admin', '2022-08-10 16:31:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8157, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:31:23', '1', 'admin', '2022-08-10 16:31:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8158, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-10 16:31:31', '1', 'admin', '2022-08-10 16:31:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8159, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:31:35', '1', 'admin', '2022-08-10 16:31:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8160, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:31:35', '1', 'admin', '2022-08-10 16:31:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8161, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-10 16:31:36', '1', 'admin', '2022-08-10 16:31:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8162, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:31:38', '1', 'admin', '2022-08-10 16:31:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8163, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:31:38', '1', 'admin', '2022-08-10 16:31:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8164, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-10 16:31:40', '1', 'admin', '2022-08-10 16:31:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8165, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:31:42', '1', 'admin', '2022-08-10 16:31:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8166, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:31:42', '1', 'admin', '2022-08-10 16:31:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8167, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-10 16:31:44', '1', 'admin', '2022-08-10 16:31:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8168, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:31:50', '1', 'admin', '2022-08-10 16:31:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8169, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:31:50', '1', 'admin', '2022-08-10 16:31:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8170, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:31:55', '1', 'admin', '2022-08-10 16:31:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8171, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:31:55', '1', 'admin', '2022-08-10 16:31:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8172, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:31:56', '1', 'admin', '2022-08-10 16:31:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8173, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:31:56', '1', 'admin', '2022-08-10 16:31:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8174, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-10 16:32:05', '1', 'admin', '2022-08-10 16:32:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8175, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:32:05', '1', 'admin', '2022-08-10 16:32:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8176, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:32:05', '1', 'admin', '2022-08-10 16:32:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8177, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-08-10 16:32:20', '1', 'admin', '2022-08-10 16:32:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8178, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-08-10 16:32:20', '1', 'admin', '2022-08-10 16:32:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8179, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:32:31', '1', 'admin', '2022-08-10 16:32:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8180, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 16:32:47', '1', 'admin', '2022-08-10 16:32:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8181, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 16:32:47', '1', 'admin', '2022-08-10 16:32:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8182, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-08-10 16:32:49', '1', 'admin', '2022-08-10 16:32:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8183, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-08-10 16:32:49', '1', 'admin', '2022-08-10 16:32:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8184, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-08-10 16:32:55', '1', 'admin', '2022-08-10 16:32:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8185, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 16:32:55', '1', 'admin', '2022-08-10 16:32:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8186, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:32:57', '1', 'admin', '2022-08-10 16:32:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8187, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:32:57', '1', 'admin', '2022-08-10 16:32:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8188, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-10 16:33:13', '1', 'admin', '2022-08-10 16:33:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8189, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:33:13', '1', 'admin', '2022-08-10 16:33:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8190, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:33:13', '1', 'admin', '2022-08-10 16:33:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8191, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:33:35', '1', 'admin', '2022-08-10 16:33:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8192, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:33:47', '1', 'admin', '2022-08-10 16:33:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8193, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-10 16:33:52', '1', 'admin', '2022-08-10 16:33:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8194, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:33:56', '1', 'admin', '2022-08-10 16:33:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8195, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:33:56', '1', 'admin', '2022-08-10 16:33:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8196, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-10 16:34:01', '1', 'admin', '2022-08-10 16:34:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8197, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:34:04', '1', 'admin', '2022-08-10 16:34:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8198, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:34:04', '1', 'admin', '2022-08-10 16:34:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8199, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-10 16:34:25', '1', 'admin', '2022-08-10 16:34:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8200, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:34:25', '1', 'admin', '2022-08-10 16:34:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8201, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:34:25', '1', 'admin', '2022-08-10 16:34:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8202, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:34:29', '1', 'admin', '2022-08-10 16:34:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8203, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:34:33', '1', 'admin', '2022-08-10 16:34:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8204, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2022-08-10 16:34:40', '1', 'admin', '2022-08-10 16:34:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8205, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:34:40', '1', 'admin', '2022-08-10 16:34:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8206, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:34:40', '1', 'admin', '2022-08-10 16:34:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8207, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:34:47', '1', 'admin', '2022-08-10 16:34:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8208, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-10 16:34:50', '1', 'admin', '2022-08-10 16:34:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8209, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-08-10 16:35:34', '1', 'admin', '2022-08-10 16:35:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8210, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:35:34', '1', 'admin', '2022-08-10 16:35:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8211, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:35:34', '1', 'admin', '2022-08-10 16:35:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8212, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 16:35:42', '1', 'admin', '2022-08-10 16:35:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8213, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 16:35:43', '1', 'admin', '2022-08-10 16:35:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8214, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-08-10 16:35:46', '1', 'admin', '2022-08-10 16:35:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8215, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-08-10 16:35:46', '1', 'admin', '2022-08-10 16:35:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8216, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-08-10 16:35:50', '1', 'admin', '2022-08-10 16:35:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8217, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 16:35:50', '1', 'admin', '2022-08-10 16:35:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8218, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-08-10 16:35:53', '1', 'admin', '2022-08-10 16:35:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8219, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-08-10 16:35:53', '1', 'admin', '2022-08-10 16:35:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8220, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2022-08-10 16:35:54', '1', 'admin', '2022-08-10 16:35:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8221, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2022-08-10 16:35:54', '1', 'admin', '2022-08-10 16:35:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8222, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:36:07', '1', 'admin', '2022-08-10 16:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8223, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:36:07', '1', 'admin', '2022-08-10 16:36:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8224, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:36:09', '1', 'admin', '2022-08-10 16:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8225, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:36:09', '1', 'admin', '2022-08-10 16:36:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8226, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-08-10 16:36:24', '1', 'admin', '2022-08-10 16:36:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8227, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:36:24', '1', 'admin', '2022-08-10 16:36:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8228, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:36:25', '1', 'admin', '2022-08-10 16:36:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8229, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-08-10 16:36:51', '1', 'admin', '2022-08-10 16:36:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8230, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-08-10 16:36:51', '1', 'admin', '2022-08-10 16:36:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8231, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:36:56', '1', 'admin', '2022-08-10 16:36:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8232, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-10 16:37:03', '1', 'admin', '2022-08-10 16:37:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8233, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:37:08', '1', 'admin', '2022-08-10 16:37:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8234, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:37:08', '1', 'admin', '2022-08-10 16:37:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8235, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-08-10 16:37:09', '1', 'admin', '2022-08-10 16:37:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8236, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-08-10 16:38:12', '1', 'admin', '2022-08-10 16:38:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8237, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:38:12', '1', 'admin', '2022-08-10 16:38:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8238, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:38:12', '1', 'admin', '2022-08-10 16:38:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8239, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-08-10 16:38:15', '1', 'admin', '2022-08-10 16:38:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8240, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=109', '127.0.0.1', '/system/res/postUpdate', '2022-08-10 16:38:18', '1', 'admin', '2022-08-10 16:38:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8241, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-08-10 16:38:18', '1', 'admin', '2022-08-10 16:38:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8242, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-08-10 16:38:18', '1', 'admin', '2022-08-10 16:38:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8243, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 16:38:22', '1', 'admin', '2022-08-10 16:38:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8244, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 16:38:22', '1', 'admin', '2022-08-10 16:38:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8245, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-08-10 16:38:23', '1', 'admin', '2022-08-10 16:38:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8246, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-08-10 16:38:23', '1', 'admin', '2022-08-10 16:38:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8247, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-08-10 16:38:30', '1', 'admin', '2022-08-10 16:38:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8248, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 16:38:30', '1', 'admin', '2022-08-10 16:38:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8249, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:38:33', '1', 'admin', '2022-08-10 16:38:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8250, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:38:33', '1', 'admin', '2022-08-10 16:38:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8251, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:38:34', '1', 'admin', '2022-08-10 16:38:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8252, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:38:34', '1', 'admin', '2022-08-10 16:38:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8253, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/delete', '2022-08-10 16:38:44', '1', 'admin', '2022-08-10 16:38:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8254, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/delete', '2022-08-10 16:39:17', '1', 'admin', '2022-08-10 16:39:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8255, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:42:32', '1', 'admin', '2022-08-10 16:42:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8256, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:42:32', '1', 'admin', '2022-08-10 16:42:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8257, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:42:35', '1', 'admin', '2022-08-10 16:42:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8258, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:42:35', '1', 'admin', '2022-08-10 16:42:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8259, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/delete', '2022-08-10 16:42:55', '1', 'admin', '2022-08-10 16:42:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8260, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:43:03', '1', 'admin', '2022-08-10 16:43:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8261, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:43:03', '1', 'admin', '2022-08-10 16:43:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8262, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:47:02', '1', 'admin', '2022-08-10 16:47:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8263, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:47:02', '1', 'admin', '2022-08-10 16:47:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8264, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:47:04', '1', 'admin', '2022-08-10 16:47:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8265, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:47:04', '1', 'admin', '2022-08-10 16:47:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8266, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/delete', '2022-08-10 16:47:13', '1', 'admin', '2022-08-10 16:47:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8267, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:47:16', '1', 'admin', '2022-08-10 16:47:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8268, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/upload', '2022-08-10 16:47:48', '1', 'admin', '2022-08-10 16:47:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8269, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 16:47:48', '1', 'admin', '2022-08-10 16:47:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8270, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-08-10 16:48:21', '1', 'admin', '2022-08-10 16:48:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8271, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-08-10 16:48:21', '1', 'admin', '2022-08-10 16:48:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8272, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 16:48:29', '1', 'admin', '2022-08-10 16:48:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8273, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 16:48:29', '1', 'admin', '2022-08-10 16:48:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8274, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 16:50:17', '1', 'admin', '2022-08-10 16:50:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8275, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 16:50:17', '1', 'admin', '2022-08-10 16:50:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8276, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/upload', '2022-08-10 16:50:19', '1', 'admin', '2022-08-10 16:50:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8277, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 16:50:19', '1', 'admin', '2022-08-10 16:50:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8278, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-08-10 16:50:42', '1', 'admin', '2022-08-10 16:50:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8279, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-08-10 16:50:42', '1', 'admin', '2022-08-10 16:50:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8280, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=entity-1&name=666&des=666&file=&url=E%3A%5C%E5%8C%BA%E5%9D%97%E9%93%BE3.0%5C20200713175723934.png&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 16:50:42', '1', 'admin', '2022-08-10 16:50:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8281, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 17:00:26', '1', 'admin', '2022-08-10 17:00:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8282, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 17:00:26', '1', 'admin', '2022-08-10 17:00:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8283, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/upload', '2022-08-10 17:00:29', '1', 'admin', '2022-08-10 17:00:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8284, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:00:29', '1', 'admin', '2022-08-10 17:00:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8285, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-08-10 17:00:49', '1', 'admin', '2022-08-10 17:00:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8286, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-08-10 17:00:49', '1', 'admin', '2022-08-10 17:00:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8287, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=entity-3&name=%E5%93%88%E5%93%88&des=%E5%93%88%E5%93%88&file=&url=666&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:00:49', '1', 'admin', '2022-08-10 17:00:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8288, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 17:00:50', '1', 'admin', '2022-08-10 17:00:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8289, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:00:50', '1', 'admin', '2022-08-10 17:00:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8290, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 17:00:56', '1', 'admin', '2022-08-10 17:00:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8291, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:00:57', '1', 'admin', '2022-08-10 17:00:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8292, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 17:02:19', '1', 'admin', '2022-08-10 17:02:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8293, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 17:02:19', '1', 'admin', '2022-08-10 17:02:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8294, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 17:02:20', '1', 'admin', '2022-08-10 17:02:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8295, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:02:20', '1', 'admin', '2022-08-10 17:02:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8296, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity/upload', '2022-08-10 17:02:38', '1', 'admin', '2022-08-10 17:02:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8297, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:02:38', '1', 'admin', '2022-08-10 17:02:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8298, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-08-10 17:02:54', '1', 'admin', '2022-08-10 17:02:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8299, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-08-10 17:02:54', '1', 'admin', '2022-08-10 17:02:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8300, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=entity-9&name=%E5%93%88%E5%93%88&des=66&file=&url=66&userRole=%E7%AE%A1%E7%90%86%E5%91%98', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:02:54', '1', 'admin', '2022-08-10 17:02:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8301, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 17:02:57', '1', 'admin', '2022-08-10 17:02:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8302, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:02:57', '1', 'admin', '2022-08-10 17:02:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8303, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/update', '2022-08-10 17:04:10', '1', 'admin', '2022-08-10 17:04:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8304, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/update?id=entity-9', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:04:10', '1', 'admin', '2022-08-10 17:04:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8305, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:05:07', '1', 'admin', '2022-08-10 17:05:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8306, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 17:08:52', '1', 'admin', '2022-08-10 17:08:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8307, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 17:08:53', '1', 'admin', '2022-08-10 17:08:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8308, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 17:08:54', '1', 'admin', '2022-08-10 17:08:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8309, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:08:54', '1', 'admin', '2022-08-10 17:08:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8310, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/update', '2022-08-10 17:08:57', '1', 'admin', '2022-08-10 17:08:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8311, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/update?id=entity-9', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:08:58', '1', 'admin', '2022-08-10 17:08:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8312, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/update?id=entity-9', '127.0.0.1', '/system/entity/postUpdate', '2022-08-10 17:09:13', '1', 'admin', '2022-08-10 17:09:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8313, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:09:20', '1', 'admin', '2022-08-10 17:09:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8314, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/update', '2022-08-10 17:09:31', '1', 'admin', '2022-08-10 17:09:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8315, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/update?id=entity-9', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:09:31', '1', 'admin', '2022-08-10 17:09:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8316, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:09:36', '1', 'admin', '2022-08-10 17:09:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8317, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/update', '2022-08-10 17:13:23', '1', 'admin', '2022-08-10 17:13:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8318, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/update?id=entity-9', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:13:23', '1', 'admin', '2022-08-10 17:13:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8319, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:14:13', '1', 'admin', '2022-08-10 17:14:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8320, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 17:17:45', '1', 'admin', '2022-08-10 17:17:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8321, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 17:17:45', '1', 'admin', '2022-08-10 17:17:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8322, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 17:17:47', '1', 'admin', '2022-08-10 17:17:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8323, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:17:47', '1', 'admin', '2022-08-10 17:17:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8324, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/update', '2022-08-10 17:17:51', '1', 'admin', '2022-08-10 17:17:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8325, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/update?id=entity-9', '127.0.0.1', '/system/user/uploadRole', '2022-08-10 17:17:52', '1', 'admin', '2022-08-10 17:17:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8326, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/update?id=entity-9', '127.0.0.1', '/system/entity/postUpdate', '2022-08-10 17:18:15', '1', 'admin', '2022-08-10 17:18:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8327, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 17:18:18', '1', 'admin', '2022-08-10 17:18:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8328, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 17:23:24', '1', 'guest', '2022-08-10 17:23:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8329, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 17:23:25', '1', 'guest', '2022-08-10 17:23:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8330, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 17:23:40', '1', 'admin', '2022-08-10 17:23:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8331, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 17:23:40', '1', 'admin', '2022-08-10 17:23:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8332, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 17:23:43', '1', 'admin', '2022-08-10 17:23:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8333, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 17:23:43', '1', 'admin', '2022-08-10 17:23:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8334, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 17:24:48', '1', 'admin', '2022-08-10 17:24:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8335, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 17:24:49', '1', 'admin', '2022-08-10 17:24:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8336, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-08-10 17:24:51', '1', 'admin', '2022-08-10 17:24:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8337, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-08-10 17:24:51', '1', 'admin', '2022-08-10 17:24:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8338, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-08-10 18:11:04', '1', 'admin', '2022-08-10 18:11:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8339, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-08-10 18:11:04', '1', 'admin', '2022-08-10 18:11:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8340, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-08-10 18:11:06', '1', 'admin', '2022-08-10 18:11:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8341, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-08-10 18:11:06', '1', 'admin', '2022-08-10 18:11:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8342, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 10:47:24', '1', 'guest', '2022-09-01 10:47:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8343, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 10:47:24', '1', 'guest', '2022-09-01 10:47:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8344, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 10:47:27', '1', 'guest', '2022-09-01 10:47:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8345, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 10:47:27', '1', 'guest', '2022-09-01 10:47:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8346, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 10:47:47', '1', 'admin', '2022-09-01 10:47:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8347, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 10:47:47', '1', 'admin', '2022-09-01 10:47:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8348, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-09-01 10:47:50', '1', 'admin', '2022-09-01 10:47:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8349, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 10:47:50', '1', 'admin', '2022-09-01 10:47:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8350, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:47:50', '1', 'admin', '2022-09-01 10:47:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8351, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:48:12', '1', 'admin', '2022-09-01 10:48:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8352, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:48:15', '1', 'admin', '2022-09-01 10:48:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8353, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:48:22', '1', 'admin', '2022-09-01 10:48:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8354, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-09-01 10:48:28', '1', 'admin', '2022-09-01 10:48:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8355, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 10:48:28', '1', 'admin', '2022-09-01 10:48:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8356, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-09-01 10:48:33', '1', 'admin', '2022-09-01 10:48:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8357, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-09-01 10:48:33', '1', 'admin', '2022-09-01 10:48:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8358, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 10:48:40', '1', 'admin', '2022-09-01 10:48:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8359, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/update', '2022-09-01 10:51:19', '1', 'admin', '2022-09-01 10:51:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8360, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 10:51:21', '1', 'admin', '2022-09-01 10:51:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8361, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-09-01 10:51:22', '1', 'admin', '2022-09-01 10:51:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8362, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-09-01 10:51:22', '1', 'admin', '2022-09-01 10:51:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8363, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 10:52:15', '1', 'admin', '2022-09-01 10:52:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8364, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:52:23', '1', 'admin', '2022-09-01 10:52:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8365, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:52:28', '1', 'admin', '2022-09-01 10:52:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8366, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:52:40', '1', 'admin', '2022-09-01 10:52:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8367, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 10:54:21', '1', 'admin', '2022-09-01 10:54:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8368, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:54:24', '1', 'admin', '2022-09-01 10:54:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8369, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 10:54:24', '1', 'admin', '2022-09-01 10:54:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8370, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 10:55:31', '1', 'admin', '2022-09-01 10:55:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8371, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 10:55:35', '1', 'admin', '2022-09-01 10:55:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8372, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:55:35', '1', 'admin', '2022-09-01 10:55:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8373, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 10:55:36', '1', 'admin', '2022-09-01 10:55:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8374, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:55:39', '1', 'admin', '2022-09-01 10:55:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8375, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 10:55:39', '1', 'admin', '2022-09-01 10:55:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8376, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:55:47', '1', 'admin', '2022-09-01 10:55:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8377, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-09-01 10:57:18', '1', 'admin', '2022-09-01 10:57:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8378, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-09-01 10:57:18', '1', 'admin', '2022-09-01 10:57:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8379, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 10:57:25', '1', 'admin', '2022-09-01 10:57:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8380, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 10:57:27', '1', 'admin', '2022-09-01 10:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8381, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:57:27', '1', 'admin', '2022-09-01 10:57:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8382, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 10:57:30', '1', 'admin', '2022-09-01 10:57:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8383, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:57:40', '1', 'admin', '2022-09-01 10:57:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8384, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 10:57:40', '1', 'admin', '2022-09-01 10:57:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8385, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 10:59:00', '1', 'admin', '2022-09-01 10:59:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8386, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 10:59:03', '1', 'admin', '2022-09-01 10:59:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8387, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 10:59:03', '1', 'admin', '2022-09-01 10:59:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8388, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/opeCheck', '2022-09-01 10:59:26', '1', 'admin', '2022-09-01 10:59:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8389, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/opeTablesData', '2022-09-01 10:59:26', '1', 'admin', '2022-09-01 10:59:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8390, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:01:26', '1', 'admin', '2022-09-01 11:01:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8391, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:02:24', '1', 'admin', '2022-09-01 11:02:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8392, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:02:26', '1', 'admin', '2022-09-01 11:02:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8393, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/update', '2022-09-01 11:02:49', '1', 'admin', '2022-09-01 11:02:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8394, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 11:02:51', '1', 'admin', '2022-09-01 11:02:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8395, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-09-01 11:02:52', '1', 'admin', '2022-09-01 11:02:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8396, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-09-01 11:02:52', '1', 'admin', '2022-09-01 11:02:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8397, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-09-01 11:03:00', '1', 'admin', '2022-09-01 11:03:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8398, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 11:03:00', '1', 'admin', '2022-09-01 11:03:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8399, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 11:03:37', '1', 'admin', '2022-09-01 11:03:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8400, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:03:42', '1', 'admin', '2022-09-01 11:03:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8401, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:03:42', '1', 'admin', '2022-09-01 11:03:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8402, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/unuse', '2022-09-01 11:03:43', '1', 'admin', '2022-09-01 11:03:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8403, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:03:43', '1', 'admin', '2022-09-01 11:03:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8404, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/use', '2022-09-01 11:03:47', '1', 'admin', '2022-09-01 11:03:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8405, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:03:47', '1', 'admin', '2022-09-01 11:03:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8406, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/unuse', '2022-09-01 11:03:50', '1', 'admin', '2022-09-01 11:03:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8407, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:03:50', '1', 'admin', '2022-09-01 11:03:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8408, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 11:03:54', '1', 'admin', '2022-09-01 11:03:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8409, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 11:03:54', '1', 'admin', '2022-09-01 11:03:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8410, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-09-01 11:04:02', '1', 'admin', '2022-09-01 11:04:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8411, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:04:02', '1', 'admin', '2022-09-01 11:04:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8412, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:04:02', '1', 'admin', '2022-09-01 11:04:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8413, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:04:04', '1', 'admin', '2022-09-01 11:04:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8414, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/use', '2022-09-01 11:04:17', '1', 'admin', '2022-09-01 11:04:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8415, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:04:18', '1', 'admin', '2022-09-01 11:04:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8416, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 11:04:21', '1', 'admin', '2022-09-01 11:04:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8417, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 11:04:21', '1', 'admin', '2022-09-01 11:04:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8418, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-09-01 11:04:24', '1', 'admin', '2022-09-01 11:04:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8419, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:04:24', '1', 'admin', '2022-09-01 11:04:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8420, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:04:24', '1', 'admin', '2022-09-01 11:04:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8421, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:04:28', '1', 'admin', '2022-09-01 11:04:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8422, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:07:06', '1', 'admin', '2022-09-01 11:07:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8423, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 11:07:08', '1', 'admin', '2022-09-01 11:07:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8424, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:07:12', '1', 'admin', '2022-09-01 11:07:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8425, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:07:12', '1', 'admin', '2022-09-01 11:07:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8426, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:07:22', '1', 'admin', '2022-09-01 11:07:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8427, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:08:46', '1', 'admin', '2022-09-01 11:08:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8428, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:08:57', '1', 'admin', '2022-09-01 11:08:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8429, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:09:38', '1', 'admin', '2022-09-01 11:09:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8430, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:09:44', '1', 'admin', '2022-09-01 11:09:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8431, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:09:46', '1', 'admin', '2022-09-01 11:09:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8432, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 11:09:52', '1', 'admin', '2022-09-01 11:09:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8433, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:09:56', '1', 'admin', '2022-09-01 11:09:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8434, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:09:56', '1', 'admin', '2022-09-01 11:09:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8435, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:12:09', '1', 'admin', '2022-09-01 11:12:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8436, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:19:00', '1', 'admin', '2022-09-01 11:19:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8437, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:19:03', '1', 'admin', '2022-09-01 11:19:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8438, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:19:07', '1', 'admin', '2022-09-01 11:19:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8439, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:19:07', '1', 'admin', '2022-09-01 11:19:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8440, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-09-01 11:20:07', '1', 'admin', '2022-09-01 11:20:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8441, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 11:20:07', '1', 'admin', '2022-09-01 11:20:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8442, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-09-01 11:20:09', '1', 'admin', '2022-09-01 11:20:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8443, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-09-01 11:20:10', '1', 'admin', '2022-09-01 11:20:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8444, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-09-01 11:20:19', '1', 'admin', '2022-09-01 11:20:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8445, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 11:20:20', '1', 'admin', '2022-09-01 11:20:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8446, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 11:20:22', '1', 'admin', '2022-09-01 11:20:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8447, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 11:20:22', '1', 'admin', '2022-09-01 11:20:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8448, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-09-01 11:20:29', '1', 'admin', '2022-09-01 11:20:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8449, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 11:20:29', '1', 'admin', '2022-09-01 11:20:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8450, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-09-01 11:20:31', '1', 'admin', '2022-09-01 11:20:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8451, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-09-01 11:20:31', '1', 'admin', '2022-09-01 11:20:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8452, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-09-01 11:20:34', '1', 'admin', '2022-09-01 11:20:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8453, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-09-01 11:20:34', '1', 'admin', '2022-09-01 11:20:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8454, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 11:20:37', '1', 'admin', '2022-09-01 11:20:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8455, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 11:20:37', '1', 'admin', '2022-09-01 11:20:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8456, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-09-01 11:20:40', '1', 'admin', '2022-09-01 11:20:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8457, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:20:41', '1', 'admin', '2022-09-01 11:20:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8458, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:20:41', '1', 'admin', '2022-09-01 11:20:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8459, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:20:43', '1', 'admin', '2022-09-01 11:20:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8460, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:23:57', '1', 'admin', '2022-09-01 11:23:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8461, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:24:03', '1', 'admin', '2022-09-01 11:24:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8462, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:24:44', '1', 'admin', '2022-09-01 11:24:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8463, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:24:57', '1', 'admin', '2022-09-01 11:24:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8464, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-09-01 11:25:28', '1', 'admin', '2022-09-01 11:25:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8465, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:25:42', '1', 'admin', '2022-09-01 11:25:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8466, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:25:42', '1', 'admin', '2022-09-01 11:25:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8467, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-01 11:26:17', '1', 'test', '2022-09-01 11:26:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8468, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-01 11:26:17', '1', 'test', '2022-09-01 11:26:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8469, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-09-01 11:26:22', '1', 'test', '2022-09-01 11:26:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8470, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-09-01 11:26:23', '1', 'test', '2022-09-01 11:26:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8471, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:26:23', '1', 'test', '2022-09-01 11:26:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8472, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:26:39', '1', 'test', '2022-09-01 11:26:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8473, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:28:28', '1', 'test', '2022-09-01 11:28:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8474, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-09-01 11:28:51', '1', 'test', '2022-09-01 11:28:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8475, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-30 10:43:02', '1', 'guest', '2022-09-30 10:43:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8476, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-30 10:43:02', '1', 'guest', '2022-09-30 10:43:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8477, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-30 10:43:26', '1', 'admin', '2022-09-30 10:43:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8478, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-30 10:43:26', '1', 'admin', '2022-09-30 10:43:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8479, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-09-30 10:43:27', '1', 'admin', '2022-09-30 10:43:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8480, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-09-30 10:43:27', '1', 'admin', '2022-09-30 10:43:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8481, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-08 10:04:44', '1', 'guest', '2022-10-08 10:04:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8482, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-08 10:04:45', '1', 'guest', '2022-10-08 10:04:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8483, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-08 10:05:03', '1', 'admin', '2022-10-08 10:05:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8484, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-08 10:05:03', '1', 'admin', '2022-10-08 10:05:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8485, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-10-08 10:05:13', '1', 'admin', '2022-10-08 10:05:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8486, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-08 10:05:14', '1', 'admin', '2022-10-08 10:05:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8487, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-08 10:06:48', '1', 'admin', '2022-10-08 10:06:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8488, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-10-08 10:06:49', '1', 'admin', '2022-10-08 10:06:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8489, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-09 16:22:44', '1', 'admin', '2022-10-09 16:22:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8490, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-09 16:22:44', '1', 'admin', '2022-10-09 16:22:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8491, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-09 16:22:54', '1', 'admin', '2022-10-09 16:22:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8492, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-09 16:22:54', '1', 'admin', '2022-10-09 16:22:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8493, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-10-09 16:22:56', '1', 'admin', '2022-10-09 16:22:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8494, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-09 16:23:52', '1', 'admin', '2022-10-09 16:23:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8495, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-09 16:23:52', '1', 'admin', '2022-10-09 16:23:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8496, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-10-09 16:23:53', '1', 'admin', '2022-10-09 16:23:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8497, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-10-09 16:23:53', '1', 'admin', '2022-10-09 16:23:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8498, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-09 16:36:47', '1', 'admin', '2022-10-09 16:36:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8499, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-09 16:36:47', '1', 'admin', '2022-10-09 16:36:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8500, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-10-09 16:36:51', '1', 'admin', '2022-10-09 16:36:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8501, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-10-09 16:36:51', '1', 'admin', '2022-10-09 16:36:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8502, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-09 20:07:28', '1', 'admin', '2022-10-09 20:07:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8503, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-09 20:07:28', '1', 'admin', '2022-10-09 20:07:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8504, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-09 20:07:42', '1', 'test', '2022-10-09 20:07:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8505, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-09 20:07:42', '1', 'test', '2022-10-09 20:07:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8506, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:10:57', '1', 'guest', '2022-10-30 15:10:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8507, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:10:58', '1', 'guest', '2022-10-30 15:10:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8508, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:11:19', '1', 'test', '2022-10-30 15:11:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8509, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:11:19', '1', 'test', '2022-10-30 15:11:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8510, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-10-30 15:11:21', '1', 'test', '2022-10-30 15:11:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8511, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:11:21', '1', 'test', '2022-10-30 15:11:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8512, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:11:28', '1', 'test', '2022-10-30 15:11:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8513, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:11:28', '1', 'test', '2022-10-30 15:11:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8514, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:11:34', '1', 'test', '2022-10-30 15:11:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8515, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:11:39', '1', 'test', '2022-10-30 15:11:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8516, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:11:39', '1', 'test', '2022-10-30 15:11:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8517, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:11:46', '1', 'test', '2022-10-30 15:11:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8518, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:11:47', '1', 'test', '2022-10-30 15:11:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8519, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:11:47', '1', 'test', '2022-10-30 15:11:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8520, 4, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/role/postAuth', '2022-10-30 15:11:51', '1', 'test', '2022-10-30 15:11:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8521, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:11:51', '1', 'test', '2022-10-30 15:11:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8522, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:11:55', '1', 'test', '2022-10-30 15:11:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8523, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:11:55', '1', 'test', '2022-10-30 15:11:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8524, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-10-30 15:11:59', '1', 'test', '2022-10-30 15:11:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8525, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-10-30 15:11:59', '1', 'test', '2022-10-30 15:11:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8526, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-10-30 15:12:01', '1', 'test', '2022-10-30 15:12:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8527, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:12:01', '1', 'test', '2022-10-30 15:12:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8528, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:12:02', '1', 'test', '2022-10-30 15:12:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8529, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:12:03', '1', 'test', '2022-10-30 15:12:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8530, 4, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/role/postAuth', '2022-10-30 15:12:07', '1', 'test', '2022-10-30 15:12:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8531, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:12:07', '1', 'test', '2022-10-30 15:12:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8532, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:12:11', '1', 'test', '2022-10-30 15:12:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8533, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:12:11', '1', 'test', '2022-10-30 15:12:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8534, 4, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/role/postAuth', '2022-10-30 15:12:17', '1', 'test', '2022-10-30 15:12:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8535, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:12:17', '1', 'test', '2022-10-30 15:12:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8536, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:12:19', '1', 'test', '2022-10-30 15:12:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8537, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:12:19', '1', 'test', '2022-10-30 15:12:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8538, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-10-30 15:12:24', '1', 'test', '2022-10-30 15:12:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8539, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:12:24', '1', 'test', '2022-10-30 15:12:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8540, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:12:27', '1', 'test', '2022-10-30 15:12:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8541, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:12:27', '1', 'test', '2022-10-30 15:12:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8542, 4, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/role/postAuth', '2022-10-30 15:12:32', '1', 'test', '2022-10-30 15:12:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8543, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:12:32', '1', 'test', '2022-10-30 15:12:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8544, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:13:01', '1', 'test', '2022-10-30 15:13:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8545, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:13:01', '1', 'test', '2022-10-30 15:13:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8546, 4, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/role/postAuth', '2022-10-30 15:13:14', '1', 'test', '2022-10-30 15:13:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8547, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:13:15', '1', 'test', '2022-10-30 15:13:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8548, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:13:17', '1', 'test', '2022-10-30 15:13:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8549, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:13:17', '1', 'test', '2022-10-30 15:13:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8550, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:13:33', '1', 'admin', '2022-10-30 15:13:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8551, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:13:33', '1', 'admin', '2022-10-30 15:13:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8552, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-10-30 15:13:34', '1', 'admin', '2022-10-30 15:13:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8553, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:13:34', '1', 'admin', '2022-10-30 15:13:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8554, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-10-30 15:13:35', '1', 'admin', '2022-10-30 15:13:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8555, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-10-30 15:13:35', '1', 'admin', '2022-10-30 15:13:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8556, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:13:45', '1', 'admin', '2022-10-30 15:13:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8557, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:14:01', '1', 'test', '2022-10-30 15:14:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8558, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:14:01', '1', 'test', '2022-10-30 15:14:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8559, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-10-30 15:14:16', '1', 'admin', '2022-10-30 15:14:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8560, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-10-30 15:14:16', '1', 'admin', '2022-10-30 15:14:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8561, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-10-30 15:14:17', '1', 'admin', '2022-10-30 15:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8562, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-10-30 15:14:17', '1', 'admin', '2022-10-30 15:14:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8563, NULL, 'Chrome 10', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:16:42', '1', 'guest', '2022-11-06 15:16:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8564, NULL, 'Chrome 10', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:16:42', '1', 'guest', '2022-11-06 15:16:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8565, NULL, 'Chrome 10', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:16:56', '1', 'guest', '2022-11-06 15:16:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8566, NULL, 'Chrome 10', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:16:56', '1', 'guest', '2022-11-06 15:16:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8567, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:20:12', '1', 'guest', '2022-11-06 15:20:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8568, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:20:12', '1', 'guest', '2022-11-06 15:20:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8569, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:20:47', '1', 'admin', '2022-11-06 15:20:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8570, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:20:47', '1', 'admin', '2022-11-06 15:20:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8571, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/role', '2022-11-06 15:20:48', '1', 'admin', '2022-11-06 15:20:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8572, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-11-06 15:20:48', '1', 'admin', '2022-11-06 15:20:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8573, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/data', '2022-11-06 15:20:55', '1', 'admin', '2022-11-06 15:20:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8574, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-11-06 15:20:56', '1', 'admin', '2022-11-06 15:20:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8575, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user', '2022-11-06 15:20:59', '1', 'admin', '2022-11-06 15:20:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8576, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-11-06 15:21:00', '1', 'admin', '2022-11-06 15:21:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8577, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/log', '2022-11-06 15:21:00', '1', 'admin', '2022-11-06 15:21:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8578, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2022-11-06 15:21:01', '1', 'admin', '2022-11-06 15:21:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8579, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/changepwd', '2022-11-06 15:21:01', '1', 'admin', '2022-11-06 15:21:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8580, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/user/profile', '2022-11-06 15:21:02', '1', 'admin', '2022-11-06 15:21:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8581, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/entity', '2022-11-06 15:21:07', '1', 'admin', '2022-11-06 15:21:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8582, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-06 15:21:07', '1', 'admin', '2022-11-06 15:21:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8583, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res', '2022-11-06 15:21:09', '1', 'admin', '2022-11-06 15:21:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8584, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-11-06 15:21:09', '1', 'admin', '2022-11-06 15:21:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8585, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-11-06 15:21:09', '1', 'admin', '2022-11-06 15:21:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8586, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:36:56', '1', 'admin', '2022-11-06 15:36:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8587, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:36:56', '1', 'admin', '2022-11-06 15:36:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8588, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:37:05', '1', 'admin', '2022-11-06 15:37:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8589, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:37:05', '1', 'admin', '2022-11-06 15:37:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8590, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:37:20', '1', 'admin', '2022-11-06 15:37:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8591, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:37:20', '1', 'admin', '2022-11-06 15:37:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8592, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:37:35', '1', 'test', '2022-11-06 15:37:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8593, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:37:35', '1', 'test', '2022-11-06 15:37:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8594, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:41:16', '1', 'guest', '2022-11-06 15:41:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8595, NULL, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:41:16', '1', 'guest', '2022-11-06 15:41:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8596, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:41:43', '1', 'admin', '2022-11-06 15:41:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8597, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:41:43', '1', 'admin', '2022-11-06 15:41:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8598, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:43:42', '1', 'admin', '2022-11-06 15:43:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8599, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:43:43', '1', 'admin', '2022-11-06 15:43:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8600, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:45:51', '1', 'admin', '2022-11-06 15:45:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8601, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:45:51', '1', 'admin', '2022-11-06 15:45:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8602, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:46:00', '1', 'admin', '2022-11-06 15:46:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8603, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:46:00', '1', 'admin', '2022-11-06 15:46:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8604, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:56:02', '1', 'admin', '2022-11-06 15:56:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8605, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:56:02', '1', 'admin', '2022-11-06 15:56:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8606, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuTop', '2022-11-06 15:56:24', '1', 'admin', '2022-11-06 15:56:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8607, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 15:56:24', '1', 'admin', '2022-11-06 15:56:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8608, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-06 16:04:59', '1', 'admin', '2022-11-06 16:04:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8609, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 16:04:59', '1', 'admin', '2022-11-06 16:04:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8610, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-06 16:05:02', '1', 'admin', '2022-11-06 16:05:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8611, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-06 16:05:02', '1', 'admin', '2022-11-06 16:05:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8612, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2022-11-06 16:05:06', '1', 'admin', '2022-11-06 16:05:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8613, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-11-06 16:05:06', '1', 'admin', '2022-11-06 16:05:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8614, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2022-11-06 16:05:07', '1', 'admin', '2022-11-06 16:05:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8615, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-11-06 16:05:07', '1', 'admin', '2022-11-06 16:05:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8616, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-06 16:05:23', '1', 'test', '2022-11-06 16:05:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8617, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 16:05:23', '1', 'test', '2022-11-06 16:05:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8618, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-06 16:52:31', '1', 'test', '2022-11-06 16:52:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8619, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 16:52:32', '1', 'test', '2022-11-06 16:52:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8620, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-06 16:52:49', '1', 'test', '2022-11-06 16:52:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8621, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 16:52:49', '1', 'test', '2022-11-06 16:52:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8622, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-06 16:53:20', '1', 'admin', '2022-11-06 16:53:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8623, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-06 16:53:20', '1', 'admin', '2022-11-06 16:53:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8624, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 15:46:15', '1', 'admin', '2022-11-10 15:46:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8625, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 15:46:15', '1', 'admin', '2022-11-10 15:46:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8626, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 15:46:30', '1', 'admin', '2022-11-10 15:46:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8627, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 16:12:29', '1', 'admin', '2022-11-10 16:12:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8628, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 16:12:29', '1', 'admin', '2022-11-10 16:12:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8629, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 16:12:31', '1', 'admin', '2022-11-10 16:12:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8630, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-11-10 16:12:35', '1', 'admin', '2022-11-10 16:12:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8631, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-11-10 16:12:59', '1', 'admin', '2022-11-10 16:12:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8632, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 16:13:17', '1', 'admin', '2022-11-10 16:13:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8633, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 16:16:38', '1', 'admin', '2022-11-10 16:16:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8634, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 16:16:39', '1', 'admin', '2022-11-10 16:16:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8635, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 16:16:40', '1', 'admin', '2022-11-10 16:16:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8636, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 16:16:50', '1', 'admin', '2022-11-10 16:16:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8637, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 16:16:50', '1', 'admin', '2022-11-10 16:16:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8638, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 16:16:51', '1', 'admin', '2022-11-10 16:16:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8639, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 16:17:04', '1', 'test', '2022-11-10 16:17:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8640, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 16:17:04', '1', 'test', '2022-11-10 16:17:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8641, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 16:17:05', '1', 'test', '2022-11-10 16:17:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8642, 4, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-10 16:17:05', '1', 'test', '2022-11-10 16:17:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8643, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 16:17:19', '1', 'admin', '2022-11-10 16:17:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8644, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 16:17:19', '1', 'admin', '2022-11-10 16:17:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8645, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 16:17:20', '1', 'admin', '2022-11-10 16:17:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8646, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-10 16:17:20', '1', 'admin', '2022-11-10 16:17:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8647, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 16:20:43', '1', 'admin', '2022-11-10 16:20:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8648, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 16:20:43', '1', 'admin', '2022-11-10 16:20:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8649, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 16:20:46', '1', 'admin', '2022-11-10 16:20:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8650, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-10 16:20:46', '1', 'admin', '2022-11-10 16:20:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8651, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 20:57:54', '1', 'admin', '2022-11-10 20:57:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8652, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 20:57:54', '1', 'admin', '2022-11-10 20:57:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8653, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 20:57:56', '1', 'admin', '2022-11-10 20:57:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8654, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-10 20:57:56', '1', 'admin', '2022-11-10 20:57:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8655, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 20:59:09', '1', 'admin', '2022-11-10 20:59:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8656, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 20:59:09', '1', 'admin', '2022-11-10 20:59:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8657, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 20:59:12', '1', 'admin', '2022-11-10 20:59:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8658, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-10 20:59:12', '1', 'admin', '2022-11-10 20:59:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8659, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 21:00:26', '1', 'admin', '2022-11-10 21:00:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8660, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 21:00:26', '1', 'admin', '2022-11-10 21:00:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8661, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 21:00:39', '1', 'admin', '2022-11-10 21:00:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8662, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-10 21:00:39', '1', 'admin', '2022-11-10 21:00:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8663, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-11-10 21:05:43', '1', 'admin', '2022-11-10 21:05:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8664, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-11-10 21:05:43', '1', 'admin', '2022-11-10 21:05:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8665, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-11-10 21:08:22', '1', 'admin', '2022-11-10 21:08:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8666, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-11-10 21:08:29', '1', 'admin', '2022-11-10 21:08:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8667, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-25 14:46:58', '1', 'admin', '2022-12-25 14:46:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8668, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-25 14:46:58', '1', 'admin', '2022-12-25 14:46:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8669, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-12-25 14:47:16', '1', 'admin', '2022-12-25 14:47:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8670, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-12-25 14:47:17', '1', 'admin', '2022-12-25 14:47:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8671, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-25 14:56:05', '1', 'admin', '2022-12-25 14:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8672, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-25 14:56:05', '1', 'admin', '2022-12-25 14:56:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8673, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-12-25 14:56:21', '1', 'admin', '2022-12-25 14:56:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8674, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-12-25 14:56:21', '1', 'admin', '2022-12-25 14:56:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8675, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-25 15:00:36', '1', 'admin', '2022-12-25 15:00:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8676, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-25 15:00:36', '1', 'admin', '2022-12-25 15:00:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8677, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-12-25 15:00:38', '1', 'admin', '2022-12-25 15:00:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8678, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-12-25 15:00:38', '1', 'admin', '2022-12-25 15:00:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8679, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-25 15:01:27', '1', 'admin', '2022-12-25 15:01:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8680, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-25 15:01:27', '1', 'admin', '2022-12-25 15:01:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8681, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2022-12-25 15:01:33', '1', 'admin', '2022-12-25 15:01:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8682, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2022-12-25 15:01:33', '1', 'admin', '2022-12-25 15:01:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8683, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-25 17:20:40', '1', 'admin', '2022-12-25 17:20:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8684, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-25 17:20:40', '1', 'admin', '2022-12-25 17:20:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8685, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-25 17:20:42', '1', 'admin', '2022-12-25 17:20:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8686, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-25 17:20:42', '1', 'admin', '2022-12-25 17:20:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8687, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2022-12-25 17:20:52', '1', 'admin', '2022-12-25 17:20:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8688, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:20:52', '1', 'admin', '2022-12-25 17:20:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8689, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:20:52', '1', 'admin', '2022-12-25 17:20:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8690, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:20:56', '1', 'admin', '2022-12-25 17:20:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8691, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-25 17:21:07', '1', 'admin', '2022-12-25 17:21:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8692, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:22:03', '1', 'admin', '2022-12-25 17:22:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8693, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:22:03', '1', 'admin', '2022-12-25 17:22:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8694, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:22:05', '1', 'admin', '2022-12-25 17:22:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8695, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:22:09', '1', 'admin', '2022-12-25 17:22:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8696, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:22:09', '1', 'admin', '2022-12-25 17:22:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8697, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:22:09', '1', 'admin', '2022-12-25 17:22:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8698, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:22:18', '1', 'admin', '2022-12-25 17:22:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8699, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:22:18', '1', 'admin', '2022-12-25 17:22:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8700, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:22:19', '1', 'admin', '2022-12-25 17:22:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8701, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:22:21', '1', 'admin', '2022-12-25 17:22:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8702, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:22:21', '1', 'admin', '2022-12-25 17:22:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8703, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-25 17:22:22', '1', 'admin', '2022-12-25 17:22:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8704, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:22:27', '1', 'admin', '2022-12-25 17:22:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8705, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:22:27', '1', 'admin', '2022-12-25 17:22:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8706, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:22:27', '1', 'admin', '2022-12-25 17:22:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8707, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:22:29', '1', 'admin', '2022-12-25 17:22:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8708, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:22:29', '1', 'admin', '2022-12-25 17:22:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8709, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:22:47', '1', 'admin', '2022-12-25 17:22:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8710, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=106', '127.0.0.1', '/system/res/postUpdate', '2022-12-25 17:22:51', '1', 'admin', '2022-12-25 17:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8711, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:22:51', '1', 'admin', '2022-12-25 17:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8712, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:22:51', '1', 'admin', '2022-12-25 17:22:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8713, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:22:56', '1', 'admin', '2022-12-25 17:22:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8714, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=106', '127.0.0.1', '/system/res/postUpdate', '2022-12-25 17:22:59', '1', 'admin', '2022-12-25 17:22:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8715, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:23:00', '1', 'admin', '2022-12-25 17:23:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8716, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:23:00', '1', 'admin', '2022-12-25 17:23:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8717, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-25 17:23:20', '1', 'admin', '2022-12-25 17:23:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8718, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2022-12-25 17:23:58', '1', 'admin', '2022-12-25 17:23:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8719, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:23:58', '1', 'admin', '2022-12-25 17:23:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8720, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:23:58', '1', 'admin', '2022-12-25 17:23:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8721, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:24:01', '1', 'admin', '2022-12-25 17:24:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8722, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:24:03', '1', 'admin', '2022-12-25 17:24:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8723, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:24:03', '1', 'admin', '2022-12-25 17:24:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8724, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:24:06', '1', 'admin', '2022-12-25 17:24:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8725, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=111', '127.0.0.1', '/system/res/postUpdate', '2022-12-25 17:24:08', '1', 'admin', '2022-12-25 17:24:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8726, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:24:09', '1', 'admin', '2022-12-25 17:24:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8727, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:24:09', '1', 'admin', '2022-12-25 17:24:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8728, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:24:39', '1', 'admin', '2022-12-25 17:24:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8729, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:24:43', '1', 'admin', '2022-12-25 17:24:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8730, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:24:43', '1', 'admin', '2022-12-25 17:24:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8731, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-25 17:24:44', '1', 'admin', '2022-12-25 17:24:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8732, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=101', '127.0.0.1', '/system/res/postAdd', '2022-12-25 17:25:45', '1', 'admin', '2022-12-25 17:25:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8733, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:25:45', '1', 'admin', '2022-12-25 17:25:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8734, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:25:45', '1', 'admin', '2022-12-25 17:25:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8735, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-25 17:25:48', '1', 'admin', '2022-12-25 17:25:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8736, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=112', '127.0.0.1', '/system/res/postUpdate', '2022-12-25 17:25:51', '1', 'admin', '2022-12-25 17:25:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8737, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-25 17:25:51', '1', 'admin', '2022-12-25 17:25:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8738, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-25 17:25:51', '1', 'admin', '2022-12-25 17:25:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8739, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2022-12-25 17:25:52', '1', 'admin', '2022-12-25 17:25:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8740, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-25 17:25:52', '1', 'admin', '2022-12-25 17:25:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8741, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-12-25 17:26:45', '1', 'admin', '2022-12-25 17:26:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8742, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-12-25 17:26:45', '1', 'admin', '2022-12-25 17:26:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8743, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-12-25 17:26:50', '1', 'admin', '2022-12-25 17:26:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8744, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-25 17:26:50', '1', 'admin', '2022-12-25 17:26:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8745, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-12-25 17:26:51', '1', 'admin', '2022-12-25 17:26:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8746, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/res/resAuthTree', '2022-12-25 17:26:51', '1', 'admin', '2022-12-25 17:26:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8747, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=7', '127.0.0.1', '/system/role/postAuth', '2022-12-25 17:26:59', '1', 'admin', '2022-12-25 17:26:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8748, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-25 17:26:59', '1', 'admin', '2022-12-25 17:26:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8749, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-25 17:27:01', '1', 'admin', '2022-12-25 17:27:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8750, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-25 17:27:01', '1', 'admin', '2022-12-25 17:27:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8751, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-25 17:27:03', '1', 'admin', '2022-12-25 17:27:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8752, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-25 17:27:03', '1', 'admin', '2022-12-25 17:27:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8753, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 12:46:44', '1', 'admin', '2022-12-26 12:46:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8754, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 12:46:44', '1', 'admin', '2022-12-26 12:46:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8755, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2022-12-26 12:46:46', '1', 'admin', '2022-12-26 12:46:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8756, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-26 12:46:46', '1', 'admin', '2022-12-26 12:46:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8757, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-26 12:46:46', '1', 'admin', '2022-12-26 12:46:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8758, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2022-12-26 12:46:50', '1', 'admin', '2022-12-26 12:46:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8759, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-26 12:46:50', '1', 'admin', '2022-12-26 12:46:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8760, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2022-12-26 12:46:55', '1', 'admin', '2022-12-26 12:46:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8761, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 12:46:55', '1', 'admin', '2022-12-26 12:46:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8762, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/data', '2022-12-26 12:47:03', '1', 'admin', '2022-12-26 12:47:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8763, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-12-26 12:47:03', '1', 'admin', '2022-12-26 12:47:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8764, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/log', '2022-12-26 12:47:05', '1', 'admin', '2022-12-26 12:47:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8765, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2022-12-26 12:47:06', '1', 'admin', '2022-12-26 12:47:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8766, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user/profile', '2022-12-26 12:47:31', '1', 'admin', '2022-12-26 12:47:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8767, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user/changepwd', '2022-12-26 12:47:33', '1', 'admin', '2022-12-26 12:47:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8768, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2022-12-26 12:47:45', '1', 'admin', '2022-12-26 12:47:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8769, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-26 12:47:45', '1', 'admin', '2022-12-26 12:47:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8770, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2022-12-26 12:47:47', '1', 'admin', '2022-12-26 12:47:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8771, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 12:47:47', '1', 'admin', '2022-12-26 12:47:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8772, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2022-12-26 12:47:55', '1', 'admin', '2022-12-26 12:47:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8773, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 12:47:55', '1', 'admin', '2022-12-26 12:47:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8774, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2022-12-26 12:48:14', '1', 'admin', '2022-12-26 12:48:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8775, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2022-12-26 12:49:15', '1', 'admin', '2022-12-26 12:49:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8776, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 12:49:15', '1', 'admin', '2022-12-26 12:49:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8777, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2022-12-26 12:49:30', '1', 'admin', '2022-12-26 12:49:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8778, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2022-12-26 12:49:55', '1', 'admin', '2022-12-26 12:49:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8779, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 12:49:55', '1', 'admin', '2022-12-26 12:49:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8780, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2022-12-26 12:50:02', '1', 'admin', '2022-12-26 12:50:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8781, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2022-12-26 12:50:24', '1', 'admin', '2022-12-26 12:50:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8782, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 12:50:24', '1', 'admin', '2022-12-26 12:50:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8783, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/add', '2022-12-26 12:50:37', '1', 'admin', '2022-12-26 12:50:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8784, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/user/add', '127.0.0.1', '/system/user/postAdd', '2022-12-26 12:51:50', '1', 'admin', '2022-12-26 12:51:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8785, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 12:51:50', '1', 'admin', '2022-12-26 12:51:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8786, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2022-12-26 12:51:56', '1', 'admin', '2022-12-26 12:51:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8787, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-26 12:51:56', '1', 'admin', '2022-12-26 12:51:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8788, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 16:03:40', '1', 'admin', '2022-12-26 16:03:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8789, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 16:03:40', '1', 'admin', '2022-12-26 16:03:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8790, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2022-12-26 16:03:51', '1', 'admin', '2022-12-26 16:03:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8791, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 16:03:51', '1', 'admin', '2022-12-26 16:03:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8792, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2022-12-26 16:03:55', '1', 'admin', '2022-12-26 16:03:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8793, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 16:04:02', '1', 'admin', '2022-12-26 16:04:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8794, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2022-12-26 16:04:04', '1', 'admin', '2022-12-26 16:04:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8795, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-26 16:04:08', '1', 'admin', '2022-12-26 16:04:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8796, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 17:37:31', '1', 'admin', '2022-12-26 17:37:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8797, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 17:37:31', '1', 'admin', '2022-12-26 17:37:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8798, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 17:37:33', '1', 'admin', '2022-12-26 17:37:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8799, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 17:37:33', '1', 'admin', '2022-12-26 17:37:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8800, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 17:38:11', '1', 'admin', '2022-12-26 17:38:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8801, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 17:38:11', '1', 'admin', '2022-12-26 17:38:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8802, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=111&name=111&des=11&file=&url=111&userRole=A%E9%83%A8%E9%97%A8&userCooperator=admin&userCooperator=Ale&userCooperator=Alice&userDownloader=test&userDownloader=Bob&userDownloader=Breathe', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 17:38:11', '1', 'admin', '2022-12-26 17:38:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8803, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 17:44:53', '1', 'admin', '2022-12-26 17:44:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8804, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 17:44:53', '1', 'admin', '2022-12-26 17:44:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8805, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 17:45:00', '1', 'admin', '2022-12-26 17:45:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8806, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 17:45:00', '1', 'admin', '2022-12-26 17:45:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8807, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 17:45:11', '1', 'admin', '2022-12-26 17:45:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8808, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 17:45:11', '1', 'admin', '2022-12-26 17:45:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8809, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1&userRole=A%E9%83%A8%E9%97%A8&userCooperator=admin&userCooperator=Ale&userCooperator=Alice&userDownloader=test&userDownloader=Bob&userDownloader=Breathe', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 17:45:11', '1', 'admin', '2022-12-26 17:45:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8810, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 17:53:28', '1', 'admin', '2022-12-26 17:53:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8811, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 17:53:28', '1', 'admin', '2022-12-26 17:53:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8812, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 17:53:34', '1', 'admin', '2022-12-26 17:53:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8813, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 17:53:34', '1', 'admin', '2022-12-26 17:53:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8814, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 17:53:46', '1', 'admin', '2022-12-26 17:53:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8815, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 17:53:46', '1', 'admin', '2022-12-26 17:53:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8816, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1&userRole=A%E9%83%A8%E9%97%A8&userCooperator=admin&userCooperator=test&userDownloader=test&userDownloader=Ale', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 17:53:46', '1', 'admin', '2022-12-26 17:53:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8817, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 18:01:41', '1', 'admin', '2022-12-26 18:01:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8818, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 18:01:42', '1', 'admin', '2022-12-26 18:01:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8819, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:01:43', '1', 'admin', '2022-12-26 18:01:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8820, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:01:43', '1', 'admin', '2022-12-26 18:01:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8821, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:01:55', '1', 'admin', '2022-12-26 18:01:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8822, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 18:01:55', '1', 'admin', '2022-12-26 18:01:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8823, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=11&name=11&des=11&file=&url=11&userRole=A%E9%83%A8%E9%97%A8&userCooperator=admin&userCooperator=test&userDownloader=Bob&userDownloader=Breathe', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:01:55', '1', 'admin', '2022-12-26 18:01:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8824, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 18:06:49', '1', 'admin', '2022-12-26 18:06:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8825, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 18:06:49', '1', 'admin', '2022-12-26 18:06:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8826, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:06:51', '1', 'admin', '2022-12-26 18:06:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8827, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:06:51', '1', 'admin', '2022-12-26 18:06:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8828, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:07:02', '1', 'admin', '2022-12-26 18:07:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8829, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 18:07:02', '1', 'admin', '2022-12-26 18:07:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8830, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1&userRole=A%E9%83%A8%E9%97%A8&userCooperator=admin&userCooperator=test&userDownloader=Bob&userDownloader=Breathe', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:07:02', '1', 'admin', '2022-12-26 18:07:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8831, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 18:11:23', '1', 'admin', '2022-12-26 18:11:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8832, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 18:11:23', '1', 'admin', '2022-12-26 18:11:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8833, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:11:25', '1', 'admin', '2022-12-26 18:11:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8834, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:11:25', '1', 'admin', '2022-12-26 18:11:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8835, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 18:11:49', '1', 'admin', '2022-12-26 18:11:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8836, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:11:49', '1', 'admin', '2022-12-26 18:11:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8837, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1&userRole=A%E9%83%A8%E9%97%A8&userCooperator=admin&userCooperator=test&userDownloader=Bob&userDownloader=Breathe', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:11:49', '1', 'admin', '2022-12-26 18:11:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8838, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 18:16:02', '1', 'admin', '2022-12-26 18:16:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8839, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 18:16:02', '1', 'admin', '2022-12-26 18:16:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8840, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 18:16:05', '1', 'admin', '2022-12-26 18:16:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8841, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 18:16:05', '1', 'admin', '2022-12-26 18:16:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8842, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:16:06', '1', 'admin', '2022-12-26 18:16:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8843, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:16:06', '1', 'admin', '2022-12-26 18:16:06', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8844, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 18:16:20', '1', 'admin', '2022-12-26 18:16:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8845, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 18:16:20', '1', 'admin', '2022-12-26 18:16:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8846, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1&userRole=A%E9%83%A8%E9%97%A8&userCooperator=admin&userCooperator=Ale&userCooperator=Alice&userDownloader=test&userDownloader=Bob&userDownloader=Breathe', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 18:16:20', '1', 'admin', '2022-12-26 18:16:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8847, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 19:29:59', '1', 'admin', '2022-12-26 19:29:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8848, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 19:29:59', '1', 'admin', '2022-12-26 19:29:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8849, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 19:30:01', '1', 'admin', '2022-12-26 19:30:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8850, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 19:30:01', '1', 'admin', '2022-12-26 19:30:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8851, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 19:43:23', '1', 'admin', '2022-12-26 19:43:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8852, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 19:43:23', '1', 'admin', '2022-12-26 19:43:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8853, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 19:43:25', '1', 'admin', '2022-12-26 19:43:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8854, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 19:43:25', '1', 'admin', '2022-12-26 19:43:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8855, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 19:43:36', '1', 'admin', '2022-12-26 19:43:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8856, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 19:43:36', '1', 'admin', '2022-12-26 19:43:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8857, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 19:43:37', '1', 'admin', '2022-12-26 19:43:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8858, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 19:43:48', '1', 'admin', '2022-12-26 19:43:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8859, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1', '127.0.0.1', '/system/entity/upload', '2022-12-26 19:43:48', '1', 'admin', '2022-12-26 19:43:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8860, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload?pid=&key=1&name=1&des=1&file=&url=1', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 19:43:48', '1', 'admin', '2022-12-26 19:43:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8861, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 20:09:45', '1', 'admin', '2022-12-26 20:09:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8862, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 20:09:45', '1', 'admin', '2022-12-26 20:09:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8863, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 20:09:47', '1', 'admin', '2022-12-26 20:09:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8864, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 20:09:47', '1', 'admin', '2022-12-26 20:09:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8865, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/IPFSUpload', '2022-12-26 20:10:26', '1', 'admin', '2022-12-26 20:10:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8866, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/IPFSUpload', '2022-12-26 20:10:33', '1', 'admin', '2022-12-26 20:10:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8867, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/IPFSUpload', '2022-12-26 20:11:01', '1', 'admin', '2022-12-26 20:11:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8868, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 20:15:25', '1', 'admin', '2022-12-26 20:15:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8869, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 20:15:25', '1', 'admin', '2022-12-26 20:15:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8870, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 20:15:27', '1', 'admin', '2022-12-26 20:15:27', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8871, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 20:15:28', '1', 'admin', '2022-12-26 20:15:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8872, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/IPFSUpload', '2022-12-26 20:15:54', '1', 'admin', '2022-12-26 20:15:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8873, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 20:18:39', '1', 'admin', '2022-12-26 20:18:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8874, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 20:18:39', '1', 'admin', '2022-12-26 20:18:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8875, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 20:18:42', '1', 'admin', '2022-12-26 20:18:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8876, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 20:18:42', '1', 'admin', '2022-12-26 20:18:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8877, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 20:21:05', '1', 'admin', '2022-12-26 20:21:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8878, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 20:21:05', '1', 'admin', '2022-12-26 20:21:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8879, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 20:21:08', '1', 'admin', '2022-12-26 20:21:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8880, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 20:21:08', '1', 'admin', '2022-12-26 20:21:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8881, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/IPFSUpload', '2022-12-26 20:21:30', '1', 'admin', '2022-12-26 20:21:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8882, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 20:57:24', '1', 'admin', '2022-12-26 20:57:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8883, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 20:57:24', '1', 'admin', '2022-12-26 20:57:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8884, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-26 20:57:59', '1', 'admin', '2022-12-26 20:57:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8885, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-26 20:57:59', '1', 'admin', '2022-12-26 20:57:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8886, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/IPFSUpload', '2022-12-26 20:58:09', '1', 'admin', '2022-12-26 20:58:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8887, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/IPFSUpload', '2022-12-26 20:58:50', '1', 'admin', '2022-12-26 20:58:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8888, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/createEntity', '2022-12-26 20:58:56', '1', 'admin', '2022-12-26 20:58:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8889, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/entity/upload', '2022-12-26 20:58:56', '1', 'admin', '2022-12-26 20:58:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8890, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-26 21:11:10', '1', 'admin', '2022-12-26 21:11:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8891, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-26 21:11:10', '1', 'admin', '2022-12-26 21:11:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8892, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-27 18:06:32', '1', 'admin', '2022-12-27 18:06:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8893, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-27 18:06:32', '1', 'admin', '2022-12-27 18:06:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8894, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2022-12-27 18:06:36', '1', 'admin', '2022-12-27 18:06:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8895, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-27 18:06:36', '1', 'admin', '2022-12-27 18:06:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8896, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/update', '2022-12-27 18:06:50', '1', 'admin', '2022-12-27 18:06:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8897, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2022-12-27 18:07:44', '1', 'admin', '2022-12-27 18:07:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8898, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 13:55:43', '1', 'admin', '2022-12-28 13:55:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8899, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 13:55:43', '1', 'admin', '2022-12-28 13:55:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8900, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 14:56:17', '1', 'admin', '2022-12-28 14:56:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8901, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 14:56:17', '1', 'admin', '2022-12-28 14:56:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8902, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-28 14:56:25', '1', 'admin', '2022-12-28 14:56:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8903, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-28 14:56:25', '1', 'admin', '2022-12-28 14:56:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8904, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 15:27:33', '1', 'admin', '2022-12-28 15:27:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8905, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 15:27:33', '1', 'admin', '2022-12-28 15:27:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8906, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-28 15:27:36', '1', 'admin', '2022-12-28 15:27:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8907, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-28 15:27:36', '1', 'admin', '2022-12-28 15:27:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8908, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 15:40:48', '1', 'admin', '2022-12-28 15:40:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8909, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 15:40:48', '1', 'admin', '2022-12-28 15:40:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8910, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-28 15:40:51', '1', 'admin', '2022-12-28 15:40:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8911, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-28 15:40:51', '1', 'admin', '2022-12-28 15:40:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8912, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 15:42:22', '1', 'admin', '2022-12-28 15:42:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8913, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 15:42:22', '1', 'admin', '2022-12-28 15:42:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8914, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-28 15:42:25', '1', 'admin', '2022-12-28 15:42:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8915, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-28 15:42:25', '1', 'admin', '2022-12-28 15:42:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8916, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 15:45:22', '1', 'admin', '2022-12-28 15:45:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8917, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 15:45:22', '1', 'admin', '2022-12-28 15:45:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8918, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-28 15:45:24', '1', 'admin', '2022-12-28 15:45:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8919, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-28 15:45:24', '1', 'admin', '2022-12-28 15:45:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8920, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 15:57:31', '1', 'admin', '2022-12-28 15:57:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8921, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 15:57:32', '1', 'admin', '2022-12-28 15:57:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8922, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-28 15:57:33', '1', 'admin', '2022-12-28 15:57:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8923, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-28 15:57:34', '1', 'admin', '2022-12-28 15:57:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8924, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-28 15:58:45', '1', 'admin', '2022-12-28 15:58:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8925, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-28 15:58:46', '1', 'admin', '2022-12-28 15:58:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8926, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2022-12-28 15:58:48', '1', 'admin', '2022-12-28 15:58:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8927, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2022-12-28 15:58:48', '1', 'admin', '2022-12-28 15:58:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8928, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-30 12:35:07', '1', 'admin', '2022-12-30 12:35:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8929, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-30 12:35:07', '1', 'admin', '2022-12-30 12:35:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8930, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2022-12-30 12:35:09', '1', 'admin', '2022-12-30 12:35:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8931, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:35:09', '1', 'admin', '2022-12-30 12:35:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8932, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:35:09', '1', 'admin', '2022-12-30 12:35:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8933, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:35:20', '1', 'admin', '2022-12-30 12:35:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8934, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:35:22', '1', 'admin', '2022-12-30 12:35:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8935, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-30 12:35:30', '1', 'admin', '2022-12-30 12:35:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8936, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:35:33', '1', 'admin', '2022-12-30 12:35:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8937, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:35:33', '1', 'admin', '2022-12-30 12:35:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8938, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-30 12:36:02', '1', 'admin', '2022-12-30 12:36:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8939, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-12-30 12:37:58', '1', 'admin', '2022-12-30 12:37:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8940, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:37:58', '1', 'admin', '2022-12-30 12:37:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8941, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:37:58', '1', 'admin', '2022-12-30 12:37:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8942, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 12:38:01', '1', 'admin', '2022-12-30 12:38:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8943, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:38:09', '1', 'admin', '2022-12-30 12:38:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8944, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:38:09', '1', 'admin', '2022-12-30 12:38:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8945, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 12:38:21', '1', 'admin', '2022-12-30 12:38:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8946, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=113', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 12:38:23', '1', 'admin', '2022-12-30 12:38:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8947, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:38:23', '1', 'admin', '2022-12-30 12:38:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8948, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:38:23', '1', 'admin', '2022-12-30 12:38:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8949, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-30 12:38:48', '1', 'admin', '2022-12-30 12:38:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8950, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-12-30 12:39:30', '1', 'admin', '2022-12-30 12:39:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8951, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:39:30', '1', 'admin', '2022-12-30 12:39:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8952, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:39:30', '1', 'admin', '2022-12-30 12:39:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8953, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 12:39:33', '1', 'admin', '2022-12-30 12:39:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8954, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=114', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 12:39:36', '1', 'admin', '2022-12-30 12:39:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8955, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:39:36', '1', 'admin', '2022-12-30 12:39:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8956, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:39:36', '1', 'admin', '2022-12-30 12:39:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8957, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2022-12-30 12:39:37', '1', 'admin', '2022-12-30 12:39:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8958, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-30 12:39:37', '1', 'admin', '2022-12-30 12:39:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8959, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/auth', '2022-12-30 12:39:40', '1', 'admin', '2022-12-30 12:39:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8960, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/res/resAuthTree', '2022-12-30 12:39:40', '1', 'admin', '2022-12-30 12:39:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8961, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/role/auth?id=1', '127.0.0.1', '/system/role/postAuth', '2022-12-30 12:39:45', '1', 'admin', '2022-12-30 12:39:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8962, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2022-12-30 12:39:45', '1', 'admin', '2022-12-30 12:39:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8963, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:39:57', '1', 'admin', '2022-12-30 12:39:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8964, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-30 12:40:47', '1', 'admin', '2022-12-30 12:40:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8965, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-30 12:40:47', '1', 'admin', '2022-12-30 12:40:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8966, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2022-12-30 12:41:05', '1', 'admin', '2022-12-30 12:41:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8967, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 12:41:05', '1', 'admin', '2022-12-30 12:41:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8968, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:41:05', '1', 'admin', '2022-12-30 12:41:05', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8969, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/data', '2022-12-30 12:41:09', '1', 'admin', '2022-12-30 12:41:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8970, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2022-12-30 12:41:09', '1', 'admin', '2022-12-30 12:41:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8971, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:42:02', '1', 'admin', '2022-12-30 12:42:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8972, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:42:17', '1', 'admin', '2022-12-30 12:42:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8973, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 12:42:25', '1', 'admin', '2022-12-30 12:42:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8974, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2022-12-30 18:43:44', '1', 'admin', '2022-12-30 18:43:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8975, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2022-12-30 18:43:44', '1', 'admin', '2022-12-30 18:43:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8976, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2022-12-30 18:43:46', '1', 'admin', '2022-12-30 18:43:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8977, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:43:46', '1', 'admin', '2022-12-30 18:43:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8978, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:43:46', '1', 'admin', '2022-12-30 18:43:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8979, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:43:49', '1', 'admin', '2022-12-30 18:43:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8980, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:43:58', '1', 'admin', '2022-12-30 18:43:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8981, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:44:14', '1', 'admin', '2022-12-30 18:44:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8982, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:44:14', '1', 'admin', '2022-12-30 18:44:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8983, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-30 18:44:25', '1', 'admin', '2022-12-30 18:44:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8984, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-12-30 18:45:32', '1', 'admin', '2022-12-30 18:45:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8985, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:45:32', '1', 'admin', '2022-12-30 18:45:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8986, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:45:32', '1', 'admin', '2022-12-30 18:45:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8987, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:45:35', '1', 'admin', '2022-12-30 18:45:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8988, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=115', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:45:38', '1', 'admin', '2022-12-30 18:45:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8989, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:45:38', '1', 'admin', '2022-12-30 18:45:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8990, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:45:38', '1', 'admin', '2022-12-30 18:45:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8991, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:45:45', '1', 'admin', '2022-12-30 18:45:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8992, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=109', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:45:59', '1', 'admin', '2022-12-30 18:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8993, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:45:59', '1', 'admin', '2022-12-30 18:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8994, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:45:59', '1', 'admin', '2022-12-30 18:45:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8995, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-30 18:46:03', '1', 'admin', '2022-12-30 18:46:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8996, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-12-30 18:46:46', '1', 'admin', '2022-12-30 18:46:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8997, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:46:46', '1', 'admin', '2022-12-30 18:46:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8998, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:46:46', '1', 'admin', '2022-12-30 18:46:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (8999, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:46:49', '1', 'admin', '2022-12-30 18:46:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9000, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=109', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:46:53', '1', 'admin', '2022-12-30 18:46:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9001, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:46:53', '1', 'admin', '2022-12-30 18:46:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9002, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:46:53', '1', 'admin', '2022-12-30 18:46:53', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9003, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:46:54', '1', 'admin', '2022-12-30 18:46:54', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9004, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=116', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:46:57', '1', 'admin', '2022-12-30 18:46:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9005, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:46:57', '1', 'admin', '2022-12-30 18:46:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9006, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:46:57', '1', 'admin', '2022-12-30 18:46:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9007, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:46:59', '1', 'admin', '2022-12-30 18:46:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9008, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:47:17', '1', 'admin', '2022-12-30 18:47:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9009, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:47:17', '1', 'admin', '2022-12-30 18:47:17', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9010, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-30 18:47:20', '1', 'admin', '2022-12-30 18:47:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9011, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-12-30 18:48:26', '1', 'admin', '2022-12-30 18:48:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9012, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:48:26', '1', 'admin', '2022-12-30 18:48:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9013, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:48:26', '1', 'admin', '2022-12-30 18:48:26', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9014, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:48:30', '1', 'admin', '2022-12-30 18:48:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9015, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:48:35', '1', 'admin', '2022-12-30 18:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9016, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:48:35', '1', 'admin', '2022-12-30 18:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9017, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/add', '2022-12-30 18:48:36', '1', 'admin', '2022-12-30 18:48:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9018, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/add?pid=8', '127.0.0.1', '/system/res/postAdd', '2022-12-30 18:50:01', '1', 'admin', '2022-12-30 18:50:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9019, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:50:02', '1', 'admin', '2022-12-30 18:50:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9020, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:50:02', '1', 'admin', '2022-12-30 18:50:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9021, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:50:07', '1', 'admin', '2022-12-30 18:50:07', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9022, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=117', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:50:10', '1', 'admin', '2022-12-30 18:50:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9023, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:50:10', '1', 'admin', '2022-12-30 18:50:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9024, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:50:10', '1', 'admin', '2022-12-30 18:50:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9025, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:50:13', '1', 'admin', '2022-12-30 18:50:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9026, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=118', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:50:15', '1', 'admin', '2022-12-30 18:50:15', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9027, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:50:16', '1', 'admin', '2022-12-30 18:50:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9028, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:50:16', '1', 'admin', '2022-12-30 18:50:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9029, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:50:24', '1', 'admin', '2022-12-30 18:50:24', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9030, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=113', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:50:37', '1', 'admin', '2022-12-30 18:50:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9031, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:50:37', '1', 'admin', '2022-12-30 18:50:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9032, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:50:37', '1', 'admin', '2022-12-30 18:50:37', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9033, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/update', '2022-12-30 18:50:44', '1', 'admin', '2022-12-30 18:50:44', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9034, 3, 'Chrome 9', 'POST', 'http://127.0.0.1:8080/system/res/update?id=114', '127.0.0.1', '/system/res/postUpdate', '2022-12-30 18:50:55', '1', 'admin', '2022-12-30 18:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9035, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2022-12-30 18:50:55', '1', 'admin', '2022-12-30 18:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9036, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2022-12-30 18:50:55', '1', 'admin', '2022-12-30 18:50:55', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9037, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-03-13 20:03:12', '1', 'admin', '2023-03-13 20:03:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9038, 3, 'Chrome 9', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-03-13 20:03:12', '1', 'admin', '2023-03-13 20:03:12', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9039, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest', '2023-03-13 20:03:52', '1', 'admin', '2023-03-13 20:03:52', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9040, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest200', '2023-03-13 21:14:41', '1', 'admin', '2023-03-13 21:14:41', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9041, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest300', '2023-03-13 21:15:13', '1', 'admin', '2023-03-13 21:15:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9042, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest400', '2023-03-13 21:15:46', '1', 'admin', '2023-03-13 21:15:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9043, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest500', '2023-03-13 21:16:30', '1', 'admin', '2023-03-13 21:16:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9044, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest500', '2023-03-13 21:17:11', '1', 'admin', '2023-03-13 21:17:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9045, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-13 21:17:49', '1', 'admin', '2023-03-13 21:17:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9046, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest700', '2023-03-13 21:18:19', '1', 'admin', '2023-03-13 21:18:19', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9047, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest800', '2023-03-13 21:18:47', '1', 'admin', '2023-03-13 21:18:47', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9048, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest900', '2023-03-13 21:19:11', '1', 'admin', '2023-03-13 21:19:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9049, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest500', '2023-03-13 21:25:29', '1', 'admin', '2023-03-13 21:25:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9050, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-13 21:25:57', '1', 'admin', '2023-03-13 21:25:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9051, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest500', '2023-03-13 21:27:25', '1', 'admin', '2023-03-13 21:27:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9052, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-13 21:28:02', '1', 'admin', '2023-03-13 21:28:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9053, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-13 21:32:42', '1', 'admin', '2023-03-13 21:32:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9054, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest100', '2023-03-14 12:19:18', '1', 'admin', '2023-03-14 12:19:18', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9055, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest200', '2023-03-14 12:19:35', '1', 'admin', '2023-03-14 12:19:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9056, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest100', '2023-03-14 12:21:43', '1', 'admin', '2023-03-14 12:21:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9057, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest100', '2023-03-14 12:21:59', '1', 'admin', '2023-03-14 12:21:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9058, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest200', '2023-03-14 12:22:14', '1', 'admin', '2023-03-14 12:22:14', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9059, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest200', '2023-03-14 12:22:25', '1', 'admin', '2023-03-14 12:22:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9060, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest300', '2023-03-14 12:22:43', '1', 'admin', '2023-03-14 12:22:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9061, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest300', '2023-03-14 12:23:10', '1', 'admin', '2023-03-14 12:23:10', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9062, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest300', '2023-03-14 12:23:22', '1', 'admin', '2023-03-14 12:23:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9063, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest400', '2023-03-14 12:23:40', '1', 'admin', '2023-03-14 12:23:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9064, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest400', '2023-03-14 12:24:11', '1', 'admin', '2023-03-14 12:24:11', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9065, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest400', '2023-03-14 12:24:36', '1', 'admin', '2023-03-14 12:24:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9066, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest500', '2023-03-14 12:25:38', '1', 'admin', '2023-03-14 12:25:38', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9067, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest500', '2023-03-14 12:26:00', '1', 'admin', '2023-03-14 12:26:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9068, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest500', '2023-03-14 12:26:43', '1', 'admin', '2023-03-14 12:26:43', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9069, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-14 12:28:09', '1', 'admin', '2023-03-14 12:28:09', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9070, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-14 12:28:30', '1', 'admin', '2023-03-14 12:28:30', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9071, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-14 12:28:45', '1', 'admin', '2023-03-14 12:28:45', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9072, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest600', '2023-03-14 12:29:04', '1', 'admin', '2023-03-14 12:29:04', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9073, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest700', '2023-03-14 12:31:42', '1', 'admin', '2023-03-14 12:31:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9074, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest700', '2023-03-14 12:31:59', '1', 'admin', '2023-03-14 12:31:59', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9075, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest700', '2023-03-14 12:32:23', '1', 'admin', '2023-03-14 12:32:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9076, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest700', '2023-03-14 12:32:32', '1', 'admin', '2023-03-14 12:32:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9077, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest800', '2023-03-14 12:37:21', '1', 'admin', '2023-03-14 12:37:21', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9078, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest800', '2023-03-14 12:37:40', '1', 'admin', '2023-03-14 12:37:40', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9079, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest800', '2023-03-14 12:37:56', '1', 'admin', '2023-03-14 12:37:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9080, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest900', '2023-03-14 12:38:16', '1', 'admin', '2023-03-14 12:38:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9081, 3, 'Chrome 9', 'GET', NULL, '127.0.0.1', '/system/entity/IPFSTest900', '2023-03-14 12:38:32', '1', 'admin', '2023-03-14 12:38:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9082, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-08-08 18:16:42', '1', 'admin', '2023-08-08 18:16:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9083, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-08-08 18:16:42', '1', 'admin', '2023-08-08 18:16:42', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9084, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2023-08-08 18:17:00', '1', 'admin', '2023-08-08 18:17:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9085, 3, 'Chrome 11', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2023-08-08 18:17:00', '1', 'admin', '2023-08-08 18:17:00', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9086, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user/opeCheck', '2023-08-08 18:17:08', '1', 'admin', '2023-08-08 18:17:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9087, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/user/opeCheck', '127.0.0.1', '/system/user/tableData', '2023-08-08 18:17:08', '1', 'admin', '2023-08-08 18:17:08', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9088, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-08-08 18:28:13', '1', 'admin', '2023-08-08 18:28:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9089, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-08-08 18:28:13', '1', 'admin', '2023-08-08 18:28:13', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9090, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2023-08-08 18:28:20', '1', 'admin', '2023-08-08 18:28:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9091, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2023-08-08 18:28:20', '1', 'admin', '2023-08-08 18:28:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9092, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-08-08 18:28:20', '1', 'admin', '2023-08-08 18:28:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9093, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-08-08 18:28:29', '1', 'admin', '2023-08-08 18:28:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9094, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-08-08 18:28:33', '1', 'admin', '2023-08-08 18:28:33', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9095, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-08-08 18:28:35', '1', 'admin', '2023-08-08 18:28:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9096, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-08-08 18:28:39', '1', 'admin', '2023-08-08 18:28:39', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9097, 3, 'Chrome 11', 'POST', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/delete', '2023-08-08 18:28:48', '1', 'admin', '2023-08-08 18:28:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9098, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2023-08-08 18:28:48', '1', 'admin', '2023-08-08 18:28:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9099, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-08-08 18:28:48', '1', 'admin', '2023-08-08 18:28:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9100, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-08-08 18:28:50', '1', 'admin', '2023-08-08 18:28:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9101, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-08-08 18:28:51', '1', 'admin', '2023-08-08 18:28:51', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9102, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-08-08 18:39:46', '1', 'admin', '2023-08-08 18:39:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9103, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-08-08 18:39:46', '1', 'admin', '2023-08-08 18:39:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9104, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/data', '2023-08-08 18:39:50', '1', 'admin', '2023-08-08 18:39:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9105, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2023-08-08 18:39:50', '1', 'admin', '2023-08-08 18:39:50', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9106, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-08-08 18:40:20', '1', 'admin', '2023-08-08 18:40:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9107, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-08-08 18:40:20', '1', 'admin', '2023-08-08 18:40:20', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9108, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2023-08-08 18:40:22', '1', 'admin', '2023-08-08 18:40:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9109, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2023-08-08 18:40:22', '1', 'admin', '2023-08-08 18:40:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9110, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-08-08 18:40:22', '1', 'admin', '2023-08-08 18:40:22', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9111, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-08-08 19:18:28', '1', 'admin', '2023-08-08 19:18:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9112, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-08-08 19:18:28', '1', 'admin', '2023-08-08 19:18:28', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9113, 4, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-08-08 19:18:58', '1', 'test', '2023-08-08 19:18:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9114, 4, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-08-08 19:18:58', '1', 'test', '2023-08-08 19:18:58', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9115, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-10-17 21:02:16', '1', 'admin', '2023-10-17 21:02:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9116, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-10-17 21:02:16', '1', 'admin', '2023-10-17 21:02:16', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9117, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2023-10-17 21:02:29', '1', 'admin', '2023-10-17 21:02:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9118, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2023-10-17 21:02:29', '1', 'admin', '2023-10-17 21:02:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9119, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/privateEntity', '2023-10-17 21:02:32', '1', 'admin', '2023-10-17 21:02:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9120, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/privateEntity', '127.0.0.1', '/system/privateEntity/tableData', '2023-10-17 21:02:32', '1', 'admin', '2023-10-17 21:02:32', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9121, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/upload', '2023-10-17 21:02:34', '1', 'admin', '2023-10-17 21:02:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9122, 3, 'Chrome 11', 'POST', 'http://127.0.0.1:8080/system/entity/upload', '127.0.0.1', '/system/user/uploadRole', '2023-10-17 21:02:35', '1', 'admin', '2023-10-17 21:02:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9123, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity/download', '2023-10-17 21:02:36', '1', 'admin', '2023-10-17 21:02:36', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9124, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-10-17 21:17:46', '1', 'admin', '2023-10-17 21:17:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9125, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-10-17 21:17:46', '1', 'admin', '2023-10-17 21:17:46', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9126, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2023-10-17 21:17:48', '1', 'admin', '2023-10-17 21:17:48', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9127, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2023-10-17 21:17:49', '1', 'admin', '2023-10-17 21:17:49', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9128, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-10-17 21:48:23', '1', 'admin', '2023-10-17 21:48:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9129, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-10-17 21:48:23', '1', 'admin', '2023-10-17 21:48:23', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9130, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/entity', '2023-10-17 21:48:25', '1', 'admin', '2023-10-17 21:48:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9131, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/entity', '127.0.0.1', '/system/entity/tableData', '2023-10-17 21:48:25', '1', 'admin', '2023-10-17 21:48:25', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9132, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/log', '2023-10-17 21:48:29', '1', 'admin', '2023-10-17 21:48:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9133, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2023-10-17 21:48:29', '1', 'admin', '2023-10-17 21:48:29', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9134, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/data', '2023-10-17 21:48:31', '1', 'admin', '2023-10-17 21:48:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9135, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2023-10-17 21:48:31', '1', 'admin', '2023-10-17 21:48:31', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9136, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2023-10-17 21:48:34', '1', 'admin', '2023-10-17 21:48:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9137, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2023-10-17 21:48:34', '1', 'admin', '2023-10-17 21:48:34', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9138, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2023-10-17 21:48:35', '1', 'admin', '2023-10-17 21:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9139, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2023-10-17 21:48:35', '1', 'admin', '2023-10-17 21:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9140, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2023-10-17 21:48:35', '1', 'admin', '2023-10-17 21:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9141, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2023-10-17 21:48:35', '1', 'admin', '2023-10-17 21:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9142, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-10-17 21:48:35', '1', 'admin', '2023-10-17 21:48:35', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9143, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuTop', '2023-10-17 22:45:56', '1', 'admin', '2023-10-17 22:45:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9144, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res/menuLeft', '2023-10-17 22:45:56', '1', 'admin', '2023-10-17 22:45:56', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9145, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/res', '2023-10-17 22:45:57', '1', 'admin', '2023-10-17 22:45:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9146, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resTree', '2023-10-17 22:45:57', '1', 'admin', '2023-10-17 22:45:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9147, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/res', '127.0.0.1', '/system/res/resData', '2023-10-17 22:45:57', '1', 'admin', '2023-10-17 22:45:57', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9148, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/role', '2023-10-17 22:46:01', '1', 'admin', '2023-10-17 22:46:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9149, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/role', '127.0.0.1', '/system/role/tableData', '2023-10-17 22:46:01', '1', 'admin', '2023-10-17 22:46:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9150, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user', '2023-10-17 22:46:01', '1', 'admin', '2023-10-17 22:46:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9151, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/user', '127.0.0.1', '/system/user/tableData', '2023-10-17 22:46:01', '1', 'admin', '2023-10-17 22:46:01', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9152, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/data', '2023-10-17 22:46:02', '1', 'admin', '2023-10-17 22:46:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9153, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/data', '127.0.0.1', '/system/data/tableData', '2023-10-17 22:46:02', '1', 'admin', '2023-10-17 22:46:02', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9154, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/log', '2023-10-17 22:46:03', '1', 'admin', '2023-10-17 22:46:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9155, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/system/log', '127.0.0.1', '/system/log/tableData', '2023-10-17 22:46:03', '1', 'admin', '2023-10-17 22:46:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9156, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user/profile', '2023-10-17 22:46:03', '1', 'admin', '2023-10-17 22:46:03', '璁板綍鏃ュ織');
INSERT INTO `sys_log` VALUES (9157, 3, 'Chrome 11', 'GET', 'http://127.0.0.1:8080/login', '127.0.0.1', '/system/user/changepwd', '2023-10-17 22:46:04', '1', 'admin', '2023-10-17 22:46:04', '璁板綍鏃ュ織');

-- ----------------------------
-- Table structure for sys_res
-- ----------------------------
DROP TABLE IF EXISTS `sys_res`;
CREATE TABLE `sys_res`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `pid` bigint(20) NULL DEFAULT NULL,
  `name` varchar(111) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `des` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `url` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `level` int(11) NULL DEFAULT NULL,
  `iconCls` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'am-icon-file',
  `seq` bigint(20) NULL DEFAULT 1,
  `type` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '2' COMMENT '1 功能 2 权限',
  `status` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '1' COMMENT '1-启用 0-未启用',
  `lastUpdAcct` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lastUpdTime` datetime(0) NULL DEFAULT NULL,
  `note` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 119 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_res
-- ----------------------------
INSERT INTO `sys_res` VALUES (1, 0, 'System Management', '系统管理', '#', 1, '&#xe614;', 1, '1', '1', 'admin', '2018-01-17 10:22:03', '启用系统资源');
INSERT INTO `sys_res` VALUES (2, 1, 'System Management', '系统管理', '#', 2, '&#xe614;', 1, '1', '1', 'admin', '2016-10-25 10:47:23', '修改资源');
INSERT INTO `sys_res` VALUES (3, 2, 'Resourse Management', '资源管理', '/system/res', 3, '&#xe614;', 1, '1', '1', 'admin', '2016-10-18 16:24:08', '添加资源');
INSERT INTO `sys_res` VALUES (4, 2, 'User Management', '用户管理', '/system/user', 3, '&#xe614;', 3, '1', '1', '', '2017-10-13 11:26:19', '修改系统资源');
INSERT INTO `sys_res` VALUES (8, 2, 'data statusManagement', '数据管理', '/system/data', 3, '&#xe614;', 8, '1', '1', 'admin', '2016-10-20 21:29:24', '修改资源');
INSERT INTO `sys_res` VALUES (9, 2, 'Log Management', '日志管理', '/system/log', 3, '&#xe614;', 10, '1', '1', 'admin', '2016-10-18 19:31:47', '添加资源');
INSERT INTO `sys_res` VALUES (10, 2, 'Role Management', '角色管理', '/system/role', 3, '&#xe614;', 2, '1', '1', '', '2017-10-13 11:26:14', '修改系统资源');
INSERT INTO `sys_res` VALUES (13, 2, 'Profile', '个人资料', '/system/user/profile', 3, '&#xe614;', 15, '1', '1', 'admin', '2016-10-25 16:16:00', '添加资源');
INSERT INTO `sys_res` VALUES (14, 2, 'Changepassword', '修改密码', '/system/user/changepwd', 3, '&#xe614;', 20, '1', '1', 'admin', '2017-10-17 11:44:37', '启用系统资源');
INSERT INTO `sys_res` VALUES (17, 2, 'Page Management', '页面管理', '/system/page', 3, '&#xe614;', 7, '1', '1', 'admin', '2022-09-01 11:04:17', '修改系统资源');
INSERT INTO `sys_res` VALUES (20, 3, 'Resourse Management-add', '资源管理-添加', '/system/res/add', 4, '&#xe614;', 1, '2', '1', 'admin', '2022-01-08 19:14:57', '修改系统资源');
INSERT INTO `sys_res` VALUES (21, 3, 'Resourse Management-edit', '资源管理-编辑', '/system/res/update', 4, '&#xe614;', 2, '2', '1', 'admin', '2017-05-11 16:24:08', '添加资源');
INSERT INTO `sys_res` VALUES (22, 3, 'Resourse Management-delete', '资源管理-删除', '/system/res/delete', 4, '&#xe614;', 3, '2', '1', 'admin', '2017-05-11 16:24:46', '添加资源');
INSERT INTO `sys_res` VALUES (23, 4, 'User Management-add', '用户管理-新增', '/system/user/add', 4, '&#xe614;', 1, '2', '1', 'admin', '2017-05-11 16:35:50', '添加资源');
INSERT INTO `sys_res` VALUES (24, 4, 'User Management-edit', '用户管理-编辑', '/system/user/update', 4, '&#xe614;', 2, '2', '1', 'admin', '2017-05-11 16:36:21', '添加资源');
INSERT INTO `sys_res` VALUES (25, 4, 'User Management-delete', '用户管理-删除', '/system/user/delete', 4, '&#xe614;', 3, '2', '1', 'admin', '2017-05-11 16:36:45', '添加资源');
INSERT INTO `sys_res` VALUES (26, 10, 'Role Management-add', '角色管理-新增', '/system/role/add', 4, '&#xe614;', 1, '2', '1', 'admin', '2017-05-11 16:37:14', '添加资源');
INSERT INTO `sys_res` VALUES (27, 10, 'Role Management-edit', '角色管理-编辑', '/system/role/update', 4, '&#xe614;', 1, '2', '1', 'admin', '2017-05-11 16:37:59', '修改资源');
INSERT INTO `sys_res` VALUES (28, 10, 'Role Management-delete', '角色管理-删除', '/system/role/delete', 4, '&#xe614;', 3, '2', '1', 'admin', '2017-05-11 16:38:28', '添加资源');
INSERT INTO `sys_res` VALUES (46, 3, 'Resourse Management-use', '资源管理-启用', '/system/res/use', 4, '&#xe614;', 4, '2', '1', 'admin', '2017-10-17 16:38:34', '保存系统资源');
INSERT INTO `sys_res` VALUES (47, 3, 'Resourse Management-unuse', '资源管理-停用', '/system/res/unuse', 4, '&#xe614;', 6, '2', '1', 'admin', '2017-10-17 16:39:03', '保存系统资源');
INSERT INTO `sys_res` VALUES (48, 8, 'data statusManagement-add', '数据管理-添加', '/system/data/add', 4, '&#xe614;', 1, '2', '1', 'admin', '2017-10-17 17:11:10', '修改系统资源');
INSERT INTO `sys_res` VALUES (49, 8, 'data statusManagement-update', '数据管理-修改', '/system/data/update', 4, '&#xe614;', 2, '2', '1', 'admin', '2017-10-17 17:11:17', '修改系统资源');
INSERT INTO `sys_res` VALUES (50, 8, 'data statusManagement-delete', '数据管理-删除', '/system/data/delete', 4, '&#xe614;', 3, '2', '1', 'admin', '2017-10-17 16:59:59', '保存系统资源');
INSERT INTO `sys_res` VALUES (51, 8, 'data statusManagement-use', '数据管理-启用', '/system/data/use', 4, '&#xe614;', 4, '2', '1', 'admin', '2017-10-17 17:00:32', '保存系统资源');
INSERT INTO `sys_res` VALUES (52, 8, 'data statusManagement-unuse', '数据管理-停用', '/system/data/unuse', 4, '&#xe614;', 5, '2', '1', 'admin', '2017-10-17 17:00:58', '保存系统资源');
INSERT INTO `sys_res` VALUES (53, 10, 'Role Management-permission', '角色管理-权限', '/system/role/auth', 4, '&#xe614;', 4, '2', '1', 'admin', '2017-10-19 11:36:33', '保存系统资源');
INSERT INTO `sys_res` VALUES (54, 4, 'Role Management-use', '用户管理-解锁', '/system/user/use', 4, '&#xe614;', 4, '2', '1', 'admin', '2017-10-19 11:43:39', '修改系统资源');
INSERT INTO `sys_res` VALUES (55, 4, 'Role Management-unuse', '用户管理-锁定', '/system/user/unuse', 4, '&#xe614;', 5, '2', '1', 'admin', '2018-01-03 16:23:21', '启用系统资源');
INSERT INTO `sys_res` VALUES (56, 1, 'Monitoring management', '监控管理', '#', 2, '&#xe614;', 2, '1', '1', 'admin', '2017-10-19 11:53:00', '保存系统资源');
INSERT INTO `sys_res` VALUES (57, 56, 'Registry monitoring', '注册中心监控', 'http://127.0.0.1:8500', 3, '&#xe614;', 1, '1', '1', 'admin', '2018-01-11 13:23:09', '修改系统资源');
INSERT INTO `sys_res` VALUES (58, 56, 'service monitoring', '服务监控', 'http://127.0.0.1:7010/hystrix', 3, '&#xe614;', 5, '1', '1', 'admin', '2018-01-11 13:23:23', '修改系统资源');
INSERT INTO `sys_res` VALUES (59, 8, 'Data Management-flush', '数据管理-刷新缓存', '/system/data/cache', 4, '&#xe614;', 6, '2', '1', 'admin', '2017-10-24 09:47:50', '修改系统资源');
INSERT INTO `sys_res` VALUES (60, 2, 'session management', '会话管理', '/system/session', 4, '&#xe614;', 4, '1', '1', 'admin', '2022-09-01 11:03:47', '修改系统资源');
INSERT INTO `sys_res` VALUES (61, 56, 'Service Link Tracking', '服务链路跟踪', 'http://127.0.0.1:9411', 3, '&#xe614;', 15, '1', '1', 'admin', '2018-01-11 13:23:30', '修改系统资源');
INSERT INTO `sys_res` VALUES (62, 56, 'Service Governance', '服务治理', 'http://127.0.0.1:7001', 3, '&#xe614;', 4, '1', '1', 'admin', '2018-01-11 13:23:16', '修改系统资源');
INSERT INTO `sys_res` VALUES (101, 1, 'Data sharing', '1', '1', 2, '&#xe614', 11, '1', '1', 'admin', '2021-12-04 16:49:34', '修改系统资源');
INSERT INTO `sys_res` VALUES (102, 101, 'Query public data directory', '用户数据展示', '/system/entity', 3, '', 1, '1', '1', 'admin', '2022-08-09 18:14:12', '修改系统资源');
INSERT INTO `sys_res` VALUES (103, 101, 'Upload data directory', '用户上传数据', '/system/entity/upload', 3, '', 3, '1', '1', 'admin', '2022-08-07 18:05:11', '修改系统资源');
INSERT INTO `sys_res` VALUES (104, 101, 'Download public data directory', '用户下载数据', '/system/entity/download', 3, '&#xe614', 4, '1', '1', 'admin', '2021-12-04 15:29:19', '保存系统资源');
INSERT INTO `sys_res` VALUES (108, 8, 'public data directory-update', '对共享数据进行修改', '/system/entity/update', 4, '', 20, '1', '1', 'admin', '2022-08-10 16:35:34', '修改系统资源');
INSERT INTO `sys_res` VALUES (109, 8, 'public data directory-delete', '对共享数据目录进行删除', '/system/entity/delete', 4, '', 21, '1', '1', 'admin', '2022-12-30 18:46:53', '淇敼绯荤粺璧勬簮');
INSERT INTO `sys_res` VALUES (111, 101, 'Query group private data directory', '私有数据展示', '/system/privateEntity', 3, '', 2, '1', '1', 'admin', '2022-12-25 17:24:08', '修改系统资源');
INSERT INTO `sys_res` VALUES (112, 101, 'Download group private data directory', '发送部门私有数据下载请求', '/system/privateEntity/download', 3, '', 5, '1', '1', 'admin', '2022-12-25 17:25:51', '修改系统资源');
INSERT INTO `sys_res` VALUES (113, 8, 'public data permission-collaborators', '更新共享数据合作者权限', '/system/entity/updateCooperator', 4, '', 22, '1', '1', 'admin', '2022-12-30 18:50:37', '淇敼绯荤粺璧勬簮');
INSERT INTO `sys_res` VALUES (114, 8, 'public data permission-downloader', '更新共享数据下载者权限', '/system/entity/updateDownloader', 4, '', 23, '1', '1', 'admin', '2022-12-30 18:50:55', '淇敼绯荤粺璧勬簮');
INSERT INTO `sys_res` VALUES (115, 8, 'Private-update', '对私有数据目录进行修改', '/system/privateEntity/update', 4, '', 30, '1', '1', 'admin', '2022-12-30 18:45:38', '淇敼绯荤粺璧勬簮');
INSERT INTO `sys_res` VALUES (116, 8, 'Private-delete', '对私有数据目录进行删除', '/system/privateEntity/delete', 4, '', 31, '1', '1', 'admin', '2022-12-30 18:46:57', '淇敼绯荤粺璧勬簮');
INSERT INTO `sys_res` VALUES (117, 8, 'Private data permission-collaborators', '修改私有数据合作者权限', '/system/privateEntity/updateCooperator', 4, '', 32, '1', '1', 'admin', '2022-12-30 18:50:10', '淇敼绯荤粺璧勬簮');
INSERT INTO `sys_res` VALUES (118, 8, 'private data permission-downloader', '修改私有数据的下载者权限', '/system/privateEntity/updateDownloader', 4, '', 33, '1', '1', 'admin', '2022-12-30 18:50:15', '淇敼绯荤粺璧勬簮');

-- ----------------------------
-- Table structure for sys_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_role`;
CREATE TABLE `sys_role`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `name` varchar(55) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `des` varchar(55) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `seq` bigint(20) NULL DEFAULT 1,
  `iconCls` varchar(55) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'status_online',
  `pid` bigint(20) NULL DEFAULT 0,
  `createdate` datetime(0) NULL DEFAULT NULL,
  `status` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '1' COMMENT '1-启用 0-未启用',
  `lastUpdAcct` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lastUpdTime` datetime(0) NULL DEFAULT NULL,
  `note` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 8 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_role
-- ----------------------------
INSERT INTO `sys_role` VALUES (1, 'A Group', '管理员-系统最高权限拥有者', 1, 'status_online', 0, '2016-10-19 15:02:25', '1', 'admin', '2017-05-11 16:41:59', '更新角色');
INSERT INTO `sys_role` VALUES (7, 'B Group', '测试', 100, 'status_online', 0, '2022-11-10 15:41:38', '1', 'admin', '2018-01-11 13:18:55', '保存系统角色');

-- ----------------------------
-- Table structure for sys_role_res
-- ----------------------------
DROP TABLE IF EXISTS `sys_role_res`;
CREATE TABLE `sys_role_res`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `res_id` bigint(20) NULL DEFAULT NULL,
  `role_id` bigint(20) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `FK_sys_ROLE_RES_RES_ID`(`res_id`) USING BTREE,
  INDEX `FK_sys_ROLE_RES_ROLE_ID`(`role_id`) USING BTREE,
  CONSTRAINT `sys_role_res_ibfk_1` FOREIGN KEY (`res_id`) REFERENCES `sys_res` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `sys_role_res_ibfk_2` FOREIGN KEY (`role_id`) REFERENCES `sys_role` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE = InnoDB AUTO_INCREMENT = 2551 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_role_res
-- ----------------------------
INSERT INTO `sys_role_res` VALUES (2497, 1, 7);
INSERT INTO `sys_role_res` VALUES (2498, 101, 7);
INSERT INTO `sys_role_res` VALUES (2499, 102, 7);
INSERT INTO `sys_role_res` VALUES (2500, 111, 7);
INSERT INTO `sys_role_res` VALUES (2501, 103, 7);
INSERT INTO `sys_role_res` VALUES (2502, 104, 7);
INSERT INTO `sys_role_res` VALUES (2503, 112, 7);
INSERT INTO `sys_role_res` VALUES (2505, 1, 1);
INSERT INTO `sys_role_res` VALUES (2506, 2, 1);
INSERT INTO `sys_role_res` VALUES (2507, 3, 1);
INSERT INTO `sys_role_res` VALUES (2508, 20, 1);
INSERT INTO `sys_role_res` VALUES (2509, 21, 1);
INSERT INTO `sys_role_res` VALUES (2510, 22, 1);
INSERT INTO `sys_role_res` VALUES (2511, 46, 1);
INSERT INTO `sys_role_res` VALUES (2512, 47, 1);
INSERT INTO `sys_role_res` VALUES (2513, 10, 1);
INSERT INTO `sys_role_res` VALUES (2514, 26, 1);
INSERT INTO `sys_role_res` VALUES (2515, 27, 1);
INSERT INTO `sys_role_res` VALUES (2516, 28, 1);
INSERT INTO `sys_role_res` VALUES (2517, 53, 1);
INSERT INTO `sys_role_res` VALUES (2518, 4, 1);
INSERT INTO `sys_role_res` VALUES (2519, 23, 1);
INSERT INTO `sys_role_res` VALUES (2520, 24, 1);
INSERT INTO `sys_role_res` VALUES (2521, 25, 1);
INSERT INTO `sys_role_res` VALUES (2522, 54, 1);
INSERT INTO `sys_role_res` VALUES (2523, 55, 1);
INSERT INTO `sys_role_res` VALUES (2524, 60, 1);
INSERT INTO `sys_role_res` VALUES (2525, 17, 1);
INSERT INTO `sys_role_res` VALUES (2526, 8, 1);
INSERT INTO `sys_role_res` VALUES (2527, 48, 1);
INSERT INTO `sys_role_res` VALUES (2528, 49, 1);
INSERT INTO `sys_role_res` VALUES (2529, 50, 1);
INSERT INTO `sys_role_res` VALUES (2530, 51, 1);
INSERT INTO `sys_role_res` VALUES (2531, 52, 1);
INSERT INTO `sys_role_res` VALUES (2532, 59, 1);
INSERT INTO `sys_role_res` VALUES (2533, 108, 1);
INSERT INTO `sys_role_res` VALUES (2534, 109, 1);
INSERT INTO `sys_role_res` VALUES (2535, 113, 1);
INSERT INTO `sys_role_res` VALUES (2536, 114, 1);
INSERT INTO `sys_role_res` VALUES (2537, 9, 1);
INSERT INTO `sys_role_res` VALUES (2538, 13, 1);
INSERT INTO `sys_role_res` VALUES (2539, 14, 1);
INSERT INTO `sys_role_res` VALUES (2540, 56, 1);
INSERT INTO `sys_role_res` VALUES (2541, 57, 1);
INSERT INTO `sys_role_res` VALUES (2542, 62, 1);
INSERT INTO `sys_role_res` VALUES (2543, 58, 1);
INSERT INTO `sys_role_res` VALUES (2544, 61, 1);
INSERT INTO `sys_role_res` VALUES (2545, 101, 1);
INSERT INTO `sys_role_res` VALUES (2546, 102, 1);
INSERT INTO `sys_role_res` VALUES (2547, 111, 1);
INSERT INTO `sys_role_res` VALUES (2548, 103, 1);
INSERT INTO `sys_role_res` VALUES (2549, 104, 1);
INSERT INTO `sys_role_res` VALUES (2550, 112, 1);

-- ----------------------------
-- Table structure for sys_user
-- ----------------------------
DROP TABLE IF EXISTS `sys_user`;
CREATE TABLE `sys_user`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `name` varchar(55) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `pwd` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `status` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT '1' COMMENT '#1 正常 2.封号 ',
  `icon` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT 'images/guest.jpg',
  `email` varchar(255) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `createdate` datetime(0) NULL DEFAULT NULL,
  `phone` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `salt2` varchar(55) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `onlineStatus` varchar(2) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '在线状态  1-在线 0-离线',
  `lastUpdAcct` varchar(20) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `lastUpdTime` datetime(0) NULL DEFAULT NULL,
  `note` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL,
  `mspId` varchar(200) CHARACTER SET utf8 COLLATE utf8_general_ci NULL DEFAULT NULL COMMENT '用户所属组织的ID',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE = InnoDB AUTO_INCREMENT = 9 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_user
-- ----------------------------
INSERT INTO `sys_user` VALUES (3, 'admin', '8b276c6430bc6cfec325a09dc6713167', '1', 'images/guest.jpg', '1233', '2017-05-11 15:54:56', '123', '66432cd44c4abf25202aca49a5e14436', NULL, 'admin', '2018-01-19 18:17:57', '用户修改个人资料', 'Org1MSP');
INSERT INTO `sys_user` VALUES (4, 'test', 'faa5687f3b8294924d2bdd03c99d9132', '1', 'images/guest.jpg', '123', '2022-04-09 10:46:50', '123', '4a10250a56bbc783ad7c0fd1c4b6bb18', '0', 'admin', '2022-04-09 10:46:50', '自创用户', 'Org2MSP');
INSERT INTO `sys_user` VALUES (5, 'Alea', '31270c5793112fd935fac1a36b7a9833', '1', 'images/guest.jpg', '123', '2022-12-26 12:49:15', '123', 'eb60f52d6ad1d9adba9a0180b92c097b', '0', 'admin', '2022-12-26 12:49:15', '自创用户', 'Org1MSP');
INSERT INTO `sys_user` VALUES (6, 'Alice', 'f11a5c826db1692b8721b44ed2e9a383', '1', 'images/guest.jpg', '111', '2022-12-26 12:49:55', '111', '32e1186d7eac5f848aa5e3b83f1eab1f', '0', 'admin', '2022-12-26 12:49:55', '自创用户', 'Org1MSP');
INSERT INTO `sys_user` VALUES (7, 'Bobo', '960ec7fecfe8b96284d6987722ca1bd9', '1', 'images/guest.jpg', '111', '2022-12-26 12:50:24', '111', '9e411d2599b8546519f846ee289cd635', '0', 'admin', '2022-12-26 12:50:24', '自创用户', 'Org2MSP');
INSERT INTO `sys_user` VALUES (8, 'Breathe', '2ad053dfa986bb2d77b0287502214b29', '1', 'images/guest.jpg', '222', '2022-12-26 12:51:50', '111', 'cd2583f6b0976919bdba9169eb6f2dee', '0', 'admin', '2022-12-26 12:51:50', '自创用户', 'Org2MSP');

-- ----------------------------
-- Table structure for sys_user_role
-- ----------------------------
DROP TABLE IF EXISTS `sys_user_role`;
CREATE TABLE `sys_user_role`  (
  `id` bigint(20) NOT NULL AUTO_INCREMENT,
  `user_id` bigint(20) NULL DEFAULT NULL,
  `role_id` bigint(20) NULL DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  INDEX `FK_SYSTME_USER_ROLE_USER_ID`(`user_id`) USING BTREE,
  INDEX `FK_SYSTME_USER_ROLE_ROLE_ID`(`role_id`) USING BTREE,
  CONSTRAINT `sys_user_role_ibfk_1` FOREIGN KEY (`role_id`) REFERENCES `sys_role` (`id`) ON DELETE CASCADE ON UPDATE CASCADE,
  CONSTRAINT `sys_user_role_ibfk_2` FOREIGN KEY (`user_id`) REFERENCES `sys_user` (`id`) ON DELETE CASCADE ON UPDATE CASCADE
) ENGINE = InnoDB AUTO_INCREMENT = 27 CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of sys_user_role
-- ----------------------------
INSERT INTO `sys_user_role` VALUES (21, 3, 1);
INSERT INTO `sys_user_role` VALUES (22, 4, 7);
INSERT INTO `sys_user_role` VALUES (23, 5, 1);
INSERT INTO `sys_user_role` VALUES (24, 6, 1);
INSERT INTO `sys_user_role` VALUES (25, 7, 7);
INSERT INTO `sys_user_role` VALUES (26, 8, 7);

-- ----------------------------
-- Table structure for tongji
-- ----------------------------
DROP TABLE IF EXISTS `tongji`;
CREATE TABLE `tongji`  (
  `aaa` int(11) NULL DEFAULT NULL
) ENGINE = InnoDB CHARACTER SET = utf8 COLLATE = utf8_general_ci ROW_FORMAT = Dynamic;

-- ----------------------------
-- Records of tongji
-- ----------------------------
INSERT INTO `tongji` VALUES (475870);
INSERT INTO `tongji` VALUES (21184890);
INSERT INTO `tongji` VALUES (475870);
INSERT INTO `tongji` VALUES (1311469);

-- ----------------------------
-- Function structure for querySysRes
-- ----------------------------
DROP FUNCTION IF EXISTS `querySysRes`;
delimiter ;;
CREATE FUNCTION `querySysRes`(treeCode INT)
 RETURNS varchar(4000) CHARSET utf8
  DETERMINISTIC
BEGIN

    DECLARE sTemp VARCHAR(4000);
    DECLARE sTempChd VARCHAR(1000);

    SET sTemp = '$';

    select id  into sTempChd from sys_res t where t.id = treeCode;

    WHILE sTempChd is not null DO
      IF (sTempChd != treeCode) THEN
        SET sTemp = concat(sTemp,',',sTempChd);
      END IF;
      SELECT group_concat(id) INTO sTempChd FROM sys_res where FIND_IN_SET(pid,sTempChd)>0;
    END WHILE;
    RETURN sTemp;
  END
;;
delimiter ;

SET FOREIGN_KEY_CHECKS = 1;
